<?php
class aaSpinner {
static function best_curl_post($url, $data, &$info){
  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_POST, true);
  curl_setopt($ch, CURLOPT_POSTFIELDS, self::best_curl_postData($data));
  curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt($ch, CURLOPT_REFERER, $url);
  $html = trim(curl_exec($ch));
  curl_close($ch);

  return $html;
} // best_curl

static function best_curl_postData($data){
  $fdata = "";
  foreach($data as $key => $val){
    $fdata .= "$key=" . urlencode($val) . "&";
  }

  return $fdata;
} // best_curl

static function best_test() {
$url = 'http://thebestspinner.com/api.php';


$data = array();
$data['action'] = 'authenticate';
$data['format'] = 'php';
$data['username'] = get_option('aa_settings-spinner-username', '');
$data['password'] = get_option('aa_settings-spinner-password', '');
$output = unserialize(self::best_curl_post($url, $data, $info));
if($output['success']=='true'){
  set_transient('aa-bestspinner-session', $output['session'], DAY_IN_SECONDS * 0.8);
  return true;
} else {
  return false;
}
} // best_test

static function best_spin($text) {

$testmethod = 'rewriteText';
$url = 'http://thebestspinner.com/api.php';

if (!get_transient('aa-bestspinner-session')) {
  $tmp = self::best_test();
  if (!$tmp) {
    return false;
  }
}

  $data = array();
  $data['session'] = get_transient('aa-bestspinner-session');
  $data['format'] = 'php';
  $data['text'] = $text;
  $data['action'] = 'rewriteText';

  $output = self::best_curl_post($url, $data, $info);
  $output = unserialize($output);

  if($output['success']=='true'){
    return $output['output'];
  } else{
    return false;
  }
} // best_spin

static function writer_spin($text) {
  $quality = get_option('aa_settings-spinner-quality', '');
  
  // Spin Rewriter API settings - authentication:
  $data['email_address'] = get_option('aa_settings-spinner-username', '');
  $data['api_key'] = get_option('aa_settings-spinner-password', '');

  // Spin Rewriter API settings - request details:
  $data['action'] = "unique_variation"; // possible values: 'api_quota', 'text_with_spintax', 'unique_variation', 'unique_variation_from_spintax'
  $data['text'] = $text;
  $data['auto_protected_terms'] = "false";          // possible values: 'false' (default value), 'true'
  
  
  // quality 
  switch ($quality) {
    case 'normal':
    $quality = 'medium';
    break;
    case 'low':
    $quality = 'low';
    break;
    case 'high':
    $quality = 'high';
    break;
  }
  $data['confidence_level'] = $quality;              // possible values: 'low', 'medium' (default value), 'high' -> low je most unique
  
  
  $data['auto_sentences'] = "true";              // possible values: 'false' (default value), 'true'
  $data['auto_paragraphs'] = "false";              // possible values: 'false' (default value), 'true'
  $data['auto_new_paragraphs'] = "true";            // possible values: 'false' (default value), 'true'
  $data['auto_sentence_trees'] = "true";            // possible values: 'false' (default value), 'true'
  $data['use_only_synonyms'] = "false";            // possible values: 'false' (default value), 'true'
  $data['reorder_paragraphs'] = "false";            // possible values: 'false' (default value), 'true'
  $data['nested_spintax'] = "true";              // possible values: 'false' (default value), 'true'


  // Make the actual API request and save the JSON response.
  $api_response = self::writer_api_post($data);

  // Output interpreted JSON response (as a native PHP array).
  $api_response_interpreted = json_decode($api_response, true);
  if ($api_response_interpreted['status'] != 'OK') {
    return false;
  } else {
    return $api_response_interpreted['response'];
  }
}

  /**
   * Sends a request to the Spin Rewriter API and returns the unformatted response.
   * @param $data
   */
  static function writer_api_post($data){
    $data_raw = "";
    foreach ($data as $key => $value){
      $data_raw = $data_raw . $key . "=" . urlencode($value) . "&";
    }

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, "http://www.spinrewriter.com/action/api");
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data_raw);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    $response = trim(curl_exec($ch));
    curl_close($ch);
    return $response;
  } // writer_api_post

  static function wordai_spin($text) {
    $quality = get_option('aa_settings-spinner-quality', '');
      $text = urlencode($text);
      $email = get_option('aa_settings-spinner-username', '');
      $pass = get_option('aa_settings-spinner-password', '');
      
      // quality
      switch ($quality) {
        case 'normal':
          $quality = '50';
        break;
        case 'low':
          $quality = '0';
        break;
        case 'high':
          $quality = '100';
        break;
      }
      
      #$quality = '100'; // brojke od 0 do 100, 0 je most unique

      $ch = curl_init('http://wordai.com/users/regular-api.php');
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt ($ch, CURLOPT_POST, 1);
      curl_setopt ($ch, CURLOPT_POSTFIELDS, "s=$text&quality=$quality&email=$email&pass=$pass&returnspin=true");
      $result = curl_exec($ch);
      curl_close ($ch);

      return $result;


}
} // class