<?php



function bestsellerazon_trim_r($item) {

	if(is_array($item)) {

		return array_map('bestsellerazon_trim_r', $item);

	} else {

		return trim($item);

	}

}



function bestsellerazon_get_detail_page_url($item) {

	return apply_filters('bestsellerazon_get_detail_page_url', BestsellerAzon::get_detail_page_url($item), $item);

}

function bestsellerazon_the_detail_page_url($item) {

	echo apply_filters('bestsellerazon_the_detail_page_url', bestsellerazon_get_detail_page_url($item), $item);

}



function bestsellerazon_has_description($item) {

	return '' != trim(strip_tags($item['EditorialReviews']['EditorialReview'][0]['Content']));

}

function bestsellerazon_get_description($item, $link_atts) {

	$description = trim(substr(strip_tags($item['EditorialReviews']['EditorialReview'][0]['Content']), 0, 175));

	

	if(!empty($description)) {

		$more_link = sprintf('... <a %s href="%s">%s</a>', $link_atts, bestsellerazon_get_detail_page_url($item), __('read more &rarr;'));

		$description = force_balance_tags(wpautop($description . $more_link));

	}

	

	return apply_filters('bestsellerazon_get_description', $description, $item);

}

function bestsellerazon_the_description($item, $link_atts) {

	echo apply_filters('bestsellerazon_the_description', bestsellerazon_get_description($item, $link_atts), $item, $link_atts);

}



function bestsellerazon_has_image($bestseller_item) {

	$image = bestsellerazon_get_image($bestseller_item);

	

	return is_array($image) && isset($image['URL']);

}

function bestsellerazon_get_image($bestseller_item) {

	$image = false;

	

	if(is_array($bestseller_item['MediumImage'])) {

		$image = $bestseller_item['MediumImage'];

	} else if(is_array($bestseller_item['ImageSets']) && is_array($bestseller_item['ImageSets']['ImageSet'])) {

		foreach($bestseller_item['ImageSets']['ImageSet'] as $image_set) {

			if(is_array($image_set['MediumImage'])) {

				$image = $image_set['MediumImage'];

				break;

			}

		}

	}

	

	return $image;

}



/** TITLE **/

function bestsellerazon_get_title($bestseller_item) {

	return ((is_array($bestseller_item['ItemAttributes']) && isset($bestseller_item['ItemAttributes']['Title'])) ? $bestseller_item['ItemAttributes']['Title'] : '');

}

function bestsellerazon_the_title($bestseller_item) {

	echo bestsellerazon_get_title($bestseller_item);

}

function bestsellerazon_the_title_attr($bestseller_item) {

	echo esc_attr(bestsellerazon_get_title($bestseller_item));

}



/** IMAGES **/



function bestsellerazon_get_image_width($bestseller_item) {

	$image = bestsellerazon_get_image($bestseller_item);

	

	return ($image ? intval($image['Width']) : 0);

}

function bestsellerazon_the_image_width($bestseller_item) {

	echo bestsellerazon_get_image_width($bestseller_item);

}



function bestsellerazon_get_image_height($bestseller_item) {

	$image = bestsellerazon_get_image($bestseller_item);

	

	return ($image ? intval($image['Height']) : 0);

}

function bestsellerazon_the_image_height($bestseller_item) {

	echo bestsellerazon_get_image_height($bestseller_item);

}



function bestsellerazon_get_image_url($bestseller_item) {

	$image = bestsellerazon_get_image($bestseller_item);

	

	return ($image ? $image['URL'] : false);

}

function bestsellerazon_the_image_url($bestseller_item) {

	echo bestsellerazon_get_image_url($bestseller_item);

}



/** Price **/

function bestsellerazon_get_price_info($bestseller_item) {

	$price = false;

	

	if(is_array($bestseller_item['Offers']) && is_array($bestseller_item['Offers']['Offer']) && is_array($bestseller_item['Offers']['Offer']['OfferListing']) && is_array($bestseller_item['Offers']['Offer']['OfferListing']['Price']) && isset($bestseller_item['Offers']['Offer']['OfferListing']['Price']['FormattedPrice'])) {

		$price = $bestseller_item['Offers']['Offer']['OfferListing']['Price'];

	} 

	

	if(empty($price) && is_array($bestseller_item['OfferSummary'])) {

		foreach(array('LowestNewPrice', 'LowestUsedPrice', 'LowestRefurbishedPrice') as $offer_summary_key) {

			if(is_array($bestseller_item['OfferSummary'][$offer_summary_key]) && isset($bestseller_item['OfferSummary'][$offer_summary_key]['FormattedPrice'])) {

				$price = $bestseller_item['OfferSummary'][$offer_summary_key];

				break;

			}

		}

	} 

	

	if(empty($price) && is_array($bestseller_item['ItemAttributes']['ListPrice']) && isset($bestseller_item['ItemAttributes']['ListPrice']['FormattedPrice'])) {

		$price = $bestseller_item['ItemAttributes']['ListPrice'];

	}

	

	return $price;

}
function bestsellerazon_has_price($bestseller_item) {

	$info = bestsellerazon_get_price_info($bestseller_item);

	

	return (is_array($info) && isset($info['FormattedPrice']));

}

function bestsellerazon_get_price($bestseller_item) {

	$info = bestsellerazon_get_price_info($bestseller_item);

	

	return ((is_array($info) && isset($info['FormattedPrice'])) ? $info['FormattedPrice'] : false);

}

function bestsellerazon_the_price($bestseller_item) {

	echo bestsellerazon_get_price($bestseller_item);

}

