<p><?php _e('Choose which content types you want to allow Amazon Bestsellers to display on, whether they should display by default, and how many to display per item.'); ?></p>

<table class="form-table">

	<tbody>

		<tr valign="top">

			<th scope="row"><label for="bestsellerazon-enabled-by-default"><?php _e('Display by Default?'); ?></label></th>

			<td>

				<label>

					<input type="checkbox" <?php checked($settings['enabled-by-default'], 'yes'); ?> name="bestsellerazon[enabled-by-default]" id="bestsellerazon-enabled-by-default" value="yes" />

					<?php _e('Bestsellers should be displayed by default on all enabled content types. By unchecking this box you will have to indicate whether you want to display bestsellers on each item.'); ?>

				</label>

			</td>

		</tr>

		<tr valign="top">

			<th scope="row"><label for="bestsellerazon-display-prices"><?php _e('Display Item Prices?'); ?></label></th>

			<td>

				<label>

					<input <?php checked($settings['display-prices'], 'yes'); ?> type="checkbox" name="bestsellerazon[display-prices]" id="bestsellerazon-display-prices" value="yes" />

					<?php _e('By default, I want to display prices for items in the bestseller list'); ?>

				</label>

			</td>

		</tr>

		<tr valign="top">

			<th scope="row"><label for="bestsellerazon-display-descriptions"><?php _e('Display Item Descriptions?'); ?></label></th>

			<td>

				<label>

					<input <?php checked($settings['display-descriptions'], 'yes'); ?> type="checkbox" name="bestsellerazon[display-descriptions]" id="bestsellerazon-display-descriptions" value="yes" />

					<?php _e('By default, I want to display descriptions for items in the bestseller list'); ?>

				</label><br />

				<small><?php _e('This information is not always populated by Amazon for every product.'); ?></small>

			</td>

		</tr>

		<tr valign="top">

			<th scope="row"><label for="bestsellerazon-default-headline"><?php _e('Default Headline'); ?></label></th>

			<td>

				<input type="text" class="code large-text" name="bestsellerazon[default-headline]" id="bestsellerazon-default-headline" value="<?php esc_attr_e($settings['default-headline']); ?>" /><br />

				<small><?php _e('Set the message you want to display above the bestselling product listings featured on your website. You can change this for every post.'); ?></small>

			</td>

		</tr>

		<tr valign="top">

			<th scope="row"><label for="bestsellerazon-number-bestsellers"><?php _e('Number to Display'); ?></label></th>

			<td>

				<select name="bestsellerazon[number]" id="bestsellerazon-number">

					<?php for($i = 10; $i >= 1; $i--) { ?>

					<option <?php selected($settings['number'], $i); ?> value="<?php esc_attr_e($i); ?>"><?php esc_html_e($i); ?></option>	

					<?php } ?>

				</select>

			</td>

		</tr>

		<tr valign="top">

			<th scope="row"><label for="bestsellerazon-default-category"><?php _e('Default Bestseller Category'); ?></label></th>

			<td>

				<?php self::display_category_selector($settings['default-category-name'], $settings['default-category'], 'bestsellerazon-default-category', 'bestsellerazon[default-category]', $settings['access-key-id'], $settings['secret-access-key']); ?>

			</td>

		</tr>

		<tr valign="top">

			<th scope="row"><?php _e('Enabled Content Types'); ?></th>

			<td>

				<ul style="margin: 0">

					<?php foreach(get_post_types(array('show_ui' => true), 'objects') as $type) { ?>

					<li>

						<label>

							<input type="checkbox" <?php checked($settings['post-types'][$type->name], 'yes'); ?> name="bestsellerazon[post-types][<?php esc_attr_e($type->name); ?>]" value="yes" />

							<?php esc_html_e($type->labels->name); ?>

						</label>

					</li>

					<?php } ?>

				</ul>

				<small><?php _e('Check the boxes next to the content types you wish to use BestsellerAzon with'); ?></small>

			</td>

		</tr>

		<tr valign="top">

			<th scope="row"><?php _e('Enabled Display Contexts'); ?></th>

			<td>

				<ul style="margin: 0">

					<li>

						<label>

							<input type="checkbox" <?php checked($settings['display-contexts']['single'], 'yes'); ?> name="bestsellerazon[display-contexts][single]" value="yes" />

							<?php _e('Bestsellers are allowed to display on single content views'); ?>

						</label>

					</li>

					<li>

						<label>

							<input type="checkbox" <?php checked($settings['display-contexts']['term'], 'yes'); ?> name="bestsellerazon[display-contexts][term]" value="yes" />

							<?php _e('Bestsellers are allowed to display on category and tag views'); ?>

						</label>

					</li>

					<li>

						<label>

							<input type="checkbox" <?php checked($settings['display-contexts']['home'], 'yes'); ?> name="bestsellerazon[display-contexts][home]" value="yes" />

							<?php _e('Bestsellers are allowed to display on the home page'); ?>

						</label>

					</li>

				</ul>

		</tr>

	</tbody>

</table>