<?php

class BestsellerazonWidget extends WP_Widget {

	function __construct() {
		$widget_ops = array('classname' => 'widget_bestsellerazon', 'description' => __('Display Amazon\'s bestselling products on your site.'));
		parent::__construct('bestsellerazon', __('BestsellerAzon'), $widget_ops);
	}

	function widget( $args, $instance ) {
		extract( $args );

		$title = apply_filters('widget_title', empty($instance['headline-text']) ? '' : $instance['headline-text'], $instance, $this->id_base);
		
		$settings = BestsellerAzon::get_settings();
		$category = $instance['category'];
		if('default' === $category) {
			$category = $settings['default-category'];
		}

		$display_descriptions = $instance['display-descriptions'];
		if('default' === $display_descriptions) {
			$display_descriptions = $settings['display-descriptions'];
		}
		$display_descriptions = 'yes' === $display_descriptions;

		$display_prices = $instance['display-prices'];
		if('default' === $display_prices) {
			$display_prices = $settings['display-prices'];
		}
		$display_prices = 'yes' === $display_prices;

		$number = $instance['number'];
		if('default' === $number) {
			$number = $settings['number'];
		}
		$number = intval($number);

		$locale = $settings['locale'];

		$bestseller_items = BestsellerAzon::get_bestsellers($category, $locale);
		$last_updated_timestamp = BestsellerAzon::get_bestsellers_update_time($category, $locale);

		ob_start();
		if (is_array($bestseller_items)) {
			$bestseller_items = array_slice($bestseller_items, 0, $number);
			$link_atts = BestsellerAzon::get_link_atts();
			$resource_directory_url = plugins_url('resources/frontend', dirname(__FILE__).'bestsellerazon.php');
			
			include ('views/frontend/widget.php');
		}
		echo ob_get_clean();
	}

	function update($new_instance, $old_instance) {
		return BestsellerAzon::sanitize_meta($new_instance);
	}

	function form($instance) {
		$instance = wp_parse_args((array) $instance, BestsellerAzon::$default_meta);

		$settings = BestsellerAzon::get_settings();
		include('views/backend/controls.php');
	}

}