<?php

/**

 * Plugin Name: Flex Pretty Fonts

 * Plugin URI: http://www.flexsqueeze.com

 * Description: Use more creative font styles in FlexSqueeze and Flexibility 3

 * Version: 1.0

 * Author: Advantus Media, Inc.

 * Author URI: http://www.flexsqueeze.com

 */









//*************** Admin function ***************







add_action('admin_menu', 'my_plugin_menu');



function my_plugin_menu() {



  add_submenu_page('themes.php', 'Flex Pretty Font Options', 'Flex Pretty Fonts', 'manage_options', 'flex_pf', 'flex_pf_options');



}



function flex_pf_options() {



  if (!current_user_can('manage_options'))  {

    wp_die( __('You do not have sufficient permissions to access this page.') );

  }

  

  $options = array (

					

	array(	"type" => "begin"),

	

	array(	"type" => "title",

		  	"title" => "Site Title Font Settings",

			"descr" => "Select the font style for your site title"),

    

    array(  "id" => "flexpf_title",

		  	"name" => "Font style: ",

			"std" => "default",

			"type" => "select",

			"options" => array ("default", "ChunkFive", "Enigma", "HoneyScript", "Journal", "Komika", "League", "Miso", "Museo", "Sansation", "Sansumi", "Typewriter")),

	

	array(	"type" => "break"),

	 

	array(	"type" => "begin"),

	

	array(	"type" => "title",

		  	"title" => "Site Tagline Font Settings",

			"descr" => "Select the font style for your site tagline"),

	

	array(  "id" => "flexpf_tagline",

		  	"name" => "Font style: ",

			"std" => "default",

			"type" => "select",

			"options" => array ("default", "ChunkFive", "Enigma", "HoneyScript", "Journal", "Komika", "League", "Miso", "Museo", "Sansation", "Sansumi", "Typewriter")),

			

	

		array(  "id" => "flexpf_tagsize",

		  	"name" => "Font size: ",

			"std" => "",

			"type" => "text"),

		

		array(  "id" => "flexpf_tagclr",

		  	"name" => "Color: ",

			"std" => "FFFFFF",

			"type" => "color"),

	

	array(	"type" => "break"),

	 

	array(	"type" => "begin"),

	

	array(	"type" => "title",

		  	"title" => "Post/page Title Font Settings",

			"descr" => "Select the font style for the title of posts and pages"),

	

	array(  "id" => "flexpf_posttitle",

		  	"name" => "Font style: ",

			"std" => "default",

			"type" => "select",

			"options" => array ("default", "ChunkFive", "Enigma", "HoneyScript", "Journal", "Komika", "League", "Miso", "Museo", "Sansation", "Sansumi", "Typewriter")),

	

	array(	"type" => "break"),

	 

	array(	"type" => "begin"),

	

	array(	"type" => "title",

		  	"title" => "Sidebar Title Font Settings",

			"descr" => "Select the font style for the title of your sidebar widgets"),

	

	array(  "id" => "flexpf_sbtitle",

		  	"name" => "Font style: ",

			"std" => "default",

			"type" => "select",

			"options" => array ("default", "ChunkFive", "Enigma", "HoneyScript", "Journal", "Komika", "League", "Miso", "Museo", "Sansation", "Sansumi", "Typewriter")),

			

	

	array(	"type" => "break"),

	 

	array(	"type" => "begin"),

	

	array(	"type" => "title",

		  	"title" => "Top Feature H2 Tag Font Settings",

			"descr" => "Select the font style for any H2 tags used in your top feature area"),

	

	array(  "id" => "flexpf_tftitles",

		  	"name" => "Font style: ",

			"std" => "default",

			"type" => "select",

			"options" => array ("default", "ChunkFive", "Enigma", "HoneyScript", "Journal", "Komika", "League", "Miso", "Museo", "Sansation", "Sansumi", "Typewriter")),

			

	

	array(	"type" => "break"),

	 

	array(	"type" => "begin"),

	

	array(	"type" => "title",

		  	"title" => "Footer Feature H2 Tag Font Settings",

			"descr" => "Select the font style for any H2 tags used in your footer feature area"),

	

	array(  "id" => "flexpf_fftitles",

		  	"name" => "Font style: ",

			"std" => "default",

			"type" => "select",

			"options" => array ("default", "ChunkFive", "Enigma", "HoneyScript", "Journal", "Komika", "League", "Miso", "Museo", "Sansation", "Sansumi", "Typewriter")),

			

	

	array(	"type" => "break"),

	 

	array(	"type" => "begin"),

	



	array(	"type" => "title",

		  	"title" => "H1 Tag Font Settings",

			"descr" => "Select the font style for any H1 tags on your pages or posts"),

	

	array(  "id" => "flexpf_h1",

		  	"name" => "Font style: ",

			"std" => "default",

			"type" => "select",

			"options" => array ("default", "ChunkFive", "Enigma", "HoneyScript", "Journal", "Komika", "League", "Miso", "Museo", "Sansation", "Sansumi", "Typewriter")),

	

	array(  "id" => "flexpf_h1_clr",

		  	"name" => "Color: ",

			"std" => "333333",

			"type" => "color"),

	

	array(  "id" => "flexpf_h1size",

		  	"name" => "Font size: ",

			"std" => "28",

			"type" => "text"),

				

	array(	"type" => "break"),

	 

	array(	"type" => "begin"),

	

	array(	"type" => "title",

		  	"title" => "H2 Tag Font Settings",

			"descr" => "Select the font style for any H2 tags on your pages or posts"),

	

	array(  "id" => "flexpf_h2",

		  	"name" => "Font style: ",

			"std" => "default",

			"type" => "select",

			"options" => array ("default", "ChunkFive", "Enigma", "HoneyScript", "Journal", "Komika", "League", "Miso", "Museo", "Sansation", "Sansumi", "Typewriter")),

			

	array(  "id" => "flexpf_h2_clr",

		  	"name" => "Color: ",

			"std" => "333333",

			"type" => "color"),

	

	array(  "id" => "flexpf_h2size",

		  	"name" => "Font size: ",

			"std" => "24",

			"type" => "text"),

	

	array(	"type" => "break"),

	 

	array(	"type" => "begin"),

	

	array(	"type" => "title",

		  	"title" => "H3 Tag Font Settings",

			"descr" => "Select the font style for any H3 tags on your pages or posts"),

	

	array(  "id" => "flexpf_h3",

		  	"name" => "Font style: ",

			"std" => "default",

			"type" => "select",

			"options" => array ("default", "ChunkFive", "Enigma", "HoneyScript", "Journal", "Komika", "League", "Miso", "Museo", "Sansation", "Sansumi", "Typewriter")),

	

	array(  "id" => "flexpf_h3_clr",

		  	"name" => "Color: ",

			"std" => "333333",

			"type" => "color"),

	

	array(  "id" => "flexpf_h3size",

		  	"name" => "Font size: ",

			"std" => "21",

			"type" => "text"),

	

	array(	"type" => "break"),

	 

	array(	"type" => "begin"),

	

	array(	"type" => "title",

		  	"title" => "H4 Tag Font Settings",

			"descr" => "Select the font style for any H4 tags on your pages or posts"),

	

	array(  "id" => "flexpf_h4",

		  	"name" => "Font style: ",

			"std" => "default",

			"type" => "select",

			"options" => array ("default", "ChunkFive", "Enigma", "HoneyScript", "Journal", "Komika", "League", "Miso", "Museo", "Sansation", "Sansumi", "Typewriter")),

	

	array(  "id" => "flexpf_h4_clr",

		  	"name" => "Color: ",

			"std" => "333333",

			"type" => "color"),

	

	array(  "id" => "flexpf_h4size",

		  	"name" => "Font size: ",

			"std" => "18",

			"type" => "text"),

	

	array(	"type" => "break"),

	 

	array(	"type" => "begin"),

	

	array(	"type" => "title",

		  	"title" => "H5 Tag Font Settings",

			"descr" => "Select the font style for any H5 tags on your pages or posts"),

	

	array(  "id" => "flexpf_h5",

		  	"name" => "Font style: ",

			"std" => "default",

			"type" => "select",

			"options" => array ("default", "ChunkFive", "Enigma", "HoneyScript", "Journal", "Komika", "League", "Miso", "Museo", "Sansation", "Sansumi", "Typewriter")),

	

	array(  "id" => "flexpf_h5_clr",

		  	"name" => "Color: ",

			"std" => "333333",

			"type" => "color"),

	

	array(  "id" => "flexpf_h5size",

		  	"name" => "Font size: ",

			"std" => "16",

			"type" => "text"),

	

	array(	"type" => "break"),

	 

	array(	"type" => "begin"),

	

	array(	"type" => "title",

		  	"title" => "H6 Tag Font Settings",

			"descr" => "Select the font style for any H6 tags on your pages or posts"),

	

	array(  "id" => "flexpf_h6",

		  	"name" => "Font style: ",

			"std" => "default",

			"type" => "select",

			"options" => array ("default", "ChunkFive", "Enigma", "HoneyScript", "Journal", "Komika", "League", "Miso", "Museo", "Sansation", "Sansumi", "Typewriter")),

	

	array(  "id" => "flexpf_h6_clr",

		  	"name" => "Color: ",

			"std" => "333333",

			"type" => "color"),

	

	array(  "id" => "flexpf_h6size",

		  	"name" => "Font size: ",

			"std" => "14",

			"type" => "text"),

	

	array(	"type" => "break"),

	

	array(	"type" => "begin"),

	

	array(	"type" => "title",

		  	"title" => "Custom Style #1",

			"descr" => "Create a custom CSS class by entering the name of the class, the font, size and color. To use the style on your site, simply use &lt;p class=\"customclass\"&gt;some text&lt;/p&gt; in HTML mode. Just change the 'customclass' to whatever you name it below."),

	

	array(  "id" => "flexpf_cs1class",

		  	"name" => "Class name: ",

			"std" => "",

			"type" => "text"),

	

	array(  "id" => "flexpf_cs1",

		  	"name" => "Font style: ",

			"std" => "default",

			"type" => "select",

			"options" => array ("default", "ChunkFive", "Enigma", "HoneyScript", "Journal", "Komika", "League", "Miso", "Museo", "Sansation", "Sansumi", "Typewriter")),

	

	array(  "id" => "flexpf_cs1_clr",

		  	"name" => "Color: ",

			"std" => "333333",

			"type" => "color"),

	

	array(  "id" => "flexpf_cs1size",

		  	"name" => "Font size: ",

			"std" => "24",

			"type" => "text"),

	

	array(	"type" => "break"),

	

	array(	"type" => "begin"),

	

	array(	"type" => "title",

		  	"title" => "Custom Style #2",

			"descr" => "Create a second custom style below."),

	

	array(  "id" => "flexpf_cs2class",

		  	"name" => "Class name: ",

			"std" => "",

			"type" => "text"),

	

	array(  "id" => "flexpf_cs2",

		  	"name" => "Font style: ",

			"std" => "default",

			"type" => "select",

			"options" => array ("default", "ChunkFive", "Enigma", "HoneyScript", "Journal", "Komika", "League", "Miso", "Museo", "Sansation", "Sansumi", "Typewriter")),

	

	array(  "id" => "flexpf_cs2_clr",

		  	"name" => "Color: ",

			"std" => "333333",

			"type" => "color"),

	

	array(  "id" => "flexpf_cs2size",

		  	"name" => "Font size: ",

			"std" => "24",

			"type" => "text"),

	

	array(	"type" => "break"),

	

	array(	"type" => "begin"),

	

	array(	"type" => "title",

		  	"title" => "Custom Style #3",

			"descr" => "Create a third custom style below."),

	

	array(  "id" => "flexpf_cs3class",

		  	"name" => "Class name: ",

			"std" => "",

			"type" => "text"),

	

	array(  "id" => "flexpf_cs3",

		  	"name" => "Font style: ",

			"std" => "default",

			"type" => "select",

			"options" => array ("default", "ChunkFive", "Enigma", "HoneyScript", "Journal", "Komika", "League", "Miso", "Museo", "Sansation", "Sansumi", "Typewriter")),

	

	array(  "id" => "flexpf_cs3_clr",

		  	"name" => "Color: ",

			"std" => "333333",

			"type" => "color"),

	

	array(  "id" => "flexpf_cs3size",

		  	"name" => "Font size: ",

			"std" => "24",

			"type" => "text"),

	

	array(	"type" => "break")



		  

		  )



  ?>

  <div class="wrap">  



  <h2>Flex Pretty Font Options</h2>

  <p>You can change many of the main fonts on your site by setting the options below. Keep in mind that the more different fonts you use, the more javascript has to load with your site. Each font adds anywhere from 14Kb to 56Kb in additional script overhead. It's OK to use the same font in multiple locations as it only loads once. You just probably don't want to use ALL the fonts on your site at the same time. Keeping it to 3-4 font styles is ideal.</p>

  <?php 

  if ($_POST["action"] == "update")  

     {  

              foreach ($options as $value) {

                    update_option( $value['id'], $_REQUEST[ $value['id'] ] ); }



              foreach ($options as $value) {

                    if( isset( $_REQUEST[ $value['id'] ] ) ) { update_option( $value['id'], $_REQUEST[ $value['id'] ]  ); } else { delete_option( $value['id'] ); } }

           echo '<div class="updated"><p><strong>Options Updated</strong></p></div>';

				}

	

	

?>

  <form method="post" action=""> 

  <input type="hidden" name="action" value="update" /> 

  <p class="submit">

	<input type="submit" name="Submit" value="Update options" />

	</p>

    <?php 

  $plugin_img = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)).'images/';

  

  foreach ($options as $value) { 

  

  if ($value['type'] == "begin") { ?>

  <table class="form-table">

       <tr valign="top">

       <td>

  <?php } 

  

  else if ($value['type'] == "title") { ?>

  <h3><?php echo $value['title']; ?></h3>

  <p><?php echo $value['descr']; ?></p>

  

  </td>

  </tr>

  <tr><td>

  <?php } 

  

  else if ($value['type'] == "select") { ?>



        <div style="width:200px;float:left;"><?php echo $value['name']; ?> <select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">

            <?php foreach ($value['options'] as $option) { ?>

            <option<?php if ( get_option( $value['id'] ) == $option) { echo ' selected="selected"'; } elseif ($option == $value['std']) { echo ' selected="selected"'; } ?>><?php echo $option; ?></option>

            <?php } ?>

          </select> <a class="thickbox" href="<?php echo $plugin_img; ?>fonts.gif"><img src="<?php echo $plugin_img; ?>/font-icon.png" /></a></div>

   

      

      <?php } else if ($value['type'] == "text") { ?>

 

        <div style="width:200px;float:left;"><?php echo $value['name']; ?> <input name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_option( $value['id'] ) != "") { echo get_option( $value['id'] ); } else { echo $value['std']; } ?>" style="width:100px;"/></div>



      

      <?php } elseif ($value['type'] == "color") { ?>



        

        <div style="width:150px;float:left;">

         <?php echo $value['name']; ?> <input name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" class="color {pickerMode:'HVS',pickerFaceColor:'#555555',pickerInsetColor:'black'}" value="<?php if ( get_option( $value['id'] ) != "") { echo get_option( $value['id'] ); } else { echo $value['std']; } ?>" style="width:80px;" />

		</div>

      

      <?php } else if ($value['type'] == "break") { ?>

      </td></tr></table>

      <?php } ?>

      <?php } ?>

      <table>

       <tr><td>

	<p class="submit">

	<input type="submit" name="Submit" value="Update options" />

	</p>

    </td></tr></table>



</form>

     

  </div>

  <?php

  

}



if (is_admin()) {

	

	$plugin_js = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)).'js/';

	wp_enqueue_script('jscolor', $plugin_js . 'jscolor/jscolor.js', array('jquery'));

	wp_enqueue_script('thickbox');

	wp_enqueue_style('thickbox');

	

}



if (!is_admin()) {

	

	$plugin_js = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)).'js/';

	

	

	$selector = array('title', 'tagline', 'posttitle', 'sbtitle', 'tftitles', 'fftitles', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'cs1', 'cs2', 'cs3');

	

	wp_enqueue_script('cufon', $plugin_js . 'cufon.js', array());

	

	

	foreach ($selector as $value)

	{

		$fontvalue = get_option('flexpf_' . $value . '');

		$fontfile = strtolower($fontvalue);

		if ( $fontvalue != "default" ) 

		{

			wp_enqueue_script(''. $fontfile . '', $plugin_js . $fontfile . '.font.js', array());

	

		}

		

	

	}

	

function cufonnow() {

	echo '<script type="text/javascript"> Cufon.now(); </script>';

}



add_action('wp_footer', 'cufonnow');

	

function load_into_head() { 



$selector = array('title', 'tagline', 'posttitle', 'sbtitle', 'tftitles', 'fftitles', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'cs1', 'cs2', 'cs3');

	echo '<script type="text/javascript">';

	foreach ($selector as $value)

	{

		$fontvalue = get_option('flexpf_' . $value . '');

		$fontfile = strtolower($fontvalue);

		if ( $fontvalue != "default" ) 

		{

			if ($value == "title") { 

			echo 'Cufon.replace(\'#header h1, #header h3\', { fontFamily: "' . $fontfile . '" });';

			}

			

			else if ($value == "tagline") { 

			echo 'Cufon.replace(\'#header p.tagline\', { fontFamily: "' . $fontfile . '" });';

			}

			

			else if ($value == "posttitle") { 

			echo 'Cufon.replace(\'.posthead h1, .posthead h2, h2.pagetitle\', { fontFamily: "' . $fontfile . '" });';

			}

			

			else if ($value == "sbtitle") { 

			echo 'Cufon.replace(\'#sidebar h5, #left-sidebar h5\', { fontFamily: "' . $fontfile . '" });';

			}

			

			else if ($value == "tftitles") { 

			echo 'Cufon.replace(\'#feature h2\', { fontFamily: "' . $fontfile . '" });';

			}

			

			else if ($value == "fftitles") { 

			echo 'Cufon.replace(\'#footerfeature h2\', { fontFamily: "' . $fontfile . '" });';

			}

			

			else if ($value == "h1") { 

			echo 'Cufon.replace(\'.postcontent h1, #spwrap h1, #mainContent .postwrap h1\', { fontFamily: "' . $fontfile . '" });';

			}

			

			else if ($value == "h2") { 

			echo 'Cufon.replace(\'.postcontent h2, #spwrap h2, #mainContent .postwrap h2\', { fontFamily: "' . $fontfile . '" });';

			}

			

			else if ($value == "h3") { 

			echo 'Cufon.replace(\'.postcontent h3, #spwrap h3, #mainContent .postwrap h3\', { fontFamily: "' . $fontfile . '" });';

			}

			

			else if ($value == "h4") { 

			echo 'Cufon.replace(\'.postcontent h4, #spwrap h4, #mainContent .postwrap h4\', { fontFamily: "' . $fontfile . '" });';

			}

			

			else if ($value == "h5") { 

			echo 'Cufon.replace(\'.postcontent h5, #spwrap h5, #mainContent .postwrap h5\', { fontFamily: "' . $fontfile . '" });';

			}

			

			else if ($value == "h6") { 

			echo 'Cufon.replace(\'.postcontent h6, #spwrap h6, #mainContent .postwrap h6\', { fontFamily: "' . $fontfile . '" });';

			}

			

			else if ($value == "cs1") { 

			echo 'Cufon.replace(\'p.' . get_option('flexpf_cs1class') . '\', { fontFamily: "' . $fontfile . '" });';

			}

			

			else if ($value == "cs2") { 

			echo 'Cufon.replace(\'p.' . get_option('flexpf_cs2class') . '\', { fontFamily: "' . $fontfile . '" });';

			}

			

			else if ($value == "cs3") { 

			echo 'Cufon.replace(\'p.' . get_option('flexpf_cs3class') . '\', { fontFamily: "' . $fontfile . '" });';

			}

			

			

			

		}

		

	

	}



echo '</script>';



echo '<style type="text/css">';

if (get_option('flexpf_tagsize')) { 

	echo '#header p.tagline { font-size: ' . get_option('flexpf_tagsize') . 'px ;}';

}



echo '#header p.tagline { color: #' . get_option('flexpf_tagclr') . '}';



if (get_option('flexpf_h1') != "default") { 

	echo '.postcontent h1, #spwrap h1, #mainContent .postwrap h1 { font-size: ' . get_option('flexpf_h1size') . 'px ; color: #' . get_option('flexpf_h1_clr') . '}';

}

if (get_option('flexpf_h2') != "default") { 

	echo '.postcontent h2, #spwrap h2, #mainContent .postwrap h2 { font-size: ' . get_option('flexpf_h2size') . 'px ; color: #' . get_option('flexpf_h2_clr') . '}';

}

if (get_option('flexpf_h3') != "default") { 

	echo '.postcontent h3, #spwrap h3, #mainContent .postwrap h3 { font-size: ' . get_option('flexpf_h3size') . 'px ; color: #' . get_option('flexpf_h3_clr') . '}';

}

if (get_option('flexpf_h4') != "default") { 

	echo '.postcontent h4, #spwrap h4, #mainContent .postwrap h4 { font-size: ' . get_option('flexpf_h4size') . 'px ; color: #' . get_option('flexpf_h4_clr') . '}';

}

if (get_option('flexpf_h5') != "default") { 

	echo '.postcontent h5, #spwrap h5, #mainContent .postwrap h5 { font-size: ' . get_option('flexpf_h5size') . 'px ; color: #' . get_option('flexpf_h5_clr') . '}';

}

if (get_option('flexpf_h6') != "default") { 

	echo '.postcontent h6, #spwrap h6, #mainContent .postwrap h6 { font-size: ' . get_option('flexpf_h6size') . 'px ; color: #' . get_option('flexpf_h6_clr') . '}';

}

if (get_option('flexpf_cs1class')) { 

	echo '.' . get_option('flexpf_cs1class') . ' { font-size: ' . get_option('flexpf_cs1size') . 'px ; color: #' . get_option('flexpf_cs1_clr') . '}';

}

if (get_option('flexpf_cs2class')) { 

	echo '.' . get_option('flexpf_cs2class') . ' { font-size: ' . get_option('flexpf_cs2size') . 'px ; color: #' . get_option('flexpf_cs2_clr') . '}';

}

if (get_option('flexpf_cs3class')) { 

	echo '.' . get_option('flexpf_cs3class') . ' { font-size: ' . get_option('flexpf_cs3size') . 'px ; color: #' . get_option('flexpf_cs3_clr') . '}';

}

echo '</style>';





} add_action( is_admin() ? 'admin_head' : 'wp_head', 'load_into_head' );



}

?>