<?php

/*

Copyright (c) 2012, Rich Ways LLC

All rights reserved.



Azon FlyBox License

http://www.pluginsbyigor.com



1. Terms 



By using this software, you are agreeing to be bound by these Terms and Conditions of Use, all applicable laws and regulations, and agree that you are responsible for compliance with any applicable local laws. If you do not agree with any of these terms, you are prohibited from using this software. The materials contained in this software are protected by applicable copyright and trade mark law. 



2. Use License 



a. By using Azon FlyBox you agree and comply to Amazon.com Product Advertising API License Agreement found here: https://affiliate-program.amazon.com/gp/advertising/api/detail/agreement.html

b. You may use the Azon FlyBox software for the purposes of running a website on a number of domain names as allowed by your license. 

c. You may make a reasonable number of copies for backup purposes only. 

d. You may modify the Azon FlyBox software as per your requirements as long as the modifications would not circumvent the licensing system. 



3. Limitations 

a. You may not use Azon FlyBox on any domain not wholly owned by you. 

b. You may not distribute copies of the Azon FlyBox software or transfer any part of it to a 3rd party. 

c. You may not rent, lease, sell, or sub-license the Azon FlyBox software or copies of it.

d. You may not use the software to engage in any illegal activity. 

e. You may not circumvent the licensing system in any way. 



4. Disclaimer 



The materials on Azon FlyBox's website and the Azon FlyBox software are provided "as is". Azon FlyBox makes no warranties, expressed or implied, and hereby disclaims and negates all other warranties, including without limitation, implied warranties or conditions of merchantability, fitness for a particular purpose, or non-infringement of intellectual property or other violation of rights. Further, Azon FlyBox does not warrant or make any representations concerning the accuracy, likely results, or reliability of the use of the materials on its Internet web site or otherwise relating to such materials or on any sites linked to this site. 



5. Revisions and Errata 



The materials appearing on Azon FlyBox's web site could include technical, typographical, or photographic errors. Azon FlyBox does not warrant that any of the materials on its web site are accurate, complete, or current. Azon FlyBox may make changes to the materials contained on its web site at any time without notice. Azon FlyBox does not, however, make any commitment to update the materials. 



6. Links 



Azon FlyBox has not reviewed all of the sites linked to its Internet web site and is not responsible for the contents of any such linked site. The inclusion of any link does not imply endorsement by Azon FlyBox of the site. Use of any such linked web site is at the user's own risk. 



7. Site Terms of Use Modifications 



Azon FlyBox may revise these terms of use for its web site at any time without notice. By using this web site you are agreeing to be bound by the then current version of these Terms and Conditions of Use. 



8. Governing Law 



Any claim relating to Azon FlyBox's web site shall be governed by the laws of the State of Wisconsin (USA) without regard to its conflict of law provisions. 

*/

require_once(dirname(dirname(dirname(dirname(__FILE__)))).'/wp-load.php');

require_once(dirname(__FILE__).'/include/flybxfuncs.php');

require_once(dirname(__FILE__).'/include/admin_include.php');

require_once(dirname(__FILE__).'/app/models/templates.php');



if ( function_exists('current_user_can') && !current_user_can('manage_options') )

			die(__('Looks like your session expired. Try logging in again.'));

			

			



//BOF prepopulate test data

/*$default_timezone = 'America/Chicago';

$flybx_categories = flybx_get_pop_messages();

$flybx_posts = get_posts(array('numberposts' => 30));

$flybx_asins = array('B004M6GXMW', 'B005P68KDI', 'B005KC8NH0', 'B001R4CDA8', 'B002DOME1E', 'B007077PXG', 'B00013TQRE', '939511347', 'B005AQ42CG', 'B005CAU242', 'B003EEMFTS', 'B003XHBZV0', 'B003TPE9VY', 'B004AKCMDO', 'B00005N89B', 'B000Y11B7G', 'B0013ND30M', 'B00570A9MW', 'B0006BFQJS', 'B004RPBD3M', 'B004SPC0EW', 'B001289VUE', 'B001RNO7DU', 'B000ELUXFC', 'B000ELUXFC', 'B000ELSSZE', 'B000EUD9OU', 'B003RPW7KG', 'B003D7MQWW', 'B000ELUXFC');



$startDate = new DateTime('2012/03/01',new DateTimeZone($default_timezone));

$endDate = new DateTime('2012/04/14',new DateTimeZone($default_timezone));

do

{

	//pre-populate stats for messages

	foreach($flybx_categories as $key => $cat_name)

	{

		$val = rand(240, 450);

		$wpdb->query("INSERT INTO ".$wpdb->prefix."flybx_stats SET action = 0, variation_type = 0, variation_value = ".$key.", year = ".$startDate->format("Y").", month = ".$startDate->format("m").", day = ".$startDate->format("d").", total =".$val);

		$rand_ctr = rand(90, 150);

		if ($key == 1)

		{

			$rand_ctr = rand(200, 400);

		}

		$wpdb->query("INSERT INTO ".$wpdb->prefix."flybx_stats SET action = 1, variation_type = 0, variation_value = ".$key.", year = ".$startDate->format("Y").", month = ".$startDate->format("m").", day = ".$startDate->format("d").", total =".ceil($val * ($rand_ctr / 10000)));

	}

	

	//pre-populate stats for posts

	foreach($flybx_posts as $curr_post)

	{

		$key = $curr_post->ID;

		$val = rand(50, 80);

		if ($key == 8)

		{

			$val = rand(80, 140);

		}

		$wpdb->query("INSERT INTO ".$wpdb->prefix."flybx_stats SET action = 0, variation_type = 1, variation_value = ".$key.", year = ".$startDate->format("Y").", month = ".$startDate->format("m").", day = ".$startDate->format("d").", total =".$val);

		$rand_ctr = rand(90, 150);

		if ($key == 8)

		{

			$rand_ctr = rand(200, 400);

		}

		$wpdb->query("INSERT INTO ".$wpdb->prefix."flybx_stats SET action = 1, variation_type = 1, variation_value = ".$key.", year = ".$startDate->format("Y").", month = ".$startDate->format("m").", day = ".$startDate->format("d").", total =".ceil($val * ($rand_ctr / 10000)));

	}

	

	//pre-populate stats for asins

	foreach($flybx_asins as $curr_asin)

	{

		$key = $curr_asin;

		$val = rand(50, 80);

		$wpdb->query("INSERT INTO ".$wpdb->prefix."flybx_stats SET action = 0, variation_type = 2, variation_value = '".$key."', year = ".$startDate->format("Y").", month = ".$startDate->format("m").", day = ".$startDate->format("d").", total =".$val);

		$rand_ctr = rand(95, 150);

		if ($key == 'B004M6GXMW'|| $key == 'B002DOME1E')

		{

			$rand_ctr = rand(200, 400);

		}

		$wpdb->query("INSERT INTO ".$wpdb->prefix."flybx_stats SET action = 1, variation_type = 2, variation_value = '".$key."', year = ".$startDate->format("Y").", month = ".$startDate->format("m").", day = ".$startDate->format("d").", total =".ceil($val * ($rand_ctr / 10000)));

	}

	

	$startDate->modify("+1 day");

}

while ($startDate <= $endDate && $i < 7);

exit;*/

//EOF prepopulate test data



$flybx_stat_action = 0;

$flybx_stat_variation_type = 0;

$flybx_page_num = 0;

$results_total = 0;

$posts_per_page = 10;



if (in_array($_POST['stat_action'], array(0, 1, 2))) $flybx_stat_action = $_POST['stat_action'];

if (in_array($_POST['stat_variation_type'], array(0, 1, 2, 3))) $flybx_stat_variation_type = $_POST['stat_variation_type'];

$flybx_start_date = $_POST['start_date'];

$flybx_end_date = $_POST['end_date'];



if (is_numeric($_POST['page_num']))

{

	$flybx_page_num = $_POST['page_num'];

}



if ($flybx_stat_variation_type == 0)

{

	$flybx_templates = new flybx_templates;

	$flybx_templates = $flybx_templates->flybx_templates();

	

	$flybx_categories = array();

	foreach($flybx_templates['templates'] as $curr_template)

	{

		$flybx_categories[$curr_template['id']] = $curr_template['name'];

	}

	

	$results_total = count($flybx_categories);

}

if ($flybx_stat_variation_type == 3)

{

	$flybx_categories = flybx_active_tpls_stats();

	$results_total = count($flybx_categories);

}

elseif ($flybx_stat_variation_type == 1)

{

	$flybx_posttypes_str = get_option('flybx_posttypes');

	$flybx_posttypes = explode(',', $flybx_posttypes_str);

	



	foreach($flybx_posttypes as $curr_posttype)

	{

		$results_total = $results_total + wp_count_posts( $curr_posttype )->publish;

	}

	$the_query = new WP_Query( array( 'post_type' => $flybx_posttypes, 'posts_per_page' => $posts_per_page, 'offset' => ($flybx_page_num * $posts_per_page) ) );

	// The Loop

	while ( $the_query->have_posts() ) : $the_query->the_post();

		/*echo '<pre>';

		print_r($post);

		echo '</pre>';*/

		$flybx_categories[$post->ID] = $post->post_title;

	endwhile;



	// Reset Query

	wp_reset_query();

}

elseif ($flybx_stat_variation_type == 2)

{

	$default_timezone = 'America/Chicago';

	if (ini_get('date.timezone')) {

		$default_timezone = ini_get('date.timezone');

	}

	

	$startDate = new DateTime($flybx_start_date,new DateTimeZone($default_timezone));

	$endDate = new DateTime($flybx_end_date,new DateTimeZone($default_timezone));

	$todayDate = new DateTime(date('m/d/Y'),new DateTimeZone($default_timezone));

	if ($endDate > $todayDate)

	{

		$endDate = $todayDate;

	}

	$sql_dates_arr = array();

	

	$i = 0;

	while ($startDate <= $endDate && $i < 7)

	{

		$sql_dates_arr[] = " (year = ".$startDate->format("Y")." AND month = ".$startDate->format("m")." AND day = ".$startDate->format("d").") ";

		$startDate->modify("+1 day");

		$i++;

	}

	

	$total_res = $wpdb->get_row("SELECT COUNT(cid) as total FROM ".$wpdb->prefix."flybx_stats WHERE action = 0 AND variation_type = ".$flybx_stat_variation_type." AND (".implode(' OR ', $sql_dates_arr).") GROUP BY variation_value ORDER BY total DESC ");

	$results_total = $total_res->total;

	$res = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."flybx_stats WHERE action = 0 AND variation_type = ".$flybx_stat_variation_type." AND (".implode(' OR ', $sql_dates_arr).") GROUP BY variation_value ORDER BY total DESC LIMIT ".($flybx_page_num * $posts_per_page).",".$posts_per_page);

	

	foreach($res as $row)

	{

		$flybx_categories[$row->variation_value] = $row->variation_value;

	}

}



?>



<?php if (count($flybx_categories) == 0): ?>

	<div style="font-weight: bold; margin: 10px;"><?php _e('No data found for given dates range. Try different dates.', $flybx_plugin_slug); ?></div>

<?php endif; ?>



<table class="flybx_graph" id="flybx_graph"> 

	<caption><?php if($flybx_stat_action == 0): ?><?php _e('Pop ups', $flybx_plugin_slug); ?><?php elseif ($flybx_stat_action == 1):?><?php _e('Clicks', $flybx_plugin_slug); ?><?php else: ?><?php _e('CTR %', $flybx_plugin_slug); ?><?php endif; ?></caption> 

	<caption id="legend"><?php if($flybx_stat_action == 0): ?><?php _e('Pops', $flybx_plugin_slug); ?><?php elseif ($flybx_stat_action == 1):?><?php _e('Clicks', $flybx_plugin_slug); ?><?php else: ?><?php _e('CTR %', $flybx_plugin_slug); ?><?php endif; ?></caption> 

	<thead><td></td>

	<?php 

	

	?>

	

	<?php if (count($flybx_categories) > 0): ?>

	<?php foreach($flybx_categories as $curr_stat_cat): ?>

		<th><?=$curr_stat_cat;?></th>

	<?php endforeach; ?>

	<?php endif; ?>



	</thead> 

	<tbody> 

		

		<?php

		$default_timezone = 'America/Chicago';

		if (ini_get('date.timezone')) {

			$default_timezone = ini_get('date.timezone');

		}

		

		$startDate = new DateTime($flybx_start_date,new DateTimeZone($default_timezone));

		$endDate = new DateTime($flybx_end_date,new DateTimeZone($default_timezone));

		$todayDate = new DateTime(date('m/d/Y'),new DateTimeZone($default_timezone));

		if ($endDate > $todayDate)

		{

			$endDate = $todayDate;

		}



		$i = 0;

		do 

		{

			?>

			

			<tr><th><?=$startDate->format("m/d");?></th>

			<?php if ($results_total > 0): ?>

			<?php foreach($flybx_categories as $key => $curr_stat_cat): ?>

				<?php 

				$stat_total = 0;

				if ($flybx_stat_action == 2)

				{

					//requesting CTRs					

					$total_clicks = 0;

					$total_pops = 0;

					//get clicks

					$res = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."flybx_stats WHERE action = 1 AND variation_type = ".$flybx_stat_variation_type." AND variation_value = '".$key."' AND year = ".$startDate->format("Y")." AND month = ".$startDate->format("m")." AND day = ".$startDate->format("d")."");

					if ($res !== NULL)

					{

						$total_clicks = $res->total;

					}

					if ($total_clicks > 0)

					{

						//get pops

						$res = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."flybx_stats WHERE action = 0 AND variation_type = ".$flybx_stat_variation_type." AND variation_value = '".$key."' AND year = ".$startDate->format("Y")." AND month = ".$startDate->format("m")." AND day = ".$startDate->format("d")."");

						if ($res !== NULL)

						{

							$total_pops = $res->total;

						}

						if ($total_pops > 0)

						{

							$stat_total = $total_clicks / $total_pops * 100000;

						}

					}

				

				}

				else

				{

					$res = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."flybx_stats WHERE action = ".$flybx_stat_action." AND variation_type = ".$flybx_stat_variation_type." AND variation_value = '".$key."' AND year = ".$startDate->format("Y")." AND month = ".$startDate->format("m")." AND day = ".$startDate->format("d")." ORDER BY total DESC");

					/*echo '<br />'."SELECT * FROM ".$wpdb->prefix."flybx_stats WHERE action = ".$flybx_stat_action." AND variation_type = ".$flybx_stat_variation_type." AND variation_value = '".$key."' AND year = ".$startDate->format("Y")." AND month = ".$startDate->format("m")." AND day = ".$startDate->format("d")." ORDER BY total DESC";

					echo '<pre>';

					print_r($res);

					echo '</pre>';*/

					if ($res !== NULL)

					{

						$stat_total = $res->total;

					}

				}

				?> 

				<td><?=$stat_total;?></td>

			<?php endforeach; ?>

			<?php endif; ?>

			<?php /*<td><?=(rand(0, 150));?></td><td><?=(rand(0, 150));?></td><td><?=(rand(0, 150));?></td>  */ ?>

			

			</tr> 

			<?php

			$startDate->modify("+1 day");

			$i++;

		}

		while ($startDate <= $endDate && $i < 7);

		?>

		

		



		 

	</tbody> 

</table>







<input type="hidden" id="curr_stat_action" value="<?=$flybx_stat_action;?>" />

<input type="hidden" id="curr_stat_type" value="<?=$flybx_stat_variation_type;?>" />

<input type="hidden" id="curr_stat_page" value="<?=$flybx_page_num;?>" />

<?php 

echo 'Page '.($flybx_page_num + 1).' of '.ceil($results_total / $posts_per_page);

if ($flybx_stat_variation_type == 1 || $flybx_stat_variation_type == 2)

{

	if ($results_total > $posts_per_page && $flybx_page_num > 0)

	{

		echo '&nbsp;&nbsp;<a href="javascript: void(0);" onclick="javascript: flybx_load_stats(jQuery(\'#flybx_stat_action\').val(), '.$flybx_stat_variation_type.', '.($flybx_page_num - 1).');">&lt; '.__('Prev', $flybx_plugin_slug).'</a>';

	}

	if ($results_total > $posts_per_page && $flybx_page_num > 0 && $results_total > ($flybx_page_num + 1) * $posts_per_page)

	{

		echo ' | ';

	}

	if ($results_total > ($flybx_page_num + 1) * $posts_per_page)

	{

		echo '&nbsp;&nbsp;<a href="javascript: void(0);" onclick="javascript: flybx_load_stats(jQuery(\'#flybx_stat_action\').val(), '.$flybx_stat_variation_type.', '.($flybx_page_num + 1).');">'.__('Next', $flybx_plugin_slug).' &gt;</a>';

	}

}

