<?php
if(!defined('ABSPATH')) die('Direct access not permitted');

include(dirname(dirname(dirname(__FILE__))).'/include/flybx_amz_avail_attr.php');
require_once(dirname(dirname(dirname(__FILE__))).'/include/flybx_amz_funcs.php');

require_once(dirname(dirname(__FILE__)).'/libraries/validation.php');
$validation = new flybx_validation;
//templates
require_once(dirname(dirname(__FILE__)).'/models/templates.php');
$template = new flybx_templates;
$available_sizes = $template->available_sizes();
$available_positions = $template->available_positions();
$available_animations = $template->available_animations(FALSE, '');
$available_templates = $template->available_templates();
$available_search_methods = $template->available_search_methods();
$templates_data = $template->templates_data();

$available_best_picks = array('none' => 'None', 'lowestprice' => 'Lowest Price', 'highestprice' => 'Highest Price');

$flybx_subpage = 'list';
if (isset($_GET['subpage']) && in_array($_GET['subpage'], array('add', 'edit', 'delete'))) $flybx_subpage = $_GET['subpage'];

if ( !empty($_POST ) && '' == $error ) {
	/*echo '<div id="message" class="updated fade"><p><strong>'
	. __('Settings saved.') ;
	if (isset($flybx_additional_success) && $flybx_additional_success != '')
	{
		echo "<br />".$flybx_additional_success;
	}
	echo '</strong></p></div>';*/
	if (isset($flybx_wpfooter_warning) && $flybx_wpfooter_warning != '')
	{
		echo '<div id="message" class="error"><p><strong>'
	. __($flybx_wpfooter_warning) . '</strong></p></div>';
	}
}

if ($flybx_subpage == 'list')
{		
	$flybx_default_tplid = flybx_get_default_tplid($templates_data);
	include(dirname(dirname(__FILE__)).'/views/templates.php');
}
elseif ($flybx_subpage == 'add')
{
	//Add New Ad Unit Page
	
	//declare validation rules
	$validation->set_rule('template_name', 'Name', 'trim|required');
	$validation->set_rule('flybx_position', 'Template Placement', 'required|check_sticky');
	$validation->set_rule('flybx_salebadge', 'Sale Badge', 'required');
	$validation->set_rule('flybx_active', 'Active Status', 'required');
	$validation->set_rule('flybx_single_only', 'Restrict to Post/Page View', 'required');
	//$validation->set_rule('flybx_alignment', 'Alignment', 'required');
	$validation->set_rule('flybx_margin_top', 'Margin Top', 'trim|is_numeric');
	$validation->set_rule('flybx_margin_right', 'Margin Right', 'trim|is_numeric');
	$validation->set_rule('flybx_margin_bottom', 'Margin Bottom', 'trim|is_numeric');
	$validation->set_rule('flybx_margin_left', 'Margin Left', 'trim|is_numeric');
	$validation->set_rule('flybx_margin_bottom', 'Margin Bottom', 'trim|is_numeric');
	$validation->set_rule('flybx_margin_left', 'Margin Left', 'trim|is_numeric');
	$validation->set_rule('flybx_attrs', 'Please select at least one attribute. Attributes field', 'required_checkbox');
	$validation->set_rule('flybx_design', 'Design', '');
	$validation->set_rule('flybx_max_attrs', 'Max Attributes to Show', 'required|is_numeric');
	$validation->set_rule('flybx_make_default', 'Default', 'required');
	$validation->set_rule('flybx_odd_color', 'Odd Rows Color', 'required');
	$validation->set_rule('flybx_even_color', 'Even Rows Color', 'required');
	$validation->set_rule('flybx_text_color', 'Text Color', 'required');
	$validation->set_rule('flybx_tabbg_color', 'Tabs Bg Color', 'required');
	$validation->set_rule('flybx_tabstext_color', 'Price Text Color', 'required');
	$validation->set_rule('flybx_bestpickbg_color', 'Best Pick BG Color', 'required');
	$validation->set_rule('flybx_bestpicktext_color', 'Best Pick Text Color', 'required');
	$validation->set_rule('flybx_footer_color', 'Footer BG Color', 'required');
	$validation->set_rule('flybx_best_pick', 'Best Pick Setting', 'required');
	//$validation->show_rules();
	
	if ($validation->run() === TRUE)
	{
		$new_template = array(
							'name' => $_POST['template_name'],
							'active' => $_POST['flybx_active'],
							'position' => $_POST['flybx_position'],
							'salebadge' => $_POST['flybx_salebadge'],
							'single_only' => $_POST['flybx_single_only'],
							/*'alignment' => $_POST['flybx_alignment'],*/
							'btn_text' => $_POST['flybx_btn_text'],
							'margin_top' => $_POST['flybx_margin_top'],
							'margin_right' => $_POST['flybx_margin_right'],
							'margin_bottom' => $_POST['flybx_margin_bottom'],
							'margin_left' => $_POST['flybx_margin_left'],
							'compare_mentioned' => $_POST['compare_mentioned'],
							'max_products' => $_POST['max_products'],
							'design' => $_POST['flybx_design'],
							'attrs' => $_POST['flybx_attrs'],
							'max_attrs' => $_POST['flybx_max_attrs'],
							'odd_color' => $_POST['flybx_odd_color'],
							'even_color' => $_POST['flybx_even_color'],
							'text_color' => $_POST['flybx_text_color'],
							'tabbg_color' => $_POST['flybx_tabbg_color'],
							'tabstext_color' => $_POST['flybx_tabstext_color'],
							'bestpickbg_color' => $_POST['flybx_bestpickbg_color'],
							'bestpicktext_color' => $_POST['flybx_bestpicktext_color'],
							'footer_color' => $_POST['flybx_footer_color'],
							'best_pick' => $_POST['flybx_best_pick'],
							
							);
		$new_template['crits'] = array();
		if (isset($_POST['flybx_crit_attr']) && is_array($_POST['flybx_crit_attr']))
		{
			foreach($_POST['flybx_crit_attr'] as $crit_id => $crit_attr)
			{
				if (isset($_POST['flybx_crit_sign'][$crit_id]) && isset($_POST['flybx_crit_val'][$crit_id]) && strlen($_POST['flybx_crit_val'][$crit_id]) > 0)
				{
					$new_template['crits'][$crit_id] = array('attr' => $crit_attr, 'sign' => $_POST['flybx_crit_sign'][$crit_id], 'val' => $_POST['flybx_crit_val'][$crit_id]);
				}
			}
		}
		
		$new_template_id = $template->add_new($new_template);
		
		//save default template id if needed
		if ($_POST['flybx_make_default'] == 'yes')
		{
			flybx_update_option('default_tplid', $new_template_id);				
		}
		
		echo '<div id="message" class="updated fade"><p><strong>'
		. sprintf(__('Template Added.<br /><a href="admin.php?page=flybx-templates&subpage=edit&template_id=%s">Click Here to Edit the Template.</a>', $flybx_plugin_slug), $new_template_id);
		echo '</strong></p></div>';
		exit;
		
		//echo 'Save here!';
	}

	//$validation->debug();
	include(dirname(dirname(__FILE__)).'/views/template_add.php');
}
elseif ($flybx_subpage == 'edit')
{
	//Edit Ad Unit Page
	$template_id = FALSE;
	if (isset($_GET['template_id']) && is_numeric($_GET['template_id']) && isset($templates_data['templates'][$_GET['template_id']]))
	{
		$template_id = $_GET['template_id'];
	}
	if ($template_id === FALSE)
	{
		include(dirname(dirname(__FILE__)).'/views/templates.php');
	}
	else
	{
		$edit_template_default = $templates_data['templates'][$_GET['template_id']];
		//get current default template id
		$flybx_default_tplid = flybx_get_default_tplid($templates_data);
		
		//declare validation rules
		$validation->set_rule('template_name', 'Name', 'trim|required');
		$validation->set_rule('flybx_position', 'Template Placement', 'required|check_sticky');
		$validation->set_rule('flybx_salebadge', 'Sale Badge', 'required');
		$validation->set_rule('flybx_active', 'Active Status', 'required');
		$validation->set_rule('flybx_single_only', 'Restrict to Post/Page View', 'required');
		//$validation->set_rule('flybx_alignment', 'Alignment', 'required');
		$validation->set_rule('flybx_margin_top', 'Margin Top', 'trim|is_numeric');
		$validation->set_rule('flybx_margin_right', 'Margin Right', 'trim|is_numeric');
		$validation->set_rule('flybx_margin_bottom', 'Margin Bottom', 'trim|is_numeric');
		$validation->set_rule('flybx_margin_left', 'Margin Left', 'trim|is_numeric');
		$validation->set_rule('flybx_margin_bottom', 'Margin Bottom', 'trim|is_numeric');
		$validation->set_rule('flybx_margin_left', 'Margin Left', 'trim|is_numeric');
		$validation->set_rule('flybx_attrs', 'Please select at least one attribute. Attributes field', 'required_checkbox');
		$validation->set_rule('flybx_design', 'Design', '');
		$validation->set_rule('flybx_max_attrs', 'Max Attributes to Show', 'required|is_numeric');
		$validation->set_rule('flybx_make_default', 'Default', 'required');
		$validation->set_rule('flybx_odd_color', 'Odd Rows Color', 'required');
		$validation->set_rule('flybx_even_color', 'Even Rows Color', 'required');
		$validation->set_rule('flybx_text_color', 'Text Color', 'required');
		$validation->set_rule('flybx_tabbg_color', 'Tabs Bg Color', 'required');
		$validation->set_rule('flybx_tabstext_color', 'Price Text Color', 'required');
		$validation->set_rule('flybx_bestpickbg_color', 'Best Pick BG Color', 'required');
		$validation->set_rule('flybx_bestpicktext_color', 'Best Pick Text Color', 'required');
		$validation->set_rule('flybx_footer_color', 'Footer BG Color', 'required');
		$validation->set_rule('flybx_best_pick', 'Best Pick Setting', 'required');
		//$validation->show_rules();
		
		$available_animations = $template->available_animations(FALSE, $edit_template_default['size']);
		
		if ($validation->run() === TRUE)
		{
			$edit_template = array(
							'name' => $_POST['template_name'],
							'active' => $_POST['flybx_active'],
							'position' => $_POST['flybx_position'],
							'salebadge' => $_POST['flybx_salebadge'],
							'single_only' => $_POST['flybx_single_only'],
							/*'alignment' => $_POST['flybx_alignment'],*/
							'btn_text' => $_POST['flybx_btn_text'],
							'margin_top' => $_POST['flybx_margin_top'],
							'margin_right' => $_POST['flybx_margin_right'],
							'margin_bottom' => $_POST['flybx_margin_bottom'],
							'margin_left' => $_POST['flybx_margin_left'],
							'compare_mentioned' => $_POST['compare_mentioned'],
							'max_products' => $_POST['max_products'],
							'design' => $_POST['flybx_design'],
							'attrs' => $_POST['flybx_attrs'],
							'max_attrs' => $_POST['flybx_max_attrs'],
							'odd_color' => $_POST['flybx_odd_color'],
							'even_color' => $_POST['flybx_even_color'],
							'text_color' => $_POST['flybx_text_color'],
							'tabbg_color' => $_POST['flybx_tabbg_color'],
							'tabstext_color' => $_POST['flybx_tabstext_color'],
							'bestpickbg_color' => $_POST['flybx_bestpickbg_color'],
							'bestpicktext_color' => $_POST['flybx_bestpicktext_color'],
							'footer_color' => $_POST['flybx_footer_color'],
							'best_pick' => $_POST['flybx_best_pick'],
							
							);
			$edit_template['crits'] = array();
			if (isset($_POST['flybx_crit_attr']) && is_array($_POST['flybx_crit_attr']))
			{
				foreach($_POST['flybx_crit_attr'] as $crit_id => $crit_attr)
				{
					if (isset($_POST['flybx_crit_sign'][$crit_id]) && isset($_POST['flybx_crit_val'][$crit_id]) && strlen($_POST['flybx_crit_val'][$crit_id]) > 0)
					{
						$edit_template['crits'][$crit_id] = array('attr' => $crit_attr, 'sign' => $_POST['flybx_crit_sign'][$crit_id], 'val' => $_POST['flybx_crit_val'][$crit_id]);
					}
				}
			}
			
			$template->edit($template_id, $edit_template);
			
			//save default template id if needed
			if ($_POST['flybx_make_default'] == 'yes')
			{
				flybx_update_option('default_tplid', $_GET['template_id']);				
			}
			
			echo '<div id="message" class="updated fade"><p><strong>'
			. __('Changes saved.') ;
			if (isset($flybx_additional_success) && $flybx_additional_success != '')
			{
				echo "<br />".$flybx_additional_success;
			}
			echo '</strong></p></div>';
			//echo 'Save here!';
			$templates_data = $template->templates_data();
			$edit_template_default = $templates_data['templates'][$_GET['template_id']];
			$available_animations = $template->available_animations(FALSE, $edit_template_default['size']);
		}
		
		
		include(dirname(dirname(__FILE__)).'/views/template_edit.php');
	}
}
elseif ($flybx_subpage == 'delete')
{
	$template_id = FALSE;
	if (isset($_GET['template_id']) && is_numeric($_GET['template_id']) && isset($templates_data['templates'][$_GET['template_id']]))
	{
		$template_id = $_GET['template_id'];
		unset($templates_data['templates'][$template_id]);
		flybx_update_option('templates', serialize($templates_data));
		echo '<div id="message" class="updated fade"><p><strong>'.__('Template Deleted.') ;
		echo '<br /><a href="admin.php?page=flybx-templates">'.__('Go Back to Templates').'</a>';
		echo '</strong></p></div>';
				
	}
	else
	{
		echo '<div id="message" class="updated fade"><p><strong>'.__('Template Not Found.') ;
		echo '<br /><a href="admin.php?page=flybx-templates">'.__('Go Back to Templates').'</a>';
		echo '</strong></p></div>';
		
	}	
}