<?php
class flybx_templates
{
	
    public function __construct()
	{

	}
	
	public function available_sizes()
	{
		$sizes = array(
						'1' => '468 x 60',
						'2' => '728 x 90',
						'3' => '250 x 250',
						'4' => '200 x 200',
						'5' => '336 x 280',
						'6' => '300 x 250',
						'7' => '120 x 600',
						'8' => '160 x 600',
						'12' => '468 x 220',
						/*'51' => '180 x 500',*/
						);
		return $sizes;
	}
	
	public function available_positions()
	{
		$positions = array(						
						'1' => 'Widget',
						'2' => 'Short Code',
						'3' => 'Before Content',
						'4' => 'After Content',
						'5' => 'PHP Tag',				
						'7' => 'HTML Code'				
						);
		if (flybx_module_installed('amasticky_template')) $positions['6'] = 'Sticky';
		return $positions;
	}
	
	/*public function available_animations()
	{
		$animations = array(
						'1' => 'None',
						'2' => 'Top to Bottom',
						//'3' => 'Bottom to Top',
						//'4' => 'Top to Top',
						//'5' => 'Bottom to Bottom',
						'6' => 'Left to Left',
						'7' => 'Right to Right',
						'8' => 'Mixed Directions',
						'9' => 'Bingo',
						'10' => 'Fade Out - Fade In'
						);
		return $animations;
	}*/
	
	public function available_animations($return_full = FALSE, $parent_id = 0)
	{
		$animations = array(
						'1' => array(
								'name' => 'None',
								'parents' => array(0)
								),
						'2' => array(
								'name' => 'Drop From the Top',
								'parents' => array(1, 2, 12)
								),
						/*'3' => 'Bottom to Top',*/
						/*'4' => 'Top to Top',
						'5' => 'Bottom to Bottom',*/
						'6' => array(
								'name' => 'Left to Left',
								'parents' => array(1, 2, 7, 8, 9, 12)
								),
						'7' => array(
								'name' => 'Right to Right',
								'parents' => array(1, 2, 7, 8, 9, 12)
								),
						'8' => array(
								'name' => 'Mixed Directions',
								'parents' => array(1, 2, 12)
								),
						'9' => array(
								'name' => 'Up - Down - (Up)',
								'parents' => array(1, 2, 12)
								),
						'10' => array(
								'name' => 'Fade Out - Fade In',
								'parents' => array(1, 2, 3, 4, 5, 6, 7, 8, 9, 12)
								),
						'21' => array(
								'name' => 'Spin In/Out',
								'parents' => array(3, 4, 5, 6)
								),
						'22' => array(
								'name' => 'Drop from the Top',
								'parents' => array(3, 4, 5, 6)
								),
						'23' => array(
								'name' => 'Slide-In',
								'parents' => array(3, 4, 5, 6)
								),
						'30' => array(
								'name' => 'Left/Right Mix Up',
								'parents' => array(7, 8, 9)
								),
						);
		if ($return_full === TRUE)
		{
			return $animations;
		}
		else
		{
			//make a simple array
			$new_animations = array();
			foreach($animations as $key => $val)
			{
				if ($parent_id == 0 || in_array($parent_id, $val['parents']) || in_array(0, $val['parents']))
				{
					$new_animations[$key] = $val['name'];
				}
			}
			return $new_animations;
		}		
	}
	
	public function available_templates()
	{
		$templates = array(
						'1' => 'Blue',
						'2' => 'Red',
						'3' => 'Purple',
						'4' => 'Golden/Yellow',
						'5' => 'Brown',
						'6' => 'Green'
						);
		return $templates;
	}
	
	//amazon product search method
	public function available_search_methods()
	{
		$search_methods = array(
						'1' => 'Keywords Only',
						'2' => 'Similar Products',
						'3' => 'Accessories',

						);
		return $search_methods;
	}
	
	
	public function add_new($template = '')
	{
		if (is_array($template))
		{			
			$templates_data = $this->templates_data();
			$template['id'] = $templates_data['last_id'] + 1;
			$templates_data['last_id'] = $template['id'];
			//$templates_data['templates'] = array_merge($templates_data['templates'], array($template['id'] => $template));
			$templates_data['templates'][$template['id']] = $template;

			if (function_exists('flybx_update_option'))
			{
				flybx_update_option('templates', serialize($templates_data));
			}
			return $template['id'];
		}
		return FALSE;
	}
	
	public function edit($template_id = '0', $template = '')
	{
		if (is_array($template))
		{			
			$templates_data = $this->templates_data();
			$template['id'] = $template_id;
			$templates_data['templates'][$template_id] = $template;

			if (function_exists('flybx_update_option'))
			{
				flybx_update_option('templates', serialize($templates_data));
			}
			return TRUE;
		}
		return FALSE;
	}
	
	public function templates_data()
	{
		if (function_exists('flybx_get_option'))
		{
			$current_templates_str = flybx_get_option('appearance');
			$templates_data = unserialize($current_templates_str);
			
			if (is_array($templates_data) && count($templates_data) > 0) 
			{				
				return $templates_data;
			}
		}
		
		return array(
				'animation' => 'flyout',
				'offset' => '200px',
				'trigger_element_toggle' => 'off',
				'trigger_element' => '',
				'position' => 'right',
				'max_products' => '2',
				'bottom_margin' => '0',
				'branding' => 'no',
				'links_color' => '#21759B',
				'price_color' => '#EB552D',
				'descr_color' => '#444444',
				'bg_color' => '#FFFFFF',
				'buybtn' => 'blue',
				);
	}
	
	public function get_by_id($template_id = 0)
	{
		if ($template_id != 0)
		{
			$templates_data = $this->templates_data();
			if (isset($templates_data['templates'][$template_id]))
			{				
				return $templates_data['templates'][$template_id];
			}
		}
		return FALSE;
	}
	
	public function template_html_init($template = FALSE, $post_id = 0, $content = '')
	{
		global $flybx_unique_template_id, $post, $flybx_sim_asins;	
		
		$debugg_flybx = FALSE;
		
		//only run ajax once
		if ($flybx_unique_template_id != 0) return '';
	
		//check if restrict to single
		if ($post_id != 0 && !is_single($post_id) && !is_page($post_id) && !is_front_page()) return '';
		
		//check if hide on certain post types		
		$flybx_posttypes = explode(',', get_option('flybx_posttypes'));
		if ($post_id != 0)
		{			
			$post_type = get_post_type($post_id);
			if (!in_array($post_type, $flybx_posttypes) || (is_front_page() && !in_array('frontpage', $flybx_posttypes)))
			{
				return '';
			}			
		}

		//check if disabled for category
		$categories = get_the_category($post_id);
		$cat_amzn_off = false;
		if (is_array($categories) && count($categories) > 0)
		{
			$amzn_disabled_categories = explode(',', get_option('flybx_amzn_disabled_categories'));
			foreach($categories as $curr_category)
			{
				if (in_array($curr_category->term_id, $amzn_disabled_categories))
				{
					$cat_amzn_off = true;
				}
			}
		}
		if ($cat_amzn_off && count($shorttag_kws) == 0) return '';

		//is plugin enabled through settings?
		$plugin_enabled = get_option('flybx_active');
		if (is_numeric($plugin_enabled) && $plugin_enabled == '1') 
		{
		}
		else
		{
			return '';
		}
		
		//check if allowed device type
		require_once(dirname(dirname(dirname(__FILE__))) . '/include/flybx_mobile_detect.php');
		$flybx_device_detect = new flybx_mobile_detect;
		$flybx_devicetype = ($flybx_device_detect->isMobile() ? ($flybx_device_detect->isTablet() ? 'tablet' : 'phone') : 'computer');
		$flybx_devicetypes_str = get_option('flybx_devicetypes');
		$flybx_devicetypes = explode(',', $flybx_devicetypes_str);
		if ($flybx_devicetypes_str === FALSE || (is_array($flybx_devicetypes) && in_array($flybx_devicetype, $flybx_devicetypes)))
		{		
		}
		else
		{
			return '';
		}

		//check if selected to hide templates on this page/post
		$meta_disable = get_post_meta($post_id, 'flybx_disable', true);
		if ($meta_disable == 'on' && count($shorttag_kws) == 0) return '';		
		//EOF On/Off checks
				
		$user_country = flybx_get_locale();
		if ($user_country == 'gb') $user_country = 'uk';
		
		$aff_network = 'amz';
		$flybx_am_params = array(
								'key_id' => get_option('flybx_am_key_id'), 
								'access_key' => get_option('flybx_am_access_key'),
								'associate_tag' => flybx_get_locale_tag($user_country),
								);
		
		//shortcode placement but no keywords for this locale
		if (count($shorttag_kws) > 0 && !isset($shorttag_kws[$user_country]))
		{
			return '';
		}
		
		
		//add custom styling
		$html = '';
		/*$html = 
"<style>
.flybx_target_unq_".$flybx_unique_template_id." .flybx_mdl tr:nth-child(odd) .flybx_det, .flybx_target_unq_".$flybx_unique_template_id." .flybx_img_det {background-color: ".$template['odd_color']."!important;}
.flybx_target_unq_".$flybx_unique_template_id." .flybx_det, .flybx_target_unq_".$flybx_unique_template_id." .flybx_td_odd {background-color: ".$template['even_color']." !important; }
.flybx_target_unq_".$flybx_unique_template_id." .flybx_det {color: ".$template['text_color']."!important;}
.flybx_target_unq_".$flybx_unique_template_id." .flybx_tab, .flybx_target_unq_".$flybx_unique_template_id." a.flybx_buy_btn, .flybx_target_unq_".$flybx_unique_template_id." a.flybx_buy_btn:active, .flybx_target_unq_".$flybx_unique_template_id." a.flybx_buy_btn:visited, .flybx_target_unq_".$flybx_unique_template_id." .flybx_hghl_col a.flybx_buy_btn:hover, .flybx_target_unq_".$flybx_unique_template_id." .flybx_hghl_col .flybx_btm_ins a.flybx_buy_btn:hover , .flybx_target_unq_".$flybx_unique_template_id." .flybx_hghl_col .flybx_det a.flybx_buy_btn:hover, .flybx_target_unq_".$flybx_unique_template_id." .flybx_row_hghl {background-color: ".$template['tabbg_color']." !important;}
.flybx_target_unq_".$flybx_unique_template_id." .flybx_tab, .flybx_target_unq_".$flybx_unique_template_id." .flybx_row_hghl a, .flybx_target_unq_".$flybx_unique_template_id." .flybx_row_hghl a:active, .flybx_target_unq_".$flybx_unique_template_id." .flybx_row_hghl a:visited, .flybx_target_unq_".$flybx_unique_template_id." .flybx_row_hghl a:hover, .flybx_target_unq_".$flybx_unique_template_id." .flybx_old_price, .flybx_target_unq_".$flybx_unique_template_id." a.flybx_buy_btn, .flybx_target_unq_".$flybx_unique_template_id." a.flybx_buy_btn:active, .flybx_target_unq_".$flybx_unique_template_id." a.flybx_buy_btn:visited {color: ".$template['tabstext_color']." !important;}
.flybx_target_unq_".$flybx_unique_template_id." .flybx_hghl_col a.flybx_buy_btn, .flybx_target_unq_".$flybx_unique_template_id." .flybx_hghl_col a.flybx_buy_btn:active, .flybx_target_unq_".$flybx_unique_template_id." .flybx_hghl_col a.flybx_buy_btn:visited, .flybx_target_unq_".$flybx_unique_template_id." .flybx_btm a.flybx_buy_btn:hover, .flybx_target_unq_".$flybx_unique_template_id." .flybx_det a.flybx_buy_btn:hover, .flybx_target_unq_".$flybx_unique_template_id." .flybx_hghl_col .flybx_tab, .flybx_target_unq_".$flybx_unique_template_id." .flybx_hghl_col .flybx_price, .flybx_target_unq_".$flybx_unique_template_id." .flybx_hghl_col .flybx_row_hghl {background-color: ".$template['bestpickbg_color']." !important; color: ".$template['bestpicktext_color']." !important;}
.flybx_target_unq_".$flybx_unique_template_id." .flybx_btm {background-color: ".$template['footer_color']."!important;}
</style>";*/
		
		//checking if we have products cached
		if (count($shorttag_kws) > 0 && isset($shorttag_kws[$user_country]) && count($shorttag_kws[$user_country]) > 0)
		{
			$kws = $shorttag_kws[$user_country];
		}
		else
		{
			$kws = flybx_get_post_keywords($post_id, 0, $user_country);
		}

		if ($kws == 'doajax')
		{
			$html .= '<script type="text/javascript">jQuery(document).ready(function(){if (window.flybx_load_sim_kws) { flybx_load_sim_kws(\''.$post_id.'\', \''.$user_country.'\', \''.implode(',', $flybx_sim_asins).'\'); } });</script>';
			$flybx_unique_template_id++;
			return $html;
		}
		else
		{
			if (!is_array($kws) || count($kws) == 0) return '';
			//$html .= '<script type="text/javascript">jQuery(document).ready(function(){if (window.flybx_load_res) { flybx_load_res(\''.$post_id.'\', \''.$user_country.'\', \''.implode(',', $kws).'\'); } });</script>';
			$html .= "\n".'<script type="text/javascript">jQuery(document).ready(function(){ flybx_load_res(\''.$post_id.'\', \''.$user_country.'\', \''.implode(',', $kws).'\'); });</script>';
			//$html .= '<script type="text/javascript">flybx_load_res(\''.$post_id.'\', \''.$user_country.'\', \''.implode(',', $kws).'\');</script>';
			$flybx_unique_template_id++;
			return $html;
		}
		//$flybx_amz_data = flybx_get_cached_data($post_id, $kws, $flybx_am_params, $user_country);
		
		echo 'amz_data is';
		echo '<pre>';
		print_r($kws);
		//print_r($flybx_amz_data);
		echo '</pre>';
		exit;
		
		$html = '<div class="flybx_template flybx_template_'.$template_id.' flybx_template_unq_'.$flybx_unique_template_id.'" style="';
		
		if ($template['size'] == '1') $html .= 'width: 468px; height: 60px;';
		if ($template['size'] == '2') $html .= 'width: 728px; height: 90px;';
		if ($template['size'] == '3') $html .= 'width: 250px; height: 250px;';
		if ($template['size'] == '4') $html .= 'width: 200px; height: 200px;';
		if ($template['size'] == '5') $html .= 'width: 336px; height: 280px;';
		if ($template['size'] == '6') $html .= 'width: 300px; height: 250px;';
		if ($template['size'] == '7') $html .= 'width: 120px; height: 600px;';
		if ($template['size'] == '8') $html .= 'width: 160px; height: 600px;';
		if ($template['size'] == '12') $html .= 'width: 468px; height: 220px;';
		
		//margins
		if ($template['position'] != '6') $html .= ' margin-top: '.$template['margin_top'].'px;';
		if ($template['position'] != '6') $html .= ' margin-bottom: '.$template['margin_bottom'].'px;';
		if ($template['alignment'] != 'center') $html .= ' margin-left: '.$template['margin_left'].'px;';
		if ($template['alignment'] != 'center') $html .= ' margin-right: '.$template['margin_right'].'px;';
		
		//alignment settings
		if ($template['alignment'] == 'left') $html .= ' float: left; clear: left;';
		if ($template['alignment'] == 'right') $html .= ' float: right; clear: right;';
		if ($template['alignment'] == 'center') $html .= ' margin-left: auto; margin-right: auto; clear: both;';
		
		//sticky template
		if ($template['position'] == '6') {
			$html .= ' position: fixed; top: 50px;';
			if ($template['alignment'] == 'left') $html .= ' left: 10px;';
			if ($template['alignment'] == 'right') $html .= ' right: 10px;';
		}
		
		$html .= '"></div>';
		
		
		
		$aff_network = 'amz';
		
		//ignore below; may be used for future developments
		/*$epn_enabled = flybx_get_option('epn_enabled');
		$amzn_enabled = flybx_get_option('flybx_amzn_active');
		if (is_numeric($amzn_enabled) && $amzn_enabled == '1') 
		{
			$aff_network = 'amz';
			if ($debugg_flybx) echo '<br />flybx: '.__LINE__;
		}
		else
		{
			$aff_network = 'epn';
			if ($debugg_flybx) echo '<br />flybx: '.__LINE__;
		}
		//both amzn and epn disabled
		if (is_numeric($epn_enabled) && $epn_enabled == '0' && is_numeric($amzn_enabled) && $amzn_enabled == '0')
		{
			return '';
		}
		
		//get network		
		if (flybx_module_installed('epn'))
		{
			$epn_enabled = flybx_get_option('epn_enabled');
			if (is_numeric($epn_enabled) && $epn_enabled == '1')
			{
				$source_sequence = flybx_get_option('source_sequence');
				$epn_pops_share = flybx_get_option('epn_pops_share');
				if (($source_sequence + ($flybx_unique_template_id * 10)) <= $epn_pops_share)
				{
					$aff_network = 'epn';
					if ($debugg_flybx) echo '<br />flybx: '.__LINE__;
				}
			}
		}
		//check if epn or amzn turned off for the category
		$categories = get_the_category($post_id);
		$cat_epn_off = false;
		$cat_amzn_off = false;
		if (is_array($categories) && count($categories) > 0)
		{
			$amzn_disabled_categories = explode(',', get_option('flybx_amzn_disabled_categories'));
			$epn_disabled_categories = explode(',', get_option('flybx_epn_disabled_categories'));
			foreach($categories as $curr_category)
			{
				if (in_array($curr_category->term_id, $amzn_disabled_categories))
				{
					$cat_amzn_off = true;
				}
				if (in_array($curr_category->term_id, $epn_disabled_categories))
				{
					$cat_epn_off = true;
				}
			}
			
			//amzn off but epn on
			
			if ($cat_amzn_off === TRUE && flybx_module_installed('epn') && is_numeric($epn_enabled) && $epn_enabled == '1' && $cat_epn_off === FALSE)
			{
				$aff_network = 'epn';
				if ($debugg_flybx) echo '<br />flybx: '.__LINE__;
			}
			//epn off but amzn on
			
			if ($cat_epn_off === TRUE && is_numeric($amzn_enabled) && $amzn_enabled == '1' && $cat_amzn_off === FALSE)
			{
				$aff_network = 'amz';
				if ($debugg_flybx) echo '<br />flybx: '.__LINE__;
			}
			//both amzn and epn off
			if ($cat_epn_off === TRUE && $cat_amzn_off === TRUE)
			{
				return '';
			}
			//amzn disabled but epn unchecked
			if (is_numeric($amzn_enabled) && $amzn_enabled == '0' && $cat_epn_off === TRUE)
			{
				return '';
			}
			//epn disabled but amzn unchecked
			if (is_numeric($epn_enabled) && $epn_enabled == '0' && $cat_amzn_off === TRUE)
			{
				return '';
			}
		}
		
		//trying epn but capmaign id not set up
		if ($aff_network == 'epn')
		{
			$epn_campaign_id = flybx_get_option('epn_campaign_id');
			if (strlen($epn_campaign_id) == 0)
			{
				$aff_network = 'amz';
				if ($debugg_flybx) echo '<br />flybx: '.__LINE__;
			}
		}
		
		//epn is disabled for the country but amz is on		
		$epn_country_enabled = flybx_get_option('epn_country_enabled_'.$user_country);
		if (is_numeric($epn_country_enabled) && $epn_country_enabled == '1')
		{
			$epn_country_enabled = TRUE;
		}
		else
		{
			$epn_country_enabled = FALSE;
		}
		
		$amz_assoc_tag_option = 'flybx_am_associate_tag';
		if ($user_country != 'us')
		{
			$amz_assoc_tag_option = 'flybx_locale_tag_'.$user_country;
		}
		$amz_country_tag = get_option($amz_assoc_tag_option);
		$amz_country_enabled = FALSE;		
		if ($amz_country_tag !== FALSE && strlen($amz_country_tag) > 1)
		{
			$amz_country_enabled = TRUE;
		}
		//Country specific: epn off - amz on 
		if ($aff_network == 'epn' && $epn_country_enabled === FALSE && $amz_country_enabled === TRUE)
		{
			$aff_network = 'amz';
			if ($debugg_flybx) echo '<br />flybx: '.__LINE__;
		}
		//Country specific: epn on - amz off 
		if ($aff_network == 'amz' && $amz_country_enabled === FALSE && $epn_country_enabled === TRUE)
		{
			$aff_network = 'epn';
			if ($debugg_flybx) echo '<br />flybx: '.__LINE__;
		}*/
		
		
		
		//add js
		$interval = intval($template['interval']);
		if ($interval < 1) $interval = 1; 
		$interval = $interval * 1000;
		$html .= '<script type="text/javascript">jQuery(document).ready(function(){if (window.flybx_load_template) { flybx_load_template(\''.$template_id.'\', \''.$post_id.'\', \''.$template['animation'].'\', \''.$interval.'\', \''.$template['size'].'\', \''.$flybx_unique_template_id.'\', \''.$aff_network.'\'); } });</script>';
		
		if ($template['position'] == '6') 
		{
			$curr_height = '600';
			if ($template['size'] == '1') $curr_height = '60';
			if ($template['size'] == '2') $curr_height = '90';
			if ($template['size'] == '3') $curr_height = '250';
			if ($template['size'] == '4') $curr_height = '200';
			if ($template['size'] == '5') $curr_height = '280';
			if ($template['size'] == '6') $curr_height = '250';

			$html .= '<script type="text/javascript">jQuery(document).ready(function(){ var top_diff = (jQuery(window).height() - '.$curr_height.'); if ( top_diff < 0) { top_diff = "20";} jQuery(".flybx_template_'.$template_id.'").css("top", (top_diff / 2)); jQuery(window).resize(function() {  var top_diff = (jQuery(window).height() - '.$curr_height.'); if ( top_diff < 0) { top_diff = "20";} jQuery(".flybx_template_'.$template_id.'").css("top", (top_diff / 2)); }); });</script>';
		}
		
		//$html .= '<script type="text/javascript">if (window.flybx_load_template) { flybx_load_template(\''.$template_id.'\', \''.$post_id.'\', \''.$template['animation'].'\', \''.$interval.'\'); };</script>';
		//$flybx_unique_template_id++;
		
		return $html;
	}
	
	
	
}