<?php
/*
Copyright (c) 2012, Rich Ways LLC
All rights reserved.

Azon FlyBox License
http://www.pluginsbyigor.com

1. Terms 

By using this software, you are agreeing to be bound by these Terms and Conditions of Use, all applicable laws and regulations, and agree that you are responsible for compliance with any applicable local laws. If you do not agree with any of these terms, you are prohibited from using this software. The materials contained in this software are protected by applicable copyright and trade mark law. 

2. Use License 

a. By using Azon FlyBox you agree and comply to Amazon.com Product Advertising API License Agreement found here: https://affiliate-program.amazon.com/gp/advertising/api/detail/agreement.html
b. You may use the Azon FlyBox software for the purposes of running a website on a number of domain names as allowed by your license. 
c. You may make a reasonable number of copies for backup purposes only. 
d. You may modify the Azon FlyBox software as per your requirements as long as the modifications would not circumvent the licensing system. 

3. Limitations 
a. You may not use Azon FlyBox on any domain not wholly owned by you. 
b. You may not distribute copies of the Azon FlyBox software or transfer any part of it to a 3rd party. 
c. You may not rent, lease, sell, or sub-license the Azon FlyBox software or copies of it.
d. You may not use the software to engage in any illegal activity. 
e. You may not circumvent the licensing system in any way. 

4. Disclaimer 

The materials on Azon FlyBox's website and the Azon FlyBox software are provided "as is". Azon FlyBox makes no warranties, expressed or implied, and hereby disclaims and negates all other warranties, including without limitation, implied warranties or conditions of merchantability, fitness for a particular purpose, or non-infringement of intellectual property or other violation of rights. Further, Azon FlyBox does not warrant or make any representations concerning the accuracy, likely results, or reliability of the use of the materials on its Internet web site or otherwise relating to such materials or on any sites linked to this site. 

5. Revisions and Errata 

The materials appearing on Azon FlyBox's web site could include technical, typographical, or photographic errors. Azon FlyBox does not warrant that any of the materials on its web site are accurate, complete, or current. Azon FlyBox may make changes to the materials contained on its web site at any time without notice. Azon FlyBox does not, however, make any commitment to update the materials. 

6. Links 

Azon FlyBox has not reviewed all of the sites linked to its Internet web site and is not responsible for the contents of any such linked site. The inclusion of any link does not imply endorsement by Azon FlyBox of the site. Use of any such linked web site is at the user's own risk. 

7. Site Terms of Use Modifications 

Azon FlyBox may revise these terms of use for its web site at any time without notice. By using this web site you are agreeing to be bound by the then current version of these Terms and Conditions of Use. 

8. Governing Law 

Any claim relating to Azon FlyBox's web site shall be governed by the laws of the State of Wisconsin (USA) without regard to its conflict of law provisions. 
*/

if(!defined('ABSPATH')) die('Direct access not premitted');


/*echo '<pre>';
print_r($flybx_lang);
print_r($flybx_lang_keys);
echo '</pre>';*/

if ($flybx_saved === TRUE)
{
	echo '<div id="message" class="updated fade"><p><strong>'
		. __('Settings saved.') ;
		if (isset($flybx_additional_success) && $flybx_additional_success != '')
		{
			echo "<br />".$flybx_additional_success;
		}
		echo '</strong></p></div>';
}

if ( !empty($_POST ) && '' != $error && isset($flybx_additional_error) && $flybx_additional_error != '') {
	echo '<div id="message" class="error"><p><strong>' . __($flybx_additional_error) . '</strong></p></div>';
}
?>



<div >
	<form method="post" action="" id="important_stuff_form" name="important_stuff_form" >
	<table class="form-table" style="min-width:750px; width: auto;">
		<tr><td class="reg black" colspan="2" noWrap="noWrap">
		<?php _e('You can change appearance settings of Fly Box on this screen.', $flybx_plugin_slug);?><br />
		<?php _e('If you have any questions check out our <a href="http://www.pluginsbyigor.com/azon-flybox-faq/" target="_blank">FAQ</a>', $flybx_plugin_slug);?></td></tr>
		<?php /*if (strlen($error) > 0): ?>
			<tr><td class="reg" colspan="2" style="color:red;" align="left"><?=$error;?></td></tr>
		<?php endif; */?>
		<tr><td colspan="2">
		
			<div class="metabox-holder flybx_appearance_metabox">
				<div id="submitdiv" class="postbox">
					<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $flybx_plugin_slug ); ?>"><br /></div>
					<h3 class="hndle"><?php echo strtoupper($curr_country); ?> Appearance Settings</h3>
					<div class="inside">
						<table class="form-table" style="width:auto;">	
							
							<tr class="form-field"><th style="width:150px;"><label for="flybx_animation"><?php _e('Animation', $flybx_plugin_slug); ?>:</label></th>
							<td>									
								<select name="flybx_animation" id="flybx_animation" >
									<option value="flyout" <?php echo $validation->set_select('flybx_animation', 'flyout', ($flybx_default_appearsett['animation'] == 'flyout')); ?>> Fly Out &nbsp; </option>
									<option value="fade" <?php echo $validation->set_select('flybx_animation', 'fade', ($flybx_default_appearsett['animation'] == 'fade')); ?>> Fade In / Fade Out &nbsp; </option>
									<option value="rollin" <?php echo $validation->set_select('flybx_animation', 'rollin', ($flybx_default_appearsett['animation'] == 'rollin')); ?>> Roll In / Roll Out &nbsp; </option>
								</select>
								<?php $validation->show_error('flybx_animation'); ?>
								
							</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="flybx_offset"><?php _e('Trigger Offset', $flybx_plugin_slug); ?>:</label></th>
							<td>									
								<input type="text" name="flybx_offset" style="width:120px;" value="<?php echo $validation->set_value('flybx_offset', $flybx_default_appearsett['offset']); ?>" /><?php $validation->show_error('flybx_offset'); ?><br />
								<span class="description">Percentage or pixel height of the page required to be scrolled to display a FlyBox (examples: 50% or 120px).</span><br />
								<input type="checkbox" name="flybx_trigger_element_toggle" id="flybx_trigger_element_toggle" value="on" <?php echo $validation->set_checkbox('flybx_trigger_element_toggle', 'on', $flybx_default_appearsett['trigger_element_toggle']); ?> style="width: 20px;" /><label for="flybx_trigger_element_toggle">Trigger when scrolling reaches HTML element:</label> 
								<input type="text" name="flybx_trigger_element" style="width:180px;" value="<?php echo $validation->set_value('flybx_trigger_element', $flybx_default_appearsett['trigger_element']); ?>" /><?php $validation->show_error('flybx_trigger_element'); ?><br />
								<span class="description">If not checked, all page length is taken for calculation using value of the previous field (percentage or pixels). 
								<br />If checked, make sure to use the ID or class of an existing element on the page. Put # "hash" before the ID, or . "dot" before a class name.</span>
													
								
								
							</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="flybx_position"><?php _e('Position', $flybx_plugin_slug); ?>:</label></th>
							<td>									
								<select name="flybx_position" id="flybx_position" >
									<option value="right" <?php echo $validation->set_select('flybx_position', 'right', ($flybx_default_appearsett['position'] == 'right')); ?>> Right &nbsp; </option>
									<option value="left" <?php echo $validation->set_select('flybx_position', 'left', ($flybx_default_appearsett['position'] == 'left')); ?>> Left &nbsp; </option>
								</select>
								<?php $validation->show_error('flybx_position'); ?>
								
							</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="flybx_max_products"><?php _e('Max Products', $flybx_plugin_slug); ?>:</label></th>
							<td>									
								<select name="flybx_max_products" id="flybx_max_products" >
									<option value="1" <?php echo $validation->set_select('flybx_max_products', '1', ($flybx_default_appearsett['max_products'] == '1')); ?>> 1 &nbsp; </option>
									<option value="2" <?php echo $validation->set_select('flybx_max_products', '2', ($flybx_default_appearsett['max_products'] == '2')); ?>> 2 &nbsp; </option>
									<option value="3" <?php echo $validation->set_select('flybx_max_products', '3', ($flybx_default_appearsett['max_products'] == '3')); ?>> 3 &nbsp; </option>
								</select>
								<?php $validation->show_error('flybx_max_products'); ?>								
							</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="flybx_bottom_margin"><?php _e('Bottom Margin', $flybx_plugin_slug); ?>:</label></th>
							<td>									

								<input type="text" name="flybx_bottom_margin" style="width:40px;" value="<?php echo $validation->set_value('flybx_bottom_margin', $flybx_default_appearsett['bottom_margin']); ?>" />px <?php $validation->show_error('flybx_bottom_margin'); ?><br />

							</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="flybx_branding"><?php _e('Show "powered by" Link', $flybx_plugin_slug); ?>:</label></th>
							<td>									
								<select name="flybx_branding" id="flybx_branding" >
									<option value="yes" <?php echo $validation->set_select('flybx_branding', 'yes', ($flybx_default_appearsett['branding'] == 'yes')); ?>> Yes &nbsp; </option>
									<option value="no" <?php echo $validation->set_select('flybx_branding', 'no', ($flybx_default_appearsett['branding'] == 'no')); ?>> No &nbsp; </option>
								</select>
								<span class="description"><?php _e('I appreciate if you leave this on to help spread the word :)', $flybx_plugin_slug); ?></span>
								<?php $validation->show_error('flybx_branding'); ?>								
							</td></tr>
							
							<tr class="form-field "><th style="width:150px;"><label for="flybx_links_color"><?php _e('Links Color', $cmprzn_plugin_slug); ?>:</label></th>
							<td>									
								<input type="text" id="flybx_links_color" name="flybx_links_color" value="<?php echo $validation->set_value('flybx_links_color', $flybx_default_appearsett['links_color']); ?>" style="width:220px;" />
								<span class="description"> <a href="#" class="flybx_tooltip" title="<?php esc_attr_e("Pick a color to be used for the links.", $flybx_plugin_slug); ?>"><?php _e('( ? )', $flybx_plugin_slug); ?></a></span></label>
								<div id="flybx_links_color_picker"></div>								
								<?php $validation->show_error('flybx_links_color'); ?>
								
							</td></tr>
							
							<tr class="form-field "><th style="width:150px;"><label for="flybx_price_color"><?php _e('Price Color', $flybx_plugin_slug); ?>:</label></th>
							<td>									
								<input type="text" id="flybx_price_color" name="flybx_price_color" value="<?php echo $validation->set_value('flybx_price_color', $flybx_default_appearsett['price_color']); ?>" style="width:220px;" />
								<span class="description"> <a href="#" class="flybx_tooltip" title="<?php esc_attr_e("Pick a color to be used for the price.", $flybx_plugin_slug); ?>"><?php _e('( ? )', $flybx_plugin_slug); ?></a></span></label>
								<div id="flybx_price_color_picker"></div>								
								<?php $validation->show_error('flybx_price_color'); ?>								
							</td></tr>
							
							<tr class="form-field "><th style="width:150px;"><label for="flybx_descr_color"><?php _e('Description Color', $flybx_plugin_slug); ?>:</label></th>
							<td>									
								<input type="text" id="flybx_descr_color" name="flybx_descr_color" value="<?php echo $validation->set_value('flybx_descr_color', $flybx_default_appearsett['descr_color']); ?>" style="width:220px;" />
								<span class="description"> <a href="#" class="flybx_tooltip" title="<?php esc_attr_e("Pick a color to be used for the description excerpt.", $flybx_plugin_slug); ?>"><?php _e('( ? )', $flybx_plugin_slug); ?></a></span></label>
								<div id="flybx_descr_color_picker"></div>								
								<?php $validation->show_error('flybx_descr_color'); ?>								
							</td></tr>
							
							<tr class="form-field "><th style="width:150px;"><label for="flybx_bg_color"><?php _e('Background Color', $flybx_plugin_slug); ?>:</label></th>
							<td>									
								<input type="text" id="flybx_bg_color" name="flybx_bg_color" value="<?php echo $validation->set_value('flybx_bg_color', $flybx_default_appearsett['bg_color']); ?>" style="width:220px;" />
								<span class="description"> <a href="#" class="flybx_tooltip" title="<?php esc_attr_e("Pick a color to be used for the background.", $flybx_plugin_slug); ?>"><?php _e('( ? )', $flybx_plugin_slug); ?></a></span></label>
								<div id="flybx_bg_color_picker"></div>								
								<?php $validation->show_error('flybx_bg_color'); ?>	

								<br /><br />
								<a href="javascript: void(0);" onclick="javascript: if (confirm('<?php echo esc_attr('Reset colors to default values? This will overwrite your color changes.', $flybx_plugin_slug); ?>')) { flybx_colors_reset(); };" style="float: right; display: block;">Reset Colors To Default</a>
							</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="flybx_buybtn"><?php _e('Buy Button', $flybx_plugin_slug); ?>:</label></th>
							<td>									
								<select name="flybx_buybtn" id="flybx_buybtn" >
									<option value="blue" <?php echo $validation->set_select('flybx_buybtn', 'blue', ($flybx_default_appearsett['buybtn'] == 'blue')); ?>> Blue &nbsp; </option>
									<option value="brown" <?php echo $validation->set_select('flybx_buybtn', 'brown', ($flybx_default_appearsett['buybtn'] == 'brown')); ?>> Brown &nbsp; </option>
									<option value="orange" <?php echo $validation->set_select('flybx_buybtn', 'orange', ($flybx_default_appearsett['buybtn'] == 'orange')); ?>> Orange &nbsp; </option>
									<option value="green" <?php echo $validation->set_select('flybx_buybtn', 'green', ($flybx_default_appearsett['buybtn'] == 'green')); ?>> Green &nbsp; </option>
									<option value="purple" <?php echo $validation->set_select('flybx_buybtn', 'purple', ($flybx_default_appearsett['buybtn'] == 'purple')); ?>> Purple &nbsp; </option>
									<option value="red" <?php echo $validation->set_select('flybx_buybtn', 'red', ($flybx_default_appearsett['buybtn'] == 'red')); ?>> Red &nbsp; </option>

								</select>
								<span class="description"><?php _e('', $flybx_plugin_slug); ?></span>
								<?php $validation->show_error('flybx_buybtn'); ?>								
							</td></tr>
							
						
						
						</table>
					</div>
				</div>
			</div>
			
			<?php /*
			<?php if (count($active_countries) > 0): ?>
				<?php foreach($active_countries as $curr_country): ?>
					<div class="metabox-holder">
						<div id="submitdiv" class="postbox">
							<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $flybx_plugin_slug ); ?>"><br /></div>
							<h3 class="hndle"><?php echo strtoupper($curr_country); ?> Language Settings</h3>
							<div class="inside">
								<table class="form-table" style="width:auto;">	
									
									<?php foreach($flybx_lang as $key => $lang_vals): ?>
										<?php if (isset($lang_vals['name']) && strlen($lang_vals['name']) > 0): ?>
											<tr class="form-field"><th style="width:150px;"><label >
											<?php if (isset($lang_vals['default'])): ?>
												<?php echo $lang_vals['default']; ?>
											<?php else: ?>
												<?php echo flybx_sanitize_lang($lang_vals['name']); ?>
											<?php endif; ?>
											</label></th>
												<td>
													<input type="text" name="<?php echo $key."[".$curr_country."]"; ?>" style="width:480px;" value="<?php echo flybx_sanitize_lang($validation->set_value($key."['".$curr_country."']", (isset($lang_vals[$curr_country])?$lang_vals[$curr_country]:flybx_lang($lang_vals['name'], $curr_country)))); ?>" />
													<?php if (isset($lang_vals['description'])): ?><br /><span class="description"><?php echo $lang_vals['description']; ?></span><?php endif; ?>
													<?php $validation->show_error('sform_unit_name'); ?>
												</td></tr>
										<?php endif; ?>
									<?php endforeach; ?>
								
								
								</table>
							</div>
						</div>
					</div>
				<?php endforeach; ?>
			<?php else: ?>
				Please enter Associate ID for at least one country under Amazon tab.
			<?php endif; ?>
			*/ ?>
			

				
			</td>
		</tr>
	</table>
		
	<table>
	<tr><td>&nbsp;</td><td class="submit"><input type="submit" name="btnsubmit" value="<?php esc_attr_e('Save Settings', $flybx_plugin_slug); ?>" class="button-primary" /></td></tr>
	</table>

	<input type="hidden" name="flybx_form_submitted" value="yes" />
	</form>
								
								
								
	
	
</div>