<?php
/*
Copyright (c) 2012, Rich Ways LLC
All rights reserved.

Azon FlyBox License
http://www.PluginsByIgor.com

1. Terms 

By using this software, you are agreeing to be bound by these Terms and Conditions of Use, all applicable laws and regulations, and agree that you are responsible for compliance with any applicable local laws. If you do not agree with any of these terms, you are prohibited from using this software. The materials contained in this software are protected by applicable copyright and trade mark law. 

2. Use License 

a. By using Azon FlyBox you agree and comply to Amazon.com Product Advertising API License Agreement found here: https://affiliate-program.amazon.com/gp/advertising/api/detail/agreement.html
b. You may use the Azon FlyBox software for the purposes of running a website on a number of domain names as allowed by your license. 
c. You may make a reasonable number of copies for backup purposes only. 
d. You may modify the Azon FlyBox software as per your requirements as long as the modifications would not circumvent the licensing system. 

3. Limitations 
a. You may not use Azon FlyBox on any domain not wholly owned by you. 
b. You may not distribute copies of the Azon FlyBox software or transfer any part of it to a 3rd party. 
c. You may not rent, lease, sell, or sub-license the Azon FlyBox software or copies of it.
d. You may not use the software to engage in any illegal activity. 
e. You may not circumvent the licensing system in any way. 

4. Disclaimer 

The materials on Azon FlyBox's website and the Azon FlyBox software are provided "as is". Azon FlyBox makes no warranties, expressed or implied, and hereby disclaims and negates all other warranties, including without limitation, implied warranties or conditions of merchantability, fitness for a particular purpose, or non-infringement of intellectual property or other violation of rights. Further, Azon FlyBox does not warrant or make any representations concerning the accuracy, likely results, or reliability of the use of the materials on its Internet web site or otherwise relating to such materials or on any sites linked to this site. 

5. Revisions and Errata 

The materials appearing on Azon FlyBox's web site could include technical, typographical, or photographic errors. Azon FlyBox does not warrant that any of the materials on its web site are accurate, complete, or current. Azon FlyBox may make changes to the materials contained on its web site at any time without notice. Azon FlyBox does not, however, make any commitment to update the materials. 

6. Links 

Azon FlyBox has not reviewed all of the sites linked to its Internet web site and is not responsible for the contents of any such linked site. The inclusion of any link does not imply endorsement by Azon FlyBox of the site. Use of any such linked web site is at the user's own risk. 

7. Site Terms of Use Modifications 

Azon FlyBox may revise these terms of use for its web site at any time without notice. By using this web site you are agreeing to be bound by the then current version of these Terms and Conditions of Use. 

8. Governing Law 

Any claim relating to Azon FlyBox's web site shall be governed by the laws of the State of Wisconsin (USA) without regard to its conflict of law provisions. 
*/

if(!defined('ABSPATH')) die('Direct access not premitted');


/*echo '<pre>';
print_r($flybx_lang);
print_r($flybx_lang_keys);
echo '</pre>';*/
?>
<?php flybx_prepare_postboxes(); ?>
<div >
	<form method="post" action="" id="important_stuff_form" name="important_stuff_form" >
	<table class="form-table" style="min-width:750px; width: auto;">
		<tr><td class="reg black" colspan="2" noWrap="noWrap">
		<?php _e('You can translate words and phrases for all active countries on this screen.', $flybx_plugin_slug);?><br />
		<?php _e('Active countries are the ones that have Associate tags assigned to them under Amazon tab.', $flybx_plugin_slug);?><br />
		<?php _e('If you have any questions check out our <a href="http://www.pluginsbyigor.com/azon-flybox-faq/" target="_blank">FAQ</a>', $flybx_plugin_slug);?></td></tr>
		<?php if (strlen($error) > 0): ?>
			<tr><td class="reg" colspan="2" style="color:red;" align="left"><?=$error;?></td></tr>
		<?php endif; ?>
		<tr><td colspan="2">
			
			<?php if (count($active_countries) > 0): ?>
				<?php foreach($active_countries as $curr_country): ?>
					<div class="metabox-holder">
						<div id="submitdiv" class="postbox">
							<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $flybx_plugin_slug ); ?>"><br /></div>
							<h3 class="hndle"><?php echo strtoupper($curr_country); ?> Language Settings</h3>
							<div class="inside">
								<table class="form-table" style="width:auto;">	
									
									<?php foreach($flybx_lang as $key => $lang_vals): ?>
										<?php if (isset($lang_vals['name']) && strlen($lang_vals['name']) > 0): ?>
											<tr class="form-field"><th style="width:150px;"><label >
											<?php if (isset($lang_vals['default'])): ?>
												<?php echo $lang_vals['default']; ?>
											<?php else: ?>
												<?php echo flybx_sanitize_lang($lang_vals['name']); ?>
											<?php endif; ?>
											</label></th>
												<td>
													<input type="text" name="<?php echo $key."[".$curr_country."]"; ?>" style="width:480px;" value="<?php echo flybx_sanitize_lang($validation->set_value($key."['".$curr_country."']", (isset($lang_vals[$curr_country])?$lang_vals[$curr_country]:flybx_lang($lang_vals['name'], $curr_country)))); ?>" />
													<?php if (isset($lang_vals['description'])): ?><br /><span class="description"><?php echo $lang_vals['description']; ?></span><?php endif; ?>
													<?php $validation->show_error('sform_unit_name'); ?>
												</td></tr>
										<?php endif; ?>
									<?php endforeach; ?>
								
								
								</table>
							</div>
						</div>
					</div>
				<?php endforeach; ?>
			<?php else: ?>
				Please enter Associate ID for at least one country under Amazon tab.
			<?php endif; ?>
			
			

				
			</td>
		</tr>
	</table>
		
	<table>
	<tr><td>&nbsp;</td><td class="submit"><input type="submit" name="btnsubmit" value="<?php esc_attr_e('Save Settings', $flybx_plugin_slug); ?>" class="button-primary" /></td></tr>
	</table>

	<input type="hidden" name="flybx_form_submitted" value="yes" />
	</form>
								
								
								
	
	
</div>