<?php
/*
Copyright (c) 2012, Rich Ways LLC
All rights reserved.

Azon FlyBox License
http://www.pluginsbyigor.com

1. Terms 

By using this software, you are agreeing to be bound by these Terms and Conditions of Use, all applicable laws and regulations, and agree that you are responsible for compliance with any applicable local laws. If you do not agree with any of these terms, you are prohibited from using this software. The materials contained in this software are protected by applicable copyright and trade mark law. 

2. Use License 

a. By using Azon FlyBox you agree and comply to Amazon.com Product Advertising API License Agreement found here: https://affiliate-program.amazon.com/gp/advertising/api/detail/agreement.html
b. You may use the Azon FlyBox software for the purposes of running a website on a number of domain names as allowed by your license. 
c. You may make a reasonable number of copies for backup purposes only. 
d. You may modify the Azon FlyBox software as per your requirements as long as the modifications would not circumvent the licensing system. 

3. Limitations 
a. You may not use Azon FlyBox on any domain not wholly owned by you. 
b. You may not distribute copies of the Azon FlyBox software or transfer any part of it to a 3rd party. 
c. You may not rent, lease, sell, or sub-license the Azon FlyBox software or copies of it.
d. You may not use the software to engage in any illegal activity. 
e. You may not circumvent the licensing system in any way. 

4. Disclaimer 

The materials on Azon FlyBox's website and the Azon FlyBox software are provided "as is". Azon FlyBox makes no warranties, expressed or implied, and hereby disclaims and negates all other warranties, including without limitation, implied warranties or conditions of merchantability, fitness for a particular purpose, or non-infringement of intellectual property or other violation of rights. Further, Azon FlyBox does not warrant or make any representations concerning the accuracy, likely results, or reliability of the use of the materials on its Internet web site or otherwise relating to such materials or on any sites linked to this site. 

5. Revisions and Errata 

The materials appearing on Azon FlyBox's web site could include technical, typographical, or photographic errors. Azon FlyBox does not warrant that any of the materials on its web site are accurate, complete, or current. Azon FlyBox may make changes to the materials contained on its web site at any time without notice. Azon FlyBox does not, however, make any commitment to update the materials. 

6. Links 

Azon FlyBox has not reviewed all of the sites linked to its Internet web site and is not responsible for the contents of any such linked site. The inclusion of any link does not imply endorsement by Azon FlyBox of the site. Use of any such linked web site is at the user's own risk. 

7. Site Terms of Use Modifications 

Azon FlyBox may revise these terms of use for its web site at any time without notice. By using this web site you are agreeing to be bound by the then current version of these Terms and Conditions of Use. 

8. Governing Law 

Any claim relating to Azon FlyBox's web site shall be governed by the laws of the State of Wisconsin (USA) without regard to its conflict of law provisions. 
*/

if(!defined('ABSPATH')) die('Direct access not premitted');

?>

<div class="wrap">
	<img src="<?php echo plugin_dir_url( dirname(dirname(dirname(__FILE__))) ); ?>images/<?php echo flybx_branding_img(); ?>" style="display: block; float: right;" />
    <h2><?php  _e('Visitor Log - Azon FlyBox (Plus+ feature)', $flybx_plugin_slug); ?></h2>
 
<div class="tablenav">
	
	
	
<div class="alignleft actions">
	<form action="admin.php" method="get">
		<div style="float: left;">
			<input type="hidden" name="page" value="flybx-visitor-log" />
			<select name="template_id">
				<option value="all"><?php _e('Show all templates', $flybx_plugin_slug); ?> &nbsp;</option>
				<?php if (count($templates_data['templates']) > 0): ?>
					<?php foreach($templates_data['templates'] as $curr_template): ?>
						<option value="<?php echo $curr_template['id']; ?>" <?php echo ($filter_template_id == $curr_template['id']?' selected="selected"':''); ?>><?php echo $curr_template['name']; ?></option>
					<?php endforeach; ?>
				<?php endif; ?>

			</select>
			<select class="postform" name="filter_action">
				<option value="all"><?php _e('Show views and clicks', $flybx_plugin_slug); ?> &nbsp;</option>
				<option value="views" class="level-0" <?php echo ($filter_action == 'views'?' selected="selected"':''); ?>><?php _e('Views only', $flybx_plugin_slug); ?></option>
				<option value="clicks" class="level-0" <?php echo ($filter_action == 'clicks'?' selected="selected"':''); ?>><?php _e('Clicks only', $flybx_plugin_slug); ?></option>
			</select>
		</div>
		
		
			<div id="date-range">
				<div id="date-range-field">
				  <span></span>
				  <a href="#">&#9660;</a>
				</div>
				<div id="datepicker-calendar" style=""></div>
			</div>
		
		
		<div style="float: left;">
			<input type="hidden" name="range_from" id="range_from" />
			<input type="hidden" name="range_to" id="range_to" />
			<input type="submit" value="<?php esc_attr_e('Filter', $flybx_plugin_slug); ?>" class="button-secondary" id="post-query-submit" name="" />	
		</div>
		
	</form>
</div>


    <div class='tablenav-pages'>
        <?php echo $p->show();  // Echo out the list of paging. ?>
    </div>
	
	<br class="clear">
</div>





 
<table class="widefat">
<thead>
    <tr>
        <th><?php _e('ID', $flybx_plugin_slug); ?></th>
        <th><?php _e('Template', $flybx_plugin_slug); ?></th>
        <th><?php _e('Action', $flybx_plugin_slug); ?></th>
        <th><?php _e('Post/Page', $flybx_plugin_slug); ?></th>
        <th><?php _e('KWs', $flybx_plugin_slug); ?></th>
        <th><?php _e('ASINs', $flybx_plugin_slug); ?></th>
        <th><?php _e('IP', $flybx_plugin_slug); ?></th>
        <th><?php _e('Time', $flybx_plugin_slug); ?></th>
    </tr>
</thead>
<tbody>
<?php

 
if (count($items) > 0 ) {
    foreach($items as $curr_item) {
?> 
        <tr>
            <td><?php echo $curr_item->cid; ?></td>
            <td>
				<?php if (isset($templates_data['templates'][$curr_item->template_id])): ?>
					<?php echo $templates_data['templates'][$curr_item->template_id]['name']; ?> 
				<?php else: ?>
					<?php _e('N/A', $flybx_plugin_slug); ?>
				<?php endif; ?>
			</td>
            <td>
				<?php if ($curr_item->collect_type == '1'): ?>
					<?php _e('Click', $flybx_plugin_slug); ?>
				<?php else: ?>
					<?php _e('View', $flybx_plugin_slug); ?>
				<?php endif; ?>
			</td>
            <td>
				<?php if ($curr_item->search_method != '6' && $curr_item->post_id != 0): ?>
					<a href="<?php echo get_permalink( $curr_item->post_id ); ?>" target="_blank"><?php echo $curr_item->post_id; ?></a>
				<?php endif; ?>
			</td>
            <td><?php echo $curr_item->kws; ?></td>
            <td style="max-width: 120px;"><?php echo $curr_item->asin; ?></td>
            <td><?php echo $curr_item->ip; ?></td>    
            <td><?php echo date('m/d/Y h:i a', $curr_item->timestamp); ?></td>    
        </tr>
<?php } 
} else { ?>
        <tr>
        <td>No Record Found!</td>
        <tr>  
<?php } ?>
</tbody>
</table>

<div style="margin: 35px 0 0 0;">
<strong><?php _e('Legend:', $flybx_plugin_slug); ?></strong><br />
<?php _e('<strong>Action</strong> - can be "View" or "Click"', $flybx_plugin_slug); ?><br />
<?php _e('<strong>Post/Page</strong> - post or page id with link', $flybx_plugin_slug); ?><br />
<?php _e('<strong>KWs</strong> - keywords used to pull products', $flybx_plugin_slug); ?><br />
<?php _e('<strong>ASINs</strong> - Amazon Standard Identification Number (ASIN) of products used in the template', $flybx_plugin_slug); ?><br />
</div>
</div>


<script type="text/javascript">
jQuery(document).ready(function() {
//var to = new Date();
//var from = new Date(to.getTime() - 1000 * 60 * 60 * 24 * 14);
var to = new Date(<?php echo date('Y, ', $range_to_raw).(date('m', $range_to_raw) - 1).date(' , d, h, i, s', $range_to_raw); ?>);
var from = new Date(<?php echo date('Y, ', $range_from_raw).(date('m', $range_from_raw) - 1).date(' , d, h, i, s', $range_from_raw); ?>);

jQuery('#datepicker-calendar').DatePicker({
  inline: true,
  date: [from, to],
  calendars: 3,
  mode: 'range',
  current: new Date(to.getFullYear(), to.getMonth() - 1, 1),
  onChange: function(dates,el) {
    // update the range display
    jQuery('#date-range-field span').text(
      dates[0].getDate()+' '+dates[0].getMonthName(true)+', '+
      dates[0].getFullYear()+' - '+
      dates[1].getDate()+' '+dates[1].getMonthName(true)+', '+
      dates[1].getFullYear());
	  
	  jQuery('#range_from').val(dates[0].getDate()+'-' + (dates[0].getMonth() + 1) + '-' + dates[0].getFullYear());
	  jQuery('#range_to').val(dates[1].getDate()+'-' + (dates[1].getMonth() + 1) + '-' + dates[1].getFullYear());
  }
});


// initialize the special date dropdown field
jQuery('#date-range-field span').text(from.getDate()+' '+from.getMonthName(true)+', '+from.getFullYear()+' - '+
                                        to.getDate()+' '+to.getMonthName(true)+', '+to.getFullYear());

jQuery('#range_from').val(from.getDate()+'-' + (from.getMonth() + 1) + '-' + from.getFullYear());
jQuery('#range_to').val(to.getDate()+'-' + (to.getMonth() + 1) + '-' + to.getFullYear());

//jQuery('#date-range-field span').text('Date Range');


										
jQuery('#date-range-field').bind('click', function(){
  jQuery('#datepicker-calendar').toggle();
  if(jQuery('#date-range-field a').text().charCodeAt(0) == 9660) {
	// switch to up-arrow
	jQuery('#date-range-field a').html('&#9650;');
	jQuery('#date-range-field').css({borderBottomLeftRadius:0, borderBottomRightRadius:0});
	jQuery('#date-range-field a').css({borderBottomRightRadius:0});
  } else {
	// switch to down-arrow
	jQuery('#date-range-field a').html('&#9660;');
	jQuery('#date-range-field').css({borderBottomLeftRadius:5, borderBottomRightRadius:5});
	jQuery('#date-range-field a').css({borderBottomRightRadius:5});
  }
  return false;
});

jQuery('html').click(function() {
          if(jQuery('#datepicker-calendar').is(":visible")) {
            jQuery('#datepicker-calendar').hide();
            jQuery('#date-range-field a').html('&#9660;');
            jQuery('#date-range-field').css({borderBottomLeftRadius:5, borderBottomRightRadius:5});
            jQuery('#date-range-field a').css({borderBottomRightRadius:5});
          }
        });
		

if(jQuery('#datepicker-calendar').is(":visible")) {
            jQuery('#datepicker-calendar').hide();
            jQuery('#date-range-field a').html('&#9660;');
            jQuery('#date-range-field').css({borderBottomLeftRadius:5, borderBottomRightRadius:5});
            jQuery('#date-range-field a').css({borderBottomRightRadius:5});
          }
		  
  });
</script>

<style>
#date-range {
    position: relative;
	float: left;
}
#date-range-field {
    border: 1px solid #CCCCCC;
    border-radius: 5px 5px 5px 5px;
    cursor: pointer;
    height: 22px;
    overflow: hidden;
    position: relative;
    width: 260px;
}
#date-range-field span {
    color: #404040;
    font-size: 12px;
    font-weight: bold;
    height: 22px;
    left: 5px;
    line-height: 22px;
    position: relative;
    text-align: center;
    top: 0;
    width: 220px;
}
#date-range-field {
    cursor: pointer;
}
#date-range-field a {
    outline-style: none;
}
#date-range-field a {
    background-color: #F7F7F7;
    border-radius: 0 5px 5px 0;
    color: #B2B2B2;
    display: block;
    height: 23px;
    padding-top: 6px;
    position: absolute;
    right: 0;
    text-align: center;
    text-decoration: none;
    top: 0;
    width: 26px;
}
#datepicker-calendar {
position: absolute;
}
</style>
