<?php

/*

Copyright (c) 2012, Rich Ways LLC

All rights reserved.



Azon FlyBox License

http://www.pluginsbyigor.com



1. Terms 



By using this software, you are agreeing to be bound by these Terms and Conditions of Use, all applicable laws and regulations, and agree that you are responsible for compliance with any applicable local laws. If you do not agree with any of these terms, you are prohibited from using this software. The materials contained in this software are protected by applicable copyright and trade mark law. 



2. Use License 



a. By using Azon FlyBox you agree and comply to Amazon.com Product Advertising API License Agreement found here: https://affiliate-program.amazon.com/gp/advertising/api/detail/agreement.html

b. You may use the Azon FlyBox software for the purposes of running a website on a number of domain names as allowed by your license. 

c. You may make a reasonable number of copies for backup purposes only. 

d. You may modify the Azon FlyBox software as per your requirements as long as the modifications would not circumvent the licensing system. 



3. Limitations 

a. You may not use Azon FlyBox on any domain not wholly owned by you. 

b. You may not distribute copies of the Azon FlyBox software or transfer any part of it to a 3rd party. 

c. You may not rent, lease, sell, or sub-license the Azon FlyBox software or copies of it.

d. You may not use the software to engage in any illegal activity. 

e. You may not circumvent the licensing system in any way. 



4. Disclaimer 



The materials on Azon FlyBox's website and the Azon FlyBox software are provided "as is". Azon FlyBox makes no warranties, expressed or implied, and hereby disclaims and negates all other warranties, including without limitation, implied warranties or conditions of merchantability, fitness for a particular purpose, or non-infringement of intellectual property or other violation of rights. Further, Azon FlyBox does not warrant or make any representations concerning the accuracy, likely results, or reliability of the use of the materials on its Internet web site or otherwise relating to such materials or on any sites linked to this site. 



5. Revisions and Errata 



The materials appearing on Azon FlyBox's web site could include technical, typographical, or photographic errors. Azon FlyBox does not warrant that any of the materials on its web site are accurate, complete, or current. Azon FlyBox may make changes to the materials contained on its web site at any time without notice. Azon FlyBox does not, however, make any commitment to update the materials. 



6. Links 



Azon FlyBox has not reviewed all of the sites linked to its Internet web site and is not responsible for the contents of any such linked site. The inclusion of any link does not imply endorsement by Azon FlyBox of the site. Use of any such linked web site is at the user's own risk. 



7. Site Terms of Use Modifications 



Azon FlyBox may revise these terms of use for its web site at any time without notice. By using this web site you are agreeing to be bound by the then current version of these Terms and Conditions of Use. 



8. Governing Law 



Any claim relating to Azon FlyBox's web site shall be governed by the laws of the State of Wisconsin (USA) without regard to its conflict of law provisions. 

*/

if(!defined('ABSPATH')) die('Direct access not premitted');



//require_once(dirname(__FILE__).'/tinymce/tinymce.php');



function flybx_stats() {

	global $am_indexes, $flybx_plugin_slug, $flybx_plugin_name;

	

	if ( function_exists('current_user_can') && !current_user_can('manage_options') )

			die(__('Cheatin&#8217; uh?'));

	

	if (flybx_license_type() === FALSE)

	{

		flybx_license();

		return;

	}

	//which tab?

	$tab = 'templates';

	if (isset($_GET['tab']) && in_array($_GET['tab'], array('templates', 'posts', 'products', 'templates')))

	{

		$tab = $_GET['tab'];

	}

	

	echo '<div class="wrap"><img src="'.plugin_dir_url( dirname(__FILE__) ).'images/'.flybx_branding_img().'" style="display: block; float: right;" /><h2>' . sprintf(__('%s Stats', $flybx_plugin_slug), $flybx_plugin_name) . '</h2>';

	

	

	$tabs = array(

		'templates' => __('templates', $flybx_plugin_slug),

		'posts' => __('Pages/Posts', $flybx_plugin_slug),

		'products' => __('Products', $flybx_plugin_slug),	

		/*'templates' => __('Templates', $flybx_plugin_slug)	*/

		);



	echo '<h2 class="nav-tab-wrapper">';



	if ( isset( $redir_tab ) && array_key_exists( $redir_tab, $tabs ) ) {

		$current = $redir_tab;

	} elseif ( isset( $_GET['tab'] ) && array_key_exists( $_GET['tab'], $tabs ) ) {

		$current = $_GET['tab'];

	} else {

		$keys = array_keys( $tabs );

		$current = array_shift( $keys );

	}



	foreach ( $tabs as $callback => $text ) {

		$class = ' class="nav-tab"';



		if ( $current == $callback )

			$class = ' class="nav-tab nav-tab-active"';



		$href = add_query_arg( array( 'tab' => $callback, 's' => false, 'paged' => false, 'post_mime_type' => false, 'm' => false ) );

		$href = remove_query_arg( 'isocode', $href );

		$href = wp_nonce_url( $href, "tab-$callback" );

		$link = "<a href='" . esc_url( $href ) . "'$class>$text</a>";



		echo $link;

	}

	echo '</h2>';

	

	if ($tab == 'templates' || $tab == 'posts' || $tab == 'products' || $tab == 'templates')

	{

		?>

		

		<a href="javascript: void(0);" onclick="javascript: jQuery('#date_picker_wrap').toggle();" class="flybx_date_dropdown">+ Date: <span id="startDate"><?=date('m/d/Y', strtotime('-'.(date('w')*24).' hours'));?></span> - <span id="endDate"><?=date('m/d/Y');?></span></a>

		<div class="stat_actions_wrap">

			<?php _e('Display', $flybx_plugin_slug); ?>: <select onchange="javascript: flybx_load_stats(this.value, jQuery('#curr_stat_type').val(), jQuery('#curr_stat_page').val());" id="flybx_stat_action">

				<option value="0" selected><?php _e('Views', $flybx_plugin_slug); ?></option>

				<option value="1"><?php _e('Clicks', $flybx_plugin_slug); ?></option>

				<option value="2"><?php _e('CTR%', $flybx_plugin_slug); ?></option>

			</select>

		</div>

		<div style="position: absolute; display: none; z-index: 900;" id="date_picker_wrap">

			<div class="week-picker"></div>

		</div>

		<br style="clear: both;" />

		

		<div class="flybx_graph_wrap">

		

		</div>

		

		





<script type="text/javascript"> 

var temp_tbl_holder = '';

jQuery(function(){

            

           //jQuery("#flybx_graph").graphix({ width: 1000, height: 500, type:'line' }); 

            temp_tbl_holder = jQuery('.flybx_graph_wrap').html();

           });

jQuery(function() {

    var startDate;

    var endDate;



    var selectCurrentWeek = function() {

        window.setTimeout(function () {

            jQuery('.week-picker').find('.ui-datepicker-current-day a').addClass('ui-state-active')

        }, 1);		

    }



    jQuery('.week-picker').datepicker( {

        showOtherMonths: true,

        selectOtherMonths: true,

		maxDate: 0,

        onSelect: function(dateText, inst) { 

            var date = jQuery(this).datepicker('getDate');

            startDate = new Date(date.getFullYear(), date.getMonth(), date.getDate() - date.getDay());

            endDate = new Date(date.getFullYear(), date.getMonth(), date.getDate() - date.getDay() + 6);

            var dateFormat = inst.settings.dateFormat || jQuery.datepicker._defaults.dateFormat;

            jQuery('#startDate').text(jQuery.datepicker.formatDate( dateFormat, startDate, inst.settings ));

            jQuery('#endDate').text(jQuery.datepicker.formatDate( dateFormat, endDate, inst.settings ));



            selectCurrentWeek();

			

			jQuery('#date_picker_wrap').hide();

			flybx_load_stats(jQuery('#curr_stat_action').val(), jQuery('#curr_stat_type').val(), 0);

			//jQuery('.flybx_graph_wrap').html(temp_tbl_holder);

			

        },

        beforeShowDay: function(date) {

            var cssClass = '';

            if(date >= startDate && date <= endDate)

                cssClass = 'ui-datepicker-current-day';

            return [true, cssClass];

        },

        onChangeMonthYear: function(year, month, inst) {

            selectCurrentWeek();

        }

    });



    jQuery('.week-picker .ui-datepicker-calendar tr').live('mousemove', function() { jQuery(this).find('td a').addClass('ui-state-hover'); });

    jQuery('.week-picker .ui-datepicker-calendar tr').live('mouseleave', function() { jQuery(this).find('td a').removeClass('ui-state-hover'); });

});



jQuery(document).ready(function() {

  <?php if ($tab == 'templates'): ?>

	flybx_load_stats(0, 0, 0);

  <?php elseif ($tab == 'posts'): ?>

	flybx_load_stats(0, 1, 0);

  <?php elseif ($tab == 'templates'): ?>

	flybx_load_stats(0, 3, 0);

  <?php else: ?>

	flybx_load_stats(0, 2, 0);

  <?php endif; ?>

});



function flybx_load_stats(stat_action, stat_type, page_num)

{

	startDate = jQuery('#startDate').text();

	endDate = jQuery('#endDate').text();

	

	jQuery('.flybx_graph_wrap').html('<img src="<?=site_url("wp-content/plugins/flybx/images/ajax-loader_bar.gif");?>" style="width: 128px; height: 15px; margin: 250px auto; display: block;" />');

	jQuery('.flybx_graph_wrap').load('<?=site_url("wp-content/plugins/flybx/admin_stats.php");?>', {stat_action: stat_action, stat_variation_type: stat_type, start_date: startDate, end_date: endDate, page_num: page_num }, function () {

		if (stat_action == 2)

		{

			jQuery("#flybx_graph").graphix({ width: 1000, height: 500, type:'line', divide_by: 1000 });

		}

		else

		{

			jQuery("#flybx_graph").graphix({ width: 1000, height: 500, type:'line' });

		}

		

	});

	

}



</script> 

<style>

.flybx_graph {



}

.flybx_graph_wrap {

margin-top: 5px;

min-width: 1000px;

min-height: 500px;

}

.flybx_date_dropdown {display: block; text-decoration: none; font-weight: bold; margin-top: 5px; width: 300px; float: left;}

.stat_actions_wrap {float: left; clear: right;}

</style>

		<?php

	}

	

	

}



function flybx_prepare_kws_pop_preview()

{

	global $flybx_addons, $flybx_plugin_slug, $flybx_plugin_name;

?>

		<?php

		//BOF include flybx js for preview

		//wp_enqueue_style( 'flybx', plugins_url( 'flybx/style.css' , dirname(__FILE__) ), false, '1.0');

		?>

		<div id="am_popbox" style="display: none;">

			<div id="am_interior">

				<?php _e('Thank you for visiting our site.', $flybx_plugin_slug); ?>

				<br /><a href="javascript:void(0);" class="close"><?php _e('Close', $flybx_plugin_slug); ?></a>			

			</div>		

		</div>

		

		<?php

		$flybx_preview_tpl = 'tpl_am3across';

		if (flybx_get_option('tpl_am3across_enabled') != 1 && flybx_get_option('tpl_am1product_enabled') == 1)

		{

			$flybx_preview_tpl = 'tpl_am1product';

		}

		$flybx_msgs = flybx_get_pop_messages($flybx_preview_tpl);

		$flybx_preview_msg = $flybx_msgs[array_rand($flybx_msgs)];

		?>

		<script type="text/javascript">		

		  var flybx_preview_loaded = false;

		  function flybx_perview(keywords, source)

		  {

			var loading_script = 'ampop_results.php';

			if (source == undefined)

			{

				source = '0';

			}

			if (source == '1')

			{

				loading_script = 'epnpop_results.php';

			}

			jQuery('.flybx_preview_set').removeClass('active');

			jQuery('.flybx_preview_loading').addClass('active');

			//jQuery("#am_interior").html('');

			if (flybx_preview_loaded == false)

			{

				<?php

				//fix calls from www. to non-www etc

				$flybx_ampop_results_url = site_url('wp-content/plugins/'.$flybx_plugin_slug.'/');				

				if (isset($_SERVER['HTTP_HOST']) && substr($_SERVER['HTTP_HOST'], 0, 4) == 'www.' && substr($flybx_ampop_results_url, 0, 11) != 'http://www.' && substr($flybx_ampop_results_url, 0, 12) != 'https://www.')

				{

					if (substr($flybx_ampop_results_url, 0, 7) == 'http://') $flybx_ampop_results_url = str_replace('http://', 'http://www.', $flybx_ampop_results_url);

					if (substr($flybx_ampop_results_url, 0, 8) == 'https://') $flybx_ampop_results_url = str_replace('https://', 'https://www.', $flybx_ampop_results_url);

				}

				elseif (isset($_SERVER['HTTP_HOST']) && substr($_SERVER['HTTP_HOST'], 0, 4) != 'www.' && (substr($flybx_ampop_results_url, 0, 11) == 'http://www.' || substr($flybx_ampop_results_url, 0, 12) == 'https://www.'))

				{

					if (substr($flybx_ampop_results_url, 0, 7) == 'http://') $flybx_ampop_results_url = str_replace('http://', 'http://www.', $flybx_ampop_results_url);

					if (substr($flybx_ampop_results_url, 0, 8) == 'https://') $flybx_ampop_results_url = str_replace('https://', 'https://www.', $flybx_ampop_results_url);

				}

				?>

				var handling_script = "<?=$flybx_ampop_results_url;?>" + loading_script;

				//jQuery("#am_interior").load("<?=$flybx_ampop_results_url;?>?post_id=9999&preview=yes&tpl=<?=($flybx_preview_tpl == 'tpl_am3across'?0:1);?>", {preview_keywords: keywords}, function () {

				jQuery.ajax({

				  url: handling_script + "?post_id=9999&preview=yes&tpl=<?=($flybx_preview_tpl == 'tpl_am3across'?0:1);?>",

				  type: "POST",

				  data:  {preview_keywords: keywords},

				  success: function(data) {

					//var obj = jQuery.parseJSON(data);

					var obj = JSON.parse(data);

					var pop_html = obj.html;

					jQuery("#am_interior").html(pop_html);

					

					if (obj.jscripts != undefined && obj.jscripts.length > 0)

					{

						jQuery("#flybx_js_content").html("<iframe src=\""+ obj.jscripts +"\" style='border: 0px; widht: <?=flybx_get_option($flybx_preview_tpl."_pop_width");?>px; height: <?=(flybx_get_option($flybx_preview_tpl."_pop_height") - 80);?>px;' width='<?=flybx_get_option($flybx_preview_tpl."_pop_width");?>' height='<?=(flybx_get_option($flybx_preview_tpl."_pop_height") - 80);?>' scrolling='no' border='0'></iframe>");

					}

				am_loaded = true;

				//flybx_preview_loaded = true;

				flybx_preview_pop();		

				}

				});

			}

			else

			{

				flybx_preview_pop();

			}

		  }

			function flybx_preview_pop()

			{

				jQuery('.prod_img_link_epn img').css('visibility', 'hidden');

				jQuery('#am_interior').css('width', '<?=flybx_get_option($flybx_preview_tpl."_pop_width");?>' + 'px');

				jQuery('#am_interior').css('height', '<?=flybx_get_option($flybx_preview_tpl."_pop_height");?>' + 'px');

				jQuery('#am_interior').css('border-width', '<?=flybx_get_option($flybx_preview_tpl."_border_width");?>' + 'px');

				jQuery('#am_interior').css('border-style', '<?=flybx_get_option($flybx_preview_tpl."_border_type");?>');

				jQuery('#am_interior').css('border-color', '<?=flybx_get_option($flybx_preview_tpl."_border_color");?>');

				jQuery('.pop_title_flybx').html('<?=addslashes($flybx_preview_msg);?>');

				jQuery('.pop_title_flybx').css('font-size', '<?=flybx_get_option($flybx_preview_tpl."_message_fontsize");?>' + 'px');

				jQuery('.pop_title_flybx').css('min-height', '<?=flybx_get_option($flybx_preview_tpl."_message_fontsize");?>' + 'px');

				jQuery('.pop_title_flybx').css('color', '<?=flybx_get_option($flybx_preview_tpl."_message_color");?>');

				<?php if (flybx_get_option($flybx_preview_tpl."_branding") == 'no'): ?>

					jQuery('.flybx_poweredby').css('display', 'none');

				<?php else: ?>

					jQuery('.flybx_poweredby').css('display', 'block');

				<?php endif; ?>

				<?php

				$flybx_amzn_button_img = flybx_get_option($flybx_preview_tpl."_amzn_button_img");

				$flybx_epn_button_img = flybx_get_option($flybx_preview_tpl."_epn_button_img");

				$flybx_epn_bid_button_img = flybx_get_option($flybx_preview_tpl."_epn_bid_button_img");

				?>

				if (((jQuery('.amzn_buy_now_flybx_text').length > 0 || jQuery('.amzn_buy_now_large_flybx_text').length > 0) && '<?=$flybx_amzn_button_img;?>' != '' && '<?=$flybx_amzn_button_img;?>' != ' ') || ((jQuery('.epn_buy_now_flybx_text').length > 0 || jQuery('.epn_buy_now_large_flybx_text').length > 0) && '<?=$flybx_epn_button_img;?>' != '' && '<?=$flybx_epn_button_img;?>' != ' ') || ((jQuery('.epn_bid_now_flybx_text').length > 0 || jQuery('.epn_bid_now_large_flybx_text').length > 0) && '<?=$flybx_epn_bid_button_img;?>' != '' && '<?=$flybx_epn_bid_button_img;?>' != ' '))

				{

					jQuery('.amzn_buy_now_flybx_text, .amzn_buy_now_large_flybx_text').html('<img src="' + '<?=$flybx_amzn_button_img;?>' + '" />').addClass('flybx_image_button_link');

					jQuery('.epn_buy_now_flybx_text, .epn_buy_now_large_flybx_text').html('<img src="' + '<?=$flybx_epn_button_img;?>' + '" />').addClass('flybx_image_button_link');

					jQuery('.epn_bid_now_flybx_text, .epn_bid_now_large_flybx_text').html('<img src="' + '<?=$flybx_epn_bid_button_img;?>' + '" />').addClass('flybx_image_button_link');

				}

				else

				{

					jQuery('.buy_now_flybx_text, .buy_now_large_flybx_text').text('<?=flybx_get_option($flybx_preview_tpl."_button_text");?>');

					//button css

					jQuery('.buy_now_flybx, .buy_now_large_flybx').css('color', '<?=flybx_get_option($flybx_preview_tpl."_button_text_color");?>');

					jQuery('.buy_now_flybx, .buy_now_large_flybx').css('background-color', '<?=flybx_get_option($flybx_preview_tpl."_button_color_top");?>');

					jQuery('.buy_now_flybx, .buy_now_large_flybx').css('background', '<?=flybx_get_option($flybx_preview_tpl."_button_color_bottom");?>');

					if (jQuery.browser.mozilla && jQuery.browser.version > 3.5)

					{

						jQuery('.buy_now_flybx, .buy_now_large_flybx').css('background', '-moz-linear-gradient(top,  '+ '<?=flybx_get_option($flybx_preview_tpl."_button_color_top");?>' +' 1%, '+ '<?=flybx_get_option($flybx_preview_tpl."_button_color_middle");?>'+' 50%, '+ '<?=flybx_get_option($flybx_preview_tpl."_button_color_middle");?>' +' 52%, '+ '<?=flybx_get_option($flybx_preview_tpl."_button_color_bottom");?>' +' 100%)');

					}

					else if (jQuery.browser.opera && jQuery.browser.version > 11.1)

					{

						jQuery('.buy_now_flybx, .buy_now_large_flybx').css('background', '-o-linear-gradient(top,  '+'<?=flybx_get_option($flybx_preview_tpl."_button_color_top");?>'+' 1%,'+'<?=flybx_get_option($flybx_preview_tpl."_button_color_middle");?>'+' 50%,'+'<?=flybx_get_option($flybx_preview_tpl."_button_color_middle");?>'+' 52%,'+'<?=flybx_get_option($flybx_preview_tpl."_button_color_bottom");?>'+' 100%)');

					}

					else if ((jQuery.browser.chrome && jQuery.browser.version < 10) || (jQuery.browser.safari && (jQuery.browser.version < 5.1 && jQuery.browser.version > 3.9)))

					{

						jQuery('.buy_now_flybx, .buy_now_large_flybx').css('background', '-webkit-gradient(linear, left top, left bottom, color-stop(1%,'+'<?=flybx_get_option($flybx_preview_tpl."_button_color_top");?>'+'), color-stop(50%,'+'<?=flybx_get_option($flybx_preview_tpl."_button_color_middle");?>'+'), color-stop(52%,'+'<?=flybx_get_option($flybx_preview_tpl."_button_color_middle");?>'+'), color-stop(100%,'+'<?=flybx_get_option($flybx_preview_tpl."_button_color_bottom");?>'+'))');

					}

					else if ((jQuery.browser.chrome && jQuery.browser.version > 9.9) || (jQuery.browser.safari &&  jQuery.browser.version > 5) || jQuery.browser.webkit)

					{

						jQuery('.buy_now_flybx, .buy_now_large_flybx').css('background', '-webkit-linear-gradient(top,  '+'<?=flybx_get_option($flybx_preview_tpl."_button_color_top");?>'+' 1%,'+'<?=flybx_get_option($flybx_preview_tpl."_button_color_middle");?>'+' 50%,'+'<?=flybx_get_option($flybx_preview_tpl."_button_color_middle");?>'+' 52%,'+'<?=flybx_get_option($flybx_preview_tpl."_button_color_bottom");?>'+' 100%)');

					}

					else if ((jQuery.browser.msie && jQuery.browser.version > 9.9))

					{

						jQuery('.buy_now_flybx, .buy_now_large_flybx').css('background', '-ms-linear-gradient(top,  '+'<?=flybx_get_option($flybx_preview_tpl."_button_color_top");?>'+' 1%,'+'<?=flybx_get_option($flybx_preview_tpl."_button_color_middle");?>'+' 50%,'+'<?=flybx_get_option($flybx_preview_tpl."_button_color_middle");?>'+' 52%,'+'<?=flybx_get_option($flybx_preview_tpl."_button_color_bottom");?>'+' 100%)');

					}

					else if ((jQuery.browser.msie && jQuery.browser.version > 5.9 && jQuery.browser.version < 10))

					{

						jQuery('.buy_now_flybx, .buy_now_large_flybx').css('filter', 'progid:DXImageTransform.Microsoft.gradient( startColorstr=\''+'<?=flybx_get_option($flybx_preview_tpl."_button_color_top");?>'+'\', endColorstr=\''+'<?=flybx_get_option($flybx_preview_tpl."_button_color_bottom");?>'+'\',GradientType=0 )');

					}

					else

					{

						jQuery('.buy_now_flybx, .buy_now_large_flybx').css('background', 'linear-gradient(top,  '+'<?=flybx_get_option($flybx_preview_tpl."_button_color_top");?>'+' 1%,'+'<?=flybx_get_option($flybx_preview_tpl."_button_color_middle");?>'+' 50%,'+'<?=flybx_get_option($flybx_preview_tpl."_button_color_middle");?>'+' 52%,'+'<?=flybx_get_option($flybx_preview_tpl."_button_color_bottom");?>'+' 100%)');

					}

				}

				

				<?php if (isset($flybx_addons) && is_array($flybx_addons) && in_array('amzn_cart', $flybx_addons) && flybx_get_option('amzn_cart_enabled') == 'yes'): ?>

					<?php

					if ($flybx_preview_tpl == 'tpl_am3across')

					{

						$flybx_amzn_cart_btn_text = flybx_get_option("amzn_cart_btn_text_3prods");

						$flybx_addtocart_image = flybx_get_option("addtocart_tpl1");

					}

					elseif ($flybx_preview_tpl == 'tpl_am1product')

					{

						$flybx_amzn_cart_btn_text = flybx_get_option("amzn_cart_btn_text_1prod");

						$flybx_addtocart_image = flybx_get_option("addtocart_tpl2");

					}

					if ($flybx_amzn_cart_btn_text === FALSE || strlen(trim($flybx_amzn_cart_btn_text)) == 0)

					{

						$flybx_amzn_cart_btn_text = 'Add To Cart';

					}

					?>

						jQuery('.buy_now_flybx_text, .buy_now_large_flybx_text').removeClass('flybx_image_button_link');

						jQuery('.buy_now_flybx_text, .buy_now_large_flybx_text').text('<?=$flybx_amzn_cart_btn_text;?>');



					<?php if ($flybx_addtocart_image !== FALSE && strlen($flybx_addtocart_image) > 0): ?>

						jQuery('.amzn_buy_now_flybx_text, .amzn_buy_now_large_flybx_text').html('<img src="<?=$flybx_addtocart_image;?>" />').addClass('flybx_image_button_link');

					<?php endif; ?>



				<?php endif; ?>

				

				if ( '<?=flybx_get_option($flybx_preview_tpl."_close_btn");?>' == 'xbtn')

				{

					jQuery('.am_close_btn_flybx').css('display', 'block');

					jQuery('.am_close_txt').css('display', 'none');				

				}

				else

				{

					jQuery('.am_close_txt').css('display', 'block');

					jQuery('.am_close_btn_flybx').css('display', 'none');

				}

				

				jQuery("#am_popbox").fadeIn(1000);

				align_product_images();

				flybx_play_audio();

				

				jQuery('.flybx_preview_set').removeClass('active');

				jQuery('.flybx_preview_link').addClass('active');

			}

			function pbox_close()

			{

				jQuery("#am_popbox").hide(function(){jQuery(this).unbind()});

			}

			function align_product_images()

			{

				if (jQuery('.prod_img_link_epn').length > 0)

				{

					jQuery('.prod_img_link_epn img').each(function() {

						var img_height = jQuery(this).height();

						if (img_height == 0 || img_height == undefined)

						{

							img_height = 140;

						}

						if (jQuery(this).hasClass('epn_image_oneprod'))

						{

							var margin_top = Math.floor((270 - img_height) / 2);

						}

						else

						{

							var margin_top = Math.floor((190 - img_height) / 2);

						}

						jQuery(this).css('margin-top', margin_top);

					});

				}

				jQuery('.prod_img_link_epn img').css('visibility', 'visible');

			}

			<?php

			$flybx_audio = flybx_get_option($flybx_preview_tpl.'_audio');

			?>

			var flybx_audio_plays = 0;

			function flybx_play_audio()

			{

				<?php if ($flybx_audio !== FALSE && strlen(trim($flybx_audio)) > 0): ?>

				var flybx_audio_mp3 = '<?php echo $flybx_audio; ?>';

				if (flybx_audio_mp3 != '')

				{

					jQuery("#flybx_audio_player").jPlayer({

					  ready: function () {

					   jQuery(this).jPlayer("setMedia", {

						mp3: flybx_audio_mp3,

					   }).jPlayer('play');

					   flybx_audio_plays = flybx_audio_plays + 1;

					  },

					  swfPath: '<?=plugins_url( $flybx_plugin_slug.'/js/' , dirname(dirname(__FILE__)) );?>',

					  supplied: "mp3"

					 });

					 if (flybx_audio_plays != 0)

					 {

						jQuery('#flybx_audio_player').jPlayer('play');

					 }

				 }

				//jQuery('#flybx_audio_player').jPlayer('play');		

				<?php endif; ?>

			}

			  </script>

			  <div id="flybx_audio_player"></div>

			<style>

			.flybx_preview_set {display: none;}

			.flybx_preview_set.active {display: inline-block;}

			</style>

<?php

	

	if ($flybx_audio !== FALSE && strlen(trim($flybx_audio)) > 0)

	{

		wp_enqueue_script($flybx_plugin_slug.'_audio', plugins_url( $flybx_plugin_slug.'/js/jquery.jplayer.min.js' , dirname(dirname(__FILE__)) ), array('jquery'), '1.0', true);

	}

}





function flybx_promo_msg_bind_clicks_javascript() {

wp_enqueue_style('thickbox');

wp_enqueue_script('thickbox');

flybx_add_json_support();

?>

<script type="text/javascript" >

function flybx_promo_msg_bind_clicks()

{

	jQuery('.flybx_admin_msg a.flybx_promo_msg_link_a').click(function() {

	  flybx_promo_msg_click('link');

	});

	jQuery('.flybx_admin_msg a.flybx_promo_msg_hide_a').click(function() {

	  flybx_promo_msg_click('hide');

	});

	tb_init('a.flybx_thickbox');

}



jQuery(document).ready(function($) {

	flybx_promo_msg_bind_clicks();

});



function flybx_promo_msg_click(link_or_hide)

{

	var data = {

		action: 'flybx_promo_msg_click',

		link_or_hide: link_or_hide

	};

	jQuery('.flybx_admin_msg').fadeOut(500);



	jQuery.post(ajaxurl, data, function(response) {

	

	});

}

</script>

<?php

}





function flybx_promo_msg_javascript() {

flybx_add_json_support();

?>

<script type="text/javascript" >

jQuery(document).ready(function($) {



	var data = {

		action: 'flybx_promo_msg'

	};



	jQuery.post(ajaxurl, data, function(response) {

		//alert('Got this from the server: ' + response);

		if (response != '')

		{

			//var obj = jQuery.parseJSON(response);

			var obj = JSON.parse(response);

			if (obj.html != undefined)

			{

				jQuery(".flybx_admin_msg").css('display', 'none');

				if (jQuery(".flybx_admin_msg").length == 0)

				{

					

					jQuery(".wrap").prepend(obj.html);

				}

				else

				{

					jQuery(".flybx_admin_msg").replaceWith(obj.html);

				}

				jQuery('div.wrap h2:first').nextAll('div.updated, div.error').addClass('below-h2');

				jQuery('div.updated, div.error').not('.below-h2, .inline').insertAfter( jQuery('div.wrap h2:first') );

				jQuery(".flybx_admin_msg").css('display', 'none');

				jQuery(".flybx_admin_msg").fadeIn(500);

				flybx_promo_msg_bind_clicks();

			}

		}

	});

});

</script>

<?php

}



add_action('wp_ajax_flybx_promo_msg_click', 'flybx_promo_msg_click');



//$flybx_promo_msgs_click_url = 'http://192.232.235.92/flybx/promo_msg/get_promo_msg';

$flybx_promo_msgs_click_url = 'http://192.232.235.92/flybx/promo_msg/get_promo_msg';

function flybx_promo_msg_click() {

	global $wpdb, $_POST, $flybx_promo_msgs_click_url, $flybx_current_plugin_version;



	//get current message

	$flybx_promo_msg_raw = flybx_get_option('flybx_promo_msg', is_multisite());

	if ($flybx_promo_msg_raw === FALSE)

	{

		//generate a default msg arr

		$flybx_promo_msg = array(

					'msg_id' => 0,

					'html' => "",

					'clicked_hide' => 0,

					'clicked_link' => 0,

					'views' => 0,

					'expires' => 0

				);

	}

	else

	{

		$flybx_promo_msg = unserialize($flybx_promo_msg_raw);

	}

		//save locally first

		if (isset($_POST['link_or_hide']) && $_POST['link_or_hide'] == 'link')

		{

			$flybx_promo_msg['clicked_link'] = 1;

		}

		else

		{

			$flybx_promo_msg['clicked_hide'] = 1;

		}

		flybx_update_option('flybx_promo_msg', serialize($flybx_promo_msg), is_multisite());

		

		//register already clicked

		$args = new stdClass;

		$args->flybx_promo_msg = serialize($flybx_promo_msg);

		$args->version = $flybx_current_plugin_version;

		$request_string = flybx_prepare_request('msg_check', $args);

		$request = wp_remote_post($flybx_promo_msgs_click_url, $request_string);

		

		if (!is_wp_error($request)) 

		{

			$res = unserialize($request['body']);

			if ($res !== FALSE)

			{				

				//do nothing

			}

		}



	die(); // this is required to return a proper result

}







add_action('wp_ajax_flybx_promo_msg', 'flybx_promo_msg_update');



//$flybx_promo_msgs_url = 'http://192.232.235.92/flybx/promo_msg/get_promo_msg';

$flybx_promo_msgs_url = 'http://192.232.235.92/flybx/promo_msg/get_promo_msg';

function flybx_promo_msg_update() {

	global $wpdb, $_POST, $flybx_promo_msgs_url, $flybx_current_plugin_version, $flybx_plugin_slug, $flybx_plugin_name;



	//update last time check

	flybx_update_option('flybx_promo_msg_last_check', time(), is_multisite());

	

	//get current message

	$flybx_promo_msg_raw = flybx_get_option('flybx_promo_msg', is_multisite());

	if ($flybx_promo_msg_raw === FALSE)

	{

		//generate a default msg arr

		$flybx_promo_msg = array(

					'msg_id' => 0,

					'html' => "",

					'clicked_hide' => 0,

					'clicked_link' => 0,

					'views' => 0,

					'expires' => 0

				);

		//flybx_update_option('flybx_promo_msg', serialize($flybx_promo_msg));

	}

	else

	{

		$flybx_promo_msg = unserialize($flybx_promo_msg_raw);

	}		

		

		//grab new one

		$args = new stdClass;

		$args->flybx_promo_msg = serialize($flybx_promo_msg);

		$args->version = $flybx_current_plugin_version;

		$request_string = flybx_prepare_request('msg_check', $args);

		$request = wp_remote_post($flybx_promo_msgs_url, $request_string);

		

		/*echo '<pre>';

		print_r($request);

		echo '<pre>';*/

		

		if (!is_wp_error($request)) 

		{

			$res = unserialize($request['body']);

			/*echo '<pre>';

			print_r($res);

			echo '<pre>';

			exit;*/

			if ($res !== FALSE)

			{

				//update flybx with new msg

				if (isset($res['msg_id']))

				{

					flybx_update_option('flybx_promo_msg', serialize($res), is_multisite());

					//echo $res['html'];					

					$msg_html = $res['html'];

					

					if (stripos($msg_html, "#update_details_link#") || stripos($msg_html, "#update_install_link#"))

					{

						//update plugins update data

						$current = get_site_transient( 'update_plugins' );	//Get the current update info

						$current->last_checked = 0;						//wp_update_plugins() checks this value when determining  

						set_site_transient( 'update_plugins', $current );	//whether to actually check for updates, so we reset it to zero.

						wp_update_plugins();

						//double check if we have everything to init update

						$current = get_site_transient( 'update_plugins' );

						if (!isset($current->checked) || !in_array($flybx_plugin_slug.'/'.$flybx_plugin_slug.'.php', $current->checked))

						{

							wp_update_plugins();

						}

					}

					

					//update with correct 'update details' links

					$msg_html = str_replace("#update_details_link#", network_admin_url('plugin-install.php?tab=plugin-information&plugin='.$flybx_plugin_slug.'&TB_iframe=true&width=640&height=341'), $msg_html);

					$msg_html = str_replace("#update_install_link#", wp_nonce_url(network_admin_url('update.php?action=upgrade-plugin&plugin='.$flybx_plugin_slug.'%2F'.$flybx_plugin_slug.'.php'), "upgrade-plugin_".$flybx_plugin_slug."/".$flybx_plugin_slug.".php"), $msg_html);

					

					echo json_encode(array('html' => $msg_html));

				}

				else

				{

					flybx_update_option('flybx_promo_msg', '', is_multisite());

				}

			}

		}



	die(); // this is required to return a proper result

}



function flybx_addons_check_javascript() {

?>

<script type="text/javascript" >

jQuery(document).ready(function($) {



	var data = {

		action: 'flybx_check_for_addons'

	};



	jQuery.post(ajaxurl, data, function(response) {

		//alert('Got this from the server: ' + response);

		if (response != '')

		{

			//var obj = jQuery.parseJSON(response);

			var obj = JSON.parse(response);

			if (obj.html != undefined)

			{

				jQuery('#flybx_addons_receiving_wrap').removeClass('flybx_loading');

				jQuery('#flybx_addons_receiving_wrap').html(obj.html);

				tb_init('a.flybx_thickbox');

			}

		}

	});

});

</script>

<?php

}

add_action('wp_ajax_flybx_check_for_addons', 'flybx_check_for_addons');

//$flybx_addons_check_url = 'http://192.232.235.92/flybx/addons_check/get_addons';

$flybx_addons_check_url = 'http://192.232.235.92/flybx/addons_check/get_addons';

function flybx_check_for_addons() {

	global $wpdb, $_POST, $flybx_addons_check_url, $flybx_current_plugin_version, $flybx_plugin_slug, $flybx_plugin_name;

	

	//grab new one

	$args = new stdClass;

	$args->version = $flybx_current_plugin_version;

	$request_string = flybx_prepare_request('msg_check', $args);

	$request = wp_remote_post($flybx_addons_check_url, $request_string);



	if (!is_wp_error($request)) 

	{

		$res = unserialize($request['body']);

		

		if ($res !== FALSE)

		{				

			

			//update flybx with new msg

			if (isset($res['html']))

			{

				$msg_html = $res['html'];

				

				

				

				if (stripos($msg_html, "#update_details_link#") || stripos($msg_html, "#update_install_link#"))

				{

					//update plugins update data

					$current = get_site_transient( 'update_plugins' );	//Get the current update info

					$current->last_checked = 0;						//wp_update_plugins() checks this value when determining  

					set_site_transient( 'update_plugins', $current );	//whether to actually check for updates, so we reset it to zero.

					wp_update_plugins();

					//double check if we have everything to init update

					$current = get_site_transient( 'update_plugins' );

					if (!isset($current->checked) || !in_array($flybx_plugin_slug.'/'.$flybx_plugin_slug.'.php', $current->checked))

					{

						wp_update_plugins();

					}

				}

				

				$msg_html = str_replace("#update_install_link#", wp_nonce_url(network_admin_url('update.php?action=upgrade-plugin&plugin='.$flybx_plugin_slug.'%2F'.$flybx_plugin_slug.'.php'), "upgrade-plugin_".$flybx_plugin_slug."/".$flybx_plugin_slug.".php"), $msg_html);

					

					

				echo json_encode(array('html' => $msg_html));

			}

		}

	}

	if (is_wp_error($request)) {

		$res = new WP_Error('plugins_api_failed', __('An Unexpected HTTP Error occurred during the API request.</p> <p><a href="?" onclick="document.location.reload(); return false;">Try again</a>'), $request->get_error_message());

	}



	die(); // this is required to return a proper result

}





if (isset($_GET['page']) && $_GET['page'] == 'flybx-more-plugins')

{

	add_action('admin_head', 'flybx_more_plugins_check_javascript');

}



function flybx_more_plugins()

{

	global $wpdb, $flybx_plugin_name, $flybx_plugin_slug;

	

	if ( function_exists('current_user_can') && !current_user_can('manage_options') )

			die(__('Cheatin&#8217; uh?', $flybx_plugin_slug));

	

	$curr_email = flybx_get_option('license_email');

	

	?>

	<div class="wrap">

		<h2><?php __("Get More Plugins", $flybx_plugin_slug); ?></h2>

		<p><?php __("You can find awesome new plugins on this page!", $flybx_plugin_slug); ?></p>

		

		<div id="flybx_addons_receiving_wrap" class="flybx_loading">&nbsp;</div>



	</div>

	<style>

	.flybx_loading {

	width: 128px; 

	height: 15px; 

	margin: 250px auto; 

	display: block;

	background: url(<?=site_url('wp-content/plugins/'.$flybx_plugin_slug.'/images/ajax-loader_bar.gif');?>) no-repeat center center;

	}

	</style>

	<?php

}



function flybx_more_plugins_check_javascript() {

?>

<script type="text/javascript" >

jQuery(document).ready(function($) {



	var data = {

		action: 'flybx_check_for_plugins'

	};



	jQuery.post(ajaxurl, data, function(response) {

		//alert('Got this from the server: ' + response);

		if (response != '')

		{

			//var obj = jQuery.parseJSON(response);

			var obj = JSON.parse(response);

			if (obj.html != undefined)

			{

				jQuery('#flybx_addons_receiving_wrap').removeClass('flybx_loading');

				jQuery('#flybx_addons_receiving_wrap').html(obj.html);

				tb_init('a.flybx_thickbox');

			}

		}

	});

});

</script>

<?php

}

add_action('wp_ajax_flybx_check_for_plugins', 'flybx_check_for_plugins');

//$flybx_addons_check_url = 'http://192.232.235.92/flybx/addons_check/get_addons';

$flybx_plugins_check_url = 'http://192.232.235.92/caller/more_plugins_check/get_plugins';

function flybx_check_for_plugins() {

	global $wpdb, $_POST, $flybx_plugins_check_url, $flybx_current_plugin_version, $flybx_plugin_slug, $flybx_plugin_name;

	

	//grab new one

	$args = new stdClass;

	$args->version = $flybx_current_plugin_version;

	$request_string = flybx_prepare_request('msg_check', $args);

	$request = wp_remote_post($flybx_plugins_check_url, $request_string);



	if (!is_wp_error($request)) 

	{

		$res = unserialize($request['body']);

		

		if ($res !== FALSE)

		{				

			

			//update flybx with new msg

			if (isset($res['html']))

			{

				$msg_html = $res['html'];

				

				

				

				if (stripos($msg_html, "#update_details_link#") || stripos($msg_html, "#update_install_link#"))

				{

					//update plugins update data

					$current = get_site_transient( 'update_plugins' );	//Get the current update info

					$current->last_checked = 0;						//wp_update_plugins() checks this value when determining  

					set_site_transient( 'update_plugins', $current );	//whether to actually check for updates, so we reset it to zero.

					wp_update_plugins();

					//double check if we have everything to init update

					$current = get_site_transient( 'update_plugins' );

					if (!isset($current->checked) || !in_array($flybx_plugin_slug.'/'.$flybx_plugin_slug.'.php', $current->checked))

					{

						wp_update_plugins();

					}

				}

				

				$msg_html = str_replace("#update_install_link#", wp_nonce_url(network_admin_url('update.php?action=upgrade-plugin&plugin='.$flybx_plugin_slug.'%2F'.$flybx_plugin_slug.'.php'), "upgrade-plugin_".$flybx_plugin_slug."/".$flybx_plugin_slug.".php"), $msg_html);

					

					

				echo json_encode(array('html' => $msg_html));

			}

		}

	}

	if (is_wp_error($request)) {

		$res = new WP_Error('plugins_api_failed', __('An Unexpected HTTP Error occurred during the API request.</p> <p><a href="?" onclick="document.location.reload(); return false;">Try again</a>'), $request->get_error_message());

	}



	die(); // this is required to return a proper result

}







//BOF custom news feed widget

add_action('wp_network_dashboard_setup', 'flybx_dashboard_widgets');

add_action('wp_dashboard_setup', 'flybx_dashboard_widgets');



function flybx_dashboard_widgets() {

	global $wp_meta_boxes, $flybx_plugin_slug, $flybx_plugin_name;

	$dashboard_key = 'dashboard';

	if (isset($wp_meta_boxes['dashboard-network']))

	{

		$dashboard_key = 'dashboard-network';

	}

	wp_add_dashboard_widget( 'flybx_dashboard_custom_feed', sprintf(__('%s Recent News & Updates', $flybx_plugin_slug), $flybx_plugin_name) , 'flybx_dashboard_custom_feed_output' );

	// Get the regular dashboard widgets array 

	// (which has our new widget already but at the end)

	$normal_dashboard = $wp_meta_boxes[$dashboard_key]['normal']['core'];	



	// Backup and delete our new dashboard widget from the end of the array

	$example_widget_backup = array('flybx_dashboard_custom_feed' => $normal_dashboard['flybx_dashboard_custom_feed']);

	unset($normal_dashboard['flybx_dashboard_custom_feed']);

	// Merge the two arrays together so our widget is at the beginning

	$sorted_dashboard = array_merge($example_widget_backup, $normal_dashboard);



	// Save the sorted array back into the original metaboxes 

	$wp_meta_boxes[$dashboard_key]['normal']['core'] = $sorted_dashboard;

	

}





function flybx_dashboard_custom_feed_output() {

	global $flybx_plugin_slug, $flybx_plugin_name;

	echo '<div>';

	wp_widget_rss_output(array(

	'url' => 'http://www.pluginsbyigor.com/launch/category/azonflybox-news/feed/',

	'title' => sprintf(__('%s Recent News & Updates', $flybx_plugin_slug), $flybx_plugin_name),

	'items' => 2,

	'show_summary' => 1,

	'show_author' => 0,

	'show_date' => 1

	));

	echo '</div>';

}

//EOF custom news feed widget



function flybx_templates() {

	global $am_indexes, $flybx_plugin_slug, $flybx_plugin_name, $flybx_skip_attrs;

	//if (!wp_verify_nonce($_REQUEST['_wpnonce'], dirname(plugin_basename(__FILE__)))) exit('Unauthorized access');

	require_once(dirname(dirname(__FILE__)).'/app/controllers/manage_templates.php');	

}





function flybx_prepare_postboxes()

{

wp_enqueue_script( 'postbox' );		

?>

<script type="text/javascript">

jQuery(document).ready( function() {

	jQuery('.postbox h3, .postbox .handlediv').click( function() {

		jQuery(jQuery(this).parent().get(0)).toggleClass('closed');

	});

});

</script>

<style>

	.postbox .hndle {cursor: pointer;}

	.advanced_tab_wrap {width: 80%;}

	.flybx_form_error {

	margin: 5px 0 15px;

	background-color: #FFEBE8;

	border-color: #CC0000;

	padding: 0 0.6em;

	border-radius: 3px 3px 3px 3px;

	border-style: solid;

	border-width: 1px;

	color: #333;

	}

</style>

<?php

}



function flybx_add_json_support()

{

	global $_SERVER, $flybx_plugin_slug, $flybx_plugin_name;

	//add json support for jquery older than 1.4.1

	$flybx_json_js_url = plugins_url( $flybx_plugin_slug.'/js/json2_min.js' , dirname(dirname(__FILE__)) );				

	if (isset($_SERVER['HTTP_HOST']) && substr($_SERVER['HTTP_HOST'], 0, 4) == 'www.' && substr($flybx_json_js_url, 0, 11) != 'http://www.' && substr($flybx_json_js_url, 0, 12) != 'https://www.')

	{

		if (substr($flybx_json_js_url, 0, 7) == 'http://') $flybx_json_js_url = str_replace('http://', 'http://www.', $flybx_json_js_url);

		if (substr($flybx_json_js_url, 0, 8) == 'https://') $flybx_json_js_url = str_replace('https://', 'https://www.', $flybx_json_js_url);

	}

	elseif (isset($_SERVER['HTTP_HOST']) && substr($_SERVER['HTTP_HOST'], 0, 4) != 'www.' && (substr($flybx_json_js_url, 0, 11) == 'http://www.' || substr($flybx_json_js_url, 0, 12) == 'https://www.'))

	{

		if (substr($flybx_json_js_url, 0, 7) == 'http://') $flybx_json_js_url = str_replace('http://', 'http://www.', $flybx_json_js_url);

		if (substr($flybx_json_js_url, 0, 8) == 'https://') $flybx_json_js_url = str_replace('https://', 'https://www.', $flybx_json_js_url);

	}

	wp_enqueue_script($flybx_plugin_slug.'_json', $flybx_json_js_url, array(), '1.0', true);

}



add_action('admin_print_scripts', 'flybx_jplayer_js');

function flybx_jplayer_js()

{

	global $flybx_plugin_slug;

	wp_register_script('flybx_audio', WP_PLUGIN_URL.'/'.$flybx_plugin_slug.'/js/jquery.jplayer.min.js', array('jquery'));

	wp_enqueue_script('flybx_audio');

}



function flybx_tpledit_admin_scripts() {

	global $flybx_plugin_slug;

	wp_enqueue_script('media-upload');

	wp_enqueue_script('thickbox');

	wp_register_script('flybx_tpledit_upload', WP_PLUGIN_URL.'/'.$flybx_plugin_slug.'/js/edit_tpl.js', array('jquery','media-upload','thickbox'));

	wp_enqueue_script('flybx_tpledit_upload');

}

 

function flybx_tpledit_admin_styles() {

	wp_enqueue_style('thickbox');

}

 

if (isset($_GET['page']) && (

							($_GET['page'] == 'flybx-config' && isset($_GET['tab']) && ($_GET['tab'] == 'appearance' /*|| $_GET['tab'] == 'amazon'*/ )) //|| 

							/*($_GET['page'] == 'flybx-templates' && ($_GET['subpage'] == 'edit' || $_GET['subpage'] == 'add'))*/

							) ) 

{

	add_action('admin_print_scripts', 'flybx_tpledit_admin_scripts');

	add_action('admin_print_styles', 'flybx_tpledit_admin_styles');

}



function flybx_visitor_log()

{

	global $wpdb, $flybx_plugin_slug;

	require_once(dirname(dirname(__FILE__)).'/app/controllers/visitor_log.php');	

}