<?php

$flybx_skip_attrs = array('Feature', 'CatalogNumberList', 'EANList', 'ListPrice', 'NumberOfItems', 'PackageQuantity', 'ProductTypeName', 'ProductGroup', 'Binding', 'Title');

function flybx_get_sim_asins($asins = array(), $locale = 'us')
{
	$found_count = 0;
	$params = array(
					'key_id' => get_option('flybx_am_key_id'), 
					'access_key' => get_option('flybx_am_access_key'),
					'associate_tag' => flybx_get_locale_tag($locale)
					);
								
	$flybx_am_class = new flybx_amazon_api($params);
	$transient_name = 'flybx_sim_'.$locale.'_'.implode('_', array_slice($asins, 0, 3));
	$response_groups = array('BrowseNodes', 'Similarities');
	//TODO: check if multiple asins form content work
	$amazon_response = $flybx_am_class->similar_lookup(implode(',', $asins), $locale, $response_groups);
	if (isset($amazon_response->Items) && (count($amazon_response->Items->Item) > 0) || (isset($amazon_response->Items->Item[0]->SimilarProducts->SimilarProduct) && count($amazon_response->Items->Item[0]->SimilarProducts->SimilarProduct) > 0))
	{
		$found_count = $found_count + count($amazon_response->Items->Item);
		if ($found_count >= 10)
		{
			$results_found = TRUE;
		}
		$similar_asins = array();
		if (isset($amazon_response->Items->Item[0]->SimilarProducts->SimilarProduct) && count($amazon_response->Items->Item[0]->SimilarProducts->SimilarProduct) > 0)
		{
			foreach($amazon_response->Items->Item as $curr_sim_item)
			{
				foreach($curr_sim_item->SimilarProducts->SimilarProduct as $curr_sim_product)
				{
					if (!in_array(strval($curr_sim_product->ASIN), $similar_asins))
					{
						$similar_asins[] = strval($curr_sim_product->ASIN);
					}
				}
			}
		}
		else
		{
			foreach($amazon_response->Items->Item->SimilarProducts->SimilarProduct as $curr_sim_product)
			{
				if (!in_array(strval($curr_sim_product->ASIN), $similar_asins))
				{
					$similar_asins[] = strval($curr_sim_product->ASIN);
				}
			}
		}
		
		if (count($similar_asins) > 0)
		{
			//cache sim asins for 7 days
			set_transient($transient_name, $similar_asins, 60*60*24*7);
			
			flybx_get_am_request_window();
			$similar_asins_data = flybx_am_search('asin:'.implode(',', $similar_asins), 'All', $params, 10, $locale, '', array('BrowseNodes'));
		}
		else
		{
			$found_count = 0;
			$results_found = FALSE;
		}
	}
	
	$result = array('asins' => $similar_asins, 'data' => array());
	if (count($similar_asins) > 0)
	{
		//return data about similar items
		return $result;
	}
	
	/*echo '<pre>';
	print_r($amazon_response);
	print_r($similar_asins);
	print_r($similar_asins_data);
	echo '</pre>';*/
	return FALSE;
	//return $similar_asins;
}

function flybx_get_related_asins($asins = array(), $locale = 'us')
{
	global $flybx_search_parameters, $flybx_real_top_nodes_indexes;
	require_once(dirname(__FILE__).'/amz_search_params/'.$locale.'.php');
	require_once(dirname(__FILE__).'/amz_real_top_nodes.php');
	$kws_asins = array();
	$found_count = 0;
	$params = array(
					'key_id' => get_option('flybx_am_key_id'), 
					'access_key' => get_option('flybx_am_access_key'),
					'associate_tag' => flybx_get_locale_tag($locale)
					);
								
	$flybx_am_class = new flybx_amazon_api($params);
	$transient_name = 'flybx_sim_'.$locale.'_'.implode('_', array_slice($asins, 0, 3));

	//$similar_asins_data = flybx_am_search('asin:'.implode(',', $asins), 'All', $params, 10, $locale, '', array('BrowseNodes'));
	
	$response_groups = array('BrowseNodes');
	$amazon_response = $flybx_am_class->asin_lookup(implode(',', $asins), $locale, $response_groups);
	
	/*echo '<pre>';
	print_r($amazon_response);
	echo '</pre>';
	exit;*/
	
	if (!isset($amazon_response->Items->Request->Errors))
	{			
		/*if (@count($amazon_response->Items->Item) > 0)
		{
			//echo 'found a lot';
			$amazon_items[] = $amazon_response->Items;
			$found_count = $found_count + count($amazon_response->Items->Item);
		}
		else
		{
			//echo 'found one';
			$generic_temp_object = new stdClass();
			$generic_temp_object->Item = array('0' => $amazon_response->Items->Item);
			$amazon_items[] = $generic_temp_object;
			$found_count = $found_count + 1;
		}*/
		
		if (@count($amazon_response->Items->Item) > 0)
		{
			foreach($amazon_response->Items->Item as $curr_amz_item)
			{
				//cache current product
				$curr_product = flybx_sanitize_amz_item($curr_amz_item, 0);
				flybx_update_item_cache(strval($curr_amz_item->ASIN), $curr_product, $locale);
				
				$kws_asins[] = strval($curr_amz_item->ASIN);
			}
		}
		else
		{
			//cache current product
			$curr_product = flybx_sanitize_amz_item($amazon_response->Items->Item, 0);
			flybx_update_item_cache(strval($amazon_response->Items->Item->ASIN), $curr_product, $locale);
			
			$kws_asins[] = strval($amazon_response->Items->Item->ASIN);
		}
		
		//lets grab that browse node
		if (isset($amazon_response->Items->Item->BrowseNodes->BrowseNode))
		{
			//finding current (close match) node id
			/*$browse_nodes = array();
			if (@count($amazon_response->Items->Item->BrowseNodes->BrowseNode) > 0)
			{
				//echo 'found a lot';
				$browse_nodes[] = $amazon_response->Items->Item->BrowseNodes->BrowseNode;
			}
			else
			{
				//echo 'found one';
				$generic_temp_object = new stdClass();
				$generic_temp_object->Item = array('0' => $amazon_response->Items->Item->BrowseNodes->BrowseNode);
				$browse_nodes[] = $generic_temp_object;
			}
			
			if (count($browse_nodes) > 0)
			{
				$top_browse_node = $browse_nodes[0];
			}*/
			
			$item = $amazon_response->Items->Item;
			//find top node_id_by checking BrowseNodes children in a loop
			
			if (@count($item->BrowseNodes->BrowseNode) > 0)
			{
				$top_node_found = FALSE;
				foreach($item->BrowseNodes->BrowseNode as $curr_node)
				{
					//echo '<br />checking';
					if ($top_node_found === FALSE)
					{
						$top_node_arr = flybx_get_top_node_from_loop($curr_node, $flybx_real_top_nodes_indexes[$locale]);
						if ($top_node_arr !== FALSE)
						{
							$top_node = $top_node_arr;							
							$top_node_found = TRUE;
							$bottom_node = flybx_get_bottom_node($curr_node);
						}
						
					}
				}
			}
			else
			{
				$top_node_arr = flybx_get_top_node_from_loop($item->BrowseNodes->BrowseNode, $flybx_real_top_nodes_indexes[$locale]);
				$top_node = $top_node_arr;
				$bottom_node = flybx_get_bottom_node($item->BrowseNodes->BrowseNode);
			}
			
			//cache current product
			$curr_product = flybx_sanitize_amz_item($item, 0);
			flybx_update_item_cache($asins[0], $curr_product, $locale);
			
			//top_node from first BrowseNode only
			/*if (@count($item->BrowseNodes->BrowseNode) > 0)
			{
				$ii = 0;
				foreach($item->BrowseNodes->BrowseNode as $first_node)
				{
					if ($ii == 0)
					{
						$top_node = flybx_get_top_node($first_node);
						$bottom_node = flybx_get_bottom_node($first_node);
					}
					$ii++;
				}
			}
			else
			{
				$top_node = flybx_get_top_node($item->BrowseNodes->BrowseNode);
				$bottom_node = flybx_get_bottom_node($item->BrowseNodes->BrowseNode);
			}*/
			
			$top_node_id = $top_node['node_id'];
			$bottom_node_id = $bottom_node['node_id'];
									
			$adtnl_url_params = array();
			$adtnl_url_params['BrowseNode'] = $bottom_node_id;
			
			//let's attempt to get top index (without it we can't do smart search)
			if (isset($flybx_real_top_nodes_indexes[$locale][$top_node_id]))
			{
				$search_index = $flybx_real_top_nodes_indexes[$locale][$top_node_id];
			
				$brand = '';
				$manufacturer = '';
				//collect brand
				if (isset($amazon_response->Items->Item->ItemAttributes->Brand))
				{
					$brand = strval($amazon_response->Items->Item->ItemAttributes->Brand);
				}
				//collect manufacturer
				if (isset($amazon_response->Items->Item->ItemAttributes->Manufacturer))
				{
					$manufacturer = strval($amazon_response->Items->Item->ItemAttributes->Manufacturer);
				}
				
				
				if (/*flybx_get_option('smart_search_brand') == 'yes' &&*/ isset($brand) && in_array('Brand', $flybx_search_parameters[$locale][$search_index]))
				{
					//$adtnl_url_params['Brand'] = rawurlencode($brand);
				}
				
				if (/*flybx_get_option('smart_search_manufacturer') == 'yes' &&*/ isset($manufacturer) && in_array('Manufacturer', $flybx_search_parameters[$locale][$search_index]) && !in_array($manufacturer, array('????')))
				{
					//$adtnl_url_params['Manufacturer'] = rawurlencode($manufacturer);
				}
				
				$real_price_arr = flybx_get_real_price($amazon_response->Items->Item);
				if (isset($real_price_arr['price_amt']))
				{
					$price_min = 0;
					$price_max = 2000;
					$real_price = $real_price_arr['price_amt']/100;
					if ($real_price < 50)
					{
						$price_max = 80;
					}
					elseif ($real_price < 100)
					{
						$price_min = $real_price - 50;
						$price_max = $real_price + 80;
					}
					elseif ($real_price < 250)
					{
						$price_min = $real_price - 120;
						$price_max = $real_price + 120;
					}
					elseif ($real_price < 500)
					{
						$price_min = $real_price - 200;
						$price_max = $real_price + 200;
					}
					elseif ($real_price < 1000)
					{
						$price_min = $real_price - 400;
						$price_max = $real_price + 400;
					}
					elseif ($real_price < 2000)
					{
						$price_min = $real_price - 800;
						$price_max = $real_price + 800;
					}
					else
					{
						$price_min = $real_price - 1500;
						$price_max = $real_price + 2000;
					}
					$adtnl_url_params['MinimumPrice'] = $price_min * 100;
					$adtnl_url_params['MaximumPrice'] = $price_max * 100;
					
				}
				
				$adtnl_url_params['Condition'] = 'New';
				
				/*echo '<pre>';
				print_r($adtnl_url_params);
				echo '</pre>';*/
				
				flybx_get_am_request_window();
				$amz_rel_res = $flybx_am_class->search_amazon('', $search_index, 1, $locale, FALSE, 'Offers', $adtnl_url_params);
				
				//cache results and save asins to be used as keywords
				if (!isset($amz_rel_res->Items->Request->Errors))
				{		
					if (@count($amz_rel_res->Items->Item) > 0)
					{
						foreach($amz_rel_res->Items->Item as $curr_amz_item)
						{
							//cache current product
							$curr_product = flybx_sanitize_amz_item($curr_amz_item, 0);
							flybx_update_item_cache(strval($curr_amz_item->ASIN), $curr_product, $locale);
							
							$kws_asins[] = strval($curr_amz_item->ASIN);
						}
					}
					else
					{
						//cache current product
						$curr_product = flybx_sanitize_amz_item($amz_rel_res->Items->Item, 0);
						flybx_update_item_cache(strval($amz_rel_res->Items->Item->ASIN), $curr_product, $locale);
						
						$kws_asins[] = strval($amz_rel_res->Items->Item->ASIN);
					}
					
					

				}			
			}
			
			
		}
	}
	
	if (count($kws_asins) > 0)
	{
		return $kws_asins;
	}

	
	/*$result = array('asins' => $similar_asins, 'data' => array());
	if (count($similar_asins) > 0)
	{
		//return data about similar items
		
	}*/
	
	/*echo '<br />search_index: '.$search_index;
	echo '<br />bottom_node_id: '.$bottom_node_id;
	echo '<br />top_node_id: '.$top_node_id;
	echo '<pre>';
	print_r($top_node);
	print_r($adtnl_url_params);
	print_r($amazon_response);
	echo '</pre>';*/
	//return $similar_asins;
	return FALSE;
}

function flybx_get_top_node($obj)
{
	if (isset($obj->Ancestors))
	{

		return flybx_get_top_node($obj->Ancestors->BrowseNode);
	}
	else
	{
		$return = array(
				'node_id' => strval($obj->BrowseNodeId),
				'name' => strval($obj->Name)
				);
		return $return;
	}
}
function flybx_get_top_node_from_loop($obj, $search_indexes_map = array())
{
	/*echo '<pre>';
	print_r($search_indexes_map);
	echo '</pre>';
	exit;*/
	$curr_node_id = strval($obj->BrowseNodeId);
	$curr_name = strval($obj->Name);
	if (!isset($search_indexes_map[$curr_node_id]))
	{
		if (isset($obj->Ancestors))
		{
			return flybx_get_top_node_from_loop($obj->Ancestors->BrowseNode, $search_indexes_map);
		}
		else
		{
			/*$return = array(
					'node_id' => FALSE,
					'name' => FALSE
					);
			return $return;*/
			return FALSE;
		}
	}
	else
	{
		$return = array(
					'node_id' => $curr_node_id,
					'name' => $curr_name
					);
		return $return;
	}
}
function flybx_get_bottom_node($obj)
{
	/*if (isset($obj->Ancestors))
	{

		return flybx_get_top_node($obj->Ancestors->BrowseNode);
	}
	else
	{*/
		$return = array(
				'node_id' => strval($obj->BrowseNodeId),
				'name' => strval($obj->Name)
				);
		return $return;
	//}
}

function flybx_get_real_price($item = '')
{
	$price_arr = array('price' => 'Too low to display');
	if (isset($item->Offers) && strval($item->Offers->TotalOffers) == 0)
	{
		//no offers - show 'from' price
		if (isset($item->OfferSummary->LowestNewPrice))
		{
			$price_arr['price_amt'] = strval($item->OfferSummary->LowestNewPrice->Amount);
			$price_arr['price'] = flybx_lang('from ', $locale).strval($item->OfferSummary->LowestNewPrice->FormattedPrice);
		}
		elseif (isset($item->OfferSummary->LowestUsedPrice))
		{
			$price_arr['price_amt'] = strval($item->OfferSummary->LowestUsedPrice->Amount);
			$price_arr['price'] = flybx_lang('from ', $locale).strval($item->OfferSummary->LowestUsedPrice->FormattedPrice);
		}					
	}
	elseif (isset($item->Offers) && strval($item->Offers->TotalOffers) == 1)
	{
		//check if there is saleprice
		if (isset($item->Offers->Offer->OfferListing->SalePrice))
		{
			$price_arr['price_amt'] = strval($item->Offers->Offer->OfferListing->SalePrice->Amount);
			$price_arr['price'] = strval($item->Offers->Offer->OfferListing->SalePrice->FormattedPrice);
			if (isset($item->Offers->Offer->OfferListing->Price))
			{
				$price_arr['old_price_amt'] = strval($item->Offers->Offer->OfferListing->Price->Amount);
				$price_arr['old_price'] = strval($item->Offers->Offer->OfferListing->Price->FormattedPrice);
			}
			//save percentage saved
			if(isset($item->Offers->Offer->OfferListing->PercentageSaved))
			{
				$price_arr['percentage_saved'] = strval($item->Offers->Offer->OfferListing->PercentageSaved);
			}
		}
		else
		{							
			//no salesprice - extract old price from difference
			$price_arr['price'] = strval($item->Offers->Offer->OfferListing->Price->FormattedPrice);
			if ($price_arr['price'] != 'Too low to display')
			{
				$price_arr['price_amt'] = strval($item->Offers->Offer->OfferListing->Price->Amount);
				if (isset($item->Offers->Offer->OfferListing->AmountSaved))
				{
					//save old price
					$price_arr['old_price_amt'] = $price_arr['price_amt'] + strval($item->Offers->Offer->OfferListing->AmountSaved->Amount);
					$currency_code = strval($item->Offers->Offer->OfferListing->AmountSaved->CurrencyCode);
					$currency_sign = '$';
					if ($currency_code != 'USD')
					{
						$currency_sign = strval($item->Offers->Offer->OfferListing->AmountSaved->CurrencyCode).' ';
					}
					if ($currency_code == 'GBP')
					{
						$currency_sign = '&pound;';
					}
					
					if (in_array($currency_code, array('USD', 'GBP')))
					{
						$price_arr['old_price'] = $currency_sign.number_format(($price_arr['old_price_amt'] * 0.01), 2);
					}
					else
					{
						$price_arr['old_price'] = $currency_sign.number_format(($price_arr['old_price_amt'] * 0.01), 2, ',', ' ');
					}
					//save percentage saved
					if(isset($item->Offers->Offer->OfferListing->PercentageSaved))
					{
						$price_arr['percentage_saved'] = strval($item->Offers->Offer->OfferListing->PercentageSaved);
					}
					
				}
			}
		}
	}
	elseif (isset($item->OfferSummary->LowestNewPrice))
	{
		$price_arr['price'] = strval($item->OfferSummary->LowestNewPrice->FormattedPrice);
		$price_arr['price_amt'] = strval($item->OfferSummary->LowestNewPrice->Amount);
		//do we have a list price?
		if(isset($item->ItemAttributes->ListPrice) && ($item->ItemAttributes->ListPrice->Amount > $item->OfferSummary->LowestNewPrice->Amount || strval($item->OfferSummary->LowestNewPrice->FormattedPrice) == 'Too low to display'))
		{
			$price_arr['old_price'] = strval($item->ItemAttributes->ListPrice->FormattedPrice);
			$price_arr['old_price_amt'] = strval($item->ItemAttributes->ListPrice->Amount);
		}
	}
	elseif(isset($item->ItemAttributes->ListPrice))
	{
		$price_arr['price'] = strval($item->ItemAttributes->ListPrice->FormattedPrice);
		$price_arr['price_amt'] = strval($item->ItemAttributes->ListPrice->Amount);
	}
	
	return $price_arr;
}

function flybx_sanitize_amz_item($item = '', $skip_noimage = 1, $skip_asins_arr = array())
{
	$results = array();
	if (isset($item->ASIN))
	{		
		if (($skip_noimage != 1 || ($skip_noimage == 1 && isset($item->MediumImage->URL) && strlen(strval($item->MediumImage->URL)) > 1)) && !in_array(strval($item->ASIN), $skip_asins_arr))
		{
			$asin = strval($item->ASIN);
			$results[$asin] = array(
					/*'image' => strval($item->MediumImage->URL),
					'img_width' => intval($item->MediumImage->Width),
					'img_height' => intval($item->MediumImage->Height),							
					'large_image' => strval($item->LargeImage->URL),
					'large_image_width' => strval($item->LargeImage->Width),
					'large_image_height' => strval($item->LargeImage->Height),
					'small_image' => strval($item->SmallImage->URL),
					'small_image_width' => strval($item->SmallImage->Width),
					'small_image_height' => strval($item->SmallImage->Height),*/
					'url' => strval($item->DetailPageURL),
					'name' => strval($item->ItemAttributes->Title),
					'asin' => $asin
					);
					
			if (isset($item->MediumImage->URL))
			{
				$results[$asin] = array_merge($results[$asin], 
									array(
					'image' => strval($item->MediumImage->URL),
					'img_width' => intval($item->MediumImage->Width),
					'img_height' => intval($item->MediumImage->Height),							
					'large_image' => strval($item->LargeImage->URL),
					'large_image_width' => strval($item->LargeImage->Width),
					'large_image_height' => strval($item->LargeImage->Height),
					'small_image' => strval($item->SmallImage->URL),
					'small_image_width' => strval($item->SmallImage->Width),
					'small_image_height' => strval($item->SmallImage->Height)
					));
			}
			elseif (isset($item->ImageSets->ImageSet) && count($item->ImageSets->ImageSet) > 0)
			{
				$iii = 0;
				foreach($item->ImageSets->ImageSet as $curr_imgset)
				{
					if ($iii == 0)
					{
						$results[$asin] =  array_merge($results[$asin], 
										array(
							'image' => strval($curr_imgset->MediumImage->URL),
							'img_width' => intval($curr_imgset->MediumImage->Width),
							'img_height' => intval($curr_imgset->MediumImage->Height),							
							'large_image' => strval($curr_imgset->LargeImage->URL),
							'large_image_width' => strval($curr_imgset->LargeImage->Width),
							'large_image_height' => strval($curr_imgset->LargeImage->Height),
							'small_image' => strval($curr_imgset->SmallImage->URL),
							'small_image_width' => strval($curr_imgset->SmallImage->Width),
							'small_image_height' => strval($curr_imgset->SmallImage->Height)
							));
					}
					$iii++;
				}
				
			}
			
			/*echo '<pre>';
			print_r($results[$asin]);
			print_r($item);
			echo '</pre>';
			exit;*/
			
			//store attributes
			/*foreach()
			{
			
			}*/
			$results[$asin]['timestamp'] = time();
			
			$results[$asin]['attributes'] = flybx_xml_to_array($item->ItemAttributes); 
			/*echo '<pre>';
			print_r($values);
			echo '</pre>';*/

			$item_price = flybx_get_real_price($item);
			$results[$asin] = array_merge($results[$asin], $item_price);
			
			//always save list_price
			if(isset($item->ItemAttributes->ListPrice))
			{
				$results[$asin]['list_price'] = strval($item->ItemAttributes->ListPrice->FormattedPrice);
				$results[$asin]['list_price_amt'] = strval($item->ItemAttributes->ListPrice->Amount);
			}
			//save OfferListingId
			$results[$asin]['OfferListingId'] = '';
			if (isset($item->Offers->Offer->OfferListing->OfferListingId))
			{
				$results[$asin]['OfferListingId'] = strval($item->Offers->Offer->OfferListing->OfferListingId);
				$results[$asin]['OfferPrice'] = strval($item->Offers->Offer->OfferListing->Price->FormattedPrice);
			}
			//save "all offers" link
			
			if (isset($item->ItemLinks->ItemLink) )
			{
				$itemlinks_set = $item->ItemLinks;
									
				foreach($itemlinks_set->ItemLink as $maybe_link)
				{
					if (isset($maybe_link->Description) && isset($maybe_link->URL))
					{
						if (strval($maybe_link->Description) == 'All Offers')
						{
							$results[$asin]['url_all_offers'] = strval($maybe_link->URL);
							$results[$asin]['all_offers_total'] = @strval($item->Offers->TotalOffers);
						}
						if (strval($maybe_link->Description) == 'All Customer Reviews')
						{
							$results[$asin]['url_all_reviews'] = strval($maybe_link->URL);
						}							
					}
				}

			}
			
			//save description
			if (isset($item->EditorialReviews->EditorialReview->Source) && strval($item->EditorialReviews->EditorialReview->Source) == 'Product Description')
			{
				$results[strval($item->ASIN)]['description'] = substr(strval($item->EditorialReviews->EditorialReview->Content), 0, 1000);
			}
					
		}
	}
	return $results;
}

function flybx_update_item_cache($asin = '0', $flybx_data = array(), $locale = 'us')
{
	global $wpdb;
	$search_method = 0;
	//locale map
	$locale_map = flybx_locale_map();
	//delete old cache
	//do not filter by post_id to allow posts share same kws
	$delete_sql = "DELETE FROM `".$wpdb->prefix."flybx_cache` WHERE locale = '".$locale_map[$locale]."' AND search_method = '".$search_method."' AND `kws` = '".$wpdb->escape('asin:'.$asin)."' AND source = '0' LIMIT 1";
	$wpdb->query($delete_sql);
	
	//insert new cache
	if (count($flybx_data) > 0)
	{
		$insert_sql = "INSERT INTO `".$wpdb->prefix."flybx_cache` SET `post_id` = '0', `source` = '0', `search_method` = '".$wpdb->escape($search_method)."', `locale` = '".$locale_map[$locale]."', `content` = '".str_replace("'", "\'", serialize($flybx_data))."', `kws` = '".$wpdb->escape('asin:'.$asin)."', timestamp = '".time()."'";
		$wpdb->query($insert_sql);
	}
}

function flybx_update_asins_cache($kws = array(), $locale = 'us', $am_params = array())
{
	$asins = array();
	$data = array();
	//grab asins
	foreach($kws as $curr_kw)
	{
		$asins[] = str_replace('asin:', '', $curr_kw);
	}
	$flybx_am_class = new flybx_amazon_api($am_params);
	$response_groups = array('Offers');
	//comply with Amazon API time limits
	flybx_get_am_request_window();
	$amazon_response = $flybx_am_class->asin_lookup(implode(',', $asins), $locale, $response_groups);
	if (!isset($amazon_response->Items->Request->Errors))
	{
		if (@count($amazon_response->Items->Item) > 0)
		{
			foreach($amazon_response->Items->Item as $curr_amz_item)
			{
				//cache current product
				$curr_product = flybx_sanitize_amz_item($curr_amz_item, 0);
				flybx_update_item_cache(strval($curr_amz_item->ASIN), $curr_product, $locale);
				
				$data = array_merge($data, $curr_product);
			}
		}
		else
		{
			//cache current product
			$curr_product = flybx_sanitize_amz_item($amazon_response->Items->Item, 0);
			flybx_update_item_cache(strval($amazon_response->Items->Item->ASIN), $curr_product, $locale);
			
			$data = array_merge($data, $curr_product);
		}
	}
	return $data;
}

function flybx_xml_to_array($xml) 
{ 
  if ($xml instanceof SimpleXMLElement) { 
    $children = $xml->children(); 
    $return = null; 
  } 

  foreach ($children as $element => $value) { 
    if ($value instanceof SimpleXMLElement) { 
      $values = (array)$value->children(); 

      if (count($values) > 0) { 
        $return[$element] = flybx_xml_to_array($value); 
      } else { 
        if (!isset($return[$element])) { 
          $return[$element] = (string)$value; 
        } else { 
          if (!is_array($return[$element])) { 
            $return[$element] = array($return[$element], (string)$value); 
          } else { 
            $return[$element][] = (string)$value; 
          } 
        } 
      } 
    } 
  } 

  if (is_array($return)) { 
    return $return; 
  } else { 
    return $false; 
  } 
} 

function flybx_good_attr($template = array())
{
	require_once(dirname(__FILE__).'/flybx_amz_avail_attr.php');
	
	/*$attr_arr = array();
	foreach($flybx_attrs as $product_type => $attrs)
	{
		foreach($attrs as $curr_attr)
		{
			if (!isset($attr_arr[$curr_attr]))
			{
				$attr_arr[$curr_attr] = array($product_type);
			}
			else
			{
				$attr_arr[$curr_attr][] = $product_type;
			}
		}
	}
	
	return $attr_arr['Office Product'];*/
	
	/*echo '<pre>';
	print_r($template);
	echo '</pre>';*/
	
	if (is_array($template) && isset($template['attrs']) && is_array($template['attrs']))
	{
		return $template['attrs'];
	}
	
	return array();
	
	/*echo '<pre>';
	print_r($attr_arr);
	echo '</pre>';*/
	/*echo '<pre>';
	var_export($attr_arr);
	echo '</pre>';*/
	
}

function flybx_amz_attr_show($attr_name = '', $attrs = '', $locale = 'us')
{
	if (!is_array($attrs))
	{
		return $attrs;
	}
	else
	{
		if ($attr_name == 'Languages')
		{
			
			if (isset($attrs['Language']['Name']))
			{
				return $attrs['Language']['Name'];
			}
		}
		elseif ($attr_name == 'ItemDimensions' || $attr_name == 'ProductDimensions' || $attr_name == 'PackageDimensions')
		{
			$return = '';
			$dims = array();
			if (isset($attrs['Width']) && isset($attrs['Height']) && isset($attrs['Length']) && strlen(trim($attrs['Width'])) > 0 && strlen(trim($attrs['Height'])) > 0 && strlen(trim($attrs['Length'])) > 0 )
			{
				$dims = array();
				if ($locale == 'us' || $locale == 'uk')
				{
					$dims[] = round(($attrs['Width']) * 0.01, 1);
					$dims[] = round(($attrs['Height']) * 0.01, 1);
					$dims[] = round(($attrs['Length']) * 0.01, 1);
					$return .= implode(' x ', $dims) . ' in';
				}
				else
				{
					$dims[] = round(($attrs['Width']) * 0.01, 1);
					$dims[] = round(($attrs['Height']) * 0.01, 1);
					$dims[] = round(($attrs['Length']) * 0.01, 1);
					$return .= implode(' x ', $dims) . ' cm';
				}

				
			}
			if (isset($attrs['Weight']) && strlen(trim($attrs['Weight'])) > 0)
			{
				if ($locale == 'us' || $locale == 'uk')
				{
					if (strlen($return) > 0) $return .= '<br />'; 
					$return .= round(($attrs['Weight']) * 0.01, 1).' lb';
				}
				else
				{
					if (strlen($return) > 0) $return .= '<br />'; 
					if ($attrs['Weight'] > 1000)
					{
						$return .= round(($attrs['Weight']) * 0.001, 2).' kg';
					}
					else
					{
						$return .= $attrs['Weight'].' g';
					}
					
				}
			}
			return $return;
		}
		elseif ($attr_name == 'TradeInValue')
		{			
			if (isset($attrs['FormattedPrice']))
			{
				return $attrs['FormattedPrice'];
			}
		}
		elseif (count($attrs) == 1 && !is_array(current($attrs)))
		{
			return current($attrs);
		}
		elseif (count($attrs) == 1 && is_array(current($attrs)))
		{
			return implode(', ', current($attrs));
		}
		elseif (count($attrs) > 0)
		{
			$all_single_elements = TRUE;
			foreach($attrs as $curr_attr)
			{
				if (is_array($curr_attr))
				{
					$all_single_elements = FALSE;
				}
			}
			if ($all_single_elements === TRUE)
			{
				return implode(', ', $attrs);
			}
		}
			/*echo '<pre>';
			print_r($attrs);
			echo '</pre>';
		return 'array';*/
		return '';
	}
}
function flybx_camel_to_spaces($string = '')
{
	$string = preg_replace('/(?<=\\w)(?=[A-Z])/'," $1", $string);
	$string = trim($string);
	$abbreviations = array('U P C', 'E A N', 'S K U', 'E I S B N', 'I S B N', 'C P U', 'M P N', 'U S B', 'E S R B', 'I S O', 'P C I', 'C D R W', 'D V D R W', 'D V D', 'N T S C P A L', 'V G A', 'P C', 'C E R O', 'T V', 'B I S S', 'C E', 'G P S');
	foreach($abbreviations as $curr_abr)
	{
		$string = str_replace($curr_abr, str_replace(' ', '', $curr_abr), $string);
	}
	
	return $string;
}