<?php
if(!defined('ABSPATH')) die('Direct access not premitted');

$flybx_lang = array(
			'flybx_901' => array(
				'name' => 'Buy Now'
				),
			/*'flybx_1003' => array(
				'name' => 'Read Reviews'
				),*/
			'flybx_1006' => array(
				'name' => 'from ',
				'description' => 'In some cases prices have "from" prefix. For example: from $79.90'
				),
			'flybx_1014' => array(
				'name' => 'Product prices and availability are accurate as of %time% but are subject to change. <br />Any price and availability information displayed on the merchant site at the time of purchase will apply to the purchase of this product.',
				'description' => 'Date/Time stamp of pricing availability to comply with Amazon advertising TOS. <br />%time% token will be replaced to the actual time.'
				),
			'flybx_1015' => array(
				'name' => 'Details',
				'description' => '"Details" link that shows required by Amazon TOS timestamp'
				),
			'flybx_1016' => array(
				'name' => 'See Price',
				'description' => 'Used when price can only be seen on Amazon site'
				),
			'flybx_1050' => array(
				'name' => 'powered by',
				'description' => 'tiny branding message only visible if enabled through Appearance settings'
				),
			'flybx_1060' => array(
				'name' => 'You May Also Like',
				'description' => 'message on the top of the ad'
				),
			);
			
$flybx_lang_keys = array(
			'flybx_901' => 'Buy Now',
			/*'flybx_1003' => 'Read Reviews', */
			'flybx_1006' => 'from ', 
			'flybx_1014' => 'Product prices and availability are accurate as of %time% but are subject to change. <br />Any price and availability information displayed on the merchant site at the time of purchase will apply to the purchase of this product.',
			'flybx_1015' => 'Details',
			'flybx_1016' => 'See Price',
			'flybx_1050' => 'powered by',
			'flybx_1060' => 'You May Also Like',

			);

if (flybx_is_plus())
{
	$flybx_lang['flybx_902'] = array(
				'name' => 'Add To Cart'
				);
	$flybx_lang_keys['flybx_902'] = 'Add To Cart';
}

flybx_aply_langsett();

function flybx_aply_langsett()
{
	global $flybx_lang_keys, $flybx_lang, $flybx_attrs;
	$active_countries = flybx_active_locales();
	
	include_once(dirname(__FILE__).'/flybx_amz_avail_attr.php');
	
	//adding already translated content
	$curr_lang_str = flybx_get_option('lang_sett');
	if ($curr_lang_str !== FALSE && strlen($curr_lang_str) > 0)
	{
		$lang_unserialized = @unserialize($curr_lang_str);
		/*echo '<pre>';
		print_r($lang_unserialized);
		echo '</pre>';*/
		if (is_array($lang_unserialized) && isset($lang_unserialized['lang']) && isset($lang_unserialized['lang_keys']))
		{
			foreach($lang_unserialized['lang_keys'] as $key => $name)
			{
				if (isset($flybx_lang_keys[$key]))
				{
					//applying 
					foreach($active_countries as $curr_country)
					{
						if (isset($lang_unserialized['lang'][$key][$curr_country]))
						{
							$flybx_lang[$key][$curr_country] = $lang_unserialized['lang'][$key][$curr_country];
						}
					}
					
				}
				/*else
				{
					//adding new phrase (probably translated and deleted before?)
				}*/
			}
		}
	}
}

function flybx_save_langsett()
{
	global $flybx_lang_keys, $flybx_lang;
	$active_countries = flybx_active_locales();
	
	foreach($flybx_lang as $key => $vals)
	{
		foreach($active_countries as $curr_country)
		{
			
			$curr_country = strtolower($curr_country);
			if (isset($_POST[$key][$curr_country]))
			{
				
				$flybx_lang[$key][$curr_country] = $_POST[$key][$curr_country];
			}
		}
	}
	$lang_sett = array('lang' => $flybx_lang, 'lang_keys' => $flybx_lang_keys);
	
	$curr_lang_str = flybx_update_option('lang_sett', serialize($lang_sett));
}

function flybx_lang($word = '', $locale = 'us')
{
	global $flybx_lang_keys, $flybx_lang;
	$locale = strtolower($locale);
	if (in_array($word, $flybx_lang_keys))
	{
		$key = array_search($word, $flybx_lang_keys);
		if (isset($flybx_lang[$key][$locale]))
		{
			//found translation
			return flybx_sanitize_lang($flybx_lang[$key][$locale]);
		}
		else
		{			
			//translation not found - return defaults
			if (isset($flybx_lang[$key]['default']))
			{
				
				return flybx_sanitize_lang($flybx_lang[$key]['default']);
			}
			elseif(isset($flybx_lang[$key]['name']))
			{
				return flybx_sanitize_lang($flybx_lang[$key]['name']);
			}
		}
	}
	return flybx_sanitize_lang($word);
}

function flybx_sanitize_lang($word = '')
{
	$word = str_replace('"', '&quot;', stripslashes($word));
	return $word;
}

function flybx_timestamp_format($timestamp = '', $locale = 'us')
{
	$format = 'm/d/Y H:i e';
	return date($format, $timestamp);
}