<?php
/*
Copyright (c) 2012, Rich Ways LLC
All rights reserved.

Azon FlyBox License
http://www.pluginsbyigor.com

1. Terms 

By using this software, you are agreeing to be bound by these Terms and Conditions of Use, all applicable laws and regulations, and agree that you are responsible for compliance with any applicable local laws. If you do not agree with any of these terms, you are prohibited from using this software. The materials contained in this software are protected by applicable copyright and trade mark law. 

2. Use License 

a. By using Azon FlyBox you agree and comply to Amazon.com Product Advertising API License Agreement found here: https://affiliate-program.amazon.com/gp/advertising/api/detail/agreement.html
b. You may use the Azon FlyBox software for the purposes of running a website on a number of domain names as allowed by your license. 
c. You may make a reasonable number of copies for backup purposes only. 
d. You may modify the Azon FlyBox software as per your requirements as long as the modifications would not circumvent the licensing system. 

3. Limitations 
a. You may not use Azon FlyBox on any domain not wholly owned by you. 
b. You may not distribute copies of the Azon FlyBox software or transfer any part of it to a 3rd party. 
c. You may not rent, lease, sell, or sub-license the Azon FlyBox software or copies of it.
d. You may not use the software to engage in any illegal activity. 
e. You may not circumvent the licensing system in any way. 

4. Disclaimer 

The materials on Azon FlyBox's website and the Azon FlyBox software are provided "as is". Azon FlyBox makes no warranties, expressed or implied, and hereby disclaims and negates all other warranties, including without limitation, implied warranties or conditions of merchantability, fitness for a particular purpose, or non-infringement of intellectual property or other violation of rights. Further, Azon FlyBox does not warrant or make any representations concerning the accuracy, likely results, or reliability of the use of the materials on its Internet web site or otherwise relating to such materials or on any sites linked to this site. 

5. Revisions and Errata 

The materials appearing on Azon FlyBox's web site could include technical, typographical, or photographic errors. Azon FlyBox does not warrant that any of the materials on its web site are accurate, complete, or current. Azon FlyBox may make changes to the materials contained on its web site at any time without notice. Azon FlyBox does not, however, make any commitment to update the materials. 

6. Links 

Azon FlyBox has not reviewed all of the sites linked to its Internet web site and is not responsible for the contents of any such linked site. The inclusion of any link does not imply endorsement by Azon FlyBox of the site. Use of any such linked web site is at the user's own risk. 

7. Site Terms of Use Modifications 

Azon FlyBox may revise these terms of use for its web site at any time without notice. By using this web site you are agreeing to be bound by the then current version of these Terms and Conditions of Use. 

8. Governing Law 

Any claim relating to Azon FlyBox's web site shall be governed by the laws of the State of Wisconsin (USA) without regard to its conflict of law provisions. 
*/


function flybx_add_option($name = '', $value = '', $multisite = FALSE)
{
	global $wpdb;
	if ($name != '')
	{
		if ($multisite === FALSE)
		{
			//only add option if it doesnt already exist
			if ($res == 0 && flybx_get_option($name) === false)
			{
				$sql = "INSERT INTO ".$wpdb->prefix."flybx_options SET `name` = '".$wpdb->escape($name)."', `value` = '".$wpdb->escape($value)."'";
				$res = $wpdb->query($sql);
			}
		}
		else
		{
			//only add option if it doesnt already exist
			if ($res == 0 && flybx_get_option($name, $multisite) === false)
			{
				$sql = "INSERT INTO flybx_wpms_global_settings SET `name` = '".$wpdb->escape($name)."', `value` = '".$wpdb->escape($value)."'";
				$res = $wpdb->query($sql);
			}
		}
	}
}

function flybx_update_option($name = '', $value = '', $multisite = FALSE)
{
	global $wpdb;
	if ($name != '')
	{
		if ($multisite === FALSE)
		{
			$sql = "UPDATE ".$wpdb->prefix."flybx_options SET `value` = '".$wpdb->escape($value)."' WHERE name = '".$wpdb->escape($name)."' LIMIT 1";
			$res = $wpdb->query($sql);
			//if option doesnt exist - insert it
			if ($res == 0 && flybx_get_option($name) === false)
			{
				$sql = "INSERT INTO ".$wpdb->prefix."flybx_options SET `name` = '".$wpdb->escape($name)."', `value` = '".$wpdb->escape($value)."'";
				$res = $wpdb->query($sql);				
			}
		}
		else
		{
			$sql = "UPDATE flybx_wpms_global_settings SET `value` = '".$wpdb->escape($value)."' WHERE name = '".$wpdb->escape($name)."' LIMIT 1";
			$res = $wpdb->query($sql);
			//if option doesnt exist - insert it
			if ($res == 0 && flybx_get_option($name, $multisite) === false)
			{
				$sql = "INSERT INTO flybx_wpms_global_settings SET `name` = '".$wpdb->escape($name)."', `value` = '".$wpdb->escape($value)."'";
				//if ($name == 'flybx_show_promo_msgs') echo $sql;
				$res = $wpdb->query($sql);
			}
		}
	}
}

function flybx_get_option($name = '', $multisite = FALSE)
{
	global $wpdb;
	if ($name != '')
	{
		if ($multisite === FALSE)
		{
			$res = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."flybx_options WHERE name = '".$wpdb->escape($name)."' LIMIT 1");
		}
		else
		{
			$res = $wpdb->get_row("SELECT * FROM flybx_wpms_global_settings WHERE name = '".$wpdb->escape($name)."' LIMIT 1");
		}
		
		if ($res === NULL)
		{
			$res = false;
			return false;
		}
		else
		{
			return $res->value;
		}		
	}
}

function flybx_delete_option($name = '', $multisite = FALSE)
{
	global $wpdb;
	if ($multisite === FALSE)
	{
		$res = $wpdb->query("DELETE FROM ".$wpdb->prefix."flybx_options WHERE name = '".$wpdb->escape($name)."' LIMIT 1");
	}
	else
	{
		//multisite
		$res = $wpdb->query("DELETE FROM flybx_wpms_global_settings WHERE name = '".$wpdb->escape($name)."' LIMIT 1");
	}
}

function flybx_delete_cache($post_id = 0)
{
	global $wpdb;
	$delete_sql = "DELETE FROM `".$wpdb->prefix."flybx_cache` WHERE post_id = '".$wpdb->escape($post_id)."' LIMIT 1";
	$wpdb->query($delete_sql);

}

function flybx_clear_cache()
{
	global $wpdb;
	$delete_sql = "TRUNCATE TABLE `".$wpdb->prefix."flybx_cache`;";
	$wpdb->query($delete_sql);
	
	//delete transient stored in db
	$wpdb->query("DELETE FROM $wpdb->options WHERE (option_name LIKE '_transient_flybx_%' OR option_name LIKE '_transient_timeout_flybx_%') ");
}

function flybx_call($data = array(), $url = '', $show_errors = true, $json_decode = true, $attempt = 0)
{
	global $flybx_current_plugin_version, $flybx_plugin_slug;
	set_time_limit(300);
	
	//add admin ip
	if (count($data) > 0)
	{
		$data['admin_ip'] = $_SERVER['REMOTE_ADDR'];
		$data['version'] = $flybx_current_plugin_version;
	}
	//build get request
	$get_vars = array();
	foreach($data as $key => $val)
	{
		$get_vars[] = $key."=".urlencode($val);
	}
	$get_request = implode('&', $get_vars);
	if (!function_exists('json_decode'))
	{
		if ($show_errors) echo '<div class="updated"><p>'.__('PHP Error: Your server doesn\'t support function json_decode()', $flybx_plugin_slug).'</p></div>';	
		return false;
	}
	elseif ( function_exists('curl_init') ) {
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (compatible; Konqueror/4.0; Microsoft Windows) KHTML/4.0.80 (like Gecko)");
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $get_request);
		curl_setopt($ch, CURLOPT_TIMEOUT, 60);
		$response = curl_exec($ch);

		//echo $url.'?'.$get_vars;
		//try one more time with ip if couldn't resolve host
		if (!$response && stripos(curl_error($ch), "resolve host") && stripos($url, '192.232.235.92') === FALSE && $attempt == 0 )
		{
			curl_close($ch);
			$url = str_replace('azonflybox.com', '192.232.235.92', $url);
			return flybx_call($data, $url, $show_errors, $json_decode, ($attempt + 1));
		}
		else
		{
			if (!$response) {
				if ($show_errors) echo '<div class="updated"><p>'.__('cURL Error: ', $flybx_plugin_slug).' '.curl_error($ch).'</p></div>';	
				return false;
			}	
		}		
		curl_close($ch);
	} else { 				
		$response = @file_get_contents($url.'?'.$get_request);
		if (!$response) {
			if ($show_errors) echo '<div class="updated"><p>'.__('Error: cURL is not installed on this server.', $flybx_plugin_slug).'</p></div>';	
			return false;
		}
	}
	if ($json_decode === true)
	{
		return json_decode($response);
	}
	else
	{
		return $response;
	}
}

function flybx_locale_map()
{
	$map = array(
				'us' => 1,
				'uk' => 2,
				'de' => 3,
				'jp' => 4,
				'fr' => 5,
				'ca' => 6,
				'it' => 7,
				'cn' => 8,
				'es' => 9
				);
	return $map;
}

function flybx_get_locale($return_closest = TRUE)
{
	$country = 'smthelse';
	include_once("geoip.inc");
	$custom_geoip_path = flybx_get_option('flybx_path_to_geoip_dat');
	if ($custom_geoip_path !== FALSE && file_exists($custom_geoip_path))
	{
		$gi = geoip_open($custom_geoip_path, GEOIP_MEMORY_CACHE);
	}
	else
	{
		$gi = geoip_open(dirname(__FILE__).'/GeoIP.dat', GEOIP_MEMORY_CACHE);
	}
	$user_country = geoip_country_code_by_addr($gi, $_SERVER['REMOTE_ADDR']);
	//$user_country = geoip_country_code_by_addr($gi, 'customiphere'); //testing
	//echo 'country is: '.$user_country;
	if ($_SERVER['REMOTE_ADDR'] == '127.0.0.1')
	{
		$user_country = 'local_computer_127.0.0.1';
	}
	$user_country = strtolower($user_country);	
	//$user_country = 'us'; //testing
	
	if ($user_country == 'gb')
	{
		$user_country = 'uk';
	}
	
	if ($return_closest === FALSE)
	{
		return $user_country;
	}
	
	if (in_array($user_country, array('us', 'uk', 'de', 'jp', 'fr', 'ca', 'it', 'cn', 'es', 'gb')))
	{		
		$country = flybx_closest_locale($user_country);		
	}
	else
	{
		$country = flybx_closest_locale($country);
	}
	//echo 'country'.$country.':'.$user_country;
	//exit;
	geoip_close($gi);
	return $country;
}

function flybx_closest_locale($locale = 'us')
{
	if ($locale == 'us')
	{
		$amzn_tag = get_option('flybx_am_associate_tag');
	}
	else
	{
		$amzn_tag = get_option('flybx_locale_tag_'.$locale);
	}

	if (!in_array($locale, array('us', 'uk', 'de', 'jp', 'fr', 'ca', 'it', 'cn', 'es')) || $amzn_tag === FALSE || strlen(trim($amzn_tag)) == 0)
	{
		$default_country = flybx_get_option('flybx_unsupported_country_default');
		//echo 'default_country:'.$default_country;exit;
		if ($default_country === FALSE || $default_country == 'none')
		{			
			return 'smthelse';
		}
		else
		{
			return $default_country;
		}
	}
	return $locale;
}

function flybx_get_locale_tag($locale = 'us')
{
	if ($locale == 'us')
	{
		$tag = get_option('flybx_am_associate_tag');
	}
	else
	{
		$tag = get_option('flybx_locale_tag_'.$locale);
	}
	return $tag;
}

function flybx_base64_url_encode($input) {
 return strtr(base64_encode($input), '+/=', '-_,');
}

function flybx_base64_url_decode($input) {
 return base64_decode(strtr($input, '-_,', '+/='));
}

function flybx_get_pop_messages($flybx_tpl)
{
	$flybx_messages = array();
	$flybx_message_one = flybx_get_option($flybx_tpl.'_message');
	$flybx_message_two = flybx_get_option($flybx_tpl.'_message_two');
	$flybx_message_three = flybx_get_option($flybx_tpl.'_message_three');
	$flybx_message_four = flybx_get_option($flybx_tpl.'_message_four');
	$flybx_message_five = flybx_get_option($flybx_tpl.'_message_five');
	if (strlen($flybx_message_one) > 0) $flybx_messages[1] = stripslashes($flybx_message_one);
	if (strlen($flybx_message_two) > 0) $flybx_messages[2] = stripslashes($flybx_message_two);
	if (strlen($flybx_message_three) > 0) $flybx_messages[3] = stripslashes($flybx_message_three);
	if (strlen($flybx_message_four) > 0) $flybx_messages[4] = stripslashes($flybx_message_four);
	if (strlen($flybx_message_five) > 0) $flybx_messages[5] = stripslashes($flybx_message_five);
	return $flybx_messages;
}

function flybx_get_pop_messages_stats()
{
	global $flybx_plugin_slug;
	$msgs_arr = array();
	$tpl_msgs = flybx_get_pop_messages('tpl_am3across');
	foreach($tpl_msgs as $key => $msg)
	{
		$msgs_arr['0'.$key] = $msg.' ('.__('3 Products', $flybx_plugin_slug).')';
	}
	$tpl_msgs = flybx_get_pop_messages('tpl_am1product');
	foreach($tpl_msgs as $key => $msg)
	{
		$msgs_arr['1'.$key] = $msg.' ('.__('1 Product', $flybx_plugin_slug).')';
	}
	$tpl_msgs = flybx_get_pop_messages('tpl_custom1');
	foreach($tpl_msgs as $key => $msg)
	{
		$msgs_arr['2'.$key] = $msg.' ('.__('Custom 1', $flybx_plugin_slug).')';
	}
	$tpl_msgs = flybx_get_pop_messages('tpl_custom2');
	foreach($tpl_msgs as $key => $msg)
	{
		$msgs_arr['3'.$key] = $msg.' ('.__('Custom 2', $flybx_plugin_slug).')';
	}
	$tpl_msgs = flybx_get_pop_messages('tpl_custom3');
	foreach($tpl_msgs as $key => $msg)
	{
		$msgs_arr['4'.$key] = $msg.' ('.__('Custom 3', $flybx_plugin_slug).')';
	}
	return $msgs_arr;
}

function flybx_record_stat($action = 0, $variation_type = 0, $variation_value = '', $year = 0, $month = 0, $day = 0)
{
	global $wpdb;
	if ($year == 0) $year = date('Y');
	if ($month == 0) $month = date('m');
	if ($day == 0) $day = date('d');
	
	$sql = "SELECT * FROM ".$wpdb->prefix."flybx_stats WHERE `action` = '".$wpdb->escape($action)."' AND `variation_type` = '".$wpdb->escape($variation_type)."' AND `variation_value` = '".$wpdb->escape($variation_value)."' AND `year` = '".$wpdb->escape($year)."' AND `month` = '".$wpdb->escape($month)."' AND `day` = '".$wpdb->escape($day)."' LIMIT 1";
	$res = $wpdb->get_row($sql);
		
	if ($res === NULL)
	{
		$sql = "INSERT INTO ".$wpdb->prefix."flybx_stats SET `action` = '".$wpdb->escape($action)."', `variation_type` = '".$wpdb->escape($variation_type)."', `variation_value` = '".$wpdb->escape($variation_value)."', `year` = '".$wpdb->escape($year)."', `month` = '".$wpdb->escape($month)."', `day` = '".$wpdb->escape($day)."', `total` = '1'";
		$res = $wpdb->query($sql);
	}
	else
	{
		$sql = "UPDATE ".$wpdb->prefix."flybx_stats SET  `total` = `total` + 1 WHERE `action` = '".$wpdb->escape($action)."' AND `variation_type` = '".$wpdb->escape($variation_type)."' AND `variation_value` = '".$wpdb->escape($variation_value)."' AND `year` = '".$wpdb->escape($year)."' AND `month` = '".$wpdb->escape($month)."' AND `day` = '".$wpdb->escape($day)."' LIMIT 1";
		$res = $wpdb->query($sql);
	}
}


function flybx_record_stat_detailed($collect_type = 0, $template_id = 0, $post_id = 0, $search_method = 0, $kws = '', $asin = '', $ip = '')
{
	global $wpdb;
	//delete old records
	$days_to_keep_records = 60;	//keep records for 60 days - default
	$days_to_keep_check = flybx_get_option('flybx_visitor_log_days');
	if ($days_to_keep_check !== FALSE && is_numeric($days_to_keep_check))
	{
		$days_to_keep_records = $days_to_keep_check;
	}
	$sql = "DELETE FROM ".$wpdb->prefix."flybx_stats_detailed WHERE timestamp < '".(time() - ( $days_to_keep_records * 60 * 60 * 24 ))."'";
	$res = $wpdb->query($sql);
	
	//record new view/click
	$sql = "INSERT INTO ".$wpdb->prefix."flybx_stats_detailed SET `collect_type` = '".$wpdb->escape($collect_type)."', `template_id` = '".$wpdb->escape($template_id)."', `post_id` = '".$wpdb->escape($post_id)."', `search_method` = '".$wpdb->escape($search_method)."', `kws` = '".$wpdb->escape($kws)."', `asin` = '".$wpdb->escape($asin)."', `ip` = '".$wpdb->escape($ip)."', `timestamp` = '".time()."'";
	$res = $wpdb->query($sql);

}

//This function records exact time when any Amazon Products API request was made
function flybx_record_am_request_time()
{
	$flybx_microtime_now = microtime(true);
	flybx_update_option('am_time', $flybx_microtime_now);
}

function flybx_am_search($search_kw = '', $search_index = 'All', $params, $item_page = 1, $locale = 'us', $adtnl_url_params = array(), $return_response_groups = '', $keyword_key = '0')
{
	$flybx_am_class = new flybx_amazon_api($params);

	$results_found = FALSE;
	$found_count = 0;

	$response_groups = '';
	if (flybx_get_option('amzn_cart_enabled') == 'yes') $response_groups = array('OfferListings');
	
	if (is_array($return_response_groups))
	{
		if (is_array($response_groups))
		{
			$response_groups = array_merge($response_groups, $return_response_groups);
		}
		else
		{
			$response_groups = $return_response_groups;
		}		
	}
	
	//need Offers response group for correct prices
	if (is_array($response_groups))
	{
		array_push($response_groups, 'Offers');
	}
	else
	{
		$response_groups = array('Offers');
	}

	//return similar items
	if (stripos($search_kw, 'asin:') !== FALSE && is_array($response_groups) && in_array('Similarities', $response_groups))
	{
		$asin_arr = explode(':', $search_kw);
		//got similar asins cached?
		$transient_name = 'flybx_sim_'.$locale.'_'.implode('_', array_slice(explode(',', $asin_arr[1]), 0, 3));
		$sim_asins_cached = get_transient($transient_name);
		
		if ($sim_asins_cached === FALSE)
		{
			$amazon_response = $flybx_am_class->similar_lookup($asin_arr[1], $locale, $response_groups);
			if (isset($amazon_response->Items) && (count($amazon_response->Items->Item) > 0) || (isset($amazon_response->Items->Item[0]->SimilarProducts->SimilarProduct) && count($amazon_response->Items->Item[0]->SimilarProducts->SimilarProduct) > 0))
			{
				$found_count = $found_count + count($amazon_response->Items->Item);
				if ($found_count >= 10)
				{
					$results_found = TRUE;
				}
				$similar_asins = array();
				if (isset($amazon_response->Items->Item[0]->SimilarProducts->SimilarProduct) && count($amazon_response->Items->Item[0]->SimilarProducts->SimilarProduct) > 0)
				{
					foreach($amazon_response->Items->Item as $curr_sim_item)
					{
						foreach($curr_sim_item->SimilarProducts->SimilarProduct as $curr_sim_product)
						{
							if (!in_array(strval($curr_sim_product->ASIN), $similar_asins))
							{
								$similar_asins[] = strval($curr_sim_product->ASIN);
							}
						}
					}
				}
				else
				{
					foreach($amazon_response->Items->Item->SimilarProducts->SimilarProduct as $curr_sim_product)
					{
						if (!in_array(strval($curr_sim_product->ASIN), $similar_asins))
						{
							$similar_asins[] = strval($curr_sim_product->ASIN);
						}
					}
				}
				
				if (count($similar_asins) > 0)
				{
					//cache sim asins for 7 days
					set_transient($transient_name, $similar_asins, 60*60*24*7);
					
					flybx_get_am_request_window();
					return flybx_am_search('asin:'.implode(',', $similar_asins), $search_index, $params, $item_page, $locale, $adtnl_url_params, '');
				}
				else
				{
					$found_count = 0;
					$results_found = FALSE;
				}
			}
		}
		else
		{
			//use cached sim asins
			$similar_asins = get_transient($transient_name);
			return flybx_am_search('asin:'.implode(',', $similar_asins), $search_index, $params, $item_page, $locale, $adtnl_url_params, '');
		}		
		
	}	
	elseif (stripos($search_kw, 'asin:') !== FALSE && is_array($response_groups) && in_array('Accessories', $response_groups))
	{
		$asin_arr = explode(':', $search_kw);
		//got similar asins cached?
		$transient_name = 'flybx_xsr_'.$locale.'_'.implode('_', array_slice(explode(',', $asin_arr[1]), 0, 3));
		$sim_asins_cached = get_transient($transient_name);
		
		if ($sim_asins_cached === FALSE)
		{	
			$amazon_response = $flybx_am_class->similar_lookup($asin_arr[1], $locale, $response_groups);
			if (isset($amazon_response->Items) && (count($amazon_response->Items->Item) > 0) || (isset($amazon_response->Items->Item[0]->Accessories->Accessory) && count($amazon_response->Items->Item[0]->Accessories->Accessory) > 0))
			{
				$found_count = $found_count + count($amazon_response->Items->Item);
				if ($found_count >= 10)
				{
					$results_found = TRUE;
				}
				$similar_asins = array();
				if (isset($amazon_response->Items->Item[0]->Accessories->Accessory) && count($amazon_response->Items->Item[0]->Accessories->Accessory) > 0)
				{
					foreach($amazon_response->Items->Item as $curr_sim_item)
					{
						foreach($curr_sim_item->Accessories->Accessory as $curr_sim_product)
						{
							if (!in_array(strval($curr_sim_product->ASIN), $similar_asins))
							{
								$similar_asins[] = strval($curr_sim_product->ASIN);
							}
						}
					}
				}
				else
				{
					foreach($amazon_response->Items->Item->Accessories->Accessory as $curr_sim_product)
					{
						if (!in_array(strval($curr_sim_product->ASIN), $similar_asins))
						{
							$similar_asins[] = strval($curr_sim_product->ASIN);
						}
					}
				}
				
				if (count($similar_asins) > 0)
				{
					//cache sim asins for 7 days
					set_transient($transient_name, $similar_asins, 60*60*24*7);
					
					flybx_get_am_request_window();
					return flybx_am_search('asin:'.implode(',', $similar_asins), $search_index, $params, $item_page, $locale, $adtnl_url_params, '');
				}
				else
				{
					$found_count = 0;
					$results_found = FALSE;
				}

			}
		}
		else
		{
			//use cached sim asins
			$similar_asins = get_transient($transient_name);
			return flybx_am_search('asin:'.implode(',', $similar_asins), $search_index, $params, $item_page, $locale, $adtnl_url_params, '');
		}
		
	}
	elseif (stripos($search_kw, 'asin:') === FALSE)
	{
		$amazon_response = $flybx_am_class->search_amazon($search_kw, $search_index, $item_page, $locale, FALSE, $response_groups, $adtnl_url_params);
		
		if ($amazon_response->Items->TotalResults > 0)
		{
			$found_count = $found_count + count($amazon_response->Items->Item);
			if ($found_count >= 10)
			{
				$results_found = TRUE;
			}
			$amazon_items[] = $amazon_response->Items;
		}
	}
	else
	{
		//$search_kw = 'asin:B003VAGXWK';
		$asin_arr = explode(':', $search_kw);
		$amazon_response = $flybx_am_class->asin_lookup(trim($asin_arr[1]), $locale, $response_groups);
		if (!isset($amazon_response->Items->Request->Errors))
		{			
			if (@count($amazon_response->Items->Item) > 0)
			{
				//echo 'found a lot';
				$amazon_items[] = $amazon_response->Items;
				$found_count = $found_count + count($amazon_response->Items->Item);
			}
			else
			{
				//echo 'found one';
				$generic_temp_object = new stdClass();
				$generic_temp_object->Item = array('0' => $amazon_response->Items->Item);
				$amazon_items[] = $generic_temp_object;
				$found_count = $found_count + 1;
			}
			if ($found_count >= 10)
			{
				$results_found = TRUE;
			}
		}		
	}
	
	/*echo '<br /><br />HERE WE GO<br /><br />';
	echo '<pre>';
	print_r($amazon_response);
	echo '</pre>';*/
	
	/*echo '<pre>';
	print_r($amazon_items);
	echo '</pre>';*/
	//$time_end = microtime(true);
	//$time = $time_end - $time_start;
	//echo ' in '.$time.' seconds';

	if ($results_found === TRUE || $found_count > 0)
	{
		$skip_noimage = get_option('flybx_skip_noimage');
		//skip asins
		$skip_asins_arr = array();
		$skip_asins = get_option('flybx_skip_asins');
		if ($skip_asins !== FALSE && strlen($skip_asins) > 1)
		{
			$skip_asins = str_replace(', ', '', str_replace('  ', '', $skip_asins));
			$skip_asins_arr = explode(',', $skip_asins);
		}
		
		$results = array();
		$saved_urls = array();
		$curr_key = 0;
		foreach($amazon_items as $item_set)
		{
			foreach($item_set->Item as $item)
			{
				if (($skip_noimage != 1 || ($skip_noimage == 1 && isset($item->MediumImage->URL) && strlen(strval($item->MediumImage->URL)) > 1)) && !in_array(strval($item->ASIN), $skip_asins_arr))
				{
					$results[strval($item->ASIN)] = array(
							'image' => strval($item->MediumImage->URL),
							'img_width' => intval($item->MediumImage->Width),
							'img_height' => intval($item->MediumImage->Height),							
							'large_image' => strval($item->LargeImage->URL),
							'large_image_width' => strval($item->LargeImage->Width),
							'large_image_height' => strval($item->LargeImage->Height),
							'small_image' => strval($item->SmallImage->URL),
							'small_image_width' => strval($item->SmallImage->Width),
							'small_image_height' => strval($item->SmallImage->Height),
							'url' => strval($item->DetailPageURL),
							'name' => strval($item->ItemAttributes->Title),
							'asin' => strval($item->ASIN)
							);
							
					$results[strval($item->ASIN)]['timestamp'] = time();
			
					$results[strval($item->ASIN)]['attributes'] = flybx_xml_to_array($item->ItemAttributes); 
					
					//default price 
					$results[strval($item->ASIN)]['price'] = 'Too low to display';
					
					if (isset($item->Offers) && strval($item->Offers->TotalOffers) == 0)
					{
						//no offers - show 'from' price
						if (isset($item->OfferSummary->LowestNewPrice))
						{
							$results[strval($item->ASIN)]['price_amt'] = strval($item->OfferSummary->LowestNewPrice->Amount);
							$results[strval($item->ASIN)]['price'] = flybx_lang('from ', $locale).strval($item->OfferSummary->LowestNewPrice->FormattedPrice);
						}
						elseif (isset($item->OfferSummary->LowestUsedPrice))
						{
							$results[strval($item->ASIN)]['price_amt'] = strval($item->OfferSummary->LowestUsedPrice->Amount);
							$results[strval($item->ASIN)]['price'] = flybx_lang('from ', $locale).strval($item->OfferSummary->LowestUsedPrice->FormattedPrice);
						}					
					}
					elseif (isset($item->Offers) && strval($item->Offers->TotalOffers) == 1)
					{
						//check if there is saleprice
						if (isset($item->Offers->Offer->OfferListing->SalePrice))
						{
							$results[strval($item->ASIN)]['price_amt'] = strval($item->Offers->Offer->OfferListing->SalePrice->Amount);
							$results[strval($item->ASIN)]['price'] = strval($item->Offers->Offer->OfferListing->SalePrice->FormattedPrice);
							if (isset($item->Offers->Offer->OfferListing->Price))
							{
								$results[strval($item->ASIN)]['old_price_amt'] = strval($item->Offers->Offer->OfferListing->Price->Amount);
								$results[strval($item->ASIN)]['old_price'] = strval($item->Offers->Offer->OfferListing->Price->FormattedPrice);
							}
							//save percentage saved
							if(isset($item->Offers->Offer->OfferListing->PercentageSaved))
							{
								$results[strval($item->ASIN)]['percentage_saved'] = strval($item->Offers->Offer->OfferListing->PercentageSaved);
							}
						}
						else
						{							
							//no salesprice - extract old price from difference
							$results[strval($item->ASIN)]['price'] = strval($item->Offers->Offer->OfferListing->Price->FormattedPrice);
							if ($results[strval($item->ASIN)]['price'] != 'Too low to display')
							{
								$results[strval($item->ASIN)]['price_amt'] = strval($item->Offers->Offer->OfferListing->Price->Amount);
								if (isset($item->Offers->Offer->OfferListing->AmountSaved))
								{
									//save old price
									$results[strval($item->ASIN)]['old_price_amt'] = $results[strval($item->ASIN)]['price_amt'] + strval($item->Offers->Offer->OfferListing->AmountSaved->Amount);
									$currency_code = strval($item->Offers->Offer->OfferListing->AmountSaved->CurrencyCode);
									$currency_sign = '$';
									if ($currency_code != 'USD')
									{
										$currency_sign = strval($item->Offers->Offer->OfferListing->AmountSaved->CurrencyCode).' ';
									}
									if ($currency_code == 'GBP')
									{
										$currency_sign = '&pound;';
									}
									
									if (in_array($currency_code, array('USD', 'GBP')))
									{
										$results[strval($item->ASIN)]['old_price'] = $currency_sign.number_format(($results[strval($item->ASIN)]['old_price_amt'] * 0.01), 2);
									}
									else
									{
										$results[strval($item->ASIN)]['old_price'] = $currency_sign.number_format(($results[strval($item->ASIN)]['old_price_amt'] * 0.01), 2, ',', ' ');
									}
									//save percentage saved
									if(isset($item->Offers->Offer->OfferListing->PercentageSaved))
									{
										$results[strval($item->ASIN)]['percentage_saved'] = strval($item->Offers->Offer->OfferListing->PercentageSaved);
									}
									
								}
							}
						}
					}
					elseif (isset($item->OfferSummary->LowestNewPrice))
					{
						$results[strval($item->ASIN)]['price'] = strval($item->OfferSummary->LowestNewPrice->FormattedPrice);
						$results[strval($item->ASIN)]['price_amt'] = strval($item->OfferSummary->LowestNewPrice->Amount);
						//do we have a list price?
						if(isset($item->ItemAttributes->ListPrice) && ($item->ItemAttributes->ListPrice->Amount > $item->OfferSummary->LowestNewPrice->Amount || strval($item->OfferSummary->LowestNewPrice->FormattedPrice) == 'Too low to display'))
						{
							$results[strval($item->ASIN)]['old_price'] = strval($item->ItemAttributes->ListPrice->FormattedPrice);
							$results[strval($item->ASIN)]['old_price_amt'] = strval($item->ItemAttributes->ListPrice->Amount);
						}
					}
					elseif(isset($item->ItemAttributes->ListPrice))
					{
						$results[strval($item->ASIN)]['price'] = strval($item->ItemAttributes->ListPrice->FormattedPrice);
						$results[strval($item->ASIN)]['price_amt'] = strval($item->ItemAttributes->ListPrice->Amount);
					}
					//always save list_price
					if(isset($item->ItemAttributes->ListPrice))
					{
						$results[strval($item->ASIN)]['list_price'] = strval($item->ItemAttributes->ListPrice->FormattedPrice);
						$results[strval($item->ASIN)]['list_price_amt'] = strval($item->ItemAttributes->ListPrice->Amount);
					}
					//save OfferListingId
					$results[strval($item->ASIN)]['OfferListingId'] = '';
					if (isset($item->Offers->Offer->OfferListing->OfferListingId))
					{
						$results[strval($item->ASIN)]['OfferListingId'] = strval($item->Offers->Offer->OfferListing->OfferListingId);
						$results[strval($item->ASIN)]['OfferPrice'] = strval($item->Offers->Offer->OfferListing->Price->FormattedPrice);
					}
					
					//save "all offers" link					
					if (isset($item->ItemLinks->ItemLink) )
					{
						$itemlinks_set = $item->ItemLinks;
											
						foreach($itemlinks_set->ItemLink as $maybe_link)
						{
							if (isset($maybe_link->Description) && isset($maybe_link->URL))
							{
								if (strval($maybe_link->Description) == 'All Offers')
								{
									$results[strval($item->ASIN)]['url_all_offers'] = strval($maybe_link->URL);
									$results[strval($item->ASIN)]['all_offers_total'] = @strval($item->Offers->TotalOffers);
								}
								if (strval($maybe_link->Description) == 'All Customer Reviews')
								{
									$results[strval($item->ASIN)]['url_all_reviews'] = strval($maybe_link->URL);
								}							
							}
						}

					}
					//save "more results" link in the first item
					if ($curr_key == 0 && isset($amazon_response->Items->MoreSearchResultsUrl) && strlen(strval($amazon_response->Items->MoreSearchResultsUrl)) > 0)
					{
						$results[strval($item->ASIN)]['url_more_results'] = strval($amazon_response->Items->MoreSearchResultsUrl);
						//$results[strval($item->ASIN)]['timestamp'] = time();
					}
					$results[strval($item->ASIN)]['timestamp'] = time();
					
					if ($curr_key == 0)
					{
						$results[strval($item->ASIN)]['keyword_key'] = $keyword_key;
					}
					
					//save description
					if (isset($item->EditorialReviews->EditorialReview->Source) && strval($item->EditorialReviews->EditorialReview->Source) == 'Product Description')
					{
						$results[strval($item->ASIN)]['description'] = substr(strval($item->EditorialReviews->EditorialReview->Content), 0, 1000);
					}
					$saved_urls['am_'.strval($item->ASIN)] = strval($item->DetailPageURL);
					
					$curr_key++;
				}
			}
		}
		return $results;
	}
	else
	{
		return array();
	}
}


function flybx_am_preview_results($params, $item_page = 1, $locale = 'us')
{
	$flybx_am_class = new flybx_amazon_api($params);

	$results_found = FALSE;
	$found_count = 0;

	$response_groups = '';
	if (flybx_get_option('amzn_cart_enabled') == 'yes') $response_groups = array('OfferListings');
	
	$amazon_response = $flybx_am_class->search_amazon('', 'All', $item_page, $locale, TRUE, $response_groups);
	if ($amazon_response->Items->TotalResults > 0)
	{
		$found_count = $found_count + count($amazon_response->Items->Item);
		if ($found_count >= 10)
		{
			$results_found = TRUE;
		}
		$amazon_items[] = $amazon_response->Items;
	}

	if ($results_found === TRUE || $found_count > 0)
	{
		$skip_noimage = get_option('flybx_skip_noimage');
		$results = array();
		$saved_urls = array();
		foreach($amazon_items as $item_set)
		{
			foreach($item_set->Item as $item)
			{
				if ($skip_noimage != 1 || ($skip_noimage == 1 && isset($item->MediumImage->URL) && strlen(strval($item->MediumImage->URL)) > 1))
				{
					$results[strval($item->ASIN)] = array(
							'image' => strval($item->MediumImage->URL),
							'img_width' => intval($item->MediumImage->Width),
							'img_height' => intval($item->MediumImage->Height),							
							'large_image' => strval($item->LargeImage->URL),
							'large_image_width' => strval($item->LargeImage->Width),
							'large_image_height' => strval($item->LargeImage->Height),
							'url' => strval($item->DetailPageURL),
							'name' => strval($item->ItemAttributes->Title),
							'asin' => strval($item->ASIN)
							);
					if (isset($item->OfferSummary->LowestNewPrice))
					{
						$results[strval($item->ASIN)]['price'] = strval($item->OfferSummary->LowestNewPrice->FormattedPrice);
						//do we have a list price?
						if(isset($item->ItemAttributes->ListPrice) && ($item->ItemAttributes->ListPrice->Amount > $item->OfferSummary->LowestNewPrice->Amount || strval($item->OfferSummary->LowestNewPrice->FormattedPrice) == 'Too low to display'))
						{
							$results[strval($item->ASIN)]['list_price'] = strval($item->ItemAttributes->ListPrice->FormattedPrice);
						}
					}
					elseif(isset($item->ItemAttributes->ListPrice))
					{
						$results[strval($item->ASIN)]['price'] = strval($item->ItemAttributes->ListPrice->FormattedPrice);
					}
					//save description
					if (isset($item->EditorialReviews->EditorialReview->Source) && strval($item->EditorialReviews->EditorialReview->Source) == 'Product Description')
					{
						$results[strval($item->ASIN)]['description'] = strval($item->EditorialReviews->EditorialReview->Content);
					}
					$saved_urls['am_'.strval($item->ASIN)] = strval($item->DetailPageURL);
				}
			}
		}
		return $results;
	}
	else
	{
		return array();
	}
}

function flybx_am_check_credentials($params)
{
	require_once(dirname(__FILE__).'/amazon.lib.php');
	$flybx_am_class = new flybx_amazon_api($params);

	$results_found = FALSE;
	$found_count = 0;

	$amazon_response = $flybx_am_class->search_amazon('camera', 'All', 1, 'us');
	return $amazon_response;
}

function flybx_gen_kws($content = '', $title = '', $post_id = 0)
{
	require_once(dirname(__FILE__).'/keywords_generator.php');
			
		$params['content'] = $content; //page content
		//set the length of keywords you like
		$params['min_word_length'] = 5;  //minimum length of single words
		$params['min_word_occur'] = 2;  //minimum occur of single words
		
		$params['min_2words_length'] = 3;  //minimum length of words for 2 word phrases
		$params['min_2words_phrase_length'] = 10; //minimum length of 2 word phrases
		$params['min_2words_phrase_occur'] = 2; //minimum occur of 2 words phrase

		$keyword = new flybx_keywords($params, "iso-8859-1");
		
		//get "skip words"
		$skip_keywords_str = flybx_get_option('flybx_skip_keywords');
		if ($skip_keywords_str === FALSE)
		{
			$skip_keywords = flybx_get_default_skip_keywords();
		}
		else
		{
			$skip_keywords = explode(",", $skip_keywords_str);
		}
		if (count($skip_keywords) > 0)
		{
			$keyword->common = array_merge($keyword->common, $skip_keywords);
		}
		
		//get kws settings
		$flybx_kw_sources = array();
		$flybx_kw_sources_str = flybx_get_option('flybx_kw_sources');
		if (strlen($flybx_kw_sources_str) > 0)
		{
			$flybx_kw_sources = explode(',', $flybx_kw_sources_str);
		}		
		$flybx_fallback_keywords = get_option('flybx_fallback_keywords');
		$flybx_min_kw_length = flybx_get_option('flybx_min_kw_length');
		if (in_array('categories', $flybx_kw_sources))
		{
			$categories = get_categories();
			$flybx_cat_kws = array();
			foreach($categories as $curr_cat)
			{
				$cat_kw_check = get_option('flybx_cat_kws_'.$curr_cat->term_id);
				if ($cat_kw_check !== FALSE)
				{
					$flybx_cat_kws[$curr_cat->term_id] = $cat_kw_check;
				}
			}
		}
		
		$kws = array();
		if ($content != '')
		{
			//generate form content
			if (in_array('content', $flybx_kw_sources))
			{
				$single_kws = $keyword->parse_words();
				$two_words_kws = $keyword->parse_2words();
				
				$kws = array_merge($two_words_kws, $single_kws);
				$kws = flybx_filter_out_kws($kws);
			}
		}

		
		//generate from title
		if (count($kws) == 0 && strlen($title) > 0 && in_array('title', $flybx_kw_sources))
		{
			$title = strtolower($title);
			$title = preg_replace("/(?![-])\p{P}/u", "", $title);
			
			//$kws[] = $title;
			$maybe_kws = explode(" ", $title);
			$maybe_kws = flybx_filter_out_kws($maybe_kws);
			if (count($maybe_kws) < 5)
			{
				$kws[] = implode(' ', $maybe_kws);
			}
			foreach($maybe_kws as $kw)
			{
				$kw = trim($kw);
				if (strlen($kw) > 1)
				{
					$kws[] = $kw;
				}
			}

			$kws = flybx_filter_out_kws($kws);
			//try again here
		}
		
		//generate from tags
		if (count($kws) == 0 && in_array('tags', $flybx_kw_sources) && $post_id != 0)
		{
			$posttags = get_the_tags($post_id);
			if ($posttags) {
			  foreach($posttags as $tag) {
				$kws[] = $tag->name;
			  }
			}
			$kws = flybx_filter_out_kws($kws);
			
		}
		
		//generate from categories
		if (count($kws) == 0 && in_array('categories', $flybx_kw_sources) && $post_id != 0)
		{
			$post_cats = get_the_category($post_id);
			if (is_array($post_cats) && count($post_cats) > 0)
			{
				foreach($post_cats as $post_cat)
				{
					$post_cat_kws_str = get_option('flybx_cat_kws_'.$post_cat->term_id);
					if ($post_cat_kws_str !== FALSE && strlen($post_cat_kws_str) > 0)
					{
						$post_cat_kws_arr = explode(',', $post_cat_kws_str);
						if (count($post_cat_kws_arr) > 0)
						{
							foreach($post_cat_kws_arr as $maybe_kw)
							{
								$kws[] = trim($maybe_kw);
							}
						}
					}					
				}
			}
		}
		
		//generate from fallback
		if (count($kws) == 0 && in_array('fallback', $flybx_kw_sources))
		{
			$fallback_kws_str = get_option('flybx_fallback_keywords');
			if ($fallback_kws_str !== FALSE && strlen(trim($fallback_kws_str)) > 1)
			{
				$maybe_kws = explode(',', $fallback_kws_str);
				foreach($maybe_kws as $maybe_kw)
				{
					$kws[] = trim($maybe_kw);
				}
			}
		}
		
		return $kws;
	
	return array();
}

function flybx_24h_max($val = 24)
{
	if ($val === FALSE || !is_numeric($val) || $val > 24 || $val < 1)
	{
		$val = '24';
	}
	else
	{
		$val = intval($val);
	}
	return $val;
}

function flybx_get_cached_data($post_id = 0, $kws, $am_params, $locale = 'us', $search_method = 0)
{
	global $wpdb, $flybx_preview;
	//use both 0 and 1 for kws search method
	if ($search_method == 1) $search_method = 0;
	//locale map
	$locale_map = flybx_locale_map();	
	
	$cache_hours = flybx_24h_max(flybx_get_option('flybx_cache_hours'));

	//check if we have cache data
	if ($flybx_preview === FALSE)
	{
		//let's not filter by post id because posts can share same keywords
		$res = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."flybx_cache WHERE `kws` = '".$wpdb->escape(implode(',', $kws))."' AND locale = '".$locale_map[$locale]."' AND search_method = '".$search_method."' AND source = 0 AND timestamp > '".($cache_hours * 3600)."' LIMIT 1");
	}
	
	if ($res !== NULL)
	{
		$data = unserialize(str_replace("\'", "'", $res->content));
		if (count($data) > 0)
		{
			return $data;
		}
	}
	return FALSE;
}

function flybx_get_serp_kw_str()
{
	global $flybx_glob_serpkw;
	
	if ($flybx_glob_serpkw !== FALSE)
	{
		return $flybx_glob_serpkw;
	}
	else
	{
		return '';
	}
	
	$kw = '';
	//get kws settings
	$flybx_kw_sources = array();
	$kws = array();
		
	//generate form serp
	if ( isset($_COOKIE['flybx_serp_kws']) && strlen($_COOKIE['flybx_serp_kws']) > 0)
	{

		$kws[] = $_COOKIE['flybx_serp_kws'];
		$kws = flybx_filter_out_kws($kws);
	}
	
	//use serp kw only once 
	//setcookie("flybx_serp_kws", "", time()-3600, '/', '.'.$_SERVER['HTTP_HOST']);
	
	if (count($kws) == 1)
	{
		$kw = $kws[0];
	}
	if (count($kws) > 1)
	{
		$kw = implode(' ', $kws);
	}
	return $kw;	
}

function flybx_get_pop_data($post_id = 0, $kws, $am_params, $locale = 'us', $search_method = 0)
{
	global $wpdb, $flybx_preview;
	//use both 0 and 1 for kws search method
	if ($search_method == 1) $search_method = 0;
	//locale map
	$locale_map = flybx_locale_map();	

	$cache_hours = flybx_24h_max(flybx_get_option('flybx_cache_hours'));	
	
	//BOF asin: lookups
	//first check if all keywords are asin: and if we have individual items cached
	$all_asins = TRUE;
	foreach($kws as $curr_kw)
	{
		if (stripos($curr_kw, 'asin:') === FALSE)
		{
			$all_asins = FALSE;
		}
	}
	
	if ($all_asins === TRUE)
	{
		$data_res = array();
		$kws_to_pull = array();
		foreach($kws as $curr_kw)
		{
			//get individual item cached
			$res = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."flybx_cache WHERE `kws` = '".$wpdb->escape($curr_kw)."' AND locale = '".$locale_map[$locale]."' AND timestamp > '".($cache_hours * 3600)."' LIMIT 1");
			if ($res !== NULL)
			{
				$data = unserialize(str_replace("\'", "'", $res->content));
				$data_res = array_merge($data_res, $data);
				
			}
			else
			{
				$kws_to_pull[] = $curr_kw;
			}
		}
		
		if (count($kws_to_pull) > 0)
		{
			$updated_asin_items = flybx_update_asins_cache($kws_to_pull, $locale, $am_params);
			$data_res = array_merge($updated_asin_items, $data_res);
		}
		
		if (count($data_res) > 0)
		{
			return $data_res;
		}	
	}
	//EOF asin: lookups	
	
	//let's not filter by post id because posts can share same keywords
	$res = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."flybx_cache WHERE `kws` = '".$wpdb->escape(implode(',', $kws))."' AND locale = '".$locale_map[$locale]."' AND search_method = '".$search_method."' AND source = 0 AND timestamp > '".($cache_hours * 3600)."' LIMIT 1");

	
	if ($flybx_preview === FALSE && $res !== NULL)
	{
		$data = unserialize(str_replace("\'", "'", $res->content));
		if (count($data) > 0)
		{
			return $data;
		}
		else
		{
			return false;
		}
	}
	else
	{
		return flybx_update_cache($post_id, $kws, $am_params, $locale, $search_method);
	}

}

function flybx_update_cache($post_id, $kws, $am_params, $locale = 'us', $search_method = 0)
{
	global $wpdb, $flybx_preview;
	//use both 0 and 1 for kws search method
	if ($search_method == 1) $search_method = 0;
	
	$flybx_data = array();
	$flybx_keep_going = true;
	
	//make up for negative asins
	$adtn_loops = 0;
	if (count($kws) > 0)
	{
		foreach($kws as $curr_kw)
		{
			if (stripos($curr_kw, '-asin:') !== FALSE)
			{
				$adtn_loops++;
			}
		}
	}
	
	//try kws untill we get smth
	$i = 0;
	while($flybx_keep_going == true && $i < (5 + $adtn_loops))
	{
		//comply with Amazon API time limits
		flybx_get_am_request_window();
		//$flybx_data_req = flybx_am_search('organic cotton, bodysuit, cotton, organic');
		//$fallback_searchindex = get_option('flybx_am_searchindex');
	
		$country_node_check = flybx_get_country_node($locale);
		$country_node = $country_node_check['country_node'];
		$search_index = $country_node_check['search_index'];
		
		$adtnl_url_params = array();
		if (is_numeric($country_node)) $adtnl_url_params['BrowseNode'] = $country_node;
		//condition filter
		//$condition = flybx_get_option('amzn_condition');
		//$max_price = '50';
		//if ($max_price !== FALSE && is_numeric($max_price)) $adtnl_url_params['MaximumPrice'] = $max_price;
		//if ($condition !== FALSE && in_array($condition, array('New', 'Used', 'Refurbished', 'Collectible'))) $adtnl_url_params['Condition'] = $condition;

		if ($search_method == 0 || $search_method == 1)
		{
			$flybx_data_req = flybx_am_search($kws[$i], $search_index, $am_params, 1, $locale, $adtnl_url_params);
		}
		elseif ($search_method == 2)
		{
			$flybx_data_req = flybx_am_search($kws[$i], $search_index, $am_params, 1, $locale, $adtnl_url_params, array('Similarities'));
		}
		elseif ($search_method == 3)
		{
			$flybx_data_req = flybx_am_search($kws[$i], $search_index, $am_params, 1, $locale, $adtnl_url_params, array('Accessories'));
		}
		$flybx_data = array_merge($flybx_data, $flybx_data_req);
		if (count($flybx_data) > 2)
		{
			$flybx_keep_going = false;
		}
		
		flybx_record_am_request_time();
		$i++;
	}
	
	//filter out negative keywords
	if (count($flybx_data) > 0 && count($kws) > 0)
	{
		foreach($kws as $curr_kw)
		{
			if (stripos($curr_kw, '-asin:') !== FALSE)
			{
				$asin_arr = explode(':', $curr_kw);
				if (isset($flybx_data[$asin_arr[1]]))
				{
					unset($flybx_data[$asin_arr[1]]);
				}
			}
		}
	}

	
	//locale map
	$locale_map = flybx_locale_map();
	
	if ($flybx_preview === FALSE)
	{
		//delete old cache
		//do not filter by post_id to allow posts share same kws
		$delete_sql = "DELETE FROM `".$wpdb->prefix."flybx_cache` WHERE locale = '".$locale_map[$locale]."' AND search_method = '".$search_method."' AND source = '0' LIMIT 1";
		$wpdb->query($delete_sql);
		
		//insert new cache
		if (count($flybx_data) > 0)
		{
			$insert_sql = "INSERT INTO `".$wpdb->prefix."flybx_cache` SET `post_id` = '".$wpdb->escape($post_id)."', `source` = '0', `search_method` = '".$wpdb->escape($search_method)."', `locale` = '".$locale_map[$locale]."', `content` = '".str_replace("'", "\'", serialize($flybx_data))."', `kws` = '".$wpdb->escape(implode(',', $kws))."', timestamp = '".time()."'";
			$wpdb->query($insert_sql);
		}
	}
	
	return $flybx_data;
}

function flybx_cache_cleanup()
{
	global $wpdb;
	$time = time();
	//AMZN
	$where = " WHERE source = '0' AND timestamp < '".($time - 3600)."'";
	$sql = "DELETE FROM `".$wpdb->prefix."flybx_cache` ".$where;
	$wpdb->query($sql);
	//EPN
	$epn_cache_seconds = flybx_get_option('epn_cache_seconds');
	if ($epn_cache_seconds === FALSE) $epn_cache_seconds = 0;
	$where = " WHERE source = '1' AND (timestamp < '".($time - $epn_cache_seconds)."' OR expires < '".$time."')";
	$sql = "DELETE FROM `".$wpdb->prefix."flybx_cache` ".$where;
	$wpdb->query($sql);
}

function flybx_get_post_keywords($post_id = 0, $flybx_search_method = 0, $locale = 'us', $generate_new = FALSE)
{	
	global $post, $wpdb, $flybx_check_before_after, $flybx_sim_asins;
	$flybx_preview = FALSE;
	$flybx_preview_kws = '';
	$flybx_preview_general = FALSE;
	$flybx_tpl_key = 0;
	
	$flybx_search_method_real = 1;

	$flybx_is_virtual = FALSE;
	if (isset($_GET['is_virtual']) && $_GET['is_virtual'] == 'yes')
	{
		$flybx_is_virtual = TRUE;
	}

	$flybx_kws_str = '';
	
	if ($post_id == '' && $flybx_is_virtual !== TRUE) 
	{	
		//no post id found
		return FALSE;	
	}

	//does post exist?
	$curr_post = get_post( $post_id, $output );
	if ((!isset($curr_post->ID) || $curr_post->ID != $post_id) && ($flybx_is_virtual === FALSE)) 
	{
		//post with post_id doesn't exist
		return FALSE;
	}
	
	
	//get kws settings
	$flybx_kw_sources = array();
	$flybx_kw_sources_str = flybx_get_option('flybx_kw_sources');
	if (strlen($flybx_kw_sources_str) > 0)
	{
		$flybx_kw_sources = explode(',', $flybx_kw_sources_str);
	}
	
	//use serp keywords
	if (in_array('serp', $flybx_kw_sources))
	{
		$flybx_get_serp_kw_str = flybx_get_serp_kw_str();
		if ($flybx_get_serp_kw_str != '') return array( $flybx_get_serp_kw_str );
	}
	
	//if already have keywords - return them
	$flybx_post_kws = get_post_meta($post_id, 'flybx_kws_'.$locale, true);
	if ($flybx_post_kws !== FALSE && strlen($flybx_post_kws) > 1 && $generate_new === FALSE)
	{
		return explode(',', $flybx_post_kws);
	}
	
	//OK here's the deal.
	//If Smart Search enabled but similar asins not found - do ajax loading
	if (in_array('smart_search', $flybx_kw_sources) && !in_array($locale, array('cn', 'jp')))
	{
		$custom_query = new WP_Query( array( 'post_type' => $curr_post->post_type, 'post__in' => array( $curr_post->ID ), 'ignore_sticky_posts' => TRUE ) );
		$flybx_i = 0;
		$flybx_post_content = '';
		while($custom_query->have_posts() && $flybx_i == 0)
		{
			$custom_query->the_post();
			$flybx_check_before_after = FALSE;
			$flybx_post_content = apply_filters('the_content',get_the_content());
			$flybx_i++;
		}
		wp_reset_postdata();
		
		$flybx_asins = flybx_parse_asins($flybx_post_content, $locale, TRUE);
		
		//check if we have similar asins cached
		/*if (count($flybx_asins) > 0)
		{
			$transient_name = 'flybx_sim_'.$locale.'_'.implode('_', array_slice($flybx_asins, 0, 3));
			$sim_asins_cached = get_transient($transient_name);
		}*/
		//check if post has related asins cached
		if (count($flybx_asins) > 0)
		{
			$flybx_sim_asins = $flybx_asins;
			return 'doajax';
		}

		/*if ($sim_asins_cached === FALSE)
		{
			$flybx_sim_asins = $flybx_asins;
			return 'doajax';
		}*/
		/*echo $transient_name;
		echo '<pre>';
		print_r($flybx_asins);
		var_dump($sim_asins_cached);
		echo '</pre>';*/

	}
	
	//other search methods failed - switch to kws
	if (strlen($flybx_kws_str) == 0)  $flybx_search_method = 1;

	//do we have kws?
	if(strlen($flybx_kws_str) == 0 && $flybx_search_method == 1)
	{
		//use saved keywords
		$flybx_kws_str = get_post_meta($curr_post->ID, 'flybx_keywords', true);
	}
	
	//use virtual post keywords
	if (!in_array($flybx_search_method, array(2, 3, 4)) && $flybx_is_virtual && isset($_GET['s']) && strlen($_GET['s']) > 0)
	{
		$flybx_kws_str = strip_tags(urldecode($_GET['s']));
		$flybx_search_method = 1;
		$flybx_search_method_real = 6;
	}
		
	if (strlen($flybx_kws_str) < 2 && $flybx_search_method == 1)
	{
		
		//create kws from post content
		//$flybx_content = strip_tags($curr_post->post_content);
		$custom_query = new WP_Query( array( 'post_type' => $curr_post->post_type, 'post__in' => array( $curr_post->ID ), 'ignore_sticky_posts' => TRUE ) );
		
		$flybx_i = 0;
		//re-use post content if available
		if (!isset($flybx_post_content) || strlen($flybx_post_content) == 0)
		{
			remove_filter( 'the_content', 'flybx_content_filter');
			$flybx_check_before_after = FALSE;
			$flybx_post_content = '';
			while($custom_query->have_posts() && $flybx_i == 0)
			{
				
				$custom_query->the_post();				
				$flybx_post_content = apply_filters('the_content',get_the_content());				
				$flybx_i++;
			}
			
			wp_reset_postdata();
			
			if (strlen($flybx_post_content) > 0)
			{
				$flybx_post_content = flybx_remove_html($flybx_post_content);
				$flybx_post_content = strip_tags($flybx_post_content);
			}	
		}

		$flybx_content = $flybx_post_content;
		/*echo '<textarea>'.$flybx_content;
				echo '</textarea>';*/
		$flybx_post_title = '';
		/*if (isset($post) && isset($post->post_title))
		{
			$flybx_post_title = $post->post_title;
		}*/
		$flybx_kws = flybx_gen_kws($flybx_content, $flybx_post_title, $post_id);
		
		if (count($flybx_kws) == 0) 
		{
			//no kws found :(
			return FALSE;
		}
		if (count($flybx_kws) > 0)
		{
			//save kws in custom meta
			$flybx_kws = array_slice($flybx_kws, 0, 5);
			update_post_meta($post_id, 'flybx_kws_'.$locale, implode(', ', $flybx_kws));
		}
		$flybx_search_method_real = 1;
	}
	elseif ($flybx_search_method == 1)
	{
		//got keywords? lets turn them into an array
		$flybx_kws = explode(',', trim(str_replace(', ', ',', $flybx_kws_str)));
		//$flybx_kws = array_slice($flybx_kws, 0, 5);
	}
	//string of all keywords can sometimes return the best results. adding all keywords as a first element of array
	if (stripos(implode(' ', $flybx_kws), 'asin:') === FALSE)
	{
		//$flybx_kws = array_merge(array(implode(' ', $flybx_kws)), $flybx_kws);	//this causes delays
	}	

	if (count($flybx_kws) == 0) 
	{
		return FALSE;
	}
	return $flybx_kws;
}

//This function allows us to comply with Amazon Products API TOS rule of 1 second delay between requests. It's being called before any request to Amazon is attempted.
function flybx_get_am_request_window()
{
	$i = 0;
	$flybx_keep_going = true;
	while($flybx_keep_going == true && $i < 5)
	{
		//here we are checking the time when the last amazon api request was sent to make sure that there is at least 1 second delay between requests
		$flybx_am_time = flybx_get_option('am_time');
		$flybx_microtime_now = microtime(true);
		$flybx_microtime_diff = $flybx_microtime_now - $flybx_am_time;
		if ($flybx_microtime_diff > 1)
		{
			$flybx_keep_going = false;
			return true;
		}
		else
		{
			if ($i == 4)
			{
				if ($flybx_preview === TRUE || $flybx_preview_general === TRUE)
				{
					exit(__('Error! Server is too busy.', $flybx_plugin_slug));
				}
				else
				{
					exit('error');	//if tried for 5 times and couldn't get a request window - fail silently
				}
			}
		}
		
		if ($flybx_microtime_diff < 1)
		{
			usleep((1 - $flybx_microtime_diff) * 1000000); // sleep for the remaining part of a second
		}	
		$i++;
	}
}

function flybx_active_tpls($include_inactive = FALSE)
{
	global $flybx_addons;
	$flybx_tpls = array();
	$possible_tpls_arr = explode(',', flybx_get_option('tpl_names'));
	$possible_tpls_keys = array_keys($possible_tpls_arr);
	foreach($possible_tpls_arr as $key => $curr_tpl)
	{
		$enabled = flybx_get_option($curr_tpl.'_enabled');
		if (($enabled !== FALSE && $enabled == 1) || $include_inactive === TRUE)
		{
			$flybx_tpls[$key] = $curr_tpl;
		}
	}
	
	//no amzn or epn
	$flybx_amzn_active = flybx_get_option('flybx_amzn_active');
	$epn_enabled = flybx_get_option('epn_enabled');
	if (isset($flybx_addons) && in_array('amzn', $flybx_addons) && is_numeric($flybx_amzn_active) && $flybx_amzn_active == '0' && in_array('epn', $flybx_addons) && is_numeric($epn_enabled) && $epn_enabled == '0')
	{
		foreach($flybx_tpls as $key => $val)
		{
			if ($val == 'tpl_am3across' || $val == 'tpl_am1product')
			{
				unset($flybx_tpls[$key]);
			}
		}
	}

	return $flybx_tpls;
}

function flybx_active_tpls_stats()
{
	$tpls = array();
	$active_tpls = flybx_active_tpls();
	foreach($active_tpls as $key => $tpl)
	{
		if ($tpl == 'tpl_am3across')  $tpls[$key] = '3 products';
		if ($tpl == 'tpl_am1product')  $tpls[$key] = '1 product';
		if ($tpl == 'tpl_custom1')  $tpls[$key] = 'Custom 1';
		if ($tpl == 'tpl_custom2')  $tpls[$key] = 'Custom 2';
		if ($tpl == 'tpl_custom3')  $tpls[$key] = 'Custom 3';
	}
	return $tpls;
}

function flybx_get_current_tpl()
{
	$flybx_tpls = flybx_active_tpls();
	
	$flybx_tpl = '';
	$flybx_tpl_key = 0;
	$flybx_tpl_keys = array_keys($flybx_tpls);
	$flybx_tpl_sequence = flybx_get_option('tpl_sequence');
	if (count($flybx_tpls) > 0)
	{
		if ($flybx_tpl_sequence > 4 || $flybx_tpl_sequence == end($flybx_tpl_keys) || count($flybx_tpls) == 1)
		{
			
			$flybx_tpl = $flybx_tpls[$flybx_tpl_keys[0]];
			$flybx_tpl_key = $flybx_tpl_keys[0];
		}
		else
		{
			$flybx_tpls_temp = $flybx_tpls;
			foreach($flybx_tpls_temp as $key => $msg)
			{
				if ($key <= $flybx_tpl_sequence)
				{
					unset($flybx_tpls_temp[$key]);
				}
			}

			if (count($flybx_tpls_temp) > 0)
			{
				$flybx_tpl_keys_temp = array_keys($flybx_tpls_temp);
				$flybx_tpl = $flybx_tpls_temp[$flybx_tpl_keys_temp[0]];
				$flybx_tpl_key = $flybx_tpl_keys_temp[0];
			}
			else
			{
				$flybx_tpl = $flybx_tpls[$flybx_tpl_keys[0]];
				$flybx_tpl_key = $flybx_tpl_keys[0];
			}						
		}
	}

	return array('key' => $flybx_tpl_key, 'name' => $flybx_tpl);
}

function flybx_remove_html($document){
	$search = array('@<script[^>]*?>.*?</script>@si',  // Strip out javascript
				   /*'@<[\/\!]*?[^<>]*?>@si',            // Strip out HTML tags*/
				   '@<style[^>]*?>.*?</style>@siU',    // Strip style tags properly
				   '@<![\s\S]*?--[ \t\n\r]*>@'         // Strip multi-line comments including CDATA
	);
	$text = preg_replace($search, '', $document);
	return $text;
}

function flybx_delete_keywords()
{
	global $wpdb;
	set_time_limit(300);
	$wpdb->query("DELETE FROM $wpdb->postmeta WHERE (meta_key = 'flybx_keywords' OR meta_key = 'flybx_content_asins' OR meta_key = 'flybx_kws_us' OR meta_key = 'flybx_kws_uk' OR meta_key = 'flybx_kws_ca' OR meta_key = 'flybx_kws_de' OR meta_key = 'flybx_kws_fr' OR meta_key = 'flybx_kws_it' OR meta_key = 'flybx_kws_jp' OR meta_key = 'flybx_kws_cn' OR meta_key = 'flybx_kws_es' OR meta_key = 'flybx_relasins_us' OR meta_key = 'flybx_relasins_uk' OR meta_key = 'flybx_relasins_ca' OR meta_key = 'flybx_relasins_de' OR meta_key = 'flybx_relasins_fr' OR meta_key = 'flybx_relasins_it' OR meta_key = 'flybx_relasins_jp' OR meta_key = 'flybx_relasins_cn' OR meta_key = 'flybx_relasins_es') AND meta_value != ''");
	
	//flybx_generate_keywords_bulk();
}

function flybx_generate_keywords_bulk()
{
	global $wpdb;
	$post_types_str = get_option('flybx_posttypes');
	
	$post_types = explode(',', $post_types_str);
	foreach($post_types as $key => $val)
	{
		$post_types[$key] = $wpdb->escape($val);
	}
	
	$total_posts = $wpdb->get_var($wpdb->prepare("SELECT COUNT(*) FROM $wpdb->posts WHERE post_type in ("."'".implode("', '", $post_types)."'".")"));

	
	if ($total_posts !== FALSE && $total_posts > 0)
	{
		$flybx_i = 0;
		while($flybx_i < $total_posts)
		{
			set_time_limit(300);
			$curr_post = $wpdb->get_row("SELECT * FROM $wpdb->posts WHERE post_type in ("."'".implode("', '", $post_types)."'".")", OBJECT, $flybx_i);
			$post_content_filtered = apply_filters('the_content',$curr_post->post_content);
			$flybx_kws = flybx_gen_kws($post_content_filtered, $curr_post->post_title);
			if (count($flybx_kws) > 0)
			{
				//save kws in custom meta
				$flybx_kws = array_slice($flybx_kws, 0, 5);
				update_post_meta($curr_post->ID, 'flybx_keywords', implode(',', $flybx_kws));
			}
			$flybx_i++;
		}
	}
	echo 'Done!';
	exit;
}

function flybx_get_default_skip_keywords()
{
	$words = array(
	"mod",
	"#",
	"&",
	"'",
	"(",
	")",
	"-",
	"/",
	"1-year",
	"4 sale",
	"?",
	"@ebay",
	"a",
	"about",
	"add",
	"allround",
	"also",
	"am",
	"amazon",
	"an",
	"and",
	"antiques",
	"any",
	"are the",
	"are",
	"auction",
	"authentic",
	"back",
	"bargain",
	"bargains",
	"be",
	"best",
	"between",
	"budget",
	"buy",
	"buying",
	"by",
	"can",
	"can i",
	"cash",
	"catalog",
	"characteristic",
	"chart",
	"cheap",
	"cheapest",
	"choose",
	"choosing",
	"clean",
	"clearance",
	"co",
	"com",
	"company",
	"compare",
	"comparison",
	"compatable",
	"complete",
	"condition",
	"cost of",
	"cost",
	"custom",
	"customized",
	"damage",
	"damaged",
	"deal",
	"deals",
	"did",
	"difference",
	"discount",
	"discounted",
	"do",
	"does",
	"doesa",
	"e bay",
	"ebay",
	"ebay-world",
	"ebay.at",
	"ebay.be",
	"ebay.ca",
	"ebay.ch",
	"ebay.co.uk",
	"ebay.com",
	"ebay.de",
	"ebay.es",
	"ebay.fr",
	"ebay.ie",
	"ebay.it",
	"effects",
	"en ebay",
	"excellent",
	"expensive",
	"extra",
	"extremely",
	"final",
	"find",
	"fine",
	"finish",
	"flaws",
	"for",
	"for a",
	"for sale",
	"fore",
	"found",
	"from ebay",
	"from",
	"good",
	"grade",
	"guide",
	"has",
	"history",
	"hot",
	"how much are",
	"how much do",
	"how much for",
	"how to",
	"how",
	"i like",
	"i want",
	"if",
	"in",
	"in ebay",
	"instructions",
	"is the",
	"it",
	"its",
	"like",
	"list of",
	"list",
	"look for",
	"look",
	"looking",
	"ltd",
	"made",
	"maintenance",
	"make",
	"makes",
	"making",
	"many",
	"mark",
	"market",
	"markets",
	"marking",
	"mean",
	"mintage",
	"missed",
	"missing",
	"model",
	"modest",
	"most",
	"much",
	"my",
	"name",
	"narrow",
	"not",
	"of",
	"of a",
	"old",
	"on",
	"on amazon",
	"on ebay",
	"on sale",
	"online",
	"or",
	"oversized",
	"pattern",
	"patterns",
	"paypal",
	"pic",
	"piece",
	"price",
	"prices",
	"product",
	"products",
	"punched",
	"purchase",
	"rare",
	"rarest",
	"rated",
	"rating",
	"ratings",
	"real",
	"recognize",
	"repair",
	"review",
	"reviews",
	"sale",
	"sales",
	"same",
	"scarcity",
	"schematic",
	"search",
	"sell",
	"sewn",
	"side",
	"smith",
	"smiths",
	"specification",
	"specifications",
	"specs",
	"stand",
	"store",
	"stores",
	"su ebay",
	"sur ebay",
	"test",
	"the",
	"there is",
	"there",
	"this",
	"throu",
	"throuh",
	"thru",
	"to",
	"to a",
	"troz",
	"type",
	"united states",
	"up",
	"use",
	"used",
	"using",
	"valuable",
	"value of",
	"value",
	"waking",
	"want",
	"wanted",
	"wanting to",
	"wanting",
	"warranty",
	"was",
	"website",
	"were",
	"what is the",
	"what is",
	"what",
	"where is",
	"where",
	"which is",
	"which",
	"who is",
	"who",
	"wholesale",
	"with a",
	"with no",
	"with",
	"without",
	"word",
	"words",
	"worth",
	"worthy",
	"you",
	"target cmprzn",
	"cmprzn target",
	"cmprzn cmprzn",
	"important cmprzn",
	"hover cmprzn",
	"hover",
	"cmprzn",
	"aucomz",
	"flybx"
	);
	return $words;
}

function flybx_filter_out_kws($current_kws_arr)
{
	if (is_array($current_kws_arr) && count($current_kws_arr) > 0)
	{	
		$flybx_skip_keywords_str = flybx_get_option('flybx_skip_keywords');

		if ($flybx_skip_keywords_str === FALSE)
		{
			$flybx_skip_keywords_arr = flybx_get_default_skip_keywords();
		}
		else
		{
			$flybx_skip_keywords_arr = explode(',', $flybx_skip_keywords_str);
		}
		if (count($flybx_skip_keywords_str) == 0)
		{
			$flybx_skip_keywords_str = array();
		}
		
		$flybx_skip_keywords_arr = array_diff($flybx_skip_keywords_arr, array('/'));
		$flybx_min_kw_length = flybx_get_option('flybx_min_kw_length');
		$new_kws_arr = array();
		$remove_kws = array();
	
		$old_kws_str = implode(',', $current_kws_arr);
		//trim
		foreach($current_kws_arr as $key => $val)
		{
			//remove one word keywords if selected
			if ($flybx_min_kw_length !== FALSE && $flybx_min_kw_length == 2 && count(explode(' ', trim($val))) == 1)
			{
				unset($current_kws_arr[$key]);
			}
			else
			{
				$current_kws_arr[$key] = trim($val);
			}
		}
		
		$skip_preg_arr = array();										
		foreach($flybx_skip_keywords_arr as $curr_skip_kw)
		{
			//check for exact matches											
			if (preg_match('/^(["\']).*\1$/m', $curr_skip_kw) == 1)
			{
				$str_no_quotes = substr($curr_skip_kw, 1, (strlen($curr_skip_kw) - 2));
				if (in_array($str_no_quotes, $current_kws_arr))
				{
					$remove_kws[] = $str_no_quotes;
				}
			}
			else
			{	
				if (stripos($curr_skip_kw, "*") !== FALSE)
				{
					if (substr($curr_skip_kw, 0, 1) == '*' && substr($curr_skip_kw, (strlen($curr_skip_kw) - 1), 1) == '*')
					{
						$skip_preg_arr[] = preg_quote(str_replace('*', '', $curr_skip_kw), DIRECTORY_SEPARATOR);
					}
					elseif (substr($curr_skip_kw, 0, 1) == '*')
					{
						$skip_preg_arr[] = preg_quote(str_replace('*', '', $curr_skip_kw), DIRECTORY_SEPARATOR)."\b";
					}
					elseif (substr($curr_skip_kw, (strlen($curr_skip_kw) - 1), 1) == '*')
					{
						$skip_preg_arr[] = "\b".preg_quote(str_replace('*', '', $curr_skip_kw), DIRECTORY_SEPARATOR);
					}
				}
				else
				{
					$skip_preg_arr[] = "\b".preg_quote($curr_skip_kw, DIRECTORY_SEPARATOR)."\b";
				}
			}
		}
		$new_kws_arr = array_diff($current_kws_arr, $remove_kws);

		foreach($new_kws_arr as $key => $val)
		{
			$new_val = preg_replace('/('.implode('|', $skip_preg_arr).')/i', '', $val);
			
			if (strlen(trim($new_val)) > 0)
			{
				$new_kws_arr[$key] = trim($new_val);
			}
			else
			{
				unset($new_kws_arr[$key]);
			}
		}
		
		//remove one word keywords again
		foreach($new_kws_arr as $key => $val)
		{
			//remove one word keywords if selected
			if (isset($_POST['flybx_min_kw_length']) && $_POST['flybx_min_kw_length'] == 2 && count(explode(' ', trim($val))) == 1)
			{
				unset($new_kws_arr[$key]);
			}
			//remove spaces 
			if (strlen(trim($val)) == 0)
			{
				unset($new_kws_arr[$key]);
			}
			$val = str_replace('   ', ' ', $val);
			$val = str_replace('  ', ' ', $val);
			$new_kws_arr[$key] = str_replace('  ', ' ', $val);
		}
		
		return $new_kws_arr;
	}
	else
	{
		return $current_kws_arr;
	}
}

function flybx_multisite_setup_tbl()
{
	global $wpdb;
	$charset_collate = '';
		if (strlen($wpdb->charset) > 0)	$charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";
		$sql = "CREATE TABLE IF NOT EXISTS `flybx_wpms_global_settings` (
  `name` varchar(64) NOT NULL,
  `value` longtext NOT NULL,
  PRIMARY KEY (`name`)
) ".$charset_collate;
	$wpdb->query($sql);
}

function flybx_current_version()
{
	global $flybx_plugin_slug;
	$version = 0;
	$plugins = get_plugins();
	if (isset($plugins[$flybx_plugin_slug.'/'.$flybx_plugin_slug.'.php']) && isset($plugins[$flybx_plugin_slug.'/'.$flybx_plugin_slug.'.php']['Version']))
	{
		$version = $plugins[$flybx_plugin_slug.'/'.$flybx_plugin_slug.'.php']['Version'];
	}
	return $version;
}

function flybx_get_affiliate_network($post_id = 0) 
{
	global $flybx_addons;
	$flybx_source = '0';
	$flybx_source_sequence = flybx_get_option('source_sequence');
	if ($flybx_source_sequence === FALSE)
	{
		$flybx_source_sequence = 0;
	}
	
	$flybx_amzn_category_disabled = FALSE;
	$flybx_epn_category_disabled = FALSE;
	//get disabled categories
	$flybx_amzn_disabled_categories = array();
	$flybx_amzn_disabled_categories_check = get_option('flybx_amzn_disabled_categories');
	if ($flybx_amzn_disabled_categories_check !== FALSE && isset($flybx_addons) && is_array($flybx_addons) && in_array('amzn', $flybx_addons))
	{
		$flybx_amzn_disabled_categories_check_arr = explode(',', $flybx_amzn_disabled_categories_check);
		if (count($flybx_amzn_disabled_categories_check_arr) > 0)
		{
			$flybx_amzn_disabled_categories = $flybx_amzn_disabled_categories_check_arr;
		}
	}
	$flybx_epn_disabled_categories = array();
	$flybx_epn_disabled_categories_check = get_option('flybx_epn_disabled_categories');
	if ($flybx_epn_disabled_categories_check !== FALSE && isset($flybx_addons) && is_array($flybx_addons) && in_array('epn', $flybx_addons))
	{
		$flybx_epn_disabled_categories_check_arr = explode(',', $flybx_epn_disabled_categories_check);
		if (count($flybx_epn_disabled_categories_check_arr) > 0)
		{
			$flybx_epn_disabled_categories = $flybx_epn_disabled_categories_check_arr;
		}
	}
	//get post cats
	if ($post_id != 0)
	{
		$post_cats = get_the_category($post_id);
		if (is_array($post_cats) && count($post_cats) > 0)
		{
			foreach($post_cats as $post_cat)
			{
				if (in_array($post_cat->term_id, $flybx_amzn_disabled_categories))
				{
					$flybx_amzn_category_disabled = TRUE;
				}
				if (in_array($post_cat->term_id, $flybx_epn_disabled_categories))
				{
					$flybx_epn_category_disabled = TRUE;
				}
			}
		}
	}
	
	if ($flybx_epn_category_disabled === TRUE && $flybx_amzn_category_disabled === TRUE && !isset($_GET['preview_general']) && !isset($_GET['preview']))
	{
		return '999';
	}
	
	if (is_array($flybx_addons) && in_array('epn', $flybx_addons) && (flybx_get_option('epn_enabled') == '1' || flybx_get_option('epn_enabled') === FALSE) && $flybx_epn_category_disabled !== TRUE)
	{
		$epn_pops_share = flybx_get_option('epn_pops_share');
		if ($epn_pops_share === FALSE)
		{
			$epn_pops_share = '50';
		}
		if ($flybx_source_sequence < $epn_pops_share)
		{
			$flybx_source = '1';
		}
	}
	
	//amzn disabled but epn active
	$flybx_amzn_active = flybx_get_option('flybx_amzn_active');
	if (flybx_get_option('epn_enabled') == '1' && $flybx_epn_category_disabled !== TRUE && (($flybx_amzn_active !== FALSE && is_numeric($flybx_amzn_active) && $flybx_amzn_active == '0') || $flybx_amzn_category_disabled === TRUE))
	{
		$flybx_source = '1';
	}
	
	//check if country supported and if need to substitute with different source
	if (is_array($flybx_addons) && in_array('epn', $flybx_addons) && in_array('amzn', $flybx_addons) && (flybx_get_option('epn_enabled') == '1' || flybx_get_option('epn_enabled') === FALSE) && (flybx_get_option('flybx_amzn_active') == '1' || flybx_get_option('flybx_amzn_active') === FALSE))
	{		
		$amzn_countries = array('us', 'uk', 'de', 'jp', 'fr', 'ca', 'it', 'cn', 'es', 'gb');
		$epn_countries = array('us', 'ie', 'at', 'au', 'be', 'ca', 'fr', 'de', 'it', 'es', 'ch','uk', 'nl');
		$user_country = flybx_get_locale(FALSE);
		
		//amzn only countries (jp and cn)
		$amtag_jp = get_option('flybx_locale_tag_jp');
		$amtag_cn = get_option('flybx_locale_tag_cn');
		if (($user_country == 'jp' && $amtag_jp !== FALSE && strlen($amtag_jp) > 0) || ($user_country == 'cn' && $amtag_cn !== FALSE && strlen($amtag_cn) > 0))
		{
			$flybx_source = '0';
		}
		
		//epn only countries (ie, at, au, be, ch, nl)
		if (in_array($user_country, array('ie', 'at', 'au', 'be', 'ch', 'nl')))
		{
			$epn_country_enabled_current = flybx_get_option('epn_country_enabled_'.$user_country);
			if (($epn_country_enabled_current === FALSE || $epn_country_enabled_current == '1'))
			{
				$flybx_source = '1';
			}
		}
		
		//country disabled at one of the sources but enabled at other
		if (in_array($user_country, array('us', 'uk', 'de', 'fr', 'ca', 'it', 'es')))
		{
			$epn_country_enabled_current = flybx_get_option('epn_country_enabled_'.$user_country);
			if ($user_country == 'us')
			{
				$amzn_country_enabled_current = get_option('flybx_am_associate_tag');
			}
			else
			{
				$amzn_country_enabled_current = get_option('flybx_locale_tag_'.$user_country);
			}

			if (($epn_country_enabled_current === FALSE || $epn_country_enabled_current == '1') && ($amzn_country_enabled_current === FALSE && strlen(trim($amzn_country_enabled_current)) == 0))
			{
				$flybx_source = '1';
			}
			
			if ((is_numeric($epn_country_enabled_current) && $epn_country_enabled_current == '0') && ($amzn_country_enabled_current !== FALSE && strlen(trim($amzn_country_enabled_current)) > 0))
			{
				$flybx_source = '0';
			}
		}		
	}
	
	/*echo '<br />flybx_source_sequence: '.$flybx_source_sequence;
	echo '<br />epn_pops_share: '.$epn_pops_share;
	echo '<pre>';
	print_r($flybx_addons);
	echo '</pre>';*/
	return $flybx_source;
}

function flybx_module_installed($module_name = '')
{
	global $flybx_addons;
	if (isset($flybx_addons) && is_array($flybx_addons) && in_array($module_name, $flybx_addons))
	{
		return TRUE;
	}
	return FALSE;
}

function flybx_amzn_cats_select($country = 'us', $level = 0, $parent_id = 0, $selected = array(), $break_cycle = FALSE)
{
	global $flybx_plugin_slug, $flybx_plugin_name;
	//level 0 is always search index for that locale
	//level 1 returns top node ids for the search index
	
	$html = '';
	if ($level == '0')
	{
		$flybx_amzn_level_one_cats = flybx_include_amzn_category($country, 0);
		
		if (isset($flybx_amzn_level_one_cats['indexes']))
		{
			$html .= '<select name="amzn_category['.$country.']['.$level.']" style="width: 250px;"';
			$html .= ' onchange="if (this.value == \'All\' || this.value == \'Blended\') { jQuery(\'.amzn_'.$country.'_node_children_'.$parent_id.'\').remove();} else {flybx_amzn_load_cats_selector(\''.$country.'\', \''.($level + 1).'\', this.value, \''.$parent_id.'\');}"';
			$html .= '>';
			//$html .= '<option value="0">-- '.__('All Categories', $flybx_plugin_slug).' --</option>';
			foreach($flybx_amzn_level_one_cats['indexes'] as $key => $val)
			{
				$html .= '<option value="'.$key.'" '.(isset($selected[$level]) && $key == $selected[$level]?'selected':'').'>';
				$html .= $val;
				$html .= '</option>';
			}
			$html .= '</select>';
			
			if ($break_cycle === FALSE)
			{
				if (isset($selected[($level + 1)]))
				{
					$html .= '<div class="amzn_'.$country.'_node_parent_'.$selected[$level].' amzn_'.$country.'_node_children_'.$parent_id.' amzn_'.$country.'_node_children">'.flybx_amzn_cats_select($country, ($level + 1), (isset($selected[$level]) ? $selected[$level]:0), $selected).'</div>';
				}
				else
				{
					$html .= '<div class="amzn_'.$country.'_node_parent_'.$selected[$level].' amzn_'.$country.'_node_children_'.$parent_id.' amzn_'.$country.'_node_children">'.flybx_amzn_cats_select($country, ($level + 1), (isset($selected[$level]) ? $selected[$level]:0), $selected, TRUE).'</div>';
				}
			}
		}

	}
	else
	{
		//return top nodes for the 
		$flybx_amzn_level_one_cats = flybx_include_amzn_category($country, $parent_id);
		
		if (isset($flybx_amzn_level_one_cats['nodes']))
		{
			$html .= '<select name="amzn_category['.$country.']['.$level.']" style="width: 250px;"';

			$html .= ' onchange="if (this.value == \'0\') { jQuery(\'.amzn_'.$country.'_node_children_'.$parent_id.'\').remove();} else { flybx_amzn_load_cats_selector(\''.$country.'\', \''.($level + 1).'\', this.value, \''.$parent_id.'\'); }"';

			$html .= '>';
			$html .= '<option value="0">-- '.__('All Subcategories', $flybx_plugin_slug).' --</option>';
			foreach($flybx_amzn_level_one_cats['nodes'] as $key => $val)
			{
				$html .= '<option value="'.$key.'" '.(isset($selected[$level]) && $key == $selected[$level]?'selected':'').'>';
				$html .= $val;
				$html .= '</option>';
			}
			$html .= '</select>';
			
			if ($break_cycle === FALSE)
			{
				if (isset($selected[($level + 1)]))
				{
					$html .= '<div class="amzn_'.$country.'_node_parent_'.$selected[$level].' amzn_'.$country.'_node_children_'.$parent_id.' amzn_node_children">'.flybx_amzn_cats_select($country, ($level + 1), (isset($selected[$level]) ? $selected[$level]:0), $selected).'</div>';
				}
				else
				{
					$html .= '<div class="amzn_'.$country.'_node_parent_'.$selected[$level].' amzn_'.$country.'_node_children_'.$parent_id.' amzn_'.$country.'_node_children">'.flybx_amzn_cats_select($country, ($level + 1), (isset($selected[$level]) ? $selected[$level]:0), $selected, TRUE).'</div>';
				}
			}
	
		}
	}	
	
	return $html;
}

function flybx_amzn_country_cats_javascript() {
global $flybx_plugin_slug, $flybx_plugin_name;
flybx_add_json_support();
?>
<script type="text/javascript" >
function flybx_amzn_load_cats_selector(country, level, parent_id, ancestor_id)
{
	var data = {
		action: 'flybx_amzn_get_cats',
		country: country,
		level: level,
		parent_id: parent_id,
		ancestor_id: ancestor_id
	};

	if (parent_id == 0)
	{
		jQuery('.amzn_' + country + '_category_loading_msg').html('');
	}
	else
	{
		jQuery('.amzn_' + country + '_node_children_' + ancestor_id).html('');
		jQuery('.amzn_' + country + '_category_loading_msg').html('<?php esc_attr_e('Checking subcategories...', $flybx_plugin_slug); ?>');
	}

	
	//if (parent_id != 0)
	//{
		jQuery.post(ajaxurl, data, function(response) {
			//alert('Got this from the server: ' + response);
			if (response != '')
			{
				//var obj = jQuery.parseJSON(response);
				//alert(parent_id);
				//alert(ancestor_id);
				var obj = JSON.parse(response);
				if (obj.html != undefined)
				{
					jQuery('.amzn_' + country + '_node_children_' + ancestor_id).remove();
					jQuery('.amzn_' + country + '_node_parent_' + ancestor_id).append('<div class="amzn_' + country + '_node_parent_' + obj.node_id + ' amzn_' + country + '_node_children_' + ancestor_id + ' amzn_' + country + '_node_children"></div>');
					jQuery('.amzn_' + country + '_node_parent_' + obj.node_id).html('');
					jQuery('.amzn_' + country + '_node_parent_' + obj.node_id).html(obj.html);
					jQuery('.amzn_' + country + '_category_loading_msg').html('');
				}
				
			}
		});
	//}
}
</script>
<?php
}

add_action('wp_ajax_flybx_amzn_get_cats', 'flybx_amzn_get_cats');

function flybx_amzn_get_cats() {
	global $wpdb, $_POST, $flybx_current_plugin_version;

	$country = $_POST['country'];
	$level = $_POST['level'];
	$parent_id = $_POST['parent_id'];
	
	if (/*is_numeric($parent_id) &&*/ is_numeric($level) && in_array($country, flybx_amzn_countries()))
	{
		//get children categories
		$html = flybx_amzn_cats_select($country, $level, $parent_id);
		echo json_encode(array('html' => $html, 'node_id' => $parent_id));
	}

	die(); // this is required to return a proper result
}

function flybx_include_amzn_category($country = 'us', $parent_id = 0)
{
	$curr_return = array();
	//download categories
	$flybx_am_params = array(
							'key_id' => get_option('flybx_am_key_id'), 
							'access_key' => get_option('flybx_am_access_key'),
							'associate_tag' => 'anytagfornodeid-21'
							);
	require_once(dirname(__FILE__).'/amazon.lib.php');
	$flybx_am_class = new flybx_amazon_api($flybx_am_params);
	//echo 'amzn_category '.$country.' '.$parent_id.'<br />';
	if (is_numeric($parent_id) && $parent_id == '0')
	{
		//return indexes first
		$am_indexes = $flybx_am_class->get_indexes($country);
		$curr_return['indexes'] = $am_indexes;
		
	}
	else
	{
		if (is_numeric($parent_id) === FALSE) 
		{
			//get top node id
			$parent_id = $flybx_am_class->get_top_node_id($country, $parent_id);
		}
		if (file_exists(dirname(dirname(__FILE__)).'/cache/'.$country.'/'.$parent_id.'.txt'))
		{
			$node_contents = file_get_contents(dirname(dirname(__FILE__)).'/cache/'.$country.'/'.$parent_id.'.txt');
			$node_unserialized = @unserialize($node_contents);
			if ($node_unserialized !== FALSE)
			{
				if (count($node_unserialized) > 0) $curr_return['nodes'] = $node_unserialized;
				return $curr_return;
			}
		}
		//comply with Amazon API time limits
		flybx_get_am_request_window();
		$am_result = $flybx_am_class->browse_node($country, $parent_id);
		if (isset($am_result->BrowseNodes->BrowseNode->Children->BrowseNode) )
		{
			$returned_nodes = array();
			foreach($am_result->BrowseNodes->BrowseNode->Children->BrowseNode as $curr_node)
			{
				$returned_nodes[strval($curr_node->BrowseNodeId)] = strval($curr_node->Name);
			}
			if (count($returned_nodes) > 0)
			{
				$fp = fopen(dirname(dirname(__FILE__)).'/cache/'.$country.'/'.$parent_id.'.txt', 'w');
				if ($fp !== FALSE)
				{
					fwrite($fp, serialize($returned_nodes));
					fclose($fp);
				}
			}			
			
			if (count($returned_nodes) > 0) $curr_return['nodes'] = $returned_nodes;
		}
		elseif(isset($am_result->BrowseNodes->Request->IsValid) && strval($am_result->BrowseNodes->Request->IsValid) == 'True')
		{
			//write node with no children
			$returned_nodes = array();
			$fp = fopen(dirname(dirname(__FILE__)).'/cache/'.$country.'/'.$parent_id.'.txt', 'w');
			if ($fp !== FALSE)
			{
				fwrite($fp, serialize($returned_nodes));
				fclose($fp);
			}
		}
		/*echo '<pre>';
		print_r($am_result);
		print_r($am_result->BrowseNodes->BrowseNode->Children->BrowseNode);
		print_r($returned_nodes);
		echo '</pre>';*/
		//$curr_return['nodes']
	}
	return $curr_return;
}

function flybx_amzn_countries()
{
	$countries = array(
						'1' => 'us',
						'2' => 'ca',
						'3' => 'fr',
						'4' => 'de',
						'5' => 'it',
						'6' => 'es',
						'7' => 'cn',
						'8' => 'uk',
						'9' => 'jp'
						);
	return $countries;
}

function flybx_amz_country_url($locale)
{
	$flybx_url = 'http://www.amazon.com';
	if ($locale == 'us')	$flybx_url = 'http://www.amazon.com';
	if ($locale == 'jp')	$flybx_url = 'http://www.amazon.co.jp';
	if ($locale == 'uk' || $locale == 'gb')	$flybx_url = 'http://www.amazon.co.uk';
	if ($locale == 'de')	$flybx_url = 'http://www.amazon.de';
	if ($locale == 'fr')	$flybx_url = 'http://www.amazon.fr';
	if ($locale == 'ca')	$flybx_url = 'http://www.amazon.ca';
	if ($locale == 'it')	$flybx_url = 'http://www.amazon.it';
	if ($locale == 'es')	$flybx_url = 'http://www.amazon.es';
	if ($locale == 'cn')	$flybx_url = 'http://www.amazon.cn';
	return $flybx_url;
}

function flybx_active_locales()
{
	$countries = flybx_amzn_countries();
	$active_locales = array();
	foreach($countries as $country)
	{
		$locale_tag = flybx_get_locale_tag($country);
		if ($locale_tag !== FALSE && strlen($locale_tag) > 0)
		{
			$active_locales[] = $country;
		}
	}
	return $active_locales;
}

function flybx_country_selected_cats($country = 'us')
{
	$selected_arr = array();
	$selected_str = get_option('flybx_nodes_path_'.$country);
	if ($selected_str !== FALSE)
	{
		return explode(',', $selected_str);
	}
	//get fallback search index
	$search_index = get_option('flybx_am_searchindex');
	if ($search_index !== FALSE)
	{
		return array($search_index);
	}
	return $selected_arr;
}

function flybx_get_country_node($locale = '')
{
	$country_nodes = flybx_country_selected_cats($locale);
	$search_index = $country_nodes[0];
	$country_node = end($country_nodes);
	if ($country_node == '0')
	{
		$country_node = $country_nodes[count($country_nodes) - 2];
	}
	if (!is_numeric($country_node))
	{
		$country_node = '';
	}
	return array('search_index' => $search_index, 'country_node' => $country_node);
}

//returns price given or changes "Too low to display" msg to smth else
function flybx_am_price($price = '', $too_low_msg = 'See Price')
{
	if ($price == 'Too low to display')
	{
		return $too_low_msg;
	}
	return $price;
}

function flybx_parse_asins($content = '', $locale = 'us', $strict = FALSE)
{
	$asins = array();
	preg_match_all('/<a(.*?) href=\"(.*?)\">/i', $content, $url_matches);

	/*echo '<pre>';
	print_r($url_matches);
	exit;*/

	if (isset($url_matches[2]) && count($url_matches[2]) > 0)
	{
		
		foreach($url_matches[2] as $curr_url)
		{
			$curr_url = urldecode($curr_url);
			$tlds = 'com|de|fr|co\.uk|ca|it|es|cn|jp';
			if ($strict === TRUE)
			{
				if ($locale == 'us') $tlds = 'com'; 
				if ($locale == 'uk') $tlds = 'co\.uk'; 
				if ($locale == 'ca') $tlds = 'ca'; 
				if ($locale == 'de') $tlds = 'de'; 
				if ($locale == 'fr') $tlds = 'fr'; 
				if ($locale == 'it') $tlds = 'it'; 
				if ($locale == 'es') $tlds = 'es'; 
				if ($locale == 'cn') $tlds = 'cn'; 
				if ($locale == 'jp') $tlds = 'jp'; 
			}
			if (preg_match("/\.amazon\.(".$tlds.")/", $curr_url, $matches))
			{
				//preg_match("/\/dp\/(.*)(\?|\/ref)/", $url, $matches);
				$asin_found = preg_match("/(\/dp\/|\/gp\/product\/)(.*)(\?|\/ref)/i", $curr_url, $matches);
				/*echo '<pre>';
				print_r($matches);
				echo '</pre>';*/
				
				if ($asin_found > 0 && isset($matches[2]) && !in_array($matches[2], $asins))
				{
					if (stripos($matches[2], '/'))
					{
						$arr = explode('/', $matches[2]);
						$matches[2] = $arr[0];
					}
					$asins[] = $matches[2];
				}
			}
			
			//also look for /gp/offer-listing/ASIN?SubscriptionId
			if (preg_match("/\.amazon\.(".$tlds.")/", $curr_url, $matches))
			{
				$asin_found = preg_match("/(\/dp\/offer-listing\/|\/gp\/offer-listing\/)(.*)(\?SubscriptionId|\?SubscriptionsId)/i", $curr_url, $matches);
			
				if ($asin_found > 0 && isset($matches[2]) && !in_array($matches[2], $asins))
				{
					if (stripos($matches[2], '/'))
					{
						$arr = explode('/', $matches[2]);
						$matches[2] = $arr[0];
					}
					$asins[] = $matches[2];
				}
			}
			
			$clean_asins = array();
			$junk_asins = array('images');
			//remove junk
			if (count($asins) > 0)
			{
				foreach($asins as $curr_asin)
				{
					if (!in_array($curr_asin, $junk_asins))
					{
						$clean_asins[] = $curr_asin;
					}
				}
				$asins = $clean_asins;
			}
		}
	}
	return $asins;
}

function flybx_shortcode( $atts ) {
	global $post;
	extract( shortcode_atts( array(
		'uskws' => FALSE,
		'ukkws' => FALSE,
		'cakws' => FALSE,
		'frkws' => FALSE,
		'dekws' => FALSE,
		'itkws' => FALSE,
		'eskws' => FALSE,
		'cnkws' => FALSE,
		'jpkws' => FALSE,
		'tplid' => FALSE,
		'bestpick' => FALSE,
	), $atts ) );
	
	/*echo '<pre>';
	print_r($atts);
	echo '</pre>';*/
	
	//get correct tplid
	require_once(dirname(dirname(__FILE__)).'/app/models/templates.php');
	$template = new flybx_templates;
	$templates_data = $template->templates_data();
	if (isset($tplid) && $tplid !== FALSE && $meta != 'default' && isset($templates_data['templates'][$tplid]) && $templates_data['templates'][$tplid]['active'] == 'yes')
	{
		$tpl_id = $tplid;
	}
	else
	{
		$tpl_id = flybx_get_default_tplid($templates_data);
	}
	
	//format kws data
	$shorttag_kws = array();
	if (isset($uskws) && $uskws !== FALSE) $shorttag_kws['us'] = explode(',', str_replace(', ', ',', $uskws));
	if (isset($ukkws) && $ukkws !== FALSE) $shorttag_kws['uk'] = explode(',', str_replace(', ', ',', $ukkws));
	if (isset($cakws) && $cakws !== FALSE) $shorttag_kws['ca'] = explode(',', str_replace(', ', ',', $cakws));
	if (isset($frkws) && $frkws !== FALSE) $shorttag_kws['fr'] = explode(',', str_replace(', ', ',', $frkws));
	if (isset($dekws) && $dekws !== FALSE) $shorttag_kws['de'] = explode(',', str_replace(', ', ',', $dekws));
	if (isset($eskws) && $eskws !== FALSE) $shorttag_kws['es'] = explode(',', str_replace(', ', ',', $eskws));
	if (isset($itkws) && $itkws !== FALSE) $shorttag_kws['it'] = explode(',', str_replace(', ', ',', $itkws));
	if (isset($cnkws) && $cnkws !== FALSE) $shorttag_kws['cn'] = explode(',', str_replace(', ', ',', $cnkws));
	if (isset($jpkws) && $jpkws !== FALSE) $shorttag_kws['jp'] = explode(',', str_replace(', ', ',', $jpkws));
	
	/*echo '<pre>';
	print_r($shorttag_kws);
	echo '</pre>';
	exit;*/
	
	if (is_numeric($tpl_id) && count($shorttag_kws) > 0)
	{
		include_once(dirname(dirname(__FILE__)).'/app/models/templates.php');
		$templates = new flybx_templates;
		$curr_template = $templates->get_by_id($tpl_id);
		if ($curr_template !== FALSE)
		{
			return $templates->template_html_init($tpl_id, FALSE, $post->ID, '', $shorttag_kws, $bestpick);
		}
	}
	return "";
}
add_shortcode( 'azonflybox', 'flybx_shortcode' );

function azonflybox_template( $id = 0, $echo = TRUE ) {
	global $post;

	if (is_numeric($id))
	{
		include_once(dirname(dirname(__FILE__)).'/app/models/templates.php');
		$templates = new flybx_templates;
		
		if ($echo == TRUE)
		{
			echo $templates->template_html_init($id, FALSE, $post->ID);
		}
		else
		{
			return $templates->template_html_init($id, FALSE, $post->ID);
		}
	}
	return "";
}

function flybx_is_plus()
{
	if (flybx_module_installed('amzn_cart'))
	{
		return TRUE;
	}
	return FALSE;
}
function flybx_branding_img()
{
	if (flybx_is_plus())
	{
		return 'ico_azonflybox_header_plus.png';
	}
	return 'ico_azonflybox_header.png';
}

function flybx_ajax_load_sim_asins() {
	global $flybx_skip_attrs;
	if( isset( $_POST['post_id'] ) ) {
		//perform search
		require_once(dirname(dirname(__FILE__)).'/app/controllers/ajax_load_sim_asins.php');
	}
	die();
}
add_action( 'wp_ajax_flybx_ajax_load_sim_asins', 'flybx_ajax_load_sim_asins' );
add_action( 'wp_ajax_nopriv_flybx_ajax_load_sim_asins', 'flybx_ajax_load_sim_asins' );

function flybx_ajax_load_res() {
	global $flybx_skip_attrs, $post, $flybx_post, $flybx_addons, $flybx_plugin_slug;
	if( isset( $_POST['post_id'] ) ) {
		//perform search
		require_once(dirname(dirname(__FILE__)).'/app/controllers/ajax_load_res.php');
	}
	die();
}
add_action( 'wp_ajax_flybx_ajax_load_res', 'flybx_ajax_load_res' );
add_action( 'wp_ajax_nopriv_flybx_ajax_load_res', 'flybx_ajax_load_res' );

function flybx_ajax_load_all_attr() {
	global $flybx_skip_attrs, $post, $flybx_post, $flybx_addons, $flybx_plugin_slug;
	if( isset( $_POST['post_id'] ) && function_exists('current_user_can') && current_user_can('manage_options')) {
		//perform search
		require_once(dirname(dirname(__FILE__)).'/app/controllers/ajax_load_all_attr.php');
	}
	die();
}
add_action( 'wp_ajax_flybx_ajax_load_all_attr', 'flybx_ajax_load_all_attr' );
add_action( 'wp_ajax_nopriv_flybx_ajax_load_all_attr', 'flybx_ajax_load_all_attr' );

function flybx_ajax_gen_kws() {
	global $flybx_skip_attrs;
	global $flybx_sim_asins;
	if( isset( $_POST['post_id'] ) ) {
		$flybx_only_keywords = TRUE;
		//perform search
		require_once(dirname(dirname(__FILE__)).'/app/controllers/ajax_load_kws.php');
	}
	die();
}
add_action( 'wp_ajax_flybx_ajax_gen_kws', 'flybx_ajax_gen_kws' );
add_action( 'wp_ajax_nopriv_flybx_ajax_gen_kws', 'flybx_ajax_gen_kws' );

function flybx_get_ajax_url() {
	$site_url = get_site_url();
	$admin_url = admin_url( 'admin-ajax.php' );
	if( preg_match( '/^https/', $admin_url ) && ! preg_match( '/^https/', $site_url ) ) {
		$admin_url = preg_replace( '/^https/', 'http', $admin_url );
	} else if( preg_match( '/^https/', $site_url ) && ! preg_match( '/^https/', $admin_url ) ) {
		$admin_url = preg_replace( '/^http/', 'https', $admin_url );
	}
	return $admin_url;
}

function flybx_ajax_stats_click() {
	if( isset( $_POST['kws'] ) ) {
		//collect click
		flybx_record_stat_detailed(1, $_REQUEST['tpl_id'], $_REQUEST['post_id'], 0, $_REQUEST['kws'], $_REQUEST['asin'], $_SERVER['REMOTE_ADDR']);
	}
	die();
}
add_action( 'wp_ajax_flybx_ajax_stats_click', 'flybx_ajax_stats_click' );
add_action( 'wp_ajax_nopriv_flybx_ajax_stats_click', 'flybx_ajax_stats_click' );

function flybx_ajax_stats_view() {
	if( isset( $_POST['kws'] ) ) {
		//collect click
		//flybx_record_stat_detailed(1, $_REQUEST['tpl_id'], $_REQUEST['post_id'], 0, $_REQUEST['kws'], $_REQUEST['asin'], $_SERVER['REMOTE_ADDR']);
		//record detailed stats
		flybx_record_stat_detailed(0, 1, $_REQUEST['post_id'], 0, $_REQUEST['kws'], $_REQUEST['asin'], $_SERVER['REMOTE_ADDR']);
	}
	die();
}
add_action( 'wp_ajax_flybx_ajax_stats_view', 'flybx_ajax_stats_view' );
add_action( 'wp_ajax_nopriv_flybx_ajax_stats_view', 'flybx_ajax_stats_view' );

function flybx_spaces_to_underscores($arr = array())
{
	foreach($arr as $key => $val)
	{
		$val = str_replace('& ', '', $val);
		$arr[$key] = str_replace(' ', '_', $val);
	}
	return $arr;
}

function flybx_get_default_tplid($curr_forms_data = array())
{
	if (!isset($curr_forms_data['templates']))
	{
		return 0;
	}
	$default_tplid = flybx_get_option('default_tplid');
	//echo 'tplid is: ';
	//var_dump($default_tplid);
	if ($default_tplid !== FALSE && isset($curr_forms_data['templates'][$default_tplid]) && $curr_forms_data['templates'][$default_tplid])
	{
		return $default_tplid;
	}
	else
	{
		//let's just find newest active tpl
		if (isset($curr_forms_data['last_id']) && isset($curr_forms_data['templates'][$curr_forms_data['last_id']]))
		{
			return $curr_forms_data['last_id'];
		}
	}
	return 0;
}

function flybx_get_tpl_options()
{
	require_once(dirname(dirname(__FILE__)).'/app/models/templates.php');
	$template = new flybx_templates;
	$templates_data = $template->templates_data();
	$default_tplid = flybx_get_default_tplid($templates_data);
	$tpl_options = array('default' => '-- Default Template '.($default_tplid != 0?'('.$templates_data['templates'][$default_tplid]['name'].')':'').' --');
	foreach($templates_data['templates'] as $curr_tpl)
	{
		if (/*$curr_tpl['id'] != $default_tplid &&*/ $curr_tpl['active'] == 'yes')
		{
			$tpl_options[$curr_tpl['id']] = $curr_tpl['name'];
		}
	}
	return $tpl_options;
}

add_action( 'admin_enqueue_scripts', 'flybx_pointer_enqueue_scripts' );
function flybx_pointer_enqueue_scripts() {
	//wp pointer introduced in wordpress 3.3
	if (version_compare(get_bloginfo('version'), '3.3', '<')) return;

    // Using Pointers
    wp_enqueue_style( 'wp-pointer' );
    wp_enqueue_script( 'wp-pointer' );
	
	if (isset($_GET['flybx_tour_close']) && $_GET['flybx_tour_close'] == 'yes')
	{
		flybx_update_option('quick_tour_finished', 'yes');
	}

	if ((flybx_get_option('license') !== FALSE && flybx_get_option('quick_tour_finished') != 'yes' && !isset($_GET['flybx_tour'])) || (isset($_GET['flybx_tour']) && $_GET['flybx_tour'] == '1'))
	{
		add_action( 'admin_print_footer_scripts', 'flybx_pointer_print_one' );
	}
	
	if (isset($_GET['flybx_tour']) && $_GET['flybx_tour'] == '2')
	{
		add_action( 'admin_print_footer_scripts', 'flybx_pointer_print_two' );
	}
	
	if (isset($_GET['flybx_tour']) && $_GET['flybx_tour'] == '5')
	{
		flybx_update_option('quick_tour_finished', 'yes');	//once user made it to templates page let's not bug him
		add_action( 'admin_print_footer_scripts', 'flybx_pointer_print_five' );
	}
	
	if (isset($_GET['flybx_tour']) && $_GET['flybx_tour'] == '6')
	{
		add_action( 'admin_print_footer_scripts', 'flybx_pointer_print_six' );
	}
	
	if (isset($_GET['flybx_tour']) && $_GET['flybx_tour'] == '7')
	{
		add_action( 'admin_print_footer_scripts', 'flybx_pointer_print_seven' );
	}
	
	if (isset($_GET['flybx_tour']) && $_GET['flybx_tour'] == '8')
	{
		add_action( 'admin_print_footer_scripts', 'flybx_pointer_print_eight' );
	}
}

function flybx_pointer_print_one() {
    $pointer_content = '<h3>Welcome to Azon FlyBox!</h3>';
    $pointer_content .= '<p>Would you like to take a Quick Set Up Tour?</p><p><a href="admin.php?page=flybx-config&flybx_tour_close=yes" class="button-secondary">No, thanks</a> &nbsp; &nbsp; &nbsp; <a href="admin.php?page=flybx-config&flybx_tour=2" class="button-primary">Take Tour</a></p>';
?>
<script type="text/javascript">
//<![CDATA[
jQuery(document).ready( function($) {
    $('#toplevel_page_flybx-config').pointer({
        content: '<?php echo $pointer_content; ?>',
        position: 'bottom',
        close: function(e) {
			return;
            // Once the close button is hit
        }
    }).pointer('open');
});
//]]>
</script>
<?php
}

function flybx_pointer_print_two() {
    $pointer_content = '<h3>Default Country</h3>';
    $pointer_content .= "<p>Please select your default country in case visitor comes from non-Amazon supported country.<br /><br />You can also enable/disable plugin quickly from here if you need.</p><p> <a href=\"admin.php?page=flybx-config&flybx_tour_close=yes\" class=\"button-secondary\"  onclick=\"return confirm(\'Really exit tour? You may lose any changes not saved yet.\');\" >Exit Tour</a>&nbsp; &nbsp; &nbsp;<a href=\"javascript: void(0);\" onclick=\"javascript: flybx_pointer_three();\" class=\"button-primary\" style=\"float: right;\">Next ==&gt;</a></p>";

	$pointer_content_three = '<h3>Amazon Quick Settings</h3>';
    $pointer_content_three .= "<p>These settings allow Azon FlyBox to connect to Amazon API. Use help links for help.</p><p> <a href=\"admin.php?page=flybx-config&flybx_tour_close=yes\" class=\"button-secondary\"  onclick=\"return confirm(\'Really exit tour? You may lose any changes not saved yet.\');\" >Exit Tour</a>&nbsp; &nbsp; &nbsp;<a href=\"javascript: flybx_pointer_four();\" class=\"button-primary\" style=\"float: right;\">Next ==&gt;</a></p>";

	$pointer_content_four = '<h3>Save Settings</h3>';
    //$pointer_content_four .= "<p>Don\'t forget to save your settings :)</p><p> <a href=\"admin.php?page=flybx-config&flybx_tour_close=yes\" class=\"button-secondary\"  onclick=\"return confirm(\'Really exit tour? You may lose any changes you havent\'t saved.\');\" >Exit Tour</a>&nbsp; &nbsp; &nbsp;<a href=\"javascript: flybx_pointer_five();\" class=\"button-primary\" style=\"float: right;\">Next ==&gt;</a></p>";
    $pointer_content_four .= "<p>Don\'t forget to save your settings :)</p><p> </p>";

	?>
<script type="text/javascript">
//<![CDATA[
var brand_new_pointer;
jQuery(document).ready( function($) {
    brand_new_pointer = $('#enable_and_country').pointer({
		pointerClass: 'flybx_enable_and_country_pointer',
        content: '<?php echo $pointer_content; ?>',
        position: 'left',
        close: function() {
            // Once the close button is hit
			/*if (confirm('Really exit tour? You may lose any changes not saved yet.')) 
			{
				window.location = "admin.php?page=flybx-config&flybx_tour_close=yes";
			}*/
			flybx_pointer_three();
        }
    }).pointer('open');
});

function flybx_pointer_three()
{
	jQuery('.flybx_enable_and_country_pointer').hide();
	jQuery('#avads_amz_quick_settings').pointer({
		pointerClass: 'flybx_amz_settings_pointer',
        content: '<?php echo $pointer_content_three; ?>',
        position: 'left',
        close: function() {
            // Once the close button is hit
			/*if (confirm('Really exit tour? You may lose any changes not saved yet.')) 
			{
				window.location = "admin.php?page=flybx-config&flybx_tour_close=yes";
			}*/
			flybx_pointer_four();
        }
    }).pointer('open');
}

function flybx_pointer_four()
{
	jQuery('.flybx_enable_and_country_pointer').hide();
	jQuery('.flybx_amz_settings_pointer').hide();
	jQuery("html, body").animate({ scrollTop: jQuery(document).height() }, 1000);
	jQuery('#flybx_save_important_settings').pointer({
		pointerClass: 'flybx_important_sett_close_pointer',
        content: '<?php echo $pointer_content_four; ?>',
        position: {
                edge: 'left',
                align: 'top',
				offset: '3 -70'
            },
        close: function() {
            // Once the close button is hit
			/*if (confirm('Really exit tour? You may lose any changes not saved yet.')) 
			{
				window.location = "admin.php?page=flybx-config&flybx_tour_close=yes";
			}*/
        }
    }).pointer('open');
}

//]]>
</script>
<?php
}

function flybx_pointer_print_five() {
	$pointer_content_five = '<h3>Go to Appearance tab</h3>';
    $pointer_content_five .= "<p>Click \"Appearance\" to check out Azon FlyBox appearance settings</p><p> <a href=\"admin.php?page=flybx-config&flybx_tour_close=yes\" class=\"button-secondary\"  onclick=\"return confirm(\'Really exit tour? You may lose any changes not saved yet.\');\" >Exit Tour</a>&nbsp; &nbsp; &nbsp;<a href=\"admin.php?page=flybx-config&tab=appearance&flybx_tour=6\" class=\"button-primary\" style=\"float: right;\">Next ==&gt;</a></p>";

	?>
<script type="text/javascript">
//<![CDATA[
var brand_new_pointer;
jQuery(document).ready( function($) {
	var flybx_curr_templates = $('.flybx_appearance_tab');
	
	var curr_templates_href = flybx_curr_templates.attr('href');
	curr_templates_href = curr_templates_href + '&flybx_tour=6';
	flybx_curr_templates.attr('href', curr_templates_href);
	var template_handler = $('.flybx_appearance_tab');
	//console.log(template_handler);
    template_handler.pointer({
        content: '<?php echo $pointer_content_five; ?>',
        position: {
                edge: 'top',
                align: 'center',
				offset: '100 0'
            },
        close: function() {
            // Once the close button is hit

        }
    }).pointer('open');
});
//]]>
</script>
<?php
}

function flybx_pointer_print_six() {
	$pointer_content_six = '<h3>Appearance Settings</h3>';
    $pointer_content_six .= "<p>You can manage your appearance settings on this screen (animation, triggering, position, colors etc).<br />Use FAQ links if you have any questions.<br /><br /></p><p> <a href=\"admin.php?page=flybx-config&flybx_tour_close=yes\" class=\"button-secondary\"  onclick=\"return confirm(\'Really exit tour? You may lose any changes not saved yet.\');\" >Exit Tour</a>&nbsp; &nbsp; &nbsp;<a href=\"admin.php?page=flybx-config&flybx_tour=8\" class=\"button-primary\" style=\"float: right;\">Next ==&gt;</a></p>";

	?>
<script type="text/javascript">
//<![CDATA[
var brand_new_pointer;
jQuery(document).ready( function($) {
    $('.flybx_appearance_metabox').pointer({
        content: '<?php echo $pointer_content_six; ?>',
        position: {
                edge: 'left',
                align: 'top',
				offset: '-150 -90'
            },
        close: function() {
            // Once the close button is hit
			/*if (confirm('Really exit tour? You may lose any changes you haven\'t saved.')) 
			{
				window.location = "admin.php?page=flybx-config&flybx_tour_close=yes";
			}*/
        }
    }).pointer('open');
});
//]]>
</script>
<?php
}

function flybx_pointer_print_seven() {
	$pointer_content_seven = '<h3>Azon FlyBox Widget</h3>';
    $pointer_content_seven .= "<p>Drag this widget and drop it on the sidebar on the right. Click Save and check your website.</p><p> <a href=\"admin.php?page=flybx-config&flybx_tour_close=yes\" class=\"button-secondary\"  onclick=\"return confirm(\'Really exit tour? You may lose any changes not saved yet.\');\" >Exit Tour</a>&nbsp; &nbsp; &nbsp;<a href=\"admin.php?page=flybx-templates&flybx_tour=8\" class=\"button-primary\" style=\"float: right;\">Next ==&gt;</a></p>";

	?>
<script type="text/javascript">
//<![CDATA[
var brand_new_pointer;
jQuery(document).ready( function($) {
    $("div[id*='azonflyboxwidget']").eq(0).pointer({
        content: '<?php echo $pointer_content_seven; ?>',
        position: {
                edge: 'top',
                align: 'center',
				offset: '0'
            },
        close: function() {
            // Once the close button is hit
			/*if (confirm('Really exit tour? You may lose any changes you haven\'t saved.')) 
			{
				window.location = "admin.php?page=flybx-config&flybx_tour_close=yes";
			}*/
        }
    }).pointer('open');
});
//]]>
</script>
<?php
}

function flybx_pointer_print_eight() {
	$pointer_content_seven = '<h3>Thanks!</h3>';
    //$pointer_content_seven .= "<p>Go ahead and check your site. You can play with different template settings to fit your site layout etc.<br />Try editing one of the posts or pages and note the \"Auto Azon FlyBox Data\" box. There you can tweak keywords and other options.<br /><br />If you have any questions <a href=\"http://www.pluginsbyigor.com/azon-flybox-faq/\">check the FAQ</a> and <a href=\"http://azonflybox.com/videos/\">Videos</a></p><p style=\"text-align: center;\">Like Azon FlyBox?<br /><a href=\"http://azonflybox.com/like-us-on-facebook/\" target=\"_blank\"><img src=\"".plugin_dir_url( dirname(__FILE__) )."images/btn_like.jpg\" /></a></p><p>Have fun! :)</p>";
    $pointer_content_seven .= "<p>Go ahead and check your site. You can play with different appearance settings to fit your site layout etc.<br />Try editing one of the posts or pages and note the \"Azon FlyBox Data\" box under the editor. There you can tweak keywords.<br /><br />If you have any questions <a href=\"http://www.pluginsbyigor.com/azon-flybox-faq/\">check the FAQ</a> and <a href=\"http://www.pluginsbyigor.com/azon-flybox-videos/\">Videos</a></p><p><a href=\"https://www.facebook.com/igor.urban.9\" target=\"_blank\">Are we friends on Facebook?</a></p><p>Have fun! :)</p>";

	?>
<script type="text/javascript">
//<![CDATA[
var brand_new_pointer;
jQuery(document).ready( function($) {
    $('#toplevel_page_flybx-config').pointer({
        content: '<?php echo $pointer_content_seven; ?>',
        position: {
                edge: 'left',
                align: 'center',
				offset: '0 -70'
            },		
        close: function() {
            // Once the close button is hit
			/*if (confirm('Really exit tour? You may lose any changes you haven\'t saved.')) 
			{
				window.location = "admin.php?page=flybx-config&flybx_tour_close=yes";
			}*/
        }
    }).pointer('open');
});
//]]>
</script>
<?php
}

