<?php

$pbuildercommerce_admin_options = array(
	'font' => array(
		'label' => __('Typography options','profit-builder'),
		'desc' => __('Font and typography settings for each shortcode. The "Default" option will use the theme fonts.','profit-builder'),
		'options' => array(
			array(
				'type' => 'heading',
				'label' => __('FRB-Woo Product Slider','profit-builder')
			),
			array(
				'type' => 'collapsible',
				'label' => __('Title font','profit-builder'),
				'options' => array(
					array(
						'name' => 'FRB-Woo_product_slider_title_font_family',
						'class' => 'pbuilder_font_select',
						'type' => 'select', 'search' => 'true',
						'std' => 'default',
						'label' => __('Font family','profit-builder'),
						'options' => $pbuilder_google_font_names
					),
					array(
						'name' => 'FRB-Woo_product_slider_title_font_style',
						'type' => 'select',
						'std' => 'default',
						'label' => __('Font style','profit-builder'),
						'options' => $this->get_font_variants('FRB-Woo_product_slider_title_font_family',$pbuilder_google_font_variants),
						'hide_if' => array(
							'FRB-Woo_product_slider_title_font_family' => array('default')
						)
					),
					array(
						'name' => 'FRB-Woo_product_slider_title_font_size',
						'type' => 'number',
						'label' => __('Font size','profit-builder'),
						'std' => 20,
						'unit' => 'px',
						'hide_if' => array(
							'FRB-Woo_product_slider_title_font_family' => array('default')
						)
					),
					array(
						'name' => 'FRB-Woo_product_slider_title_line_height',
						'type' => 'number',
						'label' => __('Line height','profit-builder'),
						'std' => 24,
						'unit' => 'px',
						'hide_if' => array(
							'FRB-Woo_product_slider_title_font_family' => array('default')
						)
					)
				)
			), // title font
			array(
				'type' => 'collapsible',
				'label' => __('Category font','profit-builder'),
				'options' => array(
					array(
						'name' => 'FRB-Woo_product_slider_cat_font_family',
						'class' => 'pbuilder_font_select',
						'type' => 'select', 'search' => 'true',
						'std' => 'default',
						'label' => __('Font family','profit-builder'),
						'options' => $pbuilder_google_font_names
					),
					array(
						'name' => 'FRB-Woo_product_slider_cat_font_style',
						'type' => 'select',
						'std' => 'default',
						'label' => __('Font style','profit-builder'),
						'options' => $this->get_font_variants('FRB-Woo_product_slider_cat_font_family',$pbuilder_google_font_variants),
						'hide_if' => array(
							'FRB-Woo_product_slider_cat_font_family' => array('default')
						)
					),
					array(
						'name' => 'FRB-Woo_product_slider_cat_font_size',
						'type' => 'number',
						'label' => __('Font size','profit-builder'),
						'std' => 14,
						'unit' => 'px',
						'hide_if' => array(
							'FRB-Woo_product_slider_cat_font_family' => array('default')
						)
					),
					array(
						'name' => 'FRB-Woo_product_slider_cat_line_height',
						'type' => 'number',
						'label' => __('Line height','profit-builder'),
						'std' => 18,
						'unit' => 'px',
						'hide_if' => array(
							'FRB-Woo_product_slider_cat_font_family' => array('default')
						)
					)
				)
			), // category font
			array(
				'type' => 'collapsible',
				'label' => __('Price font','profit-builder'),
				'options' => array(
					array(
						'name' => 'FRB-Woo_product_slider_price_font_family',
						'class' => 'pbuilder_font_select',
						'type' => 'select', 'search' => 'true',
						'std' => 'default',
						'label' => __('Font family','profit-builder'),
						'options' => $pbuilder_google_font_names
					),
					array(
						'name' => 'FRB-Woo_product_slider_price_font_style',
						'type' => 'select',
						'std' => 'default',
						'label' => __('Font style','profit-builder'),
						'options' => $this->get_font_variants('FRB-Woo_product_slider_price_font_family',$pbuilder_google_font_variants),
						'hide_if' => array(
							'FRB-Woo_product_slider_price_font_family' => array('default')
						)
					),
					array(
						'name' => 'FRB-Woo_product_slider_price_font_size',
						'type' => 'number',
						'label' => __('Font size','profit-builder'),
						'std' => 14,
						'unit' => 'px',
						'hide_if' => array(
							'FRB-Woo_product_slider_price_font_family' => array('default')
						)
					),
					array(
						'name' => 'FRB-Woo_product_slider_price_line_height',
						'type' => 'number',
						'label' => __('Line height','profit-builder'),
						'std' => 18,
						'unit' => 'px',
						'hide_if' => array(
							'FRB-Woo_product_slider_price_font_family' => array('default')
						)
					)
				)
			), // price font
			array(
				'type' => 'button',
				'class' => 'pbuilder_save',
				'label' => __('Save options','profit-builder')
			),	// product slider END
			array(
				'type' => 'heading',
				'label' => __('FRB-Woo Products','profit-builder')
			),
			array(
				'type' => 'collapsible',
				'label' => __('Title font','profit-builder'),
				'options' => array(
					array(
						'name' => 'FRB-Woo_products_title_font_family',
						'class' => 'pbuilder_font_select',
						'type' => 'select', 'search' => 'true',
						'std' => 'default',
						'label' => __('Font family','profit-builder'),
						'options' => $pbuilder_google_font_names
					),
					array(
						'name' => 'FRB-Woo_products_title_font_style',
						'type' => 'select',
						'std' => 'default',
						'label' => __('Font style','profit-builder'),
						'options' => $this->get_font_variants('FRB-Woo_products_title_font_family',$pbuilder_google_font_variants),
						'hide_if' => array(
							'FRB-Woo_products_title_font_family' => array('default')
						)
					),
					array(
						'name' => 'FRB-Woo_products_title_font_size',
						'type' => 'number',
						'label' => __('Font size','profit-builder'),
						'std' => 20,
						'unit' => 'px',
						'hide_if' => array(
							'FRB-Woo_products_title_font_family' => array('default')
						)
					),
					array(
						'name' => 'FRB-Woo_products_title_line_height',
						'type' => 'number',
						'label' => __('Line height','profit-builder'),
						'std' => 24,
						'unit' => 'px',
						'hide_if' => array(
							'FRB-Woo_products_title_font_family' => array('default')
						)
					)
				)
			), // title font
			array(
				'type' => 'collapsible',
				'label' => __('Price font','profit-builder'),
				'options' => array(
					array(
						'name' => 'FRB-Woo_products_price_font_family',
						'class' => 'pbuilder_font_select',
						'type' => 'select', 'search' => 'true',
						'std' => 'default',
						'label' => __('Font family','profit-builder'),
						'options' => $pbuilder_google_font_names
					),
					array(
						'name' => 'FRB-Woo_products_price_font_style',
						'type' => 'select',
						'std' => 'default',
						'label' => __('Font style','profit-builder'),
						'options' => $this->get_font_variants('FRB-Woo_products_price_font_family',$pbuilder_google_font_variants),
						'hide_if' => array(
							'FRB-Woo_products_price_font_family' => array('default')
						)
					),
					array(
						'name' => 'FRB-Woo_products_price_font_size',
						'type' => 'number',
						'label' => __('Font size','profit-builder'),
						'std' => 14,
						'unit' => 'px',
						'hide_if' => array(
							'FRB-Woo_products_price_font_family' => array('default')
						)
					),
					array(
						'name' => 'FRB-Woo_products_price_line_height',
						'type' => 'number',
						'label' => __('Line height','profit-builder'),
						'std' => 18,
						'unit' => 'px',
						'hide_if' => array(
							'FRB-Woo_products_price_font_family' => array('default')
						)
					)
				)
			), // price font
			array(
				'type' => 'button',
				'class' => 'pbuilder_save',
				'label' => __('Save options','profit-builder')
			),	//	products -- END
			array(
				'type' => 'heading',
				'label' => __('FRB-Woo Product Categories','profit-builder')
			),
			array(
				'type' => 'collapsible',
				'label' => __('Title font','profit-builder'),
				'options' => array(
					array(
						'name' => 'FRB-Woo_product_categories_title_font_family',
						'class' => 'pbuilder_font_select',
						'type' => 'select', 'search' => 'true',
						'std' => 'default',
						'label' => __('Font family','profit-builder'),
						'options' => $pbuilder_google_font_names
					),
					array(
						'name' => 'FRB-Woo_product_categories_title_font_style',
						'type' => 'select',
						'std' => 'default',
						'label' => __('Font style','profit-builder'),
						'options' => $this->get_font_variants('FRB-Woo_product_categories_title_font_family',$pbuilder_google_font_variants),
						'hide_if' => array(
							'FRB-Woo_product_categories_title_font_family' => array('default')
						)
					),
					array(
						'name' => 'FRB-Woo_product_categories_title_font_size',
						'type' => 'number',
						'label' => __('Font size','profit-builder'),
						'std' => 20,
						'unit' => 'px',
						'hide_if' => array(
							'FRB-Woo_product_categories_title_font_family' => array('default')
						)
					),
					array(
						'name' => 'FRB-Woo_product_categories_title_line_height',
						'type' => 'number',
						'label' => __('Line height','profit-builder'),
						'std' => 24,
						'unit' => 'px',
						'hide_if' => array(
							'FRB-Woo_product_categories_title_font_family' => array('default')
						)
					)
				)
			), // title font
			array(
				'type' => 'button',
				'class' => 'pbuilder_save',
				'label' => __('Save options','profit-builder')
			)
			
		)
	)
);



return $pbuildercommerce_admin_options;

?>