<?php


/* Gather wordpress menus */

$nav_menus = get_terms( 'nav_menu', array( 'hide_empty' => true ));
$pbuilder_menus = array();
$pbuilder_menu_std = '';
if(is_array($nav_menus)) 
	foreach($nav_menus as $menu) {
		if($pbuilder_menu_std == '') $pbuilder_menu_std = $menu->slug;
		$pbuilder_menus[$menu->slug] = $menu->name; 
	}

/* Gather wordpress sidebars (Must be done from the wp_head)

$pbuilder_sidebars = array();
$pbuilder_sidebar_std = '';
foreach ( $GLOBALS['wp_registered_sidebars'] as $sidebar ) {
	if($pbuilder_sidebar_std == '') $pbuilder_sidebar_std = $sidebar['id'];
	$pbuilder_sidebars[$sidebar['id']] = ucwords( $sidebar['name'] );
} 
*/

/* Gather wordpress posts */

global $wpdb, $pbuilder;

 $querystr = "
    SELECT $wpdb->posts.ID, $wpdb->posts.post_title
    FROM $wpdb->posts
	WHERE $wpdb->posts.post_status = 'publish'
	AND $wpdb->posts.post_type = 'post'
    ORDER BY $wpdb->posts.post_date DESC
 ";
$posts_array = $wpdb->get_results($querystr, OBJECT);

$pbuilder_wp_posts = array();
$first_post = '';
foreach($posts_array as $key => $obj) {
	if($first_post == '') $first_post = $key;
	$pbuilder_wp_posts[$obj->ID] = $obj->post_title;
}
$admin_optionsDB = $pbuilder->option();
$opts = array();
foreach($admin_optionsDB as $opt) {
	if(isset($opt->name) && isset($opt->value))
		$opts[$opt->name] = $opt->value;
}

$animationList = array(
	'none' => __('None', 'profit-builder'),
	'flipInX' => __('Flip in X', 'profit-builder'),
	'flipInY' => __('Flip in Y', 'profit-builder'),
	'fadeIn' => __('Fade in', 'profit-builder'),
	'fadeInDown' => __('Fade in from top', 'profit-builder'),
	'fadeInUp' => __('Fade in from bottom', 'profit-builder'),
	'fadeInLeft' => __('Fade in from left', 'profit-builder'),
	'fadeInRight' => __('Fade in from right', 'profit-builder'),
	'fadeInDownBig' => __('Slide in from top', 'profit-builder'),
	'fadeInUpBig' => __('Slide in from bottom', 'profit-builder'),
	'fadeInLeftBig' => __('Slide in from left', 'profit-builder'),
	'fadeInRightBig' => __('Slide in from right', 'profit-builder'),
	'bounceIn' => __('Bounce in', 'profit-builder'),
	'bounceInDown' => __('Bounce in from top', 'profit-builder'),
	'bounceInUp' => __('Bounce in from bottom', 'profit-builder'),
	'bounceInLeft' => __('Bounce in from left', 'profit-builder'),
	'bounceInRight' => __('Bounce in from right', 'profit-builder'),
	'rotateIn' => __('Rotate in', 'profit-builder'),
	'rotateInDownLeft' => __('Rotate in from top-left', 'profit-builder'),
	'rotateInDownRight' => __('Rotate in from top-right', 'profit-builder'),
	'rotateInUpLeft' => __('Rotate in from bottom-left', 'profit-builder'),
	'rotateInUpRight' => __('Rotate in from bottom-right', 'profit-builder'),
	'lightSpeedIn' => __('Lightning speed', 'profit-builder'),
	'rollIn' => __('Roll in', 'profit-builder')
);

$animationControl = array(
	'group_animate' => array(
		'type' => 'collapsible',
		'label' => __('Animation','profit-builder'),
		'options' => array(
			'animate' => array(
				'type' => 'select',
				'label' => __('Type:','profit-builder'),
				'std' => 'none',
				'label_width' => 0.25,
				'control_width' => 0.75,
				'options' => $animationList
			),
			'animation_delay' => array(
				'type' => 'number',
				'label' => __('Delay:','profit-builder'),
				'std' => 0,
				'unit' => 'ms',
				'min' => 0,
				'step' => 50,
				'max' => 10000,
				'half_column' => 'true'
			),
			'animation_speed' => array(
				'type' => 'number',
				'label' => __('Speed:','profit-builder'),
				'std' => 1000,
				'unit' => 'ms',
				'min' => 100,
				'step' => 50,
				'max' => 3000,
				'half_column' => 'true'
			),
			'animation_group' => array(
				'type' => 'input',
				'label_width' => 0.25,
				'control_width' => 0.75,
				'label' => __('Group:','profit-builder'),
				'std' => '',
			)
		)
	)
);



if(isset($opts['css_classes']) && $opts['css_classes'] == 'true') {
	$classControl = array(
		'group_css' => array(
			'type' => 'collapsible',
			'label' => __('ID & Custom CSS','profit-builder'),
			'options' => array(
				'shortcode_id' => array(
					'type' => 'input',
					'label' => __('ID:','profit-builder'),
					'desc' => __('For linking via hashtags','profit-builder'),
					'label_width' => 0.25,
					'control_width' => 0.75,
					'std' => ''
				),
				'class' => array(
					'type' => 'input',
					'label' => __('Class:','profit-builder'),
					'desc' => __('For custom css','profit-builder'),
					'label_width' => 0.25,
					'control_width' => 0.75,
					'std' => ''
				)
			)
		)
	);
	$tabsId = array(
		'custom_id' => array(
			'type' => 'input',
			'label' => __('Tab ID:','profit-builder'),
			'desc' => __('For use of anchor in url. Make sure that this ID is unique on the page.','profit-builder'),
			'label_width' => 0.25,
			'std' => ''
		)
	);
}
else {
	$classControl = array();
	$tabsId = array();
}

/* -------------------------------------------------------------------------------- */
/* pbuilder_woo_ext_product_slider */
/* -------------------------------------------------------------------------------- */


	global $pbuilderCommerce;
	$frbe_product_slider_default='';
	foreach ($pbuilderCommerce -> productCategoriesQuery as $key => $val) {
		$frbe_product_slider_default = $key;
		break;
	}


$frbe_product_slider = array(

	'frbe_product_slider' => array(
		'type' => 'draggable',
		'text' => __('Product Slider','profit-builder'),
		'icon' => $this->url.'images/product-slider.png',
		'function' => 'frbe_product_slider',
		'group' => 'woo_extension',
		'options' => array_merge(
		 array(
			'group_basic' => array(
				'type' => 'collapsible',
				'label' => __('Basic','profit-builder'),
				'open' => 'true',
				'options' => array(
					'slides_per_view' => array(
						'type' => 'number',
						'label' => __('Slides Per View:','profit-builder'),
						'label_width' => 0.5,
						'control_width' => 0.5,
						'min' => 1,
						'max' => 15,
						'unit' => '',
						'std' => 3
					),
					'number_of_posts' => array(
						'type' => 'number',
						'label' => __('Number Of Posts:','profit-builder'),
						'label_width' => 0.5,
						'control_width' => 0.5,
						'min' => 1,
						'max' => 50,
						'unit' => '',
						'std' => 5
					),
					'products_from' => array(
						'type' => 'select',
						'label' => __('Products From:','profit-builder'),
						'std' => 'category',
						'label_width' => 0.5,
						'control_width' => 0.5,
						'options' => array(
							'category' => 'Category',
							'featured' => 'Featured',
							'sales' => 'Sales'
						)
					),
					'categories' => array(
						'type' => 'select',
						'label' => __('Categories:','profit-builder'),
						'std' => $frbe_product_slider_default,
						'label_width' => 0.5,
						'control_width' => 0.5,
						'options' => $pbuilderCommerce -> productCategoriesQuery,
						'hide_if' => array (
							'products_from' => array('featured', 'sales')
						)
					),
					'category_order' => array(
						'type' => 'select',
						'label' => __('Order:','profit-builder'),
						'std' => 'desc',
						'label_width' => 0.5,
						'control_width' => 0.5,
						'options' => array(
							'desc' => 'Descending',
							'asc' => 'Ascending'
						)
					),
					'aspect_ratio' => array(
						'type' => 'select',
						'label' => __('Image Format:','profit-builder'),
						'std' => '1:1',
						'label_width' => 0.5,
						'control_width' => 0.5,
						'options' => array(
							'1:1.5' => 'Portrait',
							'1:1' => 'Square',
							'16:9' => 'Landscape'
						)
					),
					'resize_reference' => array(
						'type' => 'number',
						'label' => __('Min. Slide Width:','profit-builder'),
						'desc' => __('Reference for responsive layout calculations', 'profit-builder'),
						'label_width' => 0.5,
						'control_width' => 0.5,
						'unit' => 'px',
						'std' => 200
					),
					'item_align' => array(
						'type' => 'select',
						'label' => __('Item Align:','profit-builder'),
						'std' => 'center',
						'label_width' => 0.5,
						'control_width' => 0.5,
						'options' => array(
							'center' => 'Center',
							'left' => 'Left',
							'right' => 'Right'
						)
					),
					'item_spacing' => array(
						'type' => 'number',
						'label' => __('Item Padding:','profit-builder'),
						'label_width' => 0.5,
						'control_width' => 0.5,
						'unit' => 'px',
						'std' => 20
					)
				)
			),	
			'group_text' => array(
				'type' => 'collapsible',
				'label' => __('Text','profit-builder'),
				'open' => 'true',
				'options' => array(
					'title_color' => array(
						'type' => 'color',
						'label' => __('Title:','profit-builder'),
						'std' => $opts['main_color'],
						'label_width' => 0.5,
						'control_width' => 0.5
					),
					'price_color' => array(
						'type' => 'color',
						'label' => __('Price:','profit-builder'),
						'std' => '#111111',
						'label_width' => 0.5,
						'control_width' => 0.5
					),
					'category_color' => array(
						'type' => 'color',
						'label' => __('Category:','profit-builder'),
						'std' => '#111111',
						'label_width' => 0.5,
						'control_width' => 0.5
					),
					'category_show' => array(
						'type' => 'checkbox',
						'half_column' => 'true',
						'std' => 'true',
						'label' => __('Category','profit-builder')
					)
				)
			)
		),
		$classControl,
		array(
			'group_general' => array(
				'type' => 'collapsible',
				'label' => __('General','profit-builder'),
				'options' => array(
					'bot_margin' => array(
						'type' => 'number',
						'label' => __('Bottom margin:','profit-builder'),
						'std' => $opts['bottom_margin'],
						'unit' => 'px'
					)
				)
			)
		),
		$animationControl
		)
	)
);


/* -------------------------------------------------------------------------------- */
/* pbuilder_woo_ext_product_grid */
/* -------------------------------------------------------------------------------- */


$frbe_product_grid = array(

	'frbe_product_grid' => array(
		'type' => 'draggable',
		'text' => __('Product Grid','profit-builder'),
		'icon' => $this->url.'images/product-grid.png',
		'function' => 'frbe_product_grid',
		'group' => 'woo_extension',
		'options' => array_merge(
		 array(
			'group_basic' => array(
				'type' => 'collapsible',
				'label' => __('Basic','profit-builder'),
				'open' => 'true',
				'options' => array(
					'number_of_posts' => array(
						'type' => 'number',
						'label' => __('Number Of Posts:','profit-builder'),
						'label_width' => 0.5,
						'control_width' => 0.5,
						'min' => 1,
						'max' => 50,
						'unit' => '',
						'std' => 5
					),
					'products_from' => array(
						'type' => 'select',
						'label' => __('Products From:','profit-builder'),
						'std' => 'category',
						'label_width' => 0.5,
						'control_width' => 0.5,
						'options' => array(
							'category' => __('Category','profit-builder'),
							'featured' => __('Featured','profit-builder'),
							'sales' => __('Sales','profit-builder')
						)
					),
					'categories' => array(
						'type' => 'select',
						'multiselect' => 'true',
						'label' => __('Categories:','profit-builder'),
						'std' => $frbe_product_slider_default.'',
						'label_width' => 0.5,
						'control_width' => 0.5,
						'options' => $pbuilderCommerce -> productCategoriesQuery,
						'hide_if' => array (
							'products_from' => array('featured', 'sales')
						)
					),
					'category_order' => array(
						'type' => 'select',
						'label' => __('Order:','profit-builder'),
						'std' => 'desc',
						'label_width' => 0.5,
						'control_width' => 0.5,
						'options' => array(
							'desc' => 'Descending',
							'asc' => 'Ascending'
						)
					)
				)
			)
		),
		$classControl,
		array(
			'group_general' => array(
				'type' => 'collapsible',
				'label' => __('General','profit-builder'),
				'options' => array(
					'bot_margin' => array(
						'type' => 'number',
						'label' => __('Bottom margin:','profit-builder'),
						'std' => $opts['bottom_margin'],
						'unit' => 'px'
					)
				)
			)
		),
		$animationControl
		)
	)
);


/* -------------------------------------------------------------------------------- */
/* pbuilder_woo_ext_product_list */
/* -------------------------------------------------------------------------------- */


$frbe_products_list = array(

	'frbe_products_list' => array(
		'type' => 'draggable',
		'text' => __('Products','profit-builder'),
		'icon' => $this->url.'images/products.png',
		'function' => 'frbe_products_list',
		'group' => 'woo_extension',
		'options' => array_merge(
		 array(
			'group_filter' => array(
				'type' => 'collapsible',
				'label' => __('Filter','profit-builder'),
				'open' => 'true',
				'options' => array(
					'per_page' => array(
						'type' => 'number',
						'label' => __('Number of Items:','profit-builder'),
						'label_width' => 0.5,
						'control_width' => 0.5,
						'min' => 1,
						'max' => 20,
						'unit' => '',
						'std' => 1
					),
					'columns' => array(
						'type' => 'number',
						'label' => __('Number of Columns:','profit-builder'),
						'label_width' => 0.5,
						'control_width' => 0.5,
						'min' => 1,
						'max' => 4,
						'unit' => '',
						'std' => 3
					),
					'products_from' => array(
						'type' => 'select',
						'label' => __('Products from:','profit-builder'),
						'label_width' => 0.5,
						'control_width' => 0.5,
						'std' => 'category',
						'options' => array(
							'sale' => __('Sale','profit-builder'),
							'best_selling' => __('Best Selling','profit-builder'),
							'top_rated' => __('Top Rated','profit-builder'),
							'recent' => __('Recent','profit-builder'),
							'featured' => __('Featured','profit-builder'),
							'category' => __('Category','profit-builder'),
							'sku' => __('SKU','profit-builder'),
							// 'attribute' => __('Attribute','profit-builder'),
						)
					),
					'category' => array(
						'type' => 'select',
						'label' => __('Category:','profit-builder'),
						'label_width' => 0.5,
						'control_width' => 0.5,
						'std' => $frbe_product_slider_default.'',
						'options' => $pbuilderCommerce -> productCategoriesQuery,
						'hide_if' => array(
							'products_from' => array('sale','best_selling','top_rated','recent','featured','sku','attribute')
						)
					),
					'skus' => array(
						'type' => 'input',
						'label' => __('SKUs:','profit-builder'),
						'desc' => __('Insert SKU list here. Items are separated with a comma - "," ','profit-builder'),
						'label_width' => 0.5,
						'control_width' => 0.5,
						'std' => '',
						'hide_if' => array(
							'products_from' => array('sale','best_selling','top_rated','recent','featured','category','attribute')
						)
					),
					'orderby' => array(
						'type' => 'select',
						'label' => __('Order by:','profit-builder'),
						'label_width' => 0.5,
						'control_width' => 0.5,
						'std' => 'title',
						'options' => array(
							'title' => __('Title','profit-builder'),
							'date' => __('Date','profit-builder'),
							'name' => __('Name','profit-builder'),
							'rand' => __('Random','profit-builder')
						)
					),
					'order' => array(
						'type' => 'select',
						'label' => __('Order:','profit-builder'),
						'label_width' => 0.5,
						'control_width' => 0.5,
						'std' =>'asc',
						'options' => array(
							'asc' => 'Ascending',
							'desc' => 'Descending'
						)
					)
					/*,
					'image_format' => array(
						'type' => 'select',
						'label' => __('Image Format:','profit-builder'),
						'label_width' => 0.5,
						'control_width' => 0.5,
						'std' =>'1:1',
						'options' => array(
							'1:1.5' => __('Portrait','profit-builder'),
							'1:1' => __('Square','profit-builder'),
							'16:9' => __('Landscape','profit-builder')
						)
					),
					'item_align' => array(
						'type' => 'select',
						'label' => __('Item Align:','profit-builder'),
						'std' => 'center',
						'label_width' => 0.5,
						'control_width' => 0.5,
						'options' => array(
							'center' => 'Center',
							'left' => 'Left',
							'right' => 'Right'
						)
					),
					'padding' => array(
						'type' => 'number',
						'label' => __('Column padding:','profit-builder'),
						'label_width' => 0.5,
						'control_width' => 0.5,
						'min' => 1,
						'max' => 100,
						'unit' => 'px',
						'std' => 3
					)*/
				)
			)
/*,
			'group_text' => array(
				'type' => 'collapsible',
				'label' => __('Text','profit-builder'),
				'open' => 'true',
				'options' => array(
					'title_color' => array(
						'type' => 'color',
						'label' => __('Title:','profit-builder'),
						'std' => $opts['main_color'],
						'label_width' => 0.5,
						'control_width' => 0.5
					),
					'price_color' => array(
						'type' => 'color',
						'label' => __('Price:','profit-builder'),
						'std' => $opts['text_color'],
						'label_width' => 0.5,
						'control_width' => 0.5
					)
				)
			)*/
		),
		$classControl,
		array(
			'group_general' => array(
				'type' => 'collapsible',
				'label' => __('General','profit-builder'),
				'options' => array(
					'bot_margin' => array(
						'type' => 'number',
						'label' => __('Bottom margin:','profit-builder'),
						'std' => $opts['bottom_margin'],
						'unit' => 'px'
					)
				)
			)
		),
		$animationControl
		)
	)
);


/* -------------------------------------------------------------------------------- */
/* pbuilder_woo_ext_product_categories */
/* -------------------------------------------------------------------------------- */


$frbe_product_categories = array(

	'frbe_product_categories' => array(
		'type' => 'draggable',
		'text' => __('Product Categories','profit-builder'),
		'icon' => $this->url.'images/product-categories.png',
		'function' => 'frbe_product_categories',
		'group' => 'woo_extension',
		'options' => array_merge(
		 array(
			'group_basic' => array(
				'type' => 'collapsible',
				'label' => __('Basic','profit-builder'),
				'open' => 'true',
				'options' => array(
					'number_of_columns' => array(
						'type' => 'number',
						'label' => __('No. of columns:','profit-builder'),
						'label_width' => 0.5,
						'control_width' => 0.5,
						'min' => 1,
						'max' => 6,
						'unit' => '',
						'std' => 2
					),
					'number_of_cat' => array(
						'type' => 'number',
						'label' => __('No. of items:','profit-builder'),
						'label_width' => 0.5,
						'control_width' => 0.5,
						'min' => 1,
						'max' => 100,
						'unit' => '',
						'std' => 2,
						'hide_if' => array (
							'custom_categories' => array('true')
						)
					),
					'categories' => array(
						'type' => 'select',
						'label' => __('Categories:','profit-builder'),
						'multiselect' => 'true',
						'std' => $frbe_product_slider_default.'',
						'label_width' => 0.5,
						'control_width' => 0.5,
						'options' => $pbuilderCommerce -> productCategoriesQuery,
						'hide_if' => array (
							'custom_categories' => array('false')
						)
					),
					'category_order' => array(
						'type' => 'select',
						'label' => __('Order:','profit-builder'),
						'std' => 'ASC',
						'label_width' => 0.5,
						'control_width' => 0.5,
						'options' => array(
							'DESC' => 'Descending',
							'ASC' => 'Ascending'
						)
					),
					'order_by' => array(
						'type' => 'select',
						'label' => __('Order By:','profit-builder'),
						'std' => 'name',
						'label_width' => 0.5,
						'control_width' => 0.5,
						'options' => array(
							'name' => 'Name',
							'ID' => 'ID',
						)
					),
					'item_align' => array(
						'type' => 'select',
						'label' => __('Item Align:','profit-builder'),
						'std' => 'center',
						'label_width' => 0.5,
						'control_width' => 0.5,
						'options' => array(
							'center' => 'Center',
							'left' => 'Left',
							'right' => 'Right'
						)
					),
					'custom_categories' => array(
						'type' => 'checkbox',
						'half_column' => 'true',
						'std' => 'false',
						'label' => __('Custom items','profit-builder')
					),
					'hide_empty' => array(
						'type' => 'checkbox',
						'half_column' => 'true',
						'std' => 'true',
						'label' => __('Hide empty','profit-builder')
					),
					'only_main' => array(
						'type' => 'checkbox',
						'std' => 'false',
						'label' => __('Only main categories','profit-builder')
					)
				)
			)
		),
		$classControl,
		array(
			'group_general' => array(
				'type' => 'collapsible',
				'label' => __('General','profit-builder'),
				'options' => array(
					'bot_margin' => array(
						'type' => 'number',
						'label' => __('Bottom margin:','profit-builder'),
						'std' => $opts['bottom_margin'],
						'unit' => 'px'
					)
				)
			)
		),
		$animationControl
		)
	)
);






$pbuilder_shortcodes = array_merge($frbe_product_slider, $frbe_products_list, $frbe_product_grid, $frbe_product_categories);


$output = $pbuilder_shortcodes;
?>