<?php

global $leoinstalegalpg_settings;
$leoinstalegalpg_siteurl = get_site_url();
$leoinstalegalpg_adminemail = get_bloginfo('admin_email');

// General Settings section
$leoinstalegalpg_settings[] = array(
    'section_id' => 'instalegalpgeneral',
    'section_title' => 'General Settings',
    'section_description' => 'General settings, modify as your wish.',
    'section_order' => 5,
    'fields' => array(
        array(
            'id' => 'autodisplaypage',
            'title' => 'Auto Display Legal Pages on Footer',
            'desc' => 'Check this option to automatically display published legal pages on your site footer',
            'type' => 'checkbox',
            'std' => 0
        ),
        array(
            'id' => 'linkcolor',
            'title' => 'Link Color',
            'desc' => 'Modify the legal page link color on your site footer.',
            'type' => 'color',
            'std' => '#003399'
        )
    )
);


// Amazon Settings section
$leoinstalegalpg_settings[] = array(
    'section_id' => 'instaamzgeneral',
    'section_title' => 'Amazon Settings',
    'section_description' => 'Amazon settings, modify as your wish.',
    'section_order' => 5,
    'fields' => array(
        array(
            'id' => 'instaamzdsttstatus',
            'title' => 'Auto Display On Footer',
            'desc' => 'Check this option to automatically place Disclaimer Text on footer',
            'type' => 'checkbox',
            'std' => 0
        ),
        array(
            'id' => 'instalegalamzlocale',
            'title' => 'Amazon Programs',
            'desc' => 'Select Amazon programs to be displayed.',
            'type' => 'select',
            'std' => 'Amazon US',
            'choices' => array(
                'US' => 'Amazon US',
                'CA' => 'Amazon CA',
                'UK' => 'Amazon UK',
                'DE' => 'Amazon DE',
                'FR' => 'Amazon FR',
                'ES' => 'Amazon ES',
                'IT' => 'Amazon IT'
            )
        ),
        array(
            'id' => 'instalegaltxtfontsize',
            'title' => 'Select Font Size',
            'desc' => 'Select font size for the Disclaimer Text.',
            'type' => 'select',
            'std' => '11px',
            'choices' => array(
                '9px' => '9px',
                '11px' => '10px',
                '11px' => '11px',
                '12px' => '12px',
                '13px' => '13px'
            )
        ),
        array(
            'id' => 'instalegaltxtcolor',
            'title' => 'Text Color',
            'desc' => 'Modify the color of Disclaimer or Statement text on your website.',
            'type' => 'color',
            'std' => '#444'
        )
    )
);

// Language Settings section
$leoinstalegalpg_settings[] = array(
    'section_id' => 'instaamzlanguage',
    'section_title' => 'Amazon Language Settings',
    'section_description' => 'Here you can modify the default Disclaimer text according to your wish.',
    'section_order' => 9,
    'fields' => array(
        array(
            'id' => 'instalegalamzus',
            'title' => 'Amazon US',
            'desc' => 'Default Disclaimer text for Amazon.com',
            'type' => 'textarea',
            'std' => 'The owner of this website is a participant in the Amazon Services LLC Associates Program, an affiliate advertising program designed to provide a means for sites to earn advertising fees by advertising and linking to Amazon properties including, but not limited to, amazon.com, endless.com, myhabit.com, smallparts.com, or amazonwireless.com.'
        ),
        array(
            'id' => 'instalegalamzca',
            'title' => 'Amazon CA',
            'desc' => 'Default Disclaimer text for Amazon.ca',
            'type' => 'textarea',
            'std' => 'The owner of this website is a participant in the Amazon.com.ca, Inc. Associates Program, an affiliate advertising program designed to provide a means for sites to earn advertising fees by advertising and linking to Amazon.ca.'
        ),
        array(
            'id' => 'instalegalamzuk',
            'title' => 'Amazon UK',
            'desc' => 'Default Disclaimer text for Amazon.co.uk',
            'type' => 'textarea',
            'std' => 'The owner of this website is a participant in the Amazon EU Associates Programme, an affiliate advertising programme designed to provide a means for sites to earn advertising fees by advertising and linking to [insert applicable site name Amazon.co.uk, Javari.co.uk.'
        ),
        array(
            'id' => 'instalegalamzde',
            'title' => 'Amazon DE',
            'desc' => 'Default Disclaimer text for Amazon.de',
            'type' => 'textarea',
            'std' => $leoinstalegalpg_siteurl .' ist Teilnehmer des Partnerprogramms von Amazon EU, das zur Bereitstellung eines Mediums für Websites konzipiert wurde, mittels dessen durch die Platzierung von Werbeanzeigen und Links zu [bitte fügen Sie hier den zutreffenden Namen der Website ein Amazon.de, Javari.de, de.BuyVIP.com Werbekostenerstattung verdient werden kann.'
        ),
        array(
            'id' => 'instalegalamzfr',
            'title' => 'Amazon FR',
            'desc' => 'Default Disclaimer text for Amazon.fr',
            'type' => 'textarea',
            'std' => $leoinstalegalpg_siteurl .' participe au Programme Partenaires d’Amazon EU, un programme d’affiliation conçu pour permettre à des sites de percevoir une rémunération grâce à la création de liens vers Amazon.fr, Javari.fr.'
        ),
        array(
            'id' => 'instalegalamzit',
            'title' => 'Amazon IT',
            'desc' => 'Default Disclaimer text for Amazon.it',
            'type' => 'textarea',
            'std' => $leoinstalegalpg_siteurl .' partecipa al Programma Affiliazione Amazon EU, un programma di affiliazione che consente ai siti di percepire una commissione pubblicitaria pubblicizzando e fornendo link al sito Amazon.it, it.BuyVIP.com.'
        ),
        array(
            'id' => 'instalegalamzes',
            'title' => 'Amazon ES',
            'desc' => 'Default Disclaimer text for Amazon.es',
            'type' => 'textarea',
            'std' => $leoinstalegalpg_siteurl .' participa en el Programa de Afiliados de Amazon EU, un programa de publicidad para afiliados diseñado para ofrecer a sitios web un modo de obtener comisiones por publicidad, publicitando e incluyendo enlaces a Amazon.es, es.buyvip.com.'
        )
    )
);

// Support section
$leoinstalegalpg_settings[] = array(
    'section_id' => 'instalegalsupport',
    'section_title' => 'Support & Feedback',
    'section_description' => 'If you have any question or feedback for the plugin, please let us know.<br />Contact me via our Responsive Helpdesk <a href="http://wpthemeplugin.com/contact-us" target="_blank">http://wpthemeplugin.com/contact-us</a> :)',
    'section_order' => 13
);

?>