<?php

/**

 * The template for displaying product category thumbnails within loops.

 *

 * Override this template by copying it to yourtheme/woocommerce/content-product_cat.php

 *

 * @author 		WooThemes

 * @package 	WooCommerce/Templates

 * @version     1.6.4

 */



if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly



global $woocommerce_loop;



// Store loop count we're currently on

if ( empty( $woocommerce_loop['loop'] ) )

	$woocommerce_loop['loop'] = 0;



// Store column count for displaying the grid

if ( empty( $woocommerce_loop['columns'] ) )

	$woocommerce_loop['columns'] = apply_filters( 'loop_shop_columns', 4 );



// Increase loop count

$woocommerce_loop['loop']++;



// Extra post classes

$classes = array();

$classes[] = 'product-category product pbuilder_column pbuilder_column-1-'.$woocommerce_loop['columns'];

if ( 0 == ( $woocommerce_loop['loop'] - 1 ) % $woocommerce_loop['columns'] || 1 == $woocommerce_loop['columns'] )

	$classes[] = 'first';

if ( 0 == $woocommerce_loop['loop'] % $woocommerce_loop['columns'] )

	$classes[] = 'last';

?>

<li class="<?php echo implode($classes, ' '); ?>">



	<?php do_action( 'woocommerce_before_subcategory', $category ); ?>



	<a href="<?php echo get_term_link( $category->slug, 'product_cat' ); ?>">



		<?php

			/**

			 * woocommerce_before_subcategory_title hook

			 *

			 * @hooked woocommerce_subcategory_thumbnail - 10

			 */

			do_action( 'woocommerce_before_subcategory_title', $category );

		?>



		<h3 class="divwoo_cat">

			<?php

				if ( $category->count > 0 )

				echo apply_filters( 'woocommerce_subcategory_count_html', ' <mark class="divwoo_count"><span>' . $category->count . ' '.__('Items', 'pbtheme').'</span></mark>', $category );

			?>

			<?php echo $category->name; ?>

		</h3>



		<?php

			/**

			 * woocommerce_after_subcategory_title hook

			 */

			do_action( 'woocommerce_after_subcategory_title', $category );

		?>



	</a>



	<?php do_action( 'woocommerce_after_subcategory', $category ); ?>



</li>