<?php
/**
Plugin Name: Azon FlyBox
Plugin URI: http://www.pluginsbyigor.com/
Description: <strong>Get More Amazon Sales Without Looking Spammy and Scaring Visitors Away.</strong>
Author: Igor
Version: 1.2
Author URI: http://www.pluginsbyigor.com
*/

/*
Copyright (c) 2012, Rich Ways LLC
All rights reserved.

Azon FlyBox License
http://www.pluginsbyigor.com

1. Terms 

By using this software, you are agreeing to be bound by these Terms and Conditions of Use, all applicable laws and regulations, and agree that you are responsible for compliance with any applicable local laws. If you do not agree with any of these terms, you are prohibited from using this software. The materials contained in this software are protected by applicable copyright and trade mark law. 

2. Use License 

a. By using Azon FlyBox you agree and comply to Amazon.com Product Advertising API License Agreement found here: https://affiliate-program.amazon.com/gp/advertising/api/detail/agreement.html
b. You may use the Azon FlyBox software for the purposes of running a website on a number of domain names as allowed by your license. 
c. You may make a reasonable number of copies for backup purposes only. 
d. You may modify the Azon FlyBox software as per your requirements as long as the modifications would not circumvent the licensing system. 

3. Limitations 
a. You may not use Azon FlyBox on any domain not wholly owned by you. 
b. You may not distribute copies of the Azon FlyBox software or transfer any part of it to a 3rd party. 
c. You may not rent, lease, sell, or sub-license the Azon FlyBox software or copies of it.
d. You may not use the software to engage in any illegal activity. 
e. You may not circumvent the licensing system in any way. 

4. Disclaimer 

The materials on Azon FlyBox's website and the Azon FlyBox software are provided "as is". Azon FlyBox makes no warranties, expressed or implied, and hereby disclaims and negates all other warranties, including without limitation, implied warranties or conditions of merchantability, fitness for a particular purpose, or non-infringement of intellectual property or other violation of rights. Further, Azon FlyBox does not warrant or make any representations concerning the accuracy, likely results, or reliability of the use of the materials on its Internet web site or otherwise relating to such materials or on any sites linked to this site. 

5. Revisions and Errata 

The materials appearing on Azon FlyBox's web site could include technical, typographical, or photographic errors. Azon FlyBox does not warrant that any of the materials on its web site are accurate, complete, or current. Azon FlyBox may make changes to the materials contained on its web site at any time without notice. Azon FlyBox does not, however, make any commitment to update the materials. 

6. Links 

Azon FlyBox has not reviewed all of the sites linked to its Internet web site and is not responsible for the contents of any such linked site. The inclusion of any link does not imply endorsement by Azon FlyBox of the site. Use of any such linked web site is at the user's own risk. 

7. Site Terms of Use Modifications 

Azon FlyBox may revise these terms of use for its web site at any time without notice. By using this web site you are agreeing to be bound by the then current version of these Terms and Conditions of Use. 

8. Governing Law 

Any claim relating to Azon FlyBox's web site shall be governed by the laws of the State of Wisconsin (USA) without regard to its conflict of law provisions. 
*/

@set_include_path(get_include_path().';.:'.dirname(dirname(dirname(dirname(__FILE__)))));

$flybx_plugin_name = 'Azon FlyBox';
$flybx_plugin_slug = basename(dirname(__FILE__));

require_once(dirname(__FILE__).'/include/flybxfuncs.php');
require_once(dirname(__FILE__).'/include/flybx_amz_funcs.php');
require_once(dirname(__FILE__).'/include/admin_include.php');
require_once(dirname(__FILE__).'/add_ons.php');
require_once(dirname(__FILE__).'/include/flybx_lang.php');
define('flybx_MENU_PAGE', 'flybx-config');
$flybx_unique_template_id = 0;
$flybx_check_before_after = TRUE;
$flybx_sim_asins = array();
$flybx_search_parameters = array();

//pick up serp keywords
$flybx_glob_serpkw = flybx_pickup_serp_kws();

if ( !function_exists( 'get_plugins' ) )
		require_once( ABSPATH . 'wp-admin/includes/plugin.php' );
$flybx_current_plugin_version = flybx_current_version();

/* Runs when plugin is activated */
register_activation_hook(__FILE__,'flybx_install'); 

/* Runs on plugin deactivation*/
register_deactivation_hook( __FILE__, 'flybx_remove' );

$am_indexes = array('All', 'Apparel', 'Appliances', 'ArtsAndCrafts', 'Automotive', 'Baby', 'Beauty', 'Blended', 'Books', 'Classical', 'DigitalMusic', 'DVD', 'Electronics', 'GourmetFood', 'Grocery', 'HealthPersonalCare', 'HomeGarden', 'Industrial', 'Jewelry', 'KindleStore', 'Kitchen', 'Magazines', 'Miscellaneous', 'MobileApps', 'MP3Downloads', 'Music', 'MusicalInstruments', 'MusicTracks', 'OfficeProducts', 'OutdoorLiving', 'PCHardware', 'PetSupplies', 'Photo', 'Shoes', 'Software', 'SportingGoods', 'Tools', 'Toys', 'UnboxVideo', 'VHS', 'Video', 'VideoGames', 'Watches', 'Wireless', 'WirelessAccessories');
$flybx_active = get_option('flybx_active');

if ($flybx_active == 1)
{
	$flybx_post = $post;
	add_action('wp_enqueue_scripts', 'flybx_scripts');
	add_action('wp_footer', 'flybx_footer');	
}


add_action('init', 'flybx_localize');
function flybx_localize()
{
	load_plugin_textdomain(dirname(plugin_basename(__FILE__)), false, dirname(plugin_basename(__FILE__)) . '/lang/');
}

add_action( 'admin_print_styles', 'flybx_add_flybx_stylesheet' );
function flybx_add_flybx_stylesheet() {
	global $flybx_plugin_slug;
	wp_enqueue_script($flybx_plugin_slug.'_json', $flybx_json_js_url, array(), '1.0', true);
			
	wp_enqueue_script('jquery');
	
	wp_enqueue_style('jquery-style', 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.1/themes/smoothness/jquery-ui.css');
	wp_enqueue_script('jquery-ui-core');
	wp_enqueue_script('jquery-ui-datepicker', plugins_url( $flybx_plugin_slug.'/js/jquery.ui.datepicker.min.js' , dirname(__FILE__) ), array('jquery', 'jquery-ui-core'));
	wp_register_style( $flybx_plugin_slug, plugins_url( $flybx_plugin_slug.'/style.css' , dirname(__FILE__) ) );
	wp_enqueue_style( $flybx_plugin_slug );
	
	wp_enqueue_script($flybx_plugin_slug.'_raphael', plugins_url( $flybx_plugin_slug.'/js/raphael-min.js' , dirname(__FILE__) ), array('jquery'), '1.0', true);	
	wp_enqueue_script($flybx_plugin_slug.'_graphix', plugins_url( $flybx_plugin_slug.'/js/graphix.0.9.js' , dirname(__FILE__) ), array('jquery'), '1.0', true);
	
	//enqueue tiptip
	wp_enqueue_script('jquery-tiptip-flybx', plugins_url( $flybx_plugin_slug.'/js/jquery.tipTip.js' , dirname(__FILE__) ), array('jquery', 'jquery-ui-core'));
	wp_register_style( $flybx_plugin_slug.'_tiptip_css', plugins_url( $flybx_plugin_slug.'/css/tipTip.css' , dirname(__FILE__) ) );
	wp_enqueue_style( $flybx_plugin_slug.'_tiptip_css' );
	
	if (isset($_GET['page']) && $_GET['page'] == 'flybx-visitor-log')
	{
		//enqueue datepicker
		wp_enqueue_script('jquery-datepicker-flybx', plugins_url( $flybx_plugin_slug.'/js/datepicker.js' , dirname(__FILE__) ), array('jquery', 'jquery-ui-core'));
		wp_register_style( $flybx_plugin_slug.'_datepicker_base_css', plugins_url( $flybx_plugin_slug.'/css/datepicker/base.css' , dirname(__FILE__) ) );
		wp_enqueue_style( $flybx_plugin_slug.'_datepicker_base_css' );
		wp_register_style( $flybx_plugin_slug.'_datepicker_clean_css', plugins_url( $flybx_plugin_slug.'/css/datepicker/clean.css' , dirname(__FILE__) ) );
		wp_enqueue_style( $flybx_plugin_slug.'_datepicker_clean_css' );
	}
	
}

//add HTML selector link in admin bar
$flybx_domoutline = flybx_get_option('flybx_domoutline');
add_action('admin_bar_menu', 'flybx_add_toolbar_items', 900);
function flybx_add_toolbar_items($admin_bar){
	global $flybx_domoutline;
	if (function_exists('current_user_can') && current_user_can('manage_options'))
	{
		
		if ($flybx_domoutline == 'on')
		{
			$admin_bar->add_menu( array(
				'id'    => 'flybx-element-selector-link',
				'title' => 'HTML Inspector',
				'href'  => '#',	
				'meta'  => array(
					'title' => __('Azon FlyBox HTML element inspector tool')
				),
			));
		}
	}
}

function flybx_scripts()
{
	global $post, $flybx_post, $flybx_addons, $flybx_plugin_slug, $flybx_domoutline;
	$flybx_is_virtual = FALSE;
	if (isset($_GET['s']) && strlen($_GET['s']) > 0)
	{
		$flybx_is_virtual = TRUE;
	}
	if (((is_page() || is_single() || (!is_page() && !is_single()) || is_front_page()) && (isset($post) && is_numeric($post->ID))) || $flybx_is_virtual)
	{
		
		$flybx_post_id = 0;
		if (isset($post) && isset($post->ID))
		{
			$flybx_post_id = $post->ID;
		}
		//filter when to show pops		
			$flybx_post = $post;
			if (flybx_init_check($post) === true || $flybx_is_virtual):
			
				
				$flybx_http_url = plugins_url( $flybx_plugin_slug.'' , dirname(__FILE__) );				
				if (isset($_SERVER['HTTP_HOST']) && substr($_SERVER['HTTP_HOST'], 0, 4) == 'www.' && substr($flybx_http_url, 0, 11) != 'http://www.' && substr($flybx_http_url, 0, 12) != 'https://www.')
				{
					if (substr($flybx_http_url, 0, 7) == 'http://') $flybx_http_url = str_replace('http://', 'http://www.', $flybx_http_url);
					if (substr($flybx_http_url, 0, 8) == 'https://') $flybx_http_url = str_replace('https://', 'https://www.', $flybx_http_url);
				}
				elseif (isset($_SERVER['HTTP_HOST']) && substr($_SERVER['HTTP_HOST'], 0, 4) != 'www.' && (substr($flybx_http_url, 0, 11) == 'http://www.' || substr($flybx_http_url, 0, 12) == 'https://www.'))
				{
					if (substr($flybx_http_url, 0, 7) == 'http://') $flybx_http_url = str_replace('http://', 'http://www.', $flybx_http_url);
					if (substr($flybx_http_url, 0, 8) == 'https://') $flybx_http_url = str_replace('https://', 'https://www.', $flybx_http_url);
				}
				//add json support for jquery older than 1.4.1
				wp_enqueue_script($flybx_plugin_slug.'_json', $flybx_http_url.'/js/json2_min.js', array(), '1.0', true);
			
				wp_enqueue_script('jquery');
				wp_enqueue_style( $flybx_plugin_slug, plugins_url( $flybx_plugin_slug.'/style.css' , dirname(__FILE__) ), false, '1.1');
				
				$userAgent = strtolower($_SERVER['HTTP_USER_AGENT']);
					if (preg_match('/msie/', $userAgent))
					{
						wp_enqueue_style( $flybx_plugin_slug.'_css_ie', plugins_url( $flybx_plugin_slug.'/style_ie.css' , dirname(__FILE__) ), false, '1.1');
					}
				
				//fix calls from www. to non-www etc			

				//wp_enqueue_script($flybx_plugin_slug.'_easing', $flybx_http_url.'/js/jquery.easing.1.3.js', array('jquery'), '1.0', true);				
				//wp_enqueue_script($flybx_plugin_slug.'_transform', $flybx_http_url.'/js/jquery.transform-0.8.0.min.js', array('jquery'), '1.0', true);				
				//wp_enqueue_script($flybx_plugin_slug.'_template', $flybx_http_url.'/js/jquery.template.js', array('jquery'), '1.0', true);
				
				//wp_enqueue_script($flybx_plugin_slug.'_template_loader', $flybx_http_url.'/template_loader.php', array('jquery'), '1.0', true);
				wp_enqueue_script($flybx_plugin_slug.'_flybx_loader', $flybx_http_url.'/flybx_loader.js', array('jquery'), '1.0', true);
				
				if (function_exists('current_user_can') && current_user_can('manage_options'))
				{
					$flybx_domoutline = flybx_get_option('flybx_domoutline');
					if ($flybx_domoutline == 'on')
					{
						wp_enqueue_script($flybx_plugin_slug.'_flybx_admin_loader', $flybx_http_url.'/flybx_admin_loader.js', array('jquery'), '1.0', true);
						wp_enqueue_script($flybx_plugin_slug.'_flybx_domoutline', $flybx_http_url.'/js/jquery.dom-outline-1.0.js', array('jquery'), '1.0', true);
					}
				}

				//wp_enqueue_style( $flybx_plugin_slug.'_templates', plugins_url( $flybx_plugin_slug.'/css/style.css' , dirname(__FILE__) ), false, '1.1');	

				require_once(dirname(__FILE__).'/app/models/templates.php');
				$flybx_tpl = new flybx_templates;
				$flybx_tplsett = $flybx_tpl->templates_data();
								
				$flybx_get_params = array(
				  'flybx_is_virtual' => 'no',
				  'ajaxurl' => flybx_get_ajax_url(),
				  'animation' => $flybx_tplsett['animation'],
				  'position' => $flybx_tplsett['position'],
				  'btm' => $flybx_tplsett['bottom_margin'],				  
				  'el_tgl' => $flybx_tplsett['trigger_element_toggle'],				  
				  'stats' => (flybx_is_plus() === TRUE?'yes':'no'),				  
				);
				$flybx_get_params['offset_type'] = 'perc';
				$flybx_get_params['offset'] = '0';

				//figure out triggering
				if (strlen($flybx_tplsett['offset']) > 0 && substr($flybx_tplsett['offset'], -1) == '%')
				{
					$flybx_get_params['offset_type'] = 'perc';
					$flybx_get_params['offset'] = trim(str_replace('%', '', $flybx_tplsett['offset'])) / 100;
				}
				elseif(strlen($flybx_tplsett['offset']) > 0 && substr($flybx_tplsett['offset'], -2) == 'px')
				{
					$flybx_get_params['offset_type'] = 'px';
					$flybx_get_params['offset'] = trim(str_replace('px', '', $flybx_tplsett['offset']));
				}
				if ($flybx_tplsett['trigger_element_toggle'] == 'on')
				{
					$flybx_get_params['offset_el'] = $flybx_tplsett['trigger_element'];
				}
				
				
				if ($flybx_is_virtual)
				{
					$flybx_get_params['flybx_is_virtual'] = 'yes';
					$flybx_get_params['s'] = urlencode(strip_tags($_GET['s']));
					//come up with unique id
					list($flybx_custom_post_id, ) = explode('E', round(hexdec(md5($flybx_get_params['s']))/1000000000000000000000000));
					$flybx_custom_post_id = str_replace('.', '', $flybx_custom_post_id);
					$flybx_custom_post_id = abs($flybx_custom_post_id);
					$flybx_get_params['post_id'] = '99999'.substr($flybx_custom_post_id, 0, 5);
					
				}
				$flybx_get_params = apply_filters('flybx_params', $flybx_get_params, $post->ID);
				if ($flybx_get_params['animation'] == 'rollin')
				{
					//wp_enqueue_script($flybx_plugin_slug.'_flybx_rotate', $flybx_http_url.'/js/jquery.flybx_rotate.js', array('jquery'), '1.0', true);
					wp_enqueue_script('jquery-css-transform', $flybx_http_url.'/js/jquery.css-transform.js', array('jquery'), '1.0', true);
					wp_enqueue_script('jquery-animate-css-rotate-scale', $flybx_http_url.'/js/jquery-animate-css-rotate-scale.js', array('jquery'), '1.0', true);
				}
				wp_localize_script( $flybx_plugin_slug.'_flybx_loader', 'flybx_params', $flybx_get_params );
				
			endif;
	}
}
function flybx_footer() {
	global $post, $flybx_plugin_slug;
	$flybx_is_virtual = FALSE;
	if (isset($_GET['s']) && strlen($_GET['s']) > 0)
	{
		$flybx_is_virtual = TRUE;
	}

	if (((is_page() || is_single() || is_front_page()) && (isset($post) && is_numeric($post->ID)) /*&& flybx_init_check($post)*/) || $flybx_is_virtual)
	{
		?>
		<div id="flybx_box" style="display: none;">
			<div id="flybx_interior">
				<?php //_e('Thank you for visiting our site.', $flybx_plugin_slug); ?>
						
			</div>	
			<button type="button" id="flybx_box_close">Close</button>
		</div>
		<?php
		require_once(dirname(__FILE__).'/app/models/templates.php');
		$flybx_tpl = new flybx_templates;
		$flybx_tplsett = $flybx_tpl->templates_data();
		?>
		<style>
		a.flybx_prod_desclink, a.flybx_prod_desclink:active, a.flybx_prod_desclink:visited, a.flybx_prod_desclink:hover, a#flybx_timestamp_msg, a#flybx_timestamp_msg:active, a#flybx_timestamp_msg:visited, a#flybx_timestamp_msg:hover {color: <?php echo $flybx_tplsett['descr_color']; ?>!important;}
		a.flybx_prod_ttllink, a.flybx_prod_ttllink:active, a.flybx_prod_ttllink:visited, a.flybx_prod_ttllink:hover, .flybx_readmore {color: <?php echo $flybx_tplsett['links_color']; ?>!important;}
		.flybx_pricewrap a, .flybx_pricewrap a:active, .flybx_pricewrap a:visited, .flybx_pricewrap a:hover {color: <?php echo $flybx_tplsett['price_color']; ?>!important;}
		#flybx_box {background-color: <?php echo $flybx_tplsett['bg_color']; ?>!important;}
		<?php if ($flybx_tplsett['branding'] == 'yes'): ?>
			.flybx_poweredby a, .flybx_poweredby a:active, .flybx_poweredby a:visited, .flybx_poweredby a:hover {color: <?php echo $flybx_tplsett['links_color']; ?>!important;}
			.flybx_poweredby {color: <?php echo $flybx_tplsett['descr_color']; ?>!important;}
		<?php endif; ?>
		<?php if ('uk' == flybx_get_locale()): ?>
		.flybx_pricewrap {font-size: 12px!important;}
		<?php endif; ?>
		</style>
		<?php
		
		//fix to make flybox work in WP Amazillionaire theme
		if (is_front_page() && get_option('current_theme') == 'WP Amazillionaire')
		{
			//if ($flybx_check_before_after)
			//{
				require_once(dirname(__FILE__).'/app/models/templates.php');
				$templates = new flybx_templates;
				$templates_data = $templates->templates_data();
				
				$before_content = '';
				$after_content = '';		

				if ($templates_data !== FALSE && is_array($templates_data))
				{
					$before_content .= $templates->template_html_init($templates_data, $post->ID, $content);
					echo $before_content;
				}
			//}
		}
	}
}

function flybx_init_check($post = '')
{
	if ($post != '')
	{
		//filter when to show pops
		$flybx_active = get_option('flybx_active');
		//$flybx_serponly = get_option('flybx_serponly');
		//$flybx_loggedin_hide = get_option('flybx_loggedin_hide');
		//$flybx_posttypes_str = get_option('flybx_posttypes');
		//$flybx_posttypes = explode(',', $flybx_posttypes_str);
		//$flybx_pops_per_user = get_option('flybx_pops_per_user');
		//$flybx_default_behavior = get_option('flybx_default_behavior');
		//$flybx_unbounce_enabled = get_option('flybx_unbounce_enabled');
		//$flybx_unbounce_delay = get_option('flybx_unbounce_delay');
		//$flybx_active_tpls = flybx_active_tpls();
			
		if ( $flybx_active == 1 && 
			flybx_get_option('license') != false //&& 
			//($flybx_serponly == false || ($flybx_serponly == 1 && flybx_is_serp_direct())) && 				 //show to users arrived from serp only?
			//($flybx_loggedin_hide == false || ($flybx_loggedin_hide == 1 && !is_user_logged_in()) || current_user_can( 'manage_options' )) && //don't show to logged in users? doesn't affect admin
			//(((is_page() || is_single()) && in_array($post->post_type, $flybx_posttypes)) || (!is_page() && !is_single() && in_array('category_pages', $flybx_posttypes))) && 											 //filter by post type
			//($flybx_pops_per_user == false || (($flybx_pops_per_user > 0 && (!isset($_COOKIE['flybx_total_pops']) || (isset($_COOKIE['flybx_total_pops']) && $_COOKIE['flybx_total_pops'] < $flybx_pops_per_user))) || current_user_can( 'manage_options' ))) && //limit pops per user, no affect on admin
			//count($flybx_active_tpls) > 0				//hide if no active template found
			):
			
			//now check if this belongs on this particular post
			//$meta_enable = get_post_meta($post->ID, 'flybx_enable', true);
			//$meta_disable = get_post_meta($post->ID, 'flybx_disable', true);
			
			//if (($flybx_default_behavior == 'all' && $meta_disable != 'on') || ($flybx_default_behavior == 'manual' && $meta_enable == 'on')):
				//pick up serp keywords
				//flybx_pickup_serp_kws();
				return true;
			//endif;
		endif;		
	}
	return false;
}

if ( flybx_license_type() === FALSE && is_admin()&& !(isset($_GET['page']) && $_GET['page'] == 'flybx-license')) {
	function flybx_warning() {
		global $flybx_plugin_name, $flybx_plugin_slug;
		echo "
		<div id='flybx-warning' class='updated fade'><p><strong>"
		.sprintf(__('The %s plugin is not active yet.', $flybx_plugin_slug), $swzon361_plugin_name)."</strong> "
		.sprintf(
			__('You\'ll need to <a href="%1$s">Activate %2$s license</a> for it to work.', $flybx_plugin_slug)
			, "admin.php?page=flybx-license", $flybx_plugin_name)
		."</p></div>
		";
	}
	add_action('admin_notices', 'flybx_warning');
	//return;
}

function flybx_install()
{
    global $wpdb;
	
	//add plugin options
	flybx_add_options();
	
	if (is_multisite())
	{
		flybx_multisite_setup_tbl();
	}
}

function flybx_add_options()
{
	global $wpdb;
    // plugin options
    add_option("flybx_active", '1', '', 'yes');
    add_option("flybx_activated", '', '', 'yes');
	add_option("flybx_am_key_id", '', '', 'yes');
    add_option("flybx_am_access_key", '', '', 'yes');
    add_option("flybx_am_associate_tag", '', '', 'yes');
    add_option("flybx_am_searchindex", '', '', 'yes');
    add_option("flybx_skip_noimage", '1', '', 'yes');
    //add_option("flybx_serponly", '0', '', 'yes');    
    add_option("flybx_loggedin_hide", '1', '', 'yes');
	add_option("flybx_sensitivity", '10', '', 'yes');
    add_option("flybx_posttypes", 'post,page', '', 'yes');
    add_option("flybx_pops_per_user", '10000', '', 'yes');
    add_option("flybx_default_behavior", 'all', '', 'yes');
    //add_option("flybx_message", 'Wait! Check Out These Products.', '', 'yes');
    //add_option("flybx_message_fontsize", '24', '', 'yes');
    //add_option("flybx_message_color", '#FF0000', '', 'yes');
    //add_option("flybx_pop_width", '700', '', 'yes');
    //add_option("flybx_pop_height", '400', '', 'yes');
    //add_option("flybx_border_width", '5', '', 'yes');
    //add_option("flybx_border_type", 'dashed', '', 'yes');
    //add_option("flybx_border_color", '#FF0000', '', 'yes');
    //add_option("flybx_branding", 'yes', '', 'yes');
    add_option("flybx_unbounce_enabled", '1', '', 'yes');
    add_option("flybx_unbounce_delay", '10', '', 'yes');

}

$flybx_current_version_from_db = get_option('flybx_version');
if ($flybx_current_version_from_db === FALSE || version_compare($flybx_current_version_from_db, $flybx_current_plugin_version, '<'))
{	
	/*if ($flybx_curr_db_version < 2 && flybx_get_option('license') != false)
	{
		//upgrade db version
		$wpdb->query("DROP TABLE `".$wpdb->prefix."flybx_cache`");
		$wpdb->query("CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."flybx_cache` (
		  `cid` int(11) NOT NULL AUTO_INCREMENT,
		  `locale` int(1) NOT NULL DEFAULT '1' COMMENT '1 - us, 2 - uk, 3 - de, 4 - jp, 5 -fr, 6 - ca, 7 - it, 8 - cn, 9 -es',
		  `post_id` int(11) NOT NULL,
		  `content` text NOT NULL,
		  `timestamp` int(15) NOT NULL,
		  PRIMARY KEY (`cid`),
		  KEY `flybx_postid_index` (`post_id`),
		  KEY `flybx_timestamp_index` (`timestamp`)
		) DEFAULT CHARACTER SET ".$wpdb->charset." AUTO_INCREMENT=1 ;");
	}*/
	
	
	
	$current_flybx_kw_sources = flybx_get_option('flybx_kw_sources');
	if ($current_flybx_kw_sources === FALSE)
	{
		flybx_add_option('flybx_kw_sources', 'serp,content,title,fallback');
	}

	add_action('init', 'flybx_upgrade_db_etc');	
}

add_action('admin_init', 'flybx_upgrade_plugin');

function flybx_upgrade_plugin()
{
	global $flybx_current_plugin_version, $flybx_current_version_from_db, $wpdb;
	//if upgrade or first time run do these:
	$flybx_curr_db_version = get_option('flybx_db_version');
	
	update_option("flybx_version", '1.0', '', 'yes');
	update_option("flybx_db_version", '1', '', 'yes');	
}

function flybx_upgrade_db_etc()
{
	global $flybx_current_plugin_version, $flybx_current_version_from_db;
	if (is_multisite())
	{
		flybx_multisite_setup_tbl();
	}
	
	//update_option('flybx_version', $flybx_current_plugin_version);
	flybx_update_option('flybx_promo_msg', '', is_multisite());
	flybx_update_option('flybx_promo_msg_last_check', '0', is_multisite());
}

function flybx_remove() {

    /*delete_option("flybx_active");
    delete_option("flybx_serponly");
	delete_option("flybx_am_key_id");
	delete_option("flybx_am_access_key");
	delete_option("flybx_am_associate_tag");
	delete_option("flybx_am_searchindex");
	delete_option("flybx_am_time");
	delete_option("flybx_sequence");
	delete_option("flybx_posttypes");
	delete_option("flybx_loggedin_hide");*/
}


function flybx_init() {
	if ( current_user_can('administrator') ) {
		add_action('admin_menu', 'flybx_config_page');
	}
}
add_action('init', 'flybx_init');
//add_action('admin_menu', 'flybx_config_page');

//include farbtastic js and css
add_action('init', 'flybx_ilc_farbtastic_script');
function flybx_ilc_farbtastic_script() {
  wp_enqueue_style( 'farbtastic' );
  wp_enqueue_script( 'farbtastic' );
}

function flybx_config_page() {
	global $flybx_addons, $flybx_plugin_name, $flybx_plugin_slug;
	 add_menu_page('Azon FlyBox', 'Azon FlyBox', 8, 'flybx-config', 'flybx_conf', plugin_dir_url( __FILE__ ).'/images/ico_azonflybox2.png');
	 add_submenu_page('flybx-config', __('Settings', $flybx_plugin_slug), __('Settings', $flybx_plugin_slug), 8, 'flybx-config', 'flybx_conf');
	 //add_submenu_page('flybx-config', __('Templates', $flybx_plugin_slug), __('Templates', $flybx_plugin_slug), 8, 'flybx-templates', 'flybx_templates');
	 //add_submenu_page('flybx-config', __('Stats', $flybx_plugin_slug), __('Stats', $flybx_plugin_slug), 8, 'flybx-stats', 'flybx_stats');
	 if (flybx_is_plus()) add_submenu_page('flybx-config', __('Visitor Log', $flybx_plugin_slug), __('Visitor Log', $flybx_plugin_slug), 8, 'flybx-visitor-log', 'flybx_visitor_log');
	
	 add_submenu_page('flybx-config', __('License', $flybx_plugin_slug), __('License', $flybx_plugin_slug), 8, 'flybx-license', 'flybx_license');
	 add_submenu_page('flybx-config', __('Clear Cache', $flybx_plugin_slug), __('Clear Cache', $flybx_plugin_slug), 8, 'flybx-clearcache', 'flybx_clearcache');
	 
	/*if (flybx_get_option('license') == 'premium')
	{
		add_submenu_page('flybx-config', __('Get More Plugins', $flybx_plugin_slug), __('Get More Plugins', $flybx_plugin_slug), 8, 'flybx-more-plugins', 'flybx_more_plugins');
		//add_submenu_page('flybx-config', __('Upgrade', $flybx_plugin_slug), __('<span style="color: red; font-weight: bold;">Upgrade</span>', $flybx_plugin_slug), 8, 'flybx-addons', 'flybx_addons');
	}
	else*/
	if (flybx_is_plus() === FALSE)
	{
		add_submenu_page('flybx-config', __('Get More Plugins', $flybx_plugin_slug), __('Get More Plugins', $flybx_plugin_slug), 8, 'flybx-more-plugins', 'flybx_more_plugins');
		add_submenu_page('flybx-config', __('Upgrade', $flybx_plugin_slug), __('<span style="color: red; font-weight: bold;">Upgrade to Plus+</span>', $flybx_plugin_slug), 8, 'flybx-addons', 'flybx_addons');
	}
	else
	{
		add_submenu_page('flybx-config', __('Get More Plugins', $flybx_plugin_slug), __('<span style="color: red; font-weight: bold;">Get More Plugins</span>', $flybx_plugin_slug), 8, 'flybx-more-plugins', 'flybx_more_plugins');
	}
	add_submenu_page('flybx-config', __('Support', $flybx_plugin_slug), __('Support', $flybx_plugin_slug), 8, 'flybx-help', 'flybx_help');
}

//add add-ons
if (is_array($flybx_addons) && count($flybx_addons) > 0)
{
	foreach($flybx_addons as $flybx_addon)
	{
		include_once(dirname(__FILE__).'/modules/'.$flybx_addon.'/functions.php');
		if (function_exists('flybx_'.$flybx_addon.'_init'))
		{
			add_action('init', 'flybx_'.$flybx_addon.'_init');
		}
	}
}

function flybx_clearcache()
{
	global $wpdb, $flybx_plugin_name, $flybx_plugin_slug;
	if ( function_exists('current_user_can') && !current_user_can('manage_options') )
			die(__('Cheatin&#8217; uh?', $flybx_plugin_slug));
	
	if (isset($_POST['flybx_clear_cache']) && $_POST['flybx_clear_cache'] == 'yes')
	{
		flybx_clear_cache();
		if (isset($_POST['clear_keywords']) && $_POST['clear_keywords'] == '1')
		{
			flybx_delete_keywords();
		}
	}
	?>
	<div class="wrap">
		<img src="<?php echo plugin_dir_url( __FILE__ ); ?>images/<?php echo flybx_branding_img(); ?>" style="display: block; float: right;" />
		<h2>Clear Cache</h2>
		<?php echo sprintf(__('%s caches data returned from Amazon API for up to one hour to boost performance.<br />When you change settings like adding new locale associate tag it is advised to clear cache.', $flybx_plugin_slug), $flybx_plugin_name); ?>
		<p></p>
		<?php if (isset($_POST['flybx_clear_cache']) && $_POST['flybx_clear_cache'] == 'yes'): ?>
		<div class="updated">
			<h3><?php echo sprintf(__('%s Cache Cleared', $flybx_plugin_slug), $flybx_plugin_name); ?></h3>
		</div>
		<?php endif; ?>
		
		<form action="" method="post">
			<input type="checkbox" name="clear_keywords" value="1" id="delete_keywords" /><label style="margin-left: 10px;" for="delete_keywords"><?php _e('Delete keywords', $flybx_plugin_slug); ?> (<?php _e('optional', $flybx_plugin_slug); ?>)</label>
			<div class="submit"><input type="submit" value="<?php echo sprintf(__("Clear %s Cache", $flybx_plugin_slug), $flybx_plugin_name); ?>" /></div>
			<input type="hidden" name="flybx_clear_cache" value="yes" />
		</form>
	</div>
	<?php
}

function flybx_help()
{
	global $wpdb, $flybx_plugin_name, $flybx_plugin_slug;
	
	if ( function_exists('current_user_can') && !current_user_can('manage_options') )
			die(__('Cheatin&#8217; uh?', $flybx_plugin_slug));
	?>
	<div class="wrap">
		<h2><?php _e("Help and Support", $flybx_plugin_slug); ?></h2>
		<p><?php echo sprintf(__("Having trouble with %s?", $flybx_plugin_slug), $flybx_plugin_name); ?></p>		
		<p>I feel your pain. It sucks when plugins break. However...</p>
		<p style="font-size: 16px;">You're in luck! Creator of <?php echo $flybx_plugin_name; ?> provides excellent support!</p>

		<p>Please keep in mind:
			<ol>
				<li>In 99% of the cases if there's an issue with <?php echo $flybx_plugin_name; ?> it is caused by an issue with another plugin or a theme.</li>
				<li>Your question may be already answered on the <a href="http://www.pluginsbyigor.com/azon-flybox-faq/" target="_blank">FAQ page</a> ==&gt; <a href="http://www.pluginsbyigor.com/azon-flybox-faq/" target="_blank">Click Here to go to FAQ page</a></li>
				<li>Check out <a href="http://www.pluginsbyigor.com/azon-flybox-videos/" target="_blank">Video Tutorials</a>! You can learn a lot of advanced techniques from these tutorials  ==&gt;  <a href="http://www.pluginsbyigor.com/azon-flybox-videos/" target="_blank">Click Here to Watch Video Tutorials</a> </li>
			</ol>
		</p>

		<p>Still need help?</p>
		<p><a href="http://www.pluginsbyigor.com/support/" target="_blank">Click Here to Contact Me</a> and I'll get back to you as soon as possible.</p>
		
	</div>

	<?php
}

if (isset($_GET['page']) && $_GET['page'] == 'flybx-addons')
{
	add_action('admin_head', 'flybx_addons_check_javascript');
}

function flybx_addons()
{
	global $wpdb, $flybx_plugin_name, $flybx_plugin_slug;
	
	if ( function_exists('current_user_can') && !current_user_can('manage_options') )
			die(__('Cheatin&#8217; uh?', $flybx_plugin_slug));
	
	$curr_email = flybx_get_option('license_email');
	
	?>
	<div class="wrap">
		<h2><?php sprintf(__("%s Add-ons", $flybx_plugin_slug), $flybx_plugin_name); ?></h2>
		<p><?php sprintf(__("%s is growing fast! New functionality and new ways to earn money are added all the time!", $flybx_plugin_slug), $flybx_plugin_name); ?></p>
		
		<div id="flybx_addons_receiving_wrap" class="flybx_loading">&nbsp;</div>

	</div>
	<style>
	.flybx_loading {
	width: 128px; 
	height: 15px; 
	margin: 250px auto; 
	display: block;
	background: url(<?=site_url('wp-content/plugins/'.$flybx_plugin_slug.'/images/ajax-loader_bar.gif');?>) no-repeat center center;
	}
	</style>
	<?php
}

function flybx_license()
{
	global $wpdb, $flybx_plugin_name, $flybx_plugin_slug;
	if ( function_exists('current_user_can') && !current_user_can('manage_options') )
			die(__('Cheatin&#8217; uh?', $flybx_plugin_slug));
	
	$user = wp_get_current_user();
	$email = $user->user_email;
	$curr_email = flybx_get_option('license_email');
	if ($curr_email != false)
	{
		$email = $curr_email;
	}
	$name = $user->user_nicename;
	$error = '';
	if ( isset($_POST['btnsubmit']) ) 
	{
		$emailRE = '/^[a-zA-Z0-9_\-\.]+@[a-zA-Z0-9_\-]+\.[a-zA-Z0-9_\-\.]+$/i';
		if (isset($_POST['name']))  $name  = trim(strip_tags(($_POST['name'])));
		if (isset($_POST['email'])) $email = trim(strip_tags(($_POST['email'])));
		if ('' == $name)  $error .= '<div>'.__("Please enter your Name", $flybx_plugin_slug).'</div>';
		if ('' == $email) $error .= '<div>'.__("Please enter your Email", $flybx_plugin_slug).'</div>';
		if ( ! preg_match($emailRE, $email) ) $error .= '<div>'.__("Please enter correct Email address", $flybx_plugin_slug).'</div>';
		if ('' == $error) {
			//send license request
			$call_data = array(
								'email' => $email,
								'name' => $name,
								'site' => get_bloginfo('url')
								);
			$response = flybx_call($call_data, 'http://192.232.235.92/flybx/activate/site');

			//update db
			if (isset($response->sql) && strlen(trim($response->sql)) > 0)
			{
				$sql_str = str_replace('##TBLPREFIX##', $wpdb->prefix, $response->sql);
				$charset_collate = '';
				if (strlen($wpdb->charset) > 0)	$charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";
				$sql_str = str_replace('##TBLCHARSET##', $charset_collate, $sql_str);
				
				foreach(explode("##BREAK##", $sql_str) as $curr_sql)
				{					
					$wpdb->query($curr_sql);
				}
			}
			//flybx_add_options();
			echo '<div class="updated">';
			
			echo '<strong>'.ucfirst($response->response).'</strong><br />';
			echo '<strong>'.ucfirst($response->message).'</strong><br />';
			
			echo '</div>';
			
		}
	}
	
	$licensed_email = flybx_get_option('license_email');
	$licensed_name = flybx_get_option('license_name');
	$licensed_license = flybx_get_option('license');
	if ($licensed_name != false) $name = $licensed_name;

	echo '<div class="wrap"><h2>' . sprintf(__('%s License', $flybx_plugin_slug), $flybx_plugin_name) . '</h2>';
	?>
	<div class="flybx_license_wrap">
		<h3><?php echo sprintf(__('%s License', $flybx_plugin_slug), $flybx_plugin_name);?></h3>
		<div style="color: red;"><?=$error;?></div>
		<?php if ($licensed_email != false && $licensed_license != false): ?>
		<?php
		$license_real_name = 'Single Domain';
		if ($licensed_license == 'premium_unlimited' && flybx_module_installed('amzn_cart') && flybx_module_installed('epn') && flybx_module_installed('amasticky_template'))
		{
			$license_real_name = 'Multi-Site Plus+';
		}
		elseif ($licensed_license == 'premium_unlimited')
		{
			$license_real_name = 'Multi-Site';
		}
		?>
		<div style="font-weight: bold;"><?php echo sprintf(__('You are using %s under %s license.', $flybx_plugin_slug), $flybx_plugin_name, $license_real_name);?>
		</div>
		<?php endif; ?>
		<form method="post" action="admin.php?page=flybx-license" onsubmit="return checkLicenseForm(this);">
			<table class="form-table" style="width: 750px;">
			<tr class="form-field"><th style="width:120px;"><label for="ar_name" style="font-weight: bold;"><?php _e('Your Name', $flybx_plugin_slug); ?>:</label></th>
				<td><input type="text" name="name" value="<?=$name;?>" id="ar_name" size="25" style="width:220px;" /></td></tr>
			<tr class="form-field"><th style="width:120px;"><label for="ar_email" style="font-weight: bold;"><?php _e('Email', $flybx_plugin_slug); ?>:</label></th>
				<td><input type="text" name="email" value="<?=$email;?>" id="ar_email" size="25" style="width:220px;" /> &lt;&lt; <strong><?php _e('Email used to purchase license or Paypal Email', $flybx_plugin_slug); ?></strong></td></tr>
			<tr class="form-field"><th style="width:120px;">&nbsp;</th>
				<td style="line-height: 14px;"><input type="checkbox" id="flybx_agree_to_license" name="flybx_agree_to_license" style="float: left; width: 15px; margin-right: 10px;" /> <label for="flybx_agree_to_license" ><?php echo sprintf(__('I agree to %s License Agreement %s', $flybx_plugin_slug), '<a href="http://www.pluginsbyigor.com/launch/azonflybox-license-agreement/" target="_blank">', '</a>'); ?></label> </td></tr>
			<tr><td>&nbsp;</td><td class="submit"><input type="submit" name="btnsubmit" value="<?php esc_attr_e('Activate', $flybx_plugin_slug); ?>" class="button-primary" /></td></tr>
			</table>
		</form>
		<br /><br />		
		- <?php echo sprintf(__('If you used paypal enter the exact Paypal email you have used to purchase your copy of %s.', $flybx_plugin_slug), $flybx_plugin_name); ?><br />
		- <?php _e('If you used clickbank then use the email you entered on the order form.', $flybx_plugin_slug); ?><br />
		- <?php _e('Please note that some Paypal accounts can have several emails associated with them. If this is the case for you try all emails!', $flybx_plugin_slug); ?><br />
		- <?php echo sprintf(__('Do not tell other people your Paypal email or purchase email in order to use it with %s because it will get your license suspended!', $flybx_plugin_slug), $flybx_plugin_name); ?><br />
		- <?php _e('You will need to be able to access the email to get plugin updates or support.', $flybx_plugin_slug); ?><br />
		<br />
	</div>
	<div style="font-weight: bold; margin-top: 30px;">
	<?php if ($flybx_plugin_slug == 'advancedtemplateads'): ?>
		<?php _e('Follow Us on Twitter', $flybx_plugin_slug); ?> <a href="http://twitter.com/advancedtemplateads" target="_blank">@advancedtemplateads</a> <?php _e('and check us out on Facebook', $flybx_plugin_slug); ?>: <a href="http://facebook.com/AdvancedTemplateAds" target="_blank">http://facebook.com/AdvancedTemplateAds</a>
	<?php endif; ?>
	</div>
	
	<style>
	.flybx_license_wrap {
	margin: 5px 0 15px;
	background-color: #FFFFE0;
    border-color: #E6DB55;
	padding: 0 0.6em;
	border-radius: 3px 3px 3px 3px;
    border-style: solid;
    border-width: 1px;
	}
	.flybx_license_wrap a {text-decoration: none;}
	</style>
	
	<script type="text/javascript">
	<!--//
	function checkLicenseForm(theForm) {
		var error = '';
		if (theForm) {
			if (theForm['name']  && '' == theForm['name'].value)  error = '<?php esc_attr_e('Please enter your Name', $flybx_plugin_slug); ?>';
			if (theForm['email'] && '' == theForm['email'].value) error = '<?php esc_attr_e('Please enter your Email', $flybx_plugin_slug); ?>';
			if (jQuery('#flybx_agree_to_license').is(':checked'))
			{
			
			}
			else
			{
				error = '<?php esc_attr_e('Please agree to License Agreement', $flybx_plugin_slug); ?>';
			}
		}
		if ('' != error) {
			alert (error);
			return false;
		}
		return true;
	}
	//-->
	</script>
	<?php
	echo '</div>';
}

function flybx_license_type()
{
	global $wpdb;
	$res = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."flybx_options WHERE name = 'license' AND value != '' LIMIT 1");
	if ($res === NULL )
	{
		return FALSE;
	}
	else
	{
		return $res->value;
	}
}

function flybx_conf() {
	global $am_indexes, $blog_id, $wpdb, $flybx_addons, $flybx_plugin_name, $flybx_plugin_slug, $flybx_lang_keys, $flybx_lang;
	
	if ( function_exists('current_user_can') && !current_user_can('manage_options') )
			die(__('Cheatin&#8217; uh?', $flybx_plugin_slug));
	
	if (flybx_license_type() === FALSE)
	{
		flybx_license();
		return;
	}
	
	wp_enqueue_style( $flybx_plugin_slug, plugins_url( $flybx_plugin_slug.'/style.css' , dirname(__FILE__) ), false, '1.1');
	
	//which tab?
	$tab = 'important_stuff';
	if (isset($_GET['tab']) && (in_array($_GET['tab'], array('important_stuff', 'amazon', 'appearance', 'language', 'advanced')) || (defined('MULTISITE') && (MULTISITE === TRUE || MULTISITE == 1) && flybx_get_option('license') == 'premium_unlimited' && $_GET['tab'] == 'wpms')))
	{
		$tab = $_GET['tab'];
	}
	
	//get available device types
	$flybx_all_device_types = array('computer', 'tablet', 'phone');
	
	//get available post types
	$post_types = get_post_types(array('public' => true));
	if (isset($post_types['attachment'])) unset($post_types['attachment']); 
	if (isset($post_types['video'])) unset($post_types['video']); 
	if (isset($post_types['slideshow'])) unset($post_types['slideshow']);
	$post_types['frontpage'] = 'frontpage';

	$error = '';
	if ( isset($_POST['btnsubmit']) || (isset($_POST['flybx_form_submitted']) && $_POST['flybx_form_submitted'] == 'yes') ) 
	{
		//BOF Validation
		
		if ($tab == 'important_stuff')
		{
			if (isset($_POST['flybx_amzn_active']))  $flybx_amzn_active = trim(strip_tags(($_POST['flybx_amzn_active'])));
			
			if (isset($_POST['am_key_id']))  $am_key_id  = trim(strip_tags(($_POST['am_key_id'])));
			if (isset($_POST['am_access_key'])) $am_access_key = trim(strip_tags(($_POST['am_access_key'])));
			if (isset($_POST['am_associate_tag'])) $am_associate_tag = trim(strip_tags(($_POST['am_associate_tag'])));
			if (isset($_POST['am_associate_locale'])) $am_associate_locale = trim(strip_tags(($_POST['am_associate_locale'])));
			
			if (isset($_POST['am_searchindex'])) $am_searchindex = trim(strip_tags(($_POST['am_searchindex'])));
			
			if (isset($_POST['flybx_active'])) $flybx_active = trim(strip_tags(($_POST['flybx_active'])));
			
			if (isset($_POST['flybx_unsupported_country_default'])) $flybx_unsupported_country_default = trim(strip_tags(($_POST['flybx_unsupported_country_default'])));
			
			if (isset($_POST['epn_enabled'])) $epn_enabled = trim(strip_tags(($_POST['epn_enabled'])));
			if (isset($_POST['epn_campaign_id'])) $epn_campaign_id = trim(strip_tags(($_POST['epn_campaign_id'])));
			if (isset($_POST['epn_custom_id'])) $epn_custom_id = trim(strip_tags(($_POST['epn_custom_id'])));
			
			if ('0' != $flybx_active)	//no validation if user is just disabling plugin
			{
				if ($flybx_amzn_active == '1')
				{
					//Amazon settings
					if ('' == $am_key_id)  $error .= '<div>'.__('Please enter your AWS Access Key ID', $flybx_plugin_slug).'</div>';
					if ('' == $am_access_key)  $error .= '<div>'.__('Please enter your AWS Secret Access Key', $flybx_plugin_slug).'</div>';
					if ('' == $am_associate_tag)  $error .= '<div>'.__('Please enter your Amazon Associate Tag', $flybx_plugin_slug).'</div>';
					
					
					//if ('' == $am_associate_tag && '' == $am_associate_tag_uk && '' == $am_associate_tag_de && '' == $am_associate_tag_jp && '' == $am_associate_tag_fr && '' == $am_associate_tag_ca && '' == $am_associate_tag_it && '' == $am_associate_tag_cn && '' == $am_associate_tag_es )  $error .= '<div>Please enter at least one Amazon Associate Tag</div>';
					
					//AWS credentials check
					if ($error == '')
					{
						$flybx_am_params = array(
									'key_id' => $am_key_id, 
									'access_key' => $am_access_key,
									'associate_tag' => $am_associate_tag
									);
						$am_credentials_check = flybx_am_check_credentials($flybx_am_params);
						if (isset($am_credentials_check->Error) && isset($am_credentials_check->Error->Code) && isset($am_credentials_check->Error->Message))
						{
							$am_error_code = strval($am_credentials_check->Error->Code);
							if ($am_error_code == 'InvalidClientTokenId')
							{
								$error .= '<div>'.__('The AWS Access Key Id you provided is invalid. Please double check and try again. <a href="http://www.pluginsbyigor.com/faqs/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/" target="_blank">Click Here if you need help</a>', $flybx_plugin_slug).'</div>';
							}
							elseif ($am_error_code == 'SignatureDoesNotMatch')
							{
								$error .= '<div>'.__('The AWS Secret Access Key you provided is invalid. Please double check and try again. <a href="http://www.pluginsbyigor.com/faqs/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/" target="_blank">Click Here if you need help</a>', $flybx_plugin_slug).'</div>';
							}
							else
							{
								$am_error_msg = strval($am_credentials_check->Error->Message);
								$error .= '<div>'.__('The AWS Credentials you provided are invalid. Please double check and try again. Amazon answered with this', $flybx_plugin_slug).': '.$am_error_msg.'. '.__('<a href="http://www.pluginsbyigor.com/faqs/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/" target="_blank">Click Here if you need help</a>', $flybx_plugin_slug).'</div>';
							}
						}
					}
				}			
				
				//patch the footer.php
				if (isset($_POST['flybx_hidden_patch_footer']) && $_POST['flybx_hidden_patch_footer'] == 'yes')
				{
					$flybx_file_handle = fopen(get_template_directory().'/footer.php', "a+");
					if ($flybx_file_handle !== FALSE)
					{
						$flybx_footer_content = '';
						$flybx_i = 0;
						while (!feof($flybx_file_handle) && $flybx_i < 5000) {
						  $flybx_footer_content .= fread($flybx_file_handle, 8192);
						  $flybx_i++;
						}						
						
						if ($flybx_footer_content != '' && stripos($flybx_footer_content, 'wp_footer(') === FALSE && stripos($flybx_footer_content, '</body>') !== FALSE)
						{
							//make backup
							@copy(get_template_directory().'/footer.php', get_template_directory().'/BACKUP_BY_AZONFLYBOX_'.date('Y_m_d').'_of_footer.php');
							ftruncate($flybx_file_handle, 0);
							$flybx_footer_content = str_replace('</body>', '<?php wp_footer(); ?>'."\n".'</body>', $flybx_footer_content);
							fwrite($flybx_file_handle, $flybx_footer_content);
							$flybx_additional_success = __("Your theme footer.php was patched successfully.", $flybx_plugin_slug);
							
						}
					}
					else
					{
						$error .= '<div>'.__('Unable to patch the theme footer.php file. Please <a href="http://www.pluginsbyigor.com/faqs/adding-tag-to-your-theme-footer-php-file/" target="_blank">check this guide how to fix this issue manually</a>.', $flybx_plugin_slug).'</div>';
					}
					fclose($flybx_file_handle);
					
				}
				//check if the theme footer.php has wp_footer(); tag
				if (file_exists(get_template_directory().'/footer.php'))
				{
					//can read?
					$flybx_file_handle = fopen(get_template_directory().'/footer.php', "r");
					if ($flybx_file_handle !== FALSE)
					{
						$flybx_footer_content = '';
						$flybx_i = 0;
						while (!feof($flybx_file_handle) && $flybx_i < 5000) {
						  $flybx_footer_content .= fread($flybx_file_handle, 8192);
						  $flybx_i++;
						}
						fclose($flybx_file_handle);
						
						if ($flybx_footer_content != '' && stripos($flybx_footer_content, 'wp_footer(') === FALSE)
						{
							if (isset($flybx_additional_success))
							{
								unset($flybx_additional_success);
							}
							$flybx_wpfooter_warning = sprintf(__('Warning! Your theme footer.php is missing this required tag: &lt;?php wp_footer(); ?&gt;. Without this tag %s will not work.', $flybx_plugin_slug), $flybx_plugin_name);
							//can write?
							$flybx_file_handle = fopen(get_template_directory().'/footer.php', "a+");
							if ($flybx_file_handle !== FALSE && stripos($flybx_footer_content, '</body>') !== FALSE)
							{
								$flybx_wpfooter_warning .= ' <a href="javascript: void(0);" onclick="javascript: if (confirm(\''.esc_attr('Are you sure you want to patch your theme footer.php? It is recommended to backup your files first.', $flybx_plugin_slug).'\')) { document.getElementById(\'flybx_hidden_patch_footer\').value = \'yes\'; document.getElementById(\'important_stuff_form\').submit(); };">'.__('Click here to patch your footer.php', $flybx_plugin_slug).'</a>. '.__('It is recommended to back up your files first and disable any firewall plugins you may have installed.', $flybx_plugin_slug).' <a href="'.__('http://www.pluginsbyigor.com/faqs/adding-tag-to-your-theme-footer-php-file/', $flybx_plugin_slug).'" target="_blank">'.__('More Info', $flybx_plugin_slug).'</a>';
							}
							else
							{
								$flybx_wpfooter_warning .= '<a href="'.__('http://www.pluginsbyigor.com/faqs/adding-tag-to-your-theme-footer-php-file/', $flybx_plugin_slug).'" target="_blank">'.__('Click here to learn how to fix this issue', $flybx_plugin_slug).'</a>.';
							}
							
						}
					}
				}
				
				
				if ('' == $am_searchindex)  $error .= '<div>'.__('Please enter your Amazon Search Index', $flybx_plugin_slug).'</div>';
			}
		}
		elseif($tab == 'advanced')
		{
			//make submission with enter work
			if (isset($_POST['submit_all']))
			{
				$_POST['save_all_settings'] = 'Save All Settings';
			}
			/*if (isset($_POST['save_general']) || isset($_POST['save_all_settings']))
			{
				if (isset($_POST['flybx_serponly'])) $flybx_serponly = trim(strip_tags(($_POST['flybx_serponly'])));
				if (isset($_POST['flybx_sensitivity'])) $flybx_sensitivity = trim(strip_tags(($_POST['flybx_sensitivity'])));
				if (isset($_POST['flybx_loggedin_hide'])) $flybx_loggedin_hide = trim(strip_tags(($_POST['flybx_loggedin_hide'])));
				if (isset($_POST['flybx_posttypes'])) $flybx_posttypes = $_POST['flybx_posttypes'];
				if (isset($_POST['flybx_pops_per_user'])) $flybx_pops_per_user = trim(strip_tags(($_POST['flybx_pops_per_user'])));
				if (isset($_POST['flybx_default_behavior'])) $flybx_default_behavior = trim(strip_tags(($_POST['flybx_default_behavior'])));
			}*/
			/*if (isset($_POST['save_triggers']) || isset($_POST['save_all_settings']))
			{
				if (isset($_POST['flybx_unbounce_enabled'])) $flybx_unbounce_enabled = trim(strip_tags(($_POST['flybx_unbounce_enabled'])));
				if (isset($_POST['flybx_mouse_trigger_disabled'])) $flybx_mouse_trigger_disabled = trim(strip_tags(($_POST['flybx_mouse_trigger_disabled'])));
				if (isset($_POST['flybx_trapped_trigger_enabled'])) $flybx_trapped_trigger_enabled = trim(strip_tags(($_POST['flybx_trapped_trigger_enabled'])));
				if (isset($_POST['flybx_trapped_trigger_msg'])) $flybx_trapped_trigger_msg = trim(strip_tags(($_POST['flybx_trapped_trigger_msg'])));
				$flybx_trapped_trigger_msg = stripslashes($flybx_trapped_trigger_msg);
				if (isset($_POST['flybx_unbounce_delay'])) $flybx_unbounce_delay = trim(strip_tags(($_POST['flybx_unbounce_delay'])));
			}*/

			if (isset($_POST['save_keywords']) || isset($_POST['save_all_settings']))
			{
				if (isset($_POST['flybx_skip_keywords']))  
				{
					$flybx_skip_keywords  = trim(strip_tags(($_POST['flybx_skip_keywords'])));
					$flybx_skip_keywords = str_replace("\r\n", "\n", $flybx_skip_keywords);
				}
				$flybx_kw_sources = array();
				if (isset($_POST['flybx_kw_sources']))
				{
					$flybx_kw_sources = $_POST['flybx_kw_sources'];
				}
				if (isset($_POST['flybx_fallback_keywords'])) $flybx_fallback_keywords = trim(strip_tags(($_POST['flybx_fallback_keywords'])));
				if (isset($_POST['flybx_min_kw_length'])) $flybx_min_kw_length = trim(strip_tags(($_POST['flybx_min_kw_length'])));
				//category keywords
				$categories = get_categories();
				$flybx_cat_kws = array();
				foreach($categories as $curr_cat)
				{
					if (isset($_POST['flybx_cat_kws_'.$curr_cat->term_id]))
					{
						$flybx_cat_kws[$curr_cat->term_id] = $_POST['flybx_cat_kws_'.$curr_cat->term_id];
					}
					else
					{
						$flybx_cat_kws[$curr_cat->term_id] = '';
					}				
				}

				$flybx_amzn_disabled_categories = array();
				if (isset($_POST['flybx_amzn_cat_toggle']) && is_array($_POST['flybx_amzn_cat_toggle']) && count($categories) > 0 && flybx_module_installed('amzn'))
				{
					foreach($categories as $curr_cat)
					{
						if (!in_array($curr_cat->term_id, $_POST['flybx_amzn_cat_toggle']))
						{
							$flybx_amzn_disabled_categories[] = $curr_cat->term_id;
						}
					}
				}				
				$flybx_epn_disabled_categories = array();
				if (isset($_POST['flybx_epn_cat_toggle']) && is_array($_POST['flybx_epn_cat_toggle']) && count($categories) > 0 && flybx_module_installed('epn'))
				{
					foreach($categories as $curr_cat)
					{
						if (!in_array($curr_cat->term_id, $_POST['flybx_epn_cat_toggle']))
						{
							$flybx_epn_disabled_categories[] = $curr_cat->term_id;
						}
					}
				}
			}
			if (isset($_POST['save_misc']) || isset($_POST['save_all_settings']))
			{
				if (isset($_POST['flybx_posttypes'])) $flybx_posttypes = $_POST['flybx_posttypes'];
				if (isset($_POST['flybx_devicetypes'])) $flybx_devicetypes = $_POST['flybx_devicetypes'];
				//if (isset($_POST['flybx_reviewson'])) $flybx_reviewson = trim(strip_tags(($_POST['flybx_reviewson'])));
				if (isset($_POST['flybx_show_promo_msgs'])) $flybx_show_promo_msgs = intval(trim(strip_tags(($_POST['flybx_show_promo_msgs']))));
				if (isset($_POST['flybx_path_to_geoip_dat'])) 
				{
					$flybx_path_to_geoip_dat = trim(strip_tags(($_POST['flybx_path_to_geoip_dat'])));
					if (trim($flybx_path_to_geoip_dat) != '' && !file_exists($flybx_path_to_geoip_dat))
					{
						$error .= __('GeoIP.dat file not found at', $flybx_plugin_slug).': '.$flybx_path_to_geoip_dat;
					}
				}
				
				if (isset($_POST['flybx_domoutline'])) $flybx_domoutline = trim(strip_tags(($_POST['flybx_domoutline'])));
				if (isset($_POST['flybx_visitor_log_days'])) $flybx_visitor_log_days = intval(trim(strip_tags(($_POST['flybx_visitor_log_days']))));
				if (isset($_POST['flybx_cache_hours'])) $flybx_cache_hours = intval(trim(strip_tags(($_POST['flybx_cache_hours']))));
				
				//unsupported country
				if (isset($_POST['flybx_unsupported_country_default'])) $flybx_unsupported_country_default = trim(strip_tags(($_POST['flybx_unsupported_country_default'])));
			
			}
			
			//BOF pull existing options on partial submit
			/*if (!isset($_POST['save_general']) && !isset($_POST['save_all_settings']))
			{				
				$flybx_serponly = get_option('flybx_serponly');
				$flybx_sensitivity = get_option('flybx_sensitivity');
				$flybx_loggedin_hide = get_option('flybx_loggedin_hide');
				$flybx_posttypes_str = get_option('flybx_posttypes');
				$flybx_posttypes = explode(',', $flybx_posttypes_str);
				$flybx_pops_per_user = get_option('flybx_pops_per_user');
				$flybx_default_behavior = get_option('flybx_default_behavior');
			}*/
			/*if (!isset($_POST['save_triggers']) && !isset($_POST['save_all_settings']))
			{	
				$flybx_unbounce_enabled = get_option('flybx_unbounce_enabled');
				$flybx_unbounce_delay = get_option('flybx_unbounce_delay');
				$flybx_mouse_trigger_disabled = flybx_get_option('flybx_mouse_trigger_disabled');
				$flybx_trapped_trigger_enabled = flybx_get_option('flybx_trapped_trigger_enabled');
				$flybx_trapped_trigger_msg = flybx_get_option('flybx_trapped_trigger_msg');
				$flybx_trapped_trigger_msg = stripslashes($flybx_trapped_trigger_msg);
			}*/

			if (!isset($_POST['save_keywords']) && !isset($_POST['save_all_settings']))
			{		
				$flybx_skip_keywords = flybx_get_option('flybx_skip_keywords');
				if ($flybx_skip_keywords === FALSE)
				{
					$flybx_skip_keywords_arr = flybx_get_default_skip_keywords();
					$flybx_skip_keywords = implode("\n", $flybx_skip_keywords_arr);
				}
				else
				{
					$flybx_skip_keywords_arr = explode(',', $flybx_skip_keywords);
					$flybx_skip_keywords = str_replace(",", "\n", $flybx_skip_keywords);
				}
				$flybx_skip_keywords = stripslashes($flybx_skip_keywords);
				$flybx_kw_sources = array();
				$flybx_kw_sources_str = flybx_get_option('flybx_kw_sources');
				if (strlen($flybx_kw_sources_str) > 0)
				{
					$flybx_kw_sources = explode(',', $flybx_kw_sources_str);
				}				
				$flybx_fallback_keywords = get_option('flybx_fallback_keywords');
				$flybx_min_kw_length = flybx_get_option('flybx_min_kw_length');
				$categories = get_categories();
				$flybx_cat_kws = array();
				foreach($categories as $curr_cat)
				{
					$cat_kw_check = get_option('flybx_cat_kws_'.$curr_cat->term_id);
					if ($cat_kw_check !== FALSE)
					{
						$flybx_cat_kws[$curr_cat->term_id] = $cat_kw_check;
					}
				}
				
				$flybx_amzn_disabled_categories = array();
				$flybx_amzn_disabled_categories_check = get_option('flybx_amzn_disabled_categories');
				if ($flybx_amzn_disabled_categories_check !== FALSE && flybx_module_installed('amzn'))
				{
					$flybx_amzn_disabled_categories_check_arr = explode(',', $flybx_amzn_disabled_categories_check);
					if (count($flybx_amzn_disabled_categories_check_arr) > 0)
					{
						$flybx_amzn_disabled_categories = $flybx_amzn_disabled_categories_check_arr;
					}
				}
				$flybx_epn_disabled_categories = array();
				$flybx_epn_disabled_categories_check = get_option('flybx_epn_disabled_categories');
				if ($flybx_epn_disabled_categories_check !== FALSE && flybx_module_installed('epn'))
				{
					$flybx_epn_disabled_categories_check_arr = explode(',', $flybx_epn_disabled_categories_check);
					if (count($flybx_epn_disabled_categories_check_arr) > 0)
					{
						$flybx_epn_disabled_categories = $flybx_epn_disabled_categories_check_arr;
					}
				}

				
				
			}
			if (!isset($_POST['save_misc']) && !isset($_POST['save_all_settings']))
			{	
				$flybx_posttypes_str = get_option('flybx_posttypes');
				$flybx_posttypes = explode(',', $flybx_posttypes_str);
				$flybx_devicetypes_str = get_option('flybx_devicetypes');
				$flybx_devicetypes = explode(',', $flybx_devicetypes_str);
				//$flybx_reviewson = flybx_get_option('flybx_reviewson');
				$flybx_show_promo_msgs = flybx_get_option('flybx_show_promo_msgs', is_multisite());
				$flybx_path_to_geoip_dat = flybx_get_option('flybx_path_to_geoip_dat');
				
				$flybx_domoutline = flybx_get_option('flybx_domoutline');
				$flybx_visitor_log_days = flybx_get_option('flybx_visitor_log_days');
				$flybx_cache_hours = flybx_24h_max(flybx_get_option('flybx_cache_hours'));
				
				
				
				$flybx_unsupported_country_default = flybx_get_option('flybx_unsupported_country_default');
			}
			//EOF pull existing options on partial submit
		}
		elseif($tab == 'amazon')
		{
			if (isset($_POST['am_key_id']))  $am_key_id  = trim(strip_tags(($_POST['am_key_id'])));
			if (isset($_POST['am_access_key'])) $am_access_key = trim(strip_tags(($_POST['am_access_key'])));
			if (isset($_POST['skip_noimage'])) $skip_noimage = trim(strip_tags(($_POST['skip_noimage'])));
			if (isset($_POST['skip_asins'])) $skip_asins = trim(strip_tags(($_POST['skip_asins'])));
			if (isset($_POST['am_associate_tag'])) $am_associate_tag = trim(strip_tags(($_POST['am_associate_tag'])));
			if (isset($_POST['am_associate_tag_uk'])) $am_associate_tag_uk = trim(strip_tags(($_POST['am_associate_tag_uk'])));
			if (isset($_POST['am_associate_tag_de'])) $am_associate_tag_de = trim(strip_tags(($_POST['am_associate_tag_de'])));
			if (isset($_POST['am_associate_tag_jp'])) $am_associate_tag_jp = trim(strip_tags(($_POST['am_associate_tag_jp'])));
			if (isset($_POST['am_associate_tag_fr'])) $am_associate_tag_fr = trim(strip_tags(($_POST['am_associate_tag_fr'])));
			if (isset($_POST['am_associate_tag_ca'])) $am_associate_tag_ca = trim(strip_tags(($_POST['am_associate_tag_ca'])));
			if (isset($_POST['am_associate_tag_it'])) $am_associate_tag_it = trim(strip_tags(($_POST['am_associate_tag_it'])));
			if (isset($_POST['am_associate_tag_cn'])) $am_associate_tag_cn = trim(strip_tags(($_POST['am_associate_tag_cn'])));
			if (isset($_POST['am_associate_tag_es'])) $am_associate_tag_es = trim(strip_tags(($_POST['am_associate_tag_es'])));
			
			if (isset($_POST['am_searchindex'])) $am_searchindex = trim(strip_tags(($_POST['am_searchindex'])));
			
			
			//save all nodes
			if (isset($_POST['amzn_category']))
			{
				$amzn_category = $_POST['amzn_category'];
			}

			
			if ('' == $am_key_id)  $error .= '<div>'.__('Please enter your AWS Access Key ID', $flybx_plugin_slug).'</div>';
			if ('' == $am_access_key)  $error .= '<div>'.__('Please enter your AWS Secret Access Key', $flybx_plugin_slug).'</div>';
			if ('' == $am_associate_tag && '' == $am_associate_tag_uk && '' == $am_associate_tag_de && '' == $am_associate_tag_jp && '' == $am_associate_tag_fr && '' == $am_associate_tag_ca && '' == $am_associate_tag_it && '' == $am_associate_tag_cn && '' == $am_associate_tag_es )  $error .= '<div>'.__('Please enter at least one Amazon Associate Tag', $flybx_plugin_slug).'</div>';
			if ('' == $am_searchindex)  $error .= '<div>'.__('Please enter your Amazon Search Index', $flybx_plugin_slug).'</div>';
			
			if (isset($flybx_addons) && is_array($flybx_addons) && in_array('amzn_cart', $flybx_addons))
			{
				if (isset($_POST['flybx_amzn_cart_enabled'])) $flybx_amzn_cart_enabled = trim(strip_tags(($_POST['flybx_amzn_cart_enabled'])));
				if (isset($_POST['flybx_amzn_cart_btn_text_3prods'])) $flybx_amzn_cart_btn_text_3prods = trim(strip_tags(($_POST['flybx_amzn_cart_btn_text_3prods'])));
			
			}
			
			//AWS credentials check
			if ($error == '')
			{
				$flybx_am_params = array(
							'key_id' => $am_key_id, 
							'access_key' => $am_access_key,
							'associate_tag' => $am_associate_tag
							);
				$am_credentials_check = flybx_am_check_credentials($flybx_am_params);
				if (isset($am_credentials_check->Error) && isset($am_credentials_check->Error->Code) && isset($am_credentials_check->Error->Message))
				{
					$am_error_code = strval($am_credentials_check->Error->Code);
					if ($am_error_code == 'InvalidClientTokenId')
					{
						$error .= '<div>'.__('The AWS Access Key Id you provided is invalid. Please double check and try again. <a href="http://www.pluginsbyigor.com/faqs/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/" target="_blank">Click Here if you need help</a>', $flybx_plugin_slug).'</div>';
					}
					elseif ($am_error_code == 'SignatureDoesNotMatch')
					{
						$error .= '<div>'.__('The AWS Secret Access Key you provided is invalid. Please double check and try again. <a href="http://www.pluginsbyigor.com/faqs/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/" target="_blank">Click Here if you need help</a>', $flybx_plugin_slug).'</div>';
					}
					else
					{
						$am_error_msg = strval($am_credentials_check->Error->Message);
						$error .= '<div>'.__('The AWS Credentials you provided are invalid. Please double check and try again. Amazon answered with this:', $flybx_plugin_slug).' '.$am_error_msg.'. '.__('<a href="http://www.pluginsbyigor.com/faqs/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/" target="_blank">Click Here if you need help</a>', $flybx_plugin_slug).'</div>';
					}
				}
			}
		}
		elseif($tab == 'wpms')
		{
			if (isset($_POST['flybx_default_wpms_blog_id'])) $flybx_default_wpms_blog_id = trim(strip_tags(($_POST['flybx_default_wpms_blog_id'])));
			if (isset($_POST['flybx_wpms_apply_to_all'])) $flybx_wpms_apply_to_all = trim(strip_tags(($_POST['flybx_wpms_apply_to_all'])));

		}

		//EOF Validation		
		
		if ('' == $error) {
			if ($tab == 'important_stuff')
			{
		
				if (isset($_POST['flybx_amzn_active'])) {
					flybx_update_option('flybx_amzn_active', $flybx_amzn_active = trim($_POST['flybx_amzn_active']));
				} else {
					flybx_delete_option('flybx_amzn_active');
				}
				
				if (isset($_POST['flybx_unsupported_country_default']) && trim($_POST['flybx_unsupported_country_default']) != '') {
					flybx_update_option('flybx_unsupported_country_default', $flybx_unsupported_country_default = trim($_POST['flybx_unsupported_country_default']));
				} else {
					flybx_delete_option('flybx_unsupported_country_default');
				}
				
				if (isset($_POST['am_key_id']) && trim($_POST['am_key_id'])) {
					update_option('flybx_am_key_id', $am_key_id = trim($_POST['am_key_id']));
				} else {
					delete_option('flybx_am_key_id');
				}
				
				if (isset($_POST['am_access_key']) && trim($_POST['am_access_key'])) {
					update_option('flybx_am_access_key', $am_access_key = trim($_POST['am_access_key']));
				} else {
					delete_option('flybx_am_access_key');
				}
				
				
				if (isset($_POST['am_access_key']) && trim($_POST['am_access_key'])) {
					update_option('flybx_am_associate_locale', $am_associate_locale = trim($_POST['am_associate_locale']));
				} else {
					delete_option('flybx_am_associate_locale');
				}
				
				if ($am_associate_locale == 'us' && isset($_POST['am_associate_tag'])) {
					update_option('flybx_am_associate_tag', $am_associate_tag = trim($_POST['am_associate_tag']));
				}
				
				if ($am_associate_locale == 'uk' && isset($_POST['am_associate_tag'])) { update_option('flybx_locale_tag_uk', $am_associate_tag = trim($_POST['am_associate_tag'])); }
				if ($am_associate_locale == 'de' && isset($_POST['am_associate_tag'])) { update_option('flybx_locale_tag_de', $am_associate_tag = trim($_POST['am_associate_tag'])); }
				if ($am_associate_locale == 'jp' && isset($_POST['am_associate_tag'])) { update_option('flybx_locale_tag_jp', $am_associate_tag = trim($_POST['am_associate_tag'])); }
				if ($am_associate_locale == 'fr' && isset($_POST['am_associate_tag'])) { update_option('flybx_locale_tag_fr', $am_associate_tag = trim($_POST['am_associate_tag'])); }
				if ($am_associate_locale == 'ca' && isset($_POST['am_associate_tag'])) { update_option('flybx_locale_tag_ca', $am_associate_tag = trim($_POST['am_associate_tag'])); }
				if ($am_associate_locale == 'it' && isset($_POST['am_associate_tag'])) { update_option('flybx_locale_tag_it', $am_associate_tag = trim($_POST['am_associate_tag'])); }
				if ($am_associate_locale == 'cn' && isset($_POST['am_associate_tag'])) { update_option('flybx_locale_tag_cn', $am_associate_tag = trim($_POST['am_associate_tag'])); }
				if ($am_associate_locale == 'es' && isset($_POST['am_associate_tag'])) { update_option('flybx_locale_tag_es', $am_associate_tag = trim($_POST['am_associate_tag'])); }
				
				
				if (isset($_POST['am_searchindex']) && trim($_POST['am_searchindex'])) {
					update_option('flybx_am_searchindex', $am_searchindex = trim($_POST['am_searchindex']));
				} else {
					delete_option('flybx_am_searchindex');
				}
				
				if (isset($_POST['flybx_active']) && trim($_POST['flybx_active'])) {
					update_option('flybx_active', $flybx_active = trim($_POST['flybx_active']));
				} else {
					delete_option('flybx_active');
				}
				
				if (isset($_POST['epn_enabled'])) {
					flybx_update_option('epn_enabled', $epn_enabled = trim($_POST['epn_enabled']));
				} else {
					flybx_delete_option('epn_enabled');
				}
				
				if (isset($_POST['epn_campaign_id']) && trim($_POST['epn_campaign_id'])) {
					flybx_update_option('epn_campaign_id', $epn_campaign_id = trim($_POST['epn_campaign_id']));
				} else {
					flybx_delete_option('epn_campaign_id');
				}
				
				if (isset($_POST['epn_custom_id']) && trim($_POST['epn_custom_id'])) {
					flybx_update_option('epn_custom_id', $epn_custom_id = trim($_POST['epn_custom_id']));
				} else {
					flybx_delete_option('epn_custom_id');
				}
				
				
			}
			elseif ($tab == 'advanced')
			{
				//make submission with enter work
				if (isset($_POST['submit_all']))
				{
					$_POST['save_all_settings'] = 'Save All Settings';
				}

				/*if (isset($_POST['save_general']) || isset($_POST['save_all_settings']))
				{
					if (isset($_POST['flybx_serponly']) && trim($_POST['flybx_serponly'])) {
						update_option('flybx_serponly', $flybx_serponly = trim($_POST['flybx_serponly']));
					} else {
						delete_option('flybx_serponly');
					}
					
					if (isset($_POST['flybx_sensitivity']) && trim($_POST['flybx_sensitivity'])) {
						update_option('flybx_sensitivity', $flybx_sensitivity = trim($_POST['flybx_sensitivity']));
					} else {
						delete_option('flybx_sensitivity');
					}
					
					if (isset($_POST['flybx_loggedin_hide']) && trim($_POST['flybx_loggedin_hide'])) {
						update_option('flybx_loggedin_hide', $flybx_loggedin_hide = trim($_POST['flybx_loggedin_hide']));
					} else {
						delete_option('flybx_loggedin_hide');
					}
					
					if (isset($_POST['flybx_posttypes']) && is_array($_POST['flybx_posttypes'])) {
						update_option('flybx_posttypes', implode(',', $_POST['flybx_posttypes']));
						$flybx_posttypes = $_POST['flybx_posttypes'];
					} else {
						delete_option('flybx_posttypes');
						$flybx_posttypes = array();
					}
					
					if (isset($_POST['flybx_pops_per_user']) && trim($_POST['flybx_pops_per_user'])) {
						update_option('flybx_pops_per_user', $flybx_pops_per_user = trim($_POST['flybx_pops_per_user']));
					} else {
						delete_option('flybx_pops_per_user');
					}
					
					if (isset($_POST['flybx_default_behavior']) && trim($_POST['flybx_default_behavior'])) {
						update_option('flybx_default_behavior', $flybx_default_behavior = trim($_POST['flybx_default_behavior']));
					} else {
						delete_option('flybx_default_behavior');
					}
				}
				
				if (isset($_POST['save_triggers']) || isset($_POST['save_all_settings']))
				{
					if (isset($_POST['flybx_unbounce_enabled']) && trim($_POST['flybx_unbounce_enabled'])) {
						update_option('flybx_unbounce_enabled', $flybx_unbounce_enabled = trim($_POST['flybx_unbounce_enabled']));
					} else {
						delete_option('flybx_unbounce_enabled');
					}
					
					if (isset($_POST['flybx_unbounce_delay']) && trim($_POST['flybx_unbounce_delay'])) {
						update_option('flybx_unbounce_delay', $flybx_unbounce_delay = trim($_POST['flybx_unbounce_delay']));
					} else {
						delete_option('flybx_unbounce_delay');
					}
					
					if (isset($_POST['flybx_mouse_trigger_disabled']) && trim($_POST['flybx_mouse_trigger_disabled'])) {
						flybx_update_option('flybx_mouse_trigger_disabled', $flybx_mouse_trigger_disabled = trim($_POST['flybx_mouse_trigger_disabled']));
					} else {
						flybx_delete_option('flybx_mouse_trigger_disabled');
					}
					if (isset($_POST['flybx_trapped_trigger_enabled']) && trim($_POST['flybx_trapped_trigger_enabled'])) {
						flybx_update_option('flybx_trapped_trigger_enabled', $flybx_trapped_trigger_enabled = trim($_POST['flybx_trapped_trigger_enabled']));
					} else {
						flybx_delete_option('flybx_trapped_trigger_enabled');
					}
					if (isset($_POST['flybx_trapped_trigger_msg']) && trim($_POST['flybx_trapped_trigger_msg'])) {
						flybx_update_option('flybx_trapped_trigger_msg', $flybx_trapped_trigger_msg = stripslashes(trim($_POST['flybx_trapped_trigger_msg'])));
					} else {
						flybx_delete_option('flybx_trapped_trigger_msg');
					}
				}*/

				
				if (isset($_POST['save_keywords']) || isset($_POST['save_all_settings']))
				{
					if (isset($_POST['flybx_skip_keywords']) && trim($_POST['flybx_skip_keywords'])) {
						$flybx_skip_keywords = trim($_POST['flybx_skip_keywords']);
						$flybx_skip_keywords = str_replace("\r\n", "\n", $flybx_skip_keywords);
						$flybx_skip_keywords = str_replace("\n\n", "\n", $flybx_skip_keywords);
						$flybx_skip_keywords = stripslashes($flybx_skip_keywords);
						$flybx_skip_keywords_arr = explode("\n", $flybx_skip_keywords);
						//trim every element
						foreach($flybx_skip_keywords_arr as $key => $val)
						{
							$flybx_skip_keywords_arr[$key] = trim($val);
						}
						$flybx_skip_keywords_arr = array_diff($flybx_skip_keywords_arr, array('/'));
						flybx_update_option('flybx_skip_keywords', implode(',', $flybx_skip_keywords_arr));
						//update all existing keywords
						set_time_limit(300);
						
						$total_kw_posts = $wpdb->get_var("SELECT COUNT(*) FROM $wpdb->postmeta WHERE meta_key = 'flybx_keywords' AND meta_value != ''");

						if ($total_kw_posts !== FALSE && $total_kw_posts > 0)
						{
							$flybx_i = 0;
							while($flybx_i < $total_kw_posts)
							{
								set_time_limit(300);
								$meta_data_row = $wpdb->get_row("SELECT * FROM $wpdb->postmeta WHERE meta_key = 'flybx_keywords' AND meta_value != ''", OBJECT, $flybx_i);
								if ($meta_data_row !== FALSE && isset($meta_data_row->meta_value))
								{									
									$current_kws_arr = explode(",", $meta_data_row->meta_value);
									$new_kws_arr = array();
									$remove_kws = array();
									if (count($current_kws_arr) > 0)
									{	
										$old_kws_str = implode(',', $current_kws_arr);
										//trim
										foreach($current_kws_arr as $key => $val)
										{
											//remove one word keywords if selected
											if (isset($_POST['flybx_min_kw_length']) && $_POST['flybx_min_kw_length'] == 2 && count(explode(' ', trim($val))) == 1)
											{
												unset($current_kws_arr[$key]);
											}
											else
											{
												$current_kws_arr[$key] = trim($val);
											}
										}
										
										$skip_preg_arr = array();										
										foreach($flybx_skip_keywords_arr as $curr_skip_kw)
										{
											//check for exact matches											
											if (preg_match('/^(["\']).*\1$/m', $curr_skip_kw) == 1)
											{
												$str_no_quotes = substr($curr_skip_kw, 1, (strlen($curr_skip_kw) - 2));
												if (in_array($str_no_quotes, $current_kws_arr))
												{
													$remove_kws[] = $str_no_quotes;
												}
											}
											else
											{	
												if (stripos($curr_skip_kw, "*") !== FALSE)
												{
													if (substr($curr_skip_kw, 0, 1) == '*' && substr($curr_skip_kw, (strlen($curr_skip_kw) - 1), 1) == '*')
													{
														$skip_preg_arr[] = preg_quote(str_replace('*', '', $curr_skip_kw), DIRECTORY_SEPARATOR);
													}
													elseif (substr($curr_skip_kw, 0, 1) == '*')
													{
														$skip_preg_arr[] = preg_quote(str_replace('*', '', $curr_skip_kw), DIRECTORY_SEPARATOR)."\b";
													}
													elseif (substr($curr_skip_kw, (strlen($curr_skip_kw) - 1), 1) == '*')
													{
														$skip_preg_arr[] = "\b".preg_quote(str_replace('*', '', $curr_skip_kw), DIRECTORY_SEPARATOR);
													}
												}
												else
												{
													$skip_preg_arr[] = "\b".preg_quote($curr_skip_kw, DIRECTORY_SEPARATOR)."\b";
												}
											}
										}
										$new_kws_arr = array_diff($current_kws_arr, $remove_kws);
										foreach($new_kws_arr as $key => $val)
										{
											$new_val = preg_replace('/('.implode('|', $skip_preg_arr).')/i', '', $val);
											
											if (strlen($new_val) > 0)
											{
												$new_kws_arr[$key] = $new_val;
											}
											else
											{
												unset($new_kws_arr[$key]);
											}
										}
										
										//remove one word keywords again
										foreach($new_kws_arr as $key => $val)
										{
											//remove one word keywords if selected
											if (isset($_POST['flybx_min_kw_length']) && $_POST['flybx_min_kw_length'] == 2 && count(explode(' ', trim($val))) == 1)
											{
												unset($new_kws_arr[$key]);
											}
										}
										
										$new_kws_str = implode(',', $new_kws_arr);
										if ($new_kws_str != $old_kws_str)
										{
											$wpdb->query("UPDATE $wpdb->postmeta SET meta_value = '".$wpdb->escape($new_kws_str)."' WHERE meta_id = '".$meta_data_row->meta_id."' LIMIT 1");
										}
									}
								}								
								$flybx_i++;
							}
						}
						$wpdb->flush();					
						
					} else {
						flybx_delete_option('flybx_skip_keywords');
					}
					
					if (isset($_POST['flybx_kw_sources']) && is_array($_POST['flybx_kw_sources'])) {
						$flybx_kw_sources = $_POST['flybx_kw_sources'];
						flybx_update_option('flybx_kw_sources', implode(',', $flybx_kw_sources));
						//flybx_delete_keywords();
					} else {
						flybx_delete_option('flybx_kw_sources');
					}

						
					if (isset($_POST['flybx_fallback_keywords']) && trim($_POST['flybx_fallback_keywords'])) {
						update_option('flybx_fallback_keywords', $flybx_fallback_keywords = stripslashes(trim($_POST['flybx_fallback_keywords'])));
					} else {
						delete_option('flybx_fallback_keywords');
					}
					if (isset($_POST['flybx_min_kw_length']) && trim($_POST['flybx_min_kw_length'])) {
						flybx_update_option('flybx_min_kw_length', $flybx_min_kw_length = stripslashes(trim($_POST['flybx_min_kw_length'])));
					} else {
						flybx_delete_option('flybx_min_kw_length');
					}
					//category keywords
					$categories = get_categories();
					$flybx_cat_kws = array();
					foreach($categories as $curr_cat)
					{
						if (isset($_POST['flybx_cat_kws_'.$curr_cat->term_id]))
						{
							$flybx_cat_kws[$curr_cat->term_id] = $_POST['flybx_cat_kws_'.$curr_cat->term_id];
							update_option('flybx_cat_kws_'.$curr_cat->term_id, $flybx_cat_kws[$curr_cat->term_id]);
						}
						else
						{
							$flybx_cat_kws[$curr_cat->term_id] = '';
							delete_option('flybx_cat_kws_'.$curr_cat->term_id);
						}				
					}
					
					if (!isset($_POST['flybx_amzn_cat_toggle']))
					{
						$_POST['flybx_amzn_cat_toggle'] = array();
					}
					if (!isset($_POST['flybx_epn_cat_toggle']))
					{
						$_POST['flybx_epn_cat_toggle'] = array();
					}
					$flybx_amzn_disabled_categories = array();
					if (isset($_POST['flybx_amzn_cat_toggle']) && is_array($_POST['flybx_amzn_cat_toggle']) && count($categories) > 0 && flybx_module_installed('amzn'))
					{
						foreach($categories as $curr_cat)
						{
							if (!in_array($curr_cat->term_id, $_POST['flybx_amzn_cat_toggle']))
							{
								$flybx_amzn_disabled_categories[] = $curr_cat->term_id;
							}
						}						
					}
					update_option('flybx_amzn_disabled_categories', implode(',', $flybx_amzn_disabled_categories));
					$flybx_epn_disabled_categories = array();
					if (isset($_POST['flybx_epn_cat_toggle']) && is_array($_POST['flybx_epn_cat_toggle']) && count($categories) > 0 && flybx_module_installed('epn'))
					{
						foreach($categories as $curr_cat)
						{
							if (!in_array($curr_cat->term_id, $_POST['flybx_epn_cat_toggle']))
							{
								$flybx_epn_disabled_categories[] = $curr_cat->term_id;
							}
						}
					}
					update_option('flybx_epn_disabled_categories', implode(',', $flybx_epn_disabled_categories));
					
					flybx_clear_cache();
				}
				
				if (isset($_POST['save_misc']) || isset($_POST['save_all_settings']))
				{
					if (isset($_POST['flybx_posttypes']) && is_array($_POST['flybx_posttypes'])) {
						update_option('flybx_posttypes', implode(',', $_POST['flybx_posttypes']));
						$flybx_posttypes = $_POST['flybx_posttypes'];
					} else {
						delete_option('flybx_posttypes');
						$flybx_posttypes = array();
					}
					
					if (isset($_POST['flybx_devicetypes']) && is_array($_POST['flybx_devicetypes'])) {
						update_option('flybx_devicetypes', implode(',', $_POST['flybx_devicetypes']));
						$flybx_devicetypes = $_POST['flybx_devicetypes'];
					} else {
						delete_option('flybx_devicetypes');
						$flybx_devicetypes = array();
					}
					
					/*if (isset($_POST['flybx_reviewson']) && trim($_POST['flybx_reviewson']) != '') {
						flybx_update_option('flybx_reviewson', $flybx_reviewson = trim($_POST['flybx_reviewson']));
					} else {
						flybx_delete_option('flybx_reviewson');
					}*/
					
					
					if (isset($_POST['flybx_show_promo_msgs']) && trim($_POST['flybx_show_promo_msgs']) != '') {
						flybx_update_option('flybx_show_promo_msgs', $flybx_show_promo_msgs = intval(trim($_POST['flybx_show_promo_msgs'])));
					} else {
						flybx_delete_option('flybx_show_promo_msgs');
					}
					if (isset($_POST['flybx_path_to_geoip_dat']) && trim($_POST['flybx_path_to_geoip_dat']) != '') {
						flybx_update_option('flybx_path_to_geoip_dat', $flybx_path_to_geoip_dat = trim($_POST['flybx_path_to_geoip_dat']));
					} else {
						flybx_delete_option('flybx_path_to_geoip_dat');
					}
					
					if (isset($_POST['flybx_domoutline']) && trim($_POST['flybx_domoutline']) != '') {
						flybx_update_option('flybx_domoutline', $flybx_domoutline = trim($_POST['flybx_domoutline']));
					} else {
						flybx_delete_option('flybx_domoutline');
					}
					if (isset($_POST['flybx_visitor_log_days']) && trim($_POST['flybx_visitor_log_days']) != '') {
						flybx_update_option('flybx_visitor_log_days', $flybx_visitor_log_days = trim($_POST['flybx_visitor_log_days']));
					} else {
						flybx_delete_option('flybx_visitor_log_days');
					}
					if (isset($_POST['flybx_cache_hours']) && trim($_POST['flybx_cache_hours']) != '') {
						flybx_update_option('flybx_cache_hours', $flybx_cache_hours = flybx_24h_max(trim($_POST['flybx_cache_hours'])));
					} else {
						flybx_delete_option('flybx_cache_hours');
					}
					
					if (isset($_POST['flybx_unsupported_country_default']) && trim($_POST['flybx_unsupported_country_default']) != '') {
						flybx_update_option('flybx_unsupported_country_default', $flybx_unsupported_country_default = trim($_POST['flybx_unsupported_country_default']));
					} else {
						flybx_delete_option('flybx_unsupported_country_default');
					}
				}

				//BOF pull existing options on partial submit
				/*if (!isset($_POST['save_general']) && !isset($_POST['save_all_settings']))
				{				
					$flybx_serponly = get_option('flybx_serponly');
					$flybx_sensitivity = get_option('flybx_sensitivity');
					$flybx_loggedin_hide = get_option('flybx_loggedin_hide');
					$flybx_posttypes_str = get_option('flybx_posttypes');
					$flybx_posttypes = explode(',', $flybx_posttypes_str);
					$flybx_pops_per_user = get_option('flybx_pops_per_user');
					$flybx_default_behavior = get_option('flybx_default_behavior');
				}
				if (!isset($_POST['save_triggers']) && !isset($_POST['save_all_settings']))
				{	
					$flybx_unbounce_enabled = get_option('flybx_unbounce_enabled');
					$flybx_unbounce_delay = get_option('flybx_unbounce_delay');
					$flybx_mouse_trigger_disabled = flybx_get_option('flybx_mouse_trigger_disabled');
					$flybx_trapped_trigger_enabled = flybx_get_option('flybx_trapped_trigger_enabled');
					$flybx_trapped_trigger_msg = flybx_get_option('flybx_trapped_trigger_msg');
					$flybx_trapped_trigger_msg = stripslashes($flybx_trapped_trigger_msg);
				}*/

				if (!isset($_POST['save_keywords']) && !isset($_POST['save_all_settings']))
				{		
					$flybx_skip_keywords = flybx_get_option('flybx_skip_keywords');
					if ($flybx_skip_keywords === FALSE)
					{
						$flybx_skip_keywords_arr = flybx_get_default_skip_keywords();
						$flybx_skip_keywords = implode("\n", $flybx_skip_keywords_arr);
					}
					else
					{
						$flybx_skip_keywords_arr = explode(',', $flybx_skip_keywords);
						$flybx_skip_keywords = str_replace(",", "\n", $flybx_skip_keywords);
					}
					$flybx_skip_keywords = stripslashes($flybx_skip_keywords);
					$flybx_kw_sources = array();
					$flybx_kw_sources_str = flybx_get_option('flybx_kw_sources');
					if ($flybx_kw_sources_str !== FALSE)
					{
						$flybx_kw_sources = explode(',', $flybx_kw_sources_str);
					}
					$flybx_fallback_keywords = get_option('flybx_fallback_keywords');
					$flybx_min_kw_length = flybx_get_option('flybx_min_kw_length');
					$categories = get_categories();
					$flybx_cat_kws = array();
					foreach($categories as $curr_cat)
					{
						$cat_kw_check = get_option('flybx_cat_kws_'.$curr_cat->term_id);
						if ($cat_kw_check !== FALSE)
						{
							$flybx_cat_kws[$curr_cat->term_id] = $cat_kw_check;
						}
					}
					
					$flybx_amzn_disabled_categories = array();
					$flybx_amzn_disabled_categories_check = get_option('flybx_amzn_disabled_categories');
					if ($flybx_amzn_disabled_categories_check !== FALSE && flybx_module_installed('amzn'))
					{
						$flybx_amzn_disabled_categories_check_arr = explode(',', $flybx_amzn_disabled_categories_check);
						if (count($flybx_amzn_disabled_categories_check_arr) > 0)
						{
							$flybx_amzn_disabled_categories = $flybx_amzn_disabled_categories_check_arr;
						}
					}
					$flybx_epn_disabled_categories = array();
					$flybx_epn_disabled_categories_check = get_option('flybx_epn_disabled_categories');
					if ($flybx_epn_disabled_categories_check !== FALSE && flybx_module_installed('epn'))
					{
						$flybx_epn_disabled_categories_check_arr = explode(',', $flybx_epn_disabled_categories_check);
						if (count($flybx_epn_disabled_categories_check_arr) > 0)
						{
							$flybx_epn_disabled_categories = $flybx_epn_disabled_categories_check_arr;
						}
					}

					
				}
				if (!isset($_POST['save_misc']) && !isset($_POST['save_all_settings']))
				{	
					$flybx_posttypes_str = get_option('flybx_posttypes');
					$flybx_posttypes = explode(',', $flybx_posttypes_str);
					
					$flybx_devicetypes_str = get_option('flybx_devicetypes');
					$flybx_devicetypes = explode(',', $flybx_devicetypes_str);

					//$flybx_reviewson = flybx_get_option('flybx_reviewson');
					$flybx_show_promo_msgs = flybx_get_option('flybx_show_promo_msgs', is_multisite());
					$flybx_path_to_geoip_dat = flybx_get_option('flybx_path_to_geoip_dat');
					$flybx_visitor_log_days = flybx_get_option('flybx_visitor_log_days');
					$flybx_domoutline = flybx_get_option('flybx_domoutline');
					$flybx_cache_hours = flybx_24h_max(flybx_get_option('flybx_cache_hours'));
					$flybx_unsupported_country_default = flybx_get_option('flybx_unsupported_country_default');
				}
				//EOF pull existing options on partial submit
				
				
			}
			elseif ($tab == 'amazon')
			{
				if (isset($flybx_addons) && is_array($flybx_addons) && in_array('amzn_cart', $flybx_addons))
				{
					if (isset($_POST['flybx_amzn_cart_enabled']) && trim($_POST['flybx_amzn_cart_enabled'])) {
						flybx_update_option('amzn_cart_enabled', $flybx_amzn_cart_enabled = trim($_POST['flybx_amzn_cart_enabled']));
						flybx_clear_cache();
					} else {
						flybx_delete_option('amzn_cart_enabled');
					}
					if (isset($_POST['flybx_amzn_cart_btn_text_3prods']) && trim($_POST['flybx_amzn_cart_btn_text_3prods'])) {
						flybx_update_option('amzn_cart_btn_text_3prods', $flybx_amzn_cart_btn_text_3prods = trim($_POST['flybx_amzn_cart_btn_text_3prods']));
					} else {
						flybx_delete_option('amzn_cart_btn_text_3prods');
					}
					
				}
				
				
				if (isset($_POST['am_key_id']) && trim($_POST['am_key_id'])) {
					update_option('flybx_am_key_id', $am_key_id = trim($_POST['am_key_id']));
				} else {
					delete_option('flybx_am_key_id');
				}
				
				if (isset($_POST['am_access_key']) && trim($_POST['am_access_key'])) {
					update_option('flybx_am_access_key', $am_access_key = trim($_POST['am_access_key']));
				} else {
					delete_option('flybx_am_access_key');
				}
				
				if (isset($_POST['am_associate_tag']) && trim($_POST['am_associate_tag'])) {
					update_option('flybx_am_associate_tag', $am_associate_tag = trim($_POST['am_associate_tag']));
				} else {
					delete_option('flybx_am_associate_tag');
				}
				
				if (isset($_POST['am_searchindex']) && trim($_POST['am_searchindex'])) {
					update_option('flybx_am_searchindex', $am_searchindex = trim($_POST['am_searchindex']));
				} else {
					delete_option('flybx_am_searchindex');
				}
				
				//update all nodes
				if (isset($_POST['amzn_category']) && is_array($_POST['amzn_category'])) {
					foreach(flybx_amzn_countries() as $country)
					{
						if (isset($_POST['amzn_category'][$country]))
						{
							update_option('flybx_nodes_path_'.$country, implode(',', $_POST['amzn_category'][$country]));
						}
						else 
						{
							delete_option('flybx_nodes_path_'.$country);
						}
					}					
				} 
				
				
				if (isset($_POST['skip_noimage']) && trim($_POST['skip_noimage'])) {
					update_option('flybx_skip_noimage', $skip_noimage = trim($_POST['skip_noimage']));
				} else {
					delete_option('flybx_skip_noimage');
				}
				if (isset($_POST['skip_asins']) && trim($_POST['skip_asins'])) {
					update_option('flybx_skip_asins', $skip_asins = trim($_POST['skip_asins']));
				} else {
					delete_option('flybx_skip_asins');
				}
				
				
				if (isset($_POST['am_associate_tag_uk']) && trim($_POST['am_associate_tag_uk'])) { update_option('flybx_locale_tag_uk', $am_associate_tag_uk = trim($_POST['am_associate_tag_uk'])); } 
				else { delete_option('flybx_locale_tag_uk');}
				if (isset($_POST['am_associate_tag_de']) && trim($_POST['am_associate_tag_de'])) { update_option('flybx_locale_tag_de', $am_associate_tag_de = trim($_POST['am_associate_tag_de'])); } 
				else { delete_option('flybx_locale_tag_de');}
				if (isset($_POST['am_associate_tag_jp']) && trim($_POST['am_associate_tag_jp'])) { update_option('flybx_locale_tag_jp', $am_associate_tag_jp = trim($_POST['am_associate_tag_jp'])); } 
				else { delete_option('flybx_locale_tag_jp');}
				if (isset($_POST['am_associate_tag_fr']) && trim($_POST['am_associate_tag_fr'])) { update_option('flybx_locale_tag_fr', $am_associate_tag_fr = trim($_POST['am_associate_tag_fr'])); } 
				else { delete_option('flybx_locale_tag_fr');}
				if (isset($_POST['am_associate_tag_ca']) && trim($_POST['am_associate_tag_ca'])) { update_option('flybx_locale_tag_ca', $am_associate_tag_ca = trim($_POST['am_associate_tag_ca'])); } 
				else { delete_option('flybx_locale_tag_ca');}
				if (isset($_POST['am_associate_tag_it']) && trim($_POST['am_associate_tag_it'])) { update_option('flybx_locale_tag_it', $am_associate_tag_it = trim($_POST['am_associate_tag_it'])); } 
				else { delete_option('flybx_locale_tag_it');}
				if (isset($_POST['am_associate_tag_cn']) && trim($_POST['am_associate_tag_cn'])) { update_option('flybx_locale_tag_cn', $am_associate_tag_cn = trim($_POST['am_associate_tag_cn'])); } 
				else { delete_option('flybx_locale_tag_cn');}
				if (isset($_POST['am_associate_tag_es']) && trim($_POST['am_associate_tag_es'])) { update_option('flybx_locale_tag_es', $am_associate_tag_es = trim($_POST['am_associate_tag_es'])); } 
				else { delete_option('flybx_locale_tag_es');}
			}
			elseif ($tab == 'wpms')
			{
				if (isset($_POST['flybx_wpms_apply_to_all']) && trim($_POST['flybx_wpms_apply_to_all'])) {
					flybx_wpms_apply_to_all();
				}
				
				if (isset($_POST['flybx_default_wpms_blog_id']) && trim($_POST['flybx_default_wpms_blog_id']) && (is_numeric($_POST['flybx_default_wpms_blog_id']) || $_POST['flybx_default_wpms_blog_id'] == 'none')) {
					flybx_wpms_save_default_blog_id($_POST['flybx_default_wpms_blog_id']);
				}				
			}

			
		}
		
	}
	else
	{
		if ($tab == 'important_stuff')
		{
			$flybx_amzn_active = flybx_get_option('flybx_amzn_active');
			$flybx_unsupported_country_default = flybx_get_option('flybx_unsupported_country_default');
			$am_key_id = get_option('flybx_am_key_id');
			$am_access_key = get_option('flybx_am_access_key');
			$am_associate_locale = get_option('flybx_am_associate_locale');
			
			if ($am_associate_locale == '') $am_associate_locale = 'us';
			
			if ($am_associate_locale == 'us') $am_associate_tag = get_option('flybx_am_associate_tag');
			if ($am_associate_locale == 'uk') $am_associate_tag = get_option('flybx_locale_tag_uk');
			if ($am_associate_locale == 'de') $am_associate_tag = get_option('flybx_locale_tag_de');
			if ($am_associate_locale == 'jp') $am_associate_tag = get_option('flybx_locale_tag_jp');
			if ($am_associate_locale == 'fr') $am_associate_tag = get_option('flybx_locale_tag_fr');
			if ($am_associate_locale == 'ca') $am_associate_tag = get_option('flybx_locale_tag_ca');
			if ($am_associate_locale == 'it') $am_associate_tag = get_option('flybx_locale_tag_it');
			if ($am_associate_locale == 'cn') $am_associate_tag = get_option('flybx_locale_tag_cn');
			if ($am_associate_locale == 'es') $am_associate_tag = get_option('flybx_locale_tag_es');
			
			$am_searchindex = get_option('flybx_am_searchindex');
			$flybx_active = get_option('flybx_active');
			
			$epn_enabled = flybx_get_option('epn_enabled');
			$epn_campaign_id = flybx_get_option('epn_campaign_id');
			$epn_custom_id = flybx_get_option('epn_custom_id');
		}
		elseif ($tab == 'advanced')
		{
			/*$flybx_serponly = get_option('flybx_serponly');
			$flybx_sensitivity = get_option('flybx_sensitivity');
			$flybx_loggedin_hide = get_option('flybx_loggedin_hide');
			$flybx_posttypes_str = get_option('flybx_posttypes');
			$flybx_posttypes = explode(',', $flybx_posttypes_str);
			$flybx_pops_per_user = get_option('flybx_pops_per_user');
			$flybx_default_behavior = get_option('flybx_default_behavior');
			$flybx_unbounce_enabled = get_option('flybx_unbounce_enabled');
			$flybx_unbounce_delay = get_option('flybx_unbounce_delay');
			$flybx_mouse_trigger_disabled = flybx_get_option('flybx_mouse_trigger_disabled');
			$flybx_trapped_trigger_enabled = flybx_get_option('flybx_trapped_trigger_enabled');
			$flybx_trapped_trigger_msg = flybx_get_option('flybx_trapped_trigger_msg');
			$flybx_trapped_trigger_msg = stripslashes($flybx_trapped_trigger_msg);*/
			
			$flybx_skip_keywords = flybx_get_option('flybx_skip_keywords');
			if ($flybx_skip_keywords === FALSE)
			{
				$flybx_skip_keywords_arr = flybx_get_default_skip_keywords();
				$flybx_skip_keywords = implode("\n", $flybx_skip_keywords_arr);
			}
			else
			{
				$flybx_skip_keywords_arr = explode(',', $flybx_skip_keywords);
				$flybx_skip_keywords = str_replace(",", "\n", $flybx_skip_keywords);
			}
			$flybx_skip_keywords = stripslashes($flybx_skip_keywords);
			
			$flybx_kw_sources = array();
			$flybx_kw_sources_str = flybx_get_option('flybx_kw_sources');
			if (strlen($flybx_kw_sources_str) > 0)
			{
				$flybx_kw_sources = explode(',', $flybx_kw_sources_str);
			}
			$flybx_fallback_keywords = get_option('flybx_fallback_keywords');
			$flybx_min_kw_length = flybx_get_option('flybx_min_kw_length');

			$categories = get_categories();
			$flybx_cat_kws = array();
			foreach($categories as $curr_cat)
			{
				$cat_kw_check = get_option('flybx_cat_kws_'.$curr_cat->term_id);

				if ($cat_kw_check !== FALSE)
				{
					$flybx_cat_kws[$curr_cat->term_id] = $cat_kw_check;
				}
				else
				{
					$flybx_cat_kws[$curr_cat->term_id] = '';
				}
			}
			
			$flybx_amzn_disabled_categories = array();
			$flybx_amzn_disabled_categories_check = get_option('flybx_amzn_disabled_categories');
			if ($flybx_amzn_disabled_categories_check !== FALSE && flybx_module_installed('amzn'))
			{
				$flybx_amzn_disabled_categories_check_arr = explode(',', $flybx_amzn_disabled_categories_check);
				if (count($flybx_amzn_disabled_categories_check_arr) > 0)
				{
					$flybx_amzn_disabled_categories = $flybx_amzn_disabled_categories_check_arr;
				}
			}
			$flybx_epn_disabled_categories = array();
			$flybx_epn_disabled_categories_check = get_option('flybx_epn_disabled_categories');
			if ($flybx_epn_disabled_categories_check !== FALSE && flybx_module_installed('epn'))
			{
				$flybx_epn_disabled_categories_check_arr = explode(',', $flybx_epn_disabled_categories_check);
				if (count($flybx_epn_disabled_categories_check_arr) > 0)
				{
					$flybx_epn_disabled_categories = $flybx_epn_disabled_categories_check_arr;
				}
			}

			$flybx_posttypes_str = get_option('flybx_posttypes');
			$flybx_posttypes = explode(',', $flybx_posttypes_str);
			
			$flybx_devicetypes_str = get_option('flybx_devicetypes');
			$flybx_devicetypes = explode(',', $flybx_devicetypes_str);

			//$flybx_reviewson = flybx_get_option('flybx_reviewson');
			$flybx_show_promo_msgs = flybx_get_option('flybx_show_promo_msgs', is_multisite());
			$flybx_path_to_geoip_dat = flybx_get_option('flybx_path_to_geoip_dat');
			$flybx_domoutline = flybx_get_option('flybx_domoutline');
			$flybx_visitor_log_days = flybx_get_option('flybx_visitor_log_days');
			$flybx_cache_hours = flybx_24h_max(flybx_get_option('flybx_cache_hours'));
			$flybx_unsupported_country_default = flybx_get_option('flybx_unsupported_country_default');
		}
		elseif ($tab == 'amazon')
		{
			if (isset($flybx_addons) && is_array($flybx_addons) && in_array('amzn_cart', $flybx_addons))
			{
				$flybx_amzn_cart_enabled = flybx_get_option('amzn_cart_enabled');
				$flybx_amzn_cart_btn_text_3prods = flybx_get_option('amzn_cart_btn_text_3prods');
			}
			
			$am_key_id = get_option('flybx_am_key_id');
			$am_access_key = get_option('flybx_am_access_key');
			$am_associate_tag = get_option('flybx_am_associate_tag');
			
			$am_associate_tag_uk = get_option('flybx_locale_tag_uk');
			$am_associate_tag_de = get_option('flybx_locale_tag_de');
			$am_associate_tag_jp = get_option('flybx_locale_tag_jp');
			$am_associate_tag_fr = get_option('flybx_locale_tag_fr');
			$am_associate_tag_ca = get_option('flybx_locale_tag_ca');
			$am_associate_tag_it = get_option('flybx_locale_tag_it');
			$am_associate_tag_cn = get_option('flybx_locale_tag_cn');
			$am_associate_tag_es = get_option('flybx_locale_tag_es');
			
			$am_searchindex = get_option('flybx_am_searchindex');
			$skip_noimage = get_option('flybx_skip_noimage');
			$skip_asins = get_option('flybx_skip_asins');
		}
		elseif ($tab == 'wpms')
		{
			$flybx_default_wpms_blog_id = flybx_wpms_get_default_blog_id();
		}
	
	}

	if ( !empty($_POST ) && '' == $error && $tab != 'appearance') {
		echo '<div id="message" class="updated fade"><p><strong>'
		. __('Settings saved.') ;
		if (isset($flybx_additional_success) && $flybx_additional_success != '')
		{
			echo "<br />".$flybx_additional_success;
		}
		echo '</strong></p></div>';
		if (isset($flybx_wpfooter_warning) && $flybx_wpfooter_warning != '')
		{
			echo '<div id="message" class="error"><p><strong>'
		. __($flybx_wpfooter_warning) . '</strong></p></div>';
		}
	}

	
	
	

	echo '<div class="wrap"><img src="'.plugin_dir_url( __FILE__ ).'images/'.flybx_branding_img().'" style="display: block; float: right;" /><h2>' . sprintf(__('%s Settings', $flybx_plugin_slug), $flybx_plugin_name) . '</h2>';
	
	
		$tabs = array(
			'important' => 'Important Stuff',

			);
		
		$tabs['appearance'] = 'Appearance';
		if (flybx_module_installed('amzn'))	$tabs['amazon'] = 'Amazon';
		$tabs['language'] = 'Language';
		$tabs['advanced'] = 'Advanced';
		
		if (defined('MULTISITE') && (MULTISITE === TRUE || MULTISITE == 1) && flybx_get_option('license') == 'premium_unlimited')
		{
			$tabs['wpms'] = __('WPMS Settings', $flybx_plugin_slug);
		}

		echo '<h2 class="nav-tab-wrapper">';

		if ( isset( $redir_tab ) && array_key_exists( $redir_tab, $tabs ) ) {
			$current = $redir_tab;
		} elseif ( isset( $_GET['tab'] ) && array_key_exists( $_GET['tab'], $tabs ) ) {
			$current = $_GET['tab'];
		} else {
			$keys = array_keys( $tabs );
			$current = array_shift( $keys );
		}

		foreach ( $tabs as $callback => $text ) {
			$class = ' class="nav-tab '.($text == 'Appearance'?'flybx_appearance_tab':'').'"';

			if ( $current == $callback )
				$class = ' class="nav-tab nav-tab-active"';

			$href = add_query_arg( array( 'tab' => $callback, 's' => false, 'paged' => false, 'post_mime_type' => false, 'm' => false ) );
			$href = remove_query_arg( 'isocode', $href );
			$href = remove_query_arg( 'flybx_tour', $href );
			$href = wp_nonce_url( $href, "tab-$callback" );
			$link = "<a href='" . esc_url( $href ) . "'$class>$text</a>";

			echo $link;
		}
		echo '</h2>';

	?>
	<?php if ($tab == 'important_stuff'): ?>
		<?php flybx_prepare_postboxes(); ?>
		
		<form method="post" action="admin.php?page=flybx-config<?php if (isset($_GET['flybx_tour']) && $_GET['flybx_tour'] == '2') { echo '&flybx_tour=5';}; ?>" id="important_stuff_form" name="important_stuff_form" >
		<table class="form-table" style="width:750px;">
			<tr><td class="reg black" colspan="2" noWrap="noWrap"><?php _e('These settings are required for the plugin to work. If you have any questions check out our <a href="http://www.pluginsbyigor.com/azon-flybox-faq/" target="_blank">FAQ</a>', $flybx_plugin_slug);?></td></tr>
			<?php if (strlen($error) > 0): ?>
				<tr><td class="reg" colspan="2" style="color:red;" align="left"><?=$error;?></td></tr>
			<?php endif; ?>
			<tr><td colspan="2">
				<div class="metabox-holder">
					<div id="enable_and_country" class="postbox">
						<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $flybx_plugin_slug ); ?>"><br /></div>
						<h3 class="hndle"><?php echo $flybx_plugin_name; ?></h3>
						<div class="inside">
							<table class="form-table" style="width:auto;">			
								<tr class="form-field"><th style="width:150px;"><label for="flybx_active"><?php _e('Enable Plugin', $flybx_plugin_slug);?>:</label></th>
									<td>
										<select name="flybx_active" id="flybx_active">
											<option value="0"><?php _e('Disabled', $flybx_plugin_slug);?></option>
											<option value="1" <?=$flybx_active == 1?'selected':'';?>><?php _e('Enabled', $flybx_plugin_slug);?></option>
										</select>
									</td></tr>
								<tr class="form-field"><th style="width:150px;"><label for="flybx_unsupported_country_default"><?php _e('If country not supported then show', $flybx_plugin_slug); ?>:</label></th>
								<td>									
									<select name="flybx_unsupported_country_default" id="flybx_unsupported_country_default">
										<option value="none" <?=$flybx_unsupported_country_default === FALSE || $flybx_unsupported_country_default == 'none'?'selected':'';?>><?php _e('Nothing', $flybx_plugin_slug); ?> &nbsp; </option>
										<option value="us" <?=$flybx_unsupported_country_default == 'us'?'selected':'';?>><?php _e('US listings', $flybx_plugin_slug); ?> &nbsp; </option>
										<option value="uk" <?=$flybx_unsupported_country_default == 'uk'?'selected':'';?>><?php _e('UK listings', $flybx_plugin_slug); ?> &nbsp; </option>
										<option value="ca" <?=$flybx_unsupported_country_default == 'ca'?'selected':'';?>><?php _e('CA listings', $flybx_plugin_slug); ?> &nbsp; </option>
										<option value="de" <?=$flybx_unsupported_country_default == 'de'?'selected':'';?>><?php _e('DE listings', $flybx_plugin_slug); ?> &nbsp; </option>
										<option value="fr" <?=$flybx_unsupported_country_default == 'fr'?'selected':'';?>><?php _e('FR listings', $flybx_plugin_slug); ?> &nbsp; </option>
										<option value="it" <?=$flybx_unsupported_country_default == 'it'?'selected':'';?>><?php _e('IT listings', $flybx_plugin_slug); ?> &nbsp; </option>
										<option value="es" <?=$flybx_unsupported_country_default == 'es'?'selected':'';?>><?php _e('ES listings', $flybx_plugin_slug); ?> &nbsp; </option>
									</select>
									<span class="description"><?php _e('If user\'s country not supported do this (set this to your main Amazon country)', $flybx_plugin_slug); ?></span>
								</td></tr>
							</table>
						</div>
					</div>
				</div>
				
			<?php if (flybx_module_installed('amzn')): ?>
				<div class="metabox-holder">
					<div class="postbox" id="avads_amz_quick_settings">
						<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $flybx_plugin_slug); ?>"><br /></div>
						<h3 class="hndle"><?php _e('Amazon Quick Settigs', $flybx_plugin_slug); ?></h3>
						<div class="inside">
							<table class="form-table" style="width:auto;">
								
								<tr class="form-field"><th style="width:150px;"><label for="flybx_amzn_active"><?php _e('Enable Amazon', $flybx_plugin_slug); ?>:</label></th>
									<td>
										<select name="flybx_amzn_active" id="flybx_amzn_active">
											<option value="0" ><?php _e('Disabled', $flybx_plugin_slug); ?></option>
											<option value="1" <?=$flybx_amzn_active === FALSE || $flybx_amzn_active == '1'?'selected':'';?>><?php _e('Enabled', $flybx_plugin_slug); ?></option>
										</select>
									</td></tr>
								
								<tr class="form-field"><th style="width:150px;"><label for="am_key_id"><?php _e('AWS Access Key ID', $flybx_plugin_slug); ?>:</label></th>
									<td><input type="text" name="am_key_id" value="<?=$am_key_id;?>" id="am_key_id" size="25" style="width:220px;" />  <a href="<?php _e('http://www.pluginsbyigor.com/faqs/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/', $flybx_plugin_slug); ?>" title="<?php esc_attr_e('Click for Help', $flybx_plugin_slug); ?>" target="_blank">?</a> | <a href="<?php _e('https://affiliate-program.amazon.com/gp/flex/advertising/api/sign-in.html', $flybx_plugin_slug); ?>" target="_blank"><?php _e('Sign Up', $flybx_plugin_slug); ?></a></td></tr>
								
								

									
								<tr class="form-field"><th style="width:150px;"><label for="am_access_key"><?php _e('AWS Secret Access Key', $flybx_plugin_slug); ?>:</label></th>
									<td><input type="text" name="am_access_key" value="<?=$am_access_key;?>" id="am_access_key" size="25" style="width:220px;" />  <a href="<?php _e('http://www.pluginsbyigor.com/faqs/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/', $flybx_plugin_slug); ?>" title="<?php esc_attr_e('Click for Help', $flybx_plugin_slug); ?>" target="_blank">?</a></td></tr>
									
								
									
								<tr class="form-field"><th style="width:150px;"><label for="am_associate_tag"><?php _e('Amazon Associate Tag', $flybx_plugin_slug); ?>:</label></th>
									<td><input type="text" name="am_associate_tag" value="<?=$am_associate_tag;?>" id="am_associate_tag" size="25" style="width:220px;" />  <a href="<?php _e('http://www.pluginsbyigor.com/faqs/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/', $flybx_plugin_slug); ?>" title="<?php esc_attr_e('Click for Help', $flybx_plugin_slug); ?>" target="_blank">?</a> | <a href="<?php _e('https://affiliate-program.amazon.com', $flybx_plugin_slug); ?>" target="_blank"><?php _e('Sign Up', $flybx_plugin_slug); ?></a></td></tr>
								
								<tr class="form-field"><th style="width:150px;"><label for="am_associate_locale"><?php _e('Amazon Associate Locale', $flybx_plugin_slug); ?>:</label></th>
									<td>
									<select name="am_associate_locale" id="am_associate_locale" style="width:220px;" >
										<option value="us" <?=$am_associate_locale == 'us'?'selected':'';?>><?php _e('US', $flybx_plugin_slug); ?></option>
										<option value="uk" <?=$am_associate_locale == 'uk'?'selected':'';?>><?php _e('UK', $flybx_plugin_slug); ?></option>
										<option value="de" <?=$am_associate_locale == 'de'?'selected':'';?>><?php _e('DE', $flybx_plugin_slug); ?></option>
										<option value="jp" <?=$am_associate_locale == 'jp'?'selected':'';?>><?php _e('JP', $flybx_plugin_slug); ?></option>
										<option value="fr" <?=$am_associate_locale == 'fr'?'selected':'';?>><?php _e('FR', $flybx_plugin_slug); ?></option>
										<option value="ca" <?=$am_associate_locale == 'ca'?'selected':'';?>><?php _e('CA', $flybx_plugin_slug); ?></option>
										<option value="it" <?=$am_associate_locale == 'it'?'selected':'';?>><?php _e('IT', $flybx_plugin_slug); ?></option>
										<option value="cn" <?=$am_associate_locale == 'cn'?'selected':'';?>><?php _e('CN', $flybx_plugin_slug); ?></option>
										<option value="es" <?=$am_associate_locale == 'es'?'selected':'';?>><?php _e('ES', $flybx_plugin_slug); ?></option>
									</select> <?php _e('You can add more in Amazon settings tab', $flybx_plugin_slug); ?>
									</td>
								</tr>
									
								<tr class="form-field"><th style="width:150px;"><label for="am_searchindex"><?php _e('Amazon Search Index', $flybx_plugin_slug); ?>:</label></th>
								<td>
									<select name="am_searchindex" id="am_searchindex">
										<?php foreach($am_indexes as $am_index): ?>
											<option value="<?=$am_index;?>" <?=($am_searchindex == $am_index?'selected':'');?>><?=$am_index;?> &nbsp;</option>
										<?php endforeach; ?>
									</select> <?php _e('Main category to pull Amazon products from.', $flybx_plugin_slug); ?>
								</td></tr>							
								
							</table>
						</div>
					</div>
				</div>	
			<?php endif; ?>


			<?php if (flybx_module_installed('epn')): ?>							
				<div class="metabox-holder">
					<div class="postbox">
						<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $flybx_plugin_slug); ?>"><br /></div>
						<h3 class="hndle"><?php _e('ePN Quick Settigs', $flybx_plugin_slug); ?></h3>
						<div class="inside">
							<table class="form-table" style="width:auto;">
								
								<tr class="form-field"><th style="width:150px;"><label for="flybx_active"><?php _e('Enable ePN', $flybx_plugin_slug); ?>:</label></th>
									<td>
										<select name="epn_enabled" id="epn_enabled">
											<option value="0" ><?php _e('Disabled', $flybx_plugin_slug); ?></option>
											<option value="1" <?=$epn_enabled === FALSE || $epn_enabled == '1'?'selected':'';?>><?php _e('Enabled', $flybx_plugin_slug); ?></option>
										</select>
									</td></tr>
								
								<tr class="form-field"><th style="width:150px;"><label for="epn_campaign_id"><?php _e('Campaign ID', $flybx_plugin_slug); ?>:</label></th>
								<td><input type="text" name="epn_campaign_id" value="<?=$epn_campaign_id;?>" id="epn_campaign_id" size="25" style="width:220px;" /> <br /><span class="description"><?php _e('used to turn product links into your affiliate links (required)', $flybx_plugin_slug); ?></span> </td></tr>
							
								<tr class="form-field"><th style="width:150px;"><label for="epn_custom_id"><?php _e('Custom ID', $flybx_plugin_slug); ?>:</label></th>
									<td><input type="text" name="epn_custom_id" value="<?=$epn_custom_id;?>" id="epn_custom_id" size="25" style="width:220px;" /> <span class="description"><?php _e('for tracking (optional)', $flybx_plugin_slug); ?></span> </td></tr>
						
							</table>
						</div>
					</div>
				</div>	
			<?php endif; ?>
				
			</td></tr>
		</table>
		
		<table>
		<tr><td>&nbsp;</td><td class="submit"><input type="submit" name="btnsubmit" value="<?php esc_attr_e('Save Settings', $flybx_plugin_slug); ?>" id="flybx_save_important_settings" class="button-primary" /></td></tr>
		</table>
		
		<input type="hidden" name="flybx_hidden_patch_footer" id="flybx_hidden_patch_footer" value="no" />
		<input type="hidden" name="flybx_form_submitted" value="yes" />
		</form>
		
	<?php elseif ($tab == 'amazon'): ?>
		<?php flybx_prepare_postboxes(); ?>
		<form method="post" action="" >
		<table class="form-table" style="width:750px;">
			<tr><td class="reg black" colspan="2" noWrap="noWrap"><?php _e('You can set your plugin to work with different locales (countries). If you have any questions check out our <a href="http://www.pluginsbyigor.com/azon-flybox-faq/" target="_blank">FAQ</a>', $flybx_plugin_slug); ?></td></tr>
			<?php if (strlen($error)): ?>
				<tr><td class="reg" colspan="2" style="color:red;" align="left"><?=$error;?></td></tr>
			<?php endif; ?>
			<tr><td colspan="2">
			<div class="metabox-holder">
			
				<?php if (isset($flybx_addons) && is_array($flybx_addons) && in_array('amzn_cart', $flybx_addons)): ?>
					<?php
					if ($flybx_amzn_cart_btn_text_3prods === FALSE) $flybx_amzn_cart_btn_text_3prods = __('Add To Cart', $flybx_plugin_slug);
					if ($flybx_amzn_cart_btn_text_1prod === FALSE) $flybx_amzn_cart_btn_text_1prod = __('Add To Cart', $flybx_plugin_slug);
					?>
					<div id="submitdiv" class="postbox">
						<div class="handlediv" title="<?php esc_attr_e('Click to toggle', $flybx_plugin_slug); ?>"><br /></div>
						<h3 class="hndle amzn_cart_hndle"><?php _e('Amazon 90 Days Cookie Add-On (Plus+ Feature)', $flybx_plugin_slug); ?></h3>
						<div class="inside">
							<table class="form-table" style="width:auto;">
							
								<tr class="form-field"><th style="width:150px;"><label for="flybx_amzn_cart_enabled"><?php _e('90 Days Cookie Enabled', $flybx_plugin_slug); ?>:</label></th>
									<td>
										<select name="flybx_amzn_cart_enabled" id="flybx_amzn_cart_enabled">
											<option value="yes" <?=($flybx_amzn_cart_enabled !== FALSE && $flybx_amzn_cart_enabled == 'yes'?'selected':'');?>><?php _e('Enabled', $flybx_plugin_slug); ?></option>
											<option value="no" <?=($flybx_amzn_cart_enabled === FALSE || $flybx_amzn_cart_enabled == 'no'?'selected':'');?>><?php _e('Disabled', $flybx_plugin_slug); ?> &nbsp;&nbsp;</option>
										</select>
									</td></tr>
								
								<tr class="form-field"><th style="width:150px;"><label for="flybx_amzn_cart_btn_text_3prods"><?php _e('"Add To Cart" text', $flybx_plugin_slug); ?>:</label></th>
									<td><input type="text" name="flybx_amzn_cart_btn_text_3prods" value="<?=$flybx_amzn_cart_btn_text_3prods;?>" id="flybx_amzn_cart_btn_text_3prods" size="25" style="width:220px;" />  <span class="description"></span></td></tr>
							
								
							</table>
						</div>
					</div>
					
					<style>
					.amzn_cart_hndle {
					background-color: #166b94!important;
					background-image: none!important;
					color: #fff!important;
					text-shadow: 0 -1px 0 #11506F!important;
					}
					</style>
				
				<?php endif; ?>
				
					<style>
					.flybx_hide {
					display: none;
					}
					</style>
				
				<div id="submitdiv" class="postbox">
					<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $flybx_plugin_slug); ?>"><br /></div>
					<h3 class="hndle"><?php _e('AWS Settings', $flybx_plugin_slug); ?></h3>
					<div class="inside">
						<table class="form-table" style="width:auto;">
						
							<tr class="form-field"><th style="width:150px;"><label for="am_key_id"><?php _e('AWS Access Key ID', $flybx_plugin_slug); ?>:</label></th>
								<td><input type="text" name="am_key_id" value="<?=$am_key_id;?>" id="am_key_id" size="25" style="width:220px;" /> <?php _e('<a href="http://www.pluginsbyigor.com/faqs/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/" title="Click for Help" target="_blank">?</a> | <a href="https://affiliate-program.amazon.com/gp/flex/advertising/api/sign-in.html" target="_blank">Sign Up</a>', $flybx_plugin_slug); ?></td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="am_access_key"><?php _e('AWS Secret Access Key', $flybx_plugin_slug); ?>:</label></th>
								<td><input type="text" name="am_access_key" value="<?=$am_access_key;?>" id="am_access_key" size="25" style="width:220px;" />  <?php _e('<a href="http://www.pluginsbyigor.com/faqs/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/" title="Click for Help" target="_blank">?</a>', $flybx_plugin_slug); ?></td></tr>
						</table>
					</div>
				</div>
				
				
				<div id="submitdiv" class="postbox">
					<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $flybx_plugin_slug); ?>"><br /></div>
					<h3 class="hndle"><?php _e('International', $flybx_plugin_slug); ?></h3>
					<div class="inside">
						<table class="form-table" style="width:auto;">	
							<tr class="form-field">
								<th style="width:150px;"><label for="am_associate_tag"><?php _e('US Amazon Associate Tag', $flybx_plugin_slug); ?>:</label><br />
									  <?php _e('<a href="http://www.pluginsbyigor.com/faqs/whats-amazon-key-id-amazon-access-key-and-amazon-associate-tag/" title="Click for Help" target="_blank">Help</a> | <a href="https://affiliate-program.amazon.com" target="_blank">Sign Up</a>', $flybx_plugin_slug); ?>
								</th>
								<td>
									<div style="float: left; width: 130px;"><input type="text" name="am_associate_tag" value="<?=$am_associate_tag;?>" id="am_associate_tag" size="25" style="width:120px;" onkeyup="javascript: if (this.value == '') {jQuery('.amzn_us_node_parent_0').addClass('flybx_hide'); jQuery('.amzn_us_node_parent_catlbl').addClass('flybx_hide');} else {jQuery('.amzn_us_node_parent_0').removeClass('flybx_hide'); jQuery('.amzn_us_node_parent_catlbl').removeClass('flybx_hide');}" /></div>
									<?php if ($am_key_id !== FALSE): ?>
									<div style="width: 110px; float: left; padding: 0 0 0 20px;" class="amzn_us_node_parent_catlbl <?=$am_associate_tag === FALSE || $am_associate_tag == ''?'flybx_hide':'';?>">
										<?php echo  sprintf(__('%s Category Filter (optional)', $flybx_plugin_slug), 'US'); ?>:<br />
									</div>
									<div style="float: left;">
										<div id="amzn_us_category_0_wrap" class="amzn_us_node_parent_0 <?=$am_associate_tag === FALSE || $am_associate_tag == ''?'flybx_hide':'';?>">
											<?php echo flybx_amzn_cats_select('us', 0, 0, flybx_country_selected_cats('us')); ?>											
										</div>
										<div class="amzn_us_category_loading_msg"></div>
									</div>
									<?php endif; ?>
								</td></tr>
							

							<tr class="form-field">
								<th style="width:150px;"><label for="am_associate_tag_uk"><?php _e('UK Associate Tag', $flybx_plugin_slug); ?>:</label><br />
									(<?php _e('optional', $flybx_plugin_slug); ?>) <a href="https://affiliate-program.amazon.co.uk/" target="_blank"><?php _e('Sign Up', $flybx_plugin_slug); ?></a>								
								</th>
								<td>
									<div style="float: left; width: 130px;"><input type="text" name="am_associate_tag_uk" value="<?=$am_associate_tag_uk;?>" id="am_associate_tag_uk" size="25" style="width:120px;" onkeyup="javascript: if (this.value == '') {jQuery('.amzn_uk_node_parent_0').addClass('flybx_hide'); jQuery('.amzn_uk_node_parent_catlbl').addClass('flybx_hide');} else {jQuery('.amzn_uk_node_parent_0').removeClass('flybx_hide'); jQuery('.amzn_uk_node_parent_catlbl').removeClass('flybx_hide');}" /></div>
									<?php if ($am_key_id !== FALSE): ?>
										<div style="width: 110px; float: left; padding: 0 0 0 20px;" class="amzn_uk_node_parent_catlbl <?=$am_associate_tag_uk === FALSE || $am_associate_tag_uk == ''?'flybx_hide':'';?>">
											<?php echo  sprintf(__('%s Category Filter (optional)', $flybx_plugin_slug), 'UK'); ?>:<br />
										</div>
										<div style="float: left;">
											<div id="amzn_uk_category_0_wrap" class="amzn_uk_node_parent_0 <?=$am_associate_tag_uk === FALSE || $am_associate_tag_uk == ''?'flybx_hide':'';?>">
												
												<?php echo flybx_amzn_cats_select('uk', 0, 0, flybx_country_selected_cats('uk')); ?>											
											</div>
											<div class="amzn_uk_category_loading_msg"></div>
										</div>
									<?php endif; ?>
								</td></tr>
							<tr class="form-field">
								<th style="width:150px;"><label for="am_associate_tag_ca">CA Associate Tag:</label><br />
									 (<?php _e('optional', $flybx_plugin_slug); ?>) <a href="https://associates.amazon.ca/" target="_blank"><?php _e('Sign Up', $flybx_plugin_slug); ?></a>
								</th>
								<td>
									<div style="float: left; width: 130px;"><input type="text" name="am_associate_tag_ca" value="<?=$am_associate_tag_ca;?>" id="am_associate_tag_ca" size="25" style="width:120px;" onkeyup="javascript: if (this.value == '') {jQuery('.amzn_ca_node_parent_0').addClass('flybx_hide'); jQuery('.amzn_ca_node_parent_catlbl').addClass('flybx_hide');} else {jQuery('.amzn_ca_node_parent_0').removeClass('flybx_hide'); jQuery('.amzn_ca_node_parent_catlbl').removeClass('flybx_hide');}" /></div>
									<?php if ($am_key_id !== FALSE): ?>
										<div style="width: 110px; float: left; padding: 0 0 0 20px;" class="amzn_ca_node_parent_catlbl <?=$am_associate_tag_ca === FALSE || $am_associate_tag_ca == ''?'flybx_hide':'';?>">
											<?php echo  sprintf(__('%s Category Filter (optional)', $flybx_plugin_slug), 'CA'); ?>:
										</div>
										<div style="float: left;">
											<div id="amzn_ca_category_0_wrap" class="amzn_ca_node_parent_0 <?=$am_associate_tag_ca === FALSE || $am_associate_tag_ca == ''?'flybx_hide':'';?>">
												
												<?php echo flybx_amzn_cats_select('ca', 0, 0, flybx_country_selected_cats('ca')); ?>											
											</div>
											<div class="amzn_ca_category_loading_msg"></div>
										</div>
									<?php endif; ?>
								</td></tr>
							<tr class="form-field">
								<th style="width:150px;"><label for="am_associate_tag_de">DE Associate Tag:</label><br />
									 (<?php _e('optional', $flybx_plugin_slug); ?>) <a href="https://partnernet.amazon.de/" target="_blank"><?php _e('Sign Up', $flybx_plugin_slug); ?></a>
								</th>
								<td>
									<div style="float: left; width: 130px;"><input type="text" name="am_associate_tag_de" value="<?=$am_associate_tag_de;?>" id="am_associate_tag_de" size="25" style="width:120px;" onkeyup="javascript: if (this.value == '') {jQuery('.amzn_de_node_parent_0').addClass('flybx_hide'); jQuery('.amzn_de_node_parent_catlbl').addClass('flybx_hide');} else {jQuery('.amzn_de_node_parent_0').removeClass('flybx_hide'); jQuery('.amzn_de_node_parent_catlbl').removeClass('flybx_hide');}" /></div>
									<?php if ($am_key_id !== FALSE): ?>
										<div style="width: 110px; float: left; padding: 0 0 0 20px;" class="amzn_de_node_parent_catlbl <?=$am_associate_tag_de === FALSE || $am_associate_tag_de == ''?'flybx_hide':'';?>">
											<?php echo  sprintf(__('%s Category Filter (optional)', $flybx_plugin_slug), 'DE'); ?>:
										</div>
										<div style="float: left;">
											<div id="amzn_de_category_0_wrap" class="amzn_de_node_parent_0 <?=$am_associate_tag_de === FALSE || $am_associate_tag_de == ''?'flybx_hide':'';?>">												
												<?php echo flybx_amzn_cats_select('de', 0, 0, flybx_country_selected_cats('de')); ?>											
											</div>
											<div class="amzn_de_category_loading_msg"></div>
										</div>
									<?php endif; ?>
								</td></tr>							
							<tr class="form-field">
								<th style="width:150px;">
									<label for="am_associate_tag_fr">FR Associate Tag:</label><br />
									(<?php _e('optional', $flybx_plugin_slug); ?>) <a href="https://partenaires.amazon.fr/" target="_blank"><?php _e('Sign Up', $flybx_plugin_slug); ?></a>
								</th>
								<td>
									<div style="float: left; width: 130px;"><input type="text" name="am_associate_tag_fr" value="<?=$am_associate_tag_fr;?>" id="am_associate_tag_fr" size="25" style="width:120px;" onkeyup="javascript: if (this.value == '') {jQuery('.amzn_fr_node_parent_0').addClass('flybx_hide'); jQuery('.amzn_fr_node_parent_catlbl').addClass('flybx_hide');} else {jQuery('.amzn_fr_node_parent_0').removeClass('flybx_hide'); jQuery('.amzn_fr_node_parent_catlbl').removeClass('flybx_hide');}" /> </div>
									<?php if ($am_key_id !== FALSE): ?>
										<div style="width: 110px; float: left; padding: 0 0 0 20px;" class="amzn_fr_node_parent_catlbl <?=$am_associate_tag_fr === FALSE || $am_associate_tag_fr == ''?'flybx_hide':'';?>">
											<?php echo  sprintf(__('%s Category Filter (optional)', $flybx_plugin_slug), 'FR'); ?>:
										</div>
										<div style="float: left;">
											<div id="amzn_fr_category_0_wrap" class="amzn_fr_node_parent_0 <?=$am_associate_tag_fr === FALSE || $am_associate_tag_fr == ''?'flybx_hide':'';?>">												
												<?php echo flybx_amzn_cats_select('fr', 0, 0, flybx_country_selected_cats('fr')); ?>											
											</div>
											<div class="amzn_fr_category_loading_msg"></div>
										</div>
									<?php endif; ?>
										
								</td></tr>
							<tr class="form-field">
								<th style="width:150px;"><label for="am_associate_tag_it">IT Associate Tag:</label><br />
								 (<?php _e('optional', $flybx_plugin_slug); ?>) <a href="https://programma-affiliazione.amazon.it/" target="_blank"><?php _e('Sign Up', $flybx_plugin_slug); ?></a>								
								</th>
								<td>
									<div style="float: left; width: 130px;"><input type="text" name="am_associate_tag_it" value="<?=$am_associate_tag_it;?>" id="am_associate_tag_it" size="25" style="width:120px;" onkeyup="javascript: if (this.value == '') {jQuery('.amzn_it_node_parent_0').addClass('flybx_hide'); jQuery('.amzn_it_node_parent_catlbl').addClass('flybx_hide');} else {jQuery('.amzn_it_node_parent_0').removeClass('flybx_hide'); jQuery('.amzn_it_node_parent_catlbl').removeClass('flybx_hide');}" /></div>
									<?php if ($am_key_id !== FALSE): ?>
										<div style="width: 110px; float: left; padding: 0 0 0 20px;" class="amzn_it_node_parent_catlbl <?=$am_associate_tag_it === FALSE || $am_associate_tag_it == ''?'flybx_hide':'';?>">
											<?php echo  sprintf(__('%s Category Filter (optional)', $flybx_plugin_slug), 'IT'); ?>:
										</div>
										<div style="float: left;">
											<div id="amzn_it_category_0_wrap" class="amzn_it_node_parent_0 <?=$am_associate_tag_it === FALSE || $am_associate_tag_it == ''?'flybx_hide':'';?>">												
												<?php echo flybx_amzn_cats_select('it', 0, 0, flybx_country_selected_cats('it')); ?>											
											</div>
											<div class="amzn_it_category_loading_msg"></div>
										</div>
									<?php endif; ?>
								
								</td></tr>
							<tr class="form-field">
								<th style="width:150px;"><label for="am_associate_tag_es">ES Associate Tag:</label><br />
									 (<?php _e('optional', $flybx_plugin_slug); ?>) <a href="https://afiliados.amazon.es/" target="_blank"><?php _e('Sign Up', $flybx_plugin_slug); ?></a>								
								</th>
								<td>
									<div style="float: left; width: 130px;"><input type="text" name="am_associate_tag_es" value="<?=$am_associate_tag_es;?>" id="am_associate_tag_es" size="25" style="width:120px;" onkeyup="javascript: if (this.value == '') {jQuery('.amzn_es_node_parent_0').addClass('flybx_hide'); jQuery('.amzn_es_node_parent_catlbl').addClass('flybx_hide');} else {jQuery('.amzn_es_node_parent_0').removeClass('flybx_hide'); jQuery('.amzn_es_node_parent_catlbl').removeClass('flybx_hide');}" /></div>
									<?php if ($am_key_id !== FALSE): ?>
										<div style="width: 110px; float: left; padding: 0 0 0 20px;" class="amzn_es_node_parent_catlbl <?=$am_associate_tag_es === FALSE || $am_associate_tag_es == ''?'flybx_hide':'';?>">
											<?php echo  sprintf(__('%s Category Filter (optional)', $flybx_plugin_slug), 'ES'); ?>:
										</div>
										<div style="float: left;">
											<div id="amzn_es_category_0_wrap" class="amzn_es_node_parent_0 <?=$am_associate_tag_es === FALSE || $am_associate_tag_es == ''?'flybx_hide':'';?>">
												
												<?php echo flybx_amzn_cats_select('es', 0, 0, flybx_country_selected_cats('es')); ?>											
											</div>
											<div class="amzn_es_category_loading_msg"></div>
										</div>
									<?php endif; ?>
								</td></tr>
							<tr class="form-field">
								<th style="width:150px;"><label for="am_associate_tag_jp">JP Associate Tag:</label><br />
									 (<?php _e('optional', $flybx_plugin_slug); ?>) <a href="https://affiliate.amazon.co.jp/" target="_blank"><?php _e('Sign Up', $flybx_plugin_slug); ?></a>								
								</th>
								<td>
									<div style="float: left; width: 130px;"><input type="text" name="am_associate_tag_jp" value="<?=$am_associate_tag_jp;?>" id="am_associate_tag_jp" size="25" style="width:120px;" onkeyup="javascript: if (this.value == '') {jQuery('.amzn_jp_node_parent_0').addClass('flybx_hide'); jQuery('.amzn_jp_node_parent_catlbl').addClass('flybx_hide');} else {jQuery('.amzn_jp_node_parent_0').removeClass('flybx_hide'); jQuery('.amzn_jp_node_parent_catlbl').removeClass('flybx_hide');}" /></div>
									<?php if ($am_key_id !== FALSE): ?>
										<div style="width: 110px; float: left; padding: 0 0 0 20px;" class="amzn_jp_node_parent_catlbl <?=$am_associate_tag_jp === FALSE || $am_associate_tag_jp == ''?'flybx_hide':'';?>">
											<?php echo  sprintf(__('%s Category Filter (optional)', $flybx_plugin_slug), 'JP'); ?>:
										</div>
										<div style="float: left;">
											<div id="amzn_jp_category_0_wrap" class="amzn_jp_node_parent_0 <?=$am_associate_tag_jp === FALSE || $am_associate_tag_jp == ''?'flybx_hide':'';?>">												
												<?php echo flybx_amzn_cats_select('jp', 0, 0, flybx_country_selected_cats('jp')); ?>											
											</div>
											<div class="amzn_jp_category_loading_msg"></div>
										</div>
									<?php endif; ?>
								</td></tr>
							<tr class="form-field">
								<th style="width:150px;"><label for="am_associate_tag_cn">CN Associate Tag:</label><br />
									 (<?php _e('optional', $flybx_plugin_slug); ?>) <a href="https://associates.amazon.cn/" target="_blank"><?php _e('Sign Up', $flybx_plugin_slug); ?></a>								
								</th>
								<td>
									<div style="float: left; width: 130px;"><input type="text" name="am_associate_tag_cn" value="<?=$am_associate_tag_cn;?>" id="am_associate_tag_cn" size="25" style="width:120px;" onkeyup="javascript: if (this.value == '') {jQuery('.amzn_cn_node_parent_0').addClass('flybx_hide'); jQuery('.amzn_cn_node_parent_catlbl').addClass('flybx_hide');} else {jQuery('.amzn_cn_node_parent_0').removeClass('flybx_hide'); jQuery('.amzn_cn_node_parent_catlbl').removeClass('flybx_hide');}" /></div>
									<?php if ($am_key_id !== FALSE): ?>
										<div style="width: 110px; float: left; padding: 0 0 0 20px;" class="amzn_cn_node_parent_catlbl <?=$am_associate_tag_cn === FALSE || $am_associate_tag_cn == ''?'flybx_hide':'';?>">
											<?php echo  sprintf(__('%s Category Filter (optional)', $flybx_plugin_slug), 'CN'); ?>:
										</div>
										<div style="float: left;">
											<div id="amzn_cn_category_0_wrap" class="amzn_cn_node_parent_0 <?=$am_associate_tag_cn === FALSE || $am_associate_tag_cn == ''?'flybx_hide':'';?>">
												
												<?php echo flybx_amzn_cats_select('cn', 0, 0, flybx_country_selected_cats('cn')); ?>											
											</div>
											<div class="amzn_cn_category_loading_msg"></div>
										</div>
									<?php endif; ?>
								</td></tr>
							
						</table>
					</div>
				</div>
				
				<?php flybx_amzn_country_cats_javascript(); ?>

				
				<div id="submitdiv" class="postbox">
					<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $flybx_plugin_slug); ?>"><br /></div>
					<h3 class="hndle"><?php _e('Other', $flybx_plugin_slug); ?></h3>
					<div class="inside">
						<table class="form-table" style="width:auto;">		
							<tr class="form-field"><th style="width:150px;"><label for="am_searchindex"><?php _e('Amazon Search Category (fallback)', $flybx_plugin_slug); ?>:</label></th>
								<td>
									<select name="am_searchindex" id="am_searchindex">
										<?php foreach($am_indexes as $am_index): ?>
											<option value="<?=$am_index;?>" <?=($am_searchindex == $am_index?'selected':'');?>><?=$am_index;?> &nbsp;</option>
										<?php endforeach; ?>
									</select> <?php _e('Main category to pull Amazon products from.', $flybx_plugin_slug); ?>
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="skip_noimage"><?php _e('Skip Products with No Picture', $flybx_plugin_slug); ?>:</label></th>
								<td>
									<select name="skip_noimage" id="skip_noimage">
											<option value="0" <?=($skip_noimage == 0?'selected':'');?>><?php _e('No', $flybx_plugin_slug); ?> &nbsp;</option>
											<option value="1" <?=($skip_noimage == 1?'selected':'');?>><?php _e('Yes', $flybx_plugin_slug); ?> &nbsp;</option>
									</select>
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="skip_asins"><?php _e('Skip Products With ASINs', $flybx_plugin_slug); ?>:</label></th>
								<td>
									<input type="text" name="skip_asins" id="skip_asins" value="<?php echo $skip_asins; ?>" /><span class="description"><?php _e('Comma separated list of ASINs to exclude from templates.', $flybx_plugin_slug); ?></span>
								</td></tr>
						</table>
					</div>
				</div>
			
			</div>
			
			<table class="form-table" style="width:auto;">	
				<tr><td style="width: 150px;">&nbsp;</td><td class="submit"><input type="submit" name="btnsubmit" value="<?php esc_attr_e('Save Settings', $flybx_plugin_slug); ?>" class="button-primary" /></td></tr>
			</table>
			
			</td></tr>
		</table>

		</form>
	
	<?php elseif ($tab == 'language'): ?>	
		<?php
		require_once(dirname(__FILE__).'/app/controllers/sett_language.php');		
		?>	
	
	<?php elseif ($tab == 'appearance'): ?>	
		<?php
		require_once(dirname(__FILE__).'/app/controllers/sett_appearance.php');		
		?>	
		
	<?php elseif ($tab == 'wpms'): ?>
		<?php flybx_prepare_postboxes(); ?>
		<?php
		$flybx_curr_user = wp_get_current_user();
		?>
		<?php if (0 != $flybx_curr_user->ID): ?>
		<?php
		$flybx_blogs = get_blogs_of_user($flybx_curr_user->ID);
		$flybx_current_site = get_blog_details($blog_id);
		?>
		<form method="post" action="" >
		<table class="form-table" style="width:750px;">
			<tr><td class="reg black" colspan="2" noWrap="noWrap"><?php echo sprintf(__('You can apply current %s settings to all sites in your network and set default settings for use on future sites. <a href="http://www.pluginsbyigor.com/azon-flybox-faq/" target="_blank">FAQ</a>', $flybx_plugin_slug), $flybx_plugin_name); ?></td></tr>
			<?php if(strlen($error) > 0): ?>
				<tr><td class="reg" colspan="2" style="color:red;" align="left"><?=$error;?></td></tr>
			<?php endif; ?>
			<tr><td colspan="2">
				<div class="metabox-holder">
					<div id="submitdiv" class="postbox">
						<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $flybx_plugin_slug); ?>"><br /></div>
						<h3 class="hndle"><?php _e('General', $flybx_plugin_slug); ?></h3>
						<div class="inside">
							<table class="form-table" style="width:auto;">			
								<tr class="form-field"><th style="width:350px;"><label for="flybx_default_wpms_blog_id"><?php echo sprintf(__('New Sites should copy %s settings from this site', $flybx_plugin_slug), $flybx_plugin_name); ?>:</label></th>
									<td>
										<select name="flybx_default_wpms_blog_id" id="flybx_default_wpms_blog_id">
											<option value="none">-- <?php _e('Disabled', $flybx_plugin_slug); ?> --</option>
											<?php foreach($flybx_blogs as $loop_blog): ?>
												<option value="<?=$loop_blog->userblog_id;?>" <?=$flybx_default_wpms_blog_id == $loop_blog->userblog_id?'selected':'';?>><?=$loop_blog->blogname;?></option>
											<?php endforeach; ?>
										</select>
									</td></tr>
								
								<tr class="form-field"><th style="width:150px;"><label for="flybx_wpms_apply_to_all"><?php echo sprintf(__('Apply current %s settings of <strong>%s</strong> to all existing blogs', $flybx_plugin_slug), $flybx_plugin_name, $flybx_current_site->blogname); ?>:</label></th>
									<td>
										<select name="flybx_wpms_apply_to_all" id="flybx_wpms_apply_to_all">
											<option value="0"><?php _e('No', $flybx_plugin_slug); ?></option>
											<option value="1"><?php _e('Yes', $flybx_plugin_slug); ?></option>
										</select>
									</td></tr>
								
								<tr><td>&nbsp;</td><td class="submit"><input type="submit" name="btnsubmit" value="<?php esc_attr_e('Save Settings', $flybx_plugin_slug); ?>" class="button-primary" /></td></tr>
								
							</table>						
						</div>
					</div>
				</div>
			</td></tr>
		</table>

		</form>
		<?php endif; ?>
	
	<?php elseif ($tab == 'advanced'): ?>
		
		<?php flybx_prepare_postboxes(); ?>
		
		<div class="advanced_tab_wrap">
		
		<p><?php _e('You can change your plugin settings below. If you have any questions check out our <a target="_blank" href="http://www.pluginsbyigor.com/azon-flybox-faq/">FAQ</a>', $flybx_plugin_slug); ?></p>
		
		<?php if (isset($error) && strlen($error) > 0): ?>
			<div class="flybx_form_error"><?=$error;?></div>
		<?php endif; ?>
		
		<form method="post" action="" >
			
			<input type="submit" name="submit_all" value="submit all" style="display: none;" />
		
			<div class="metabox-holder">
				<?php /*<div id="submitdiv" class="postbox">
					<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $flybx_plugin_slug); ?>"><br /></div>
					<h3 class="hndle"><?php _e('General Pop-Up Settings', $flybx_plugin_slug); ?></h3>
					<div class="inside">
					
						<table class="form-table" style="width:auto;">				
							<tr class="form-field"><th style="width:150px;"><label for="flybx_serponly"><?php _e('SERP referrals only', $flybx_plugin_slug); ?>:</label></th>
								<td>
									<select name="flybx_serponly" id="flybx_serponly">
										<option value="0"><?php _e('No', $flybx_plugin_slug); ?> &nbsp; </option>
										<option value="1" <?=$flybx_serponly == 1?'selected':'';?>><?php _e('Yes', $flybx_plugin_slug); ?> &nbsp; </option>
									</select> <span class="description"><?php _e('If Yes - only show pops to users arrived from search engines directly', $flybx_plugin_slug); ?></span>
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="flybx_loggedin_hide"><?php _e('Show to Logged in Users', $flybx_plugin_slug); ?>:</label></th>
								<td>
									<select name="flybx_loggedin_hide" id="flybx_loggedin_hide">
										<option value="0"><?php _e('Yes', $flybx_plugin_slug); ?> &nbsp; </option>
										<option value="1" <?=$flybx_loggedin_hide == 1?'selected':'';?>><?php _e('No', $flybx_plugin_slug); ?> &nbsp; </option>					
									</select> <span class="description"><?php _e('Has no affect on admin user', $flybx_plugin_slug); ?></span>
								</td></tr>
							<tr class="form-field"><th style="width:150px;"><label for="flybx_sensitivity"><?php _e('Sensitivity', $flybx_plugin_slug); ?>:</label></th>
								<td>
									<select name="flybx_sensitivity" id="flybx_sensitivity">
										<option value="3" <?=$flybx_sensitivity == 3?'selected':'';?>>3 &nbsp; </option>
										<option value="4" <?=$flybx_sensitivity == 4?'selected':'';?>>4 &nbsp; </option>
										<option value="5" <?=$flybx_sensitivity == 5?'selected':'';?>>5 &nbsp; </option>
										<option value="6" <?=$flybx_sensitivity == 6?'selected':'';?>>6 &nbsp; </option>
										<option value="7" <?=$flybx_sensitivity == 7?'selected':'';?>>7 &nbsp; </option>
										<option value="8" <?=$flybx_sensitivity == 8?'selected':'';?>>8 &nbsp; </option>
										<option value="9" <?=$flybx_sensitivity == 9?'selected':'';?>>9 &nbsp; </option>
										<option value="10" <?=$flybx_sensitivity == 10?'selected':'';?>>10 &nbsp; </option>
									</select> <span class="description"><?php _e('If top 10 px of your pages have important links try using lower number here.', $flybx_plugin_slug); ?></span>
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="flybx_posttypes"><?php _e('Use on Post Types', $flybx_plugin_slug); ?>:</label></th>
								<td class="chkboxes">
									<?php foreach($post_types as $post_type): ?>
									<input type="checkbox" value="<?=$post_type;?>" name="flybx_posttypes[]" id="posttype_<?=$post_type;?>" style="width: 25px;" <?=(in_array($post_type, $flybx_posttypes)?'checked':'');?> /><label for="posttype_<?=$post_type;?>"><?=ucfirst($post_type);?></label><br />
									<?php endforeach; ?>
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="flybx_pops_per_user"><?php _e('Pop ups per user', $flybx_plugin_slug); ?>:</label></th>
								<td><input type="text" name="flybx_pops_per_user" value="<?=$flybx_pops_per_user;?>" id="flybx_pops_per_user" size="10" style="width:60px;" /></td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="flybx_default_behavior"><?php _e('Default Behavior', $flybx_plugin_slug); ?>:</label></th>
								<td>
									<select name="flybx_default_behavior" id="flybx_default_behavior">
										<option value="all" <?=$flybx_default_behavior == 'all'?'selected':'';?>><?php _e('Show on All Posts', $flybx_plugin_slug); ?> &nbsp; </option>
										<option value="manual" <?=$flybx_default_behavior == 'manual'?'selected':'';?>><?php _e('Show on Selected Posts', $flybx_plugin_slug); ?> &nbsp; </option>					
									</select>
								</td></tr>
							
							<tr><td>&nbsp;</td><td class="submit"><input type="submit" value="<?php _e('Save Settings', $flybx_plugin_slug); ?>" name="save_general" class="button-secondary" /></td></tr>
							
						</table>				
						
					</div>
				</div>
	
				<div id="submitdiv" class="postbox">
					<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $flybx_plugin_slug); ?>"><br /></div>
					<h3 class="hndle"><?php _e('Pop-Up Triggers', $flybx_plugin_slug); ?></h3>
					<div class="inside">
						<table class="form-table" style="width:auto;">	
							<tr class="form-field"><th style="width:150px;"><label for="flybx_mouse_trigger_disabled"><?php _e('Top page mouse-over', $flybx_plugin_slug); ?>:</label></th>
								<td>
									<select name="flybx_mouse_trigger_disabled" id="flybx_mouse_trigger_disabled">
										<option value="1"><?php _e('Disabled', $flybx_plugin_slug); ?> &nbsp; </option>
										<option value="0" <?=$flybx_mouse_trigger_disabled == 0?'selected':'';?>><?php _e('Enabled', $flybx_plugin_slug); ?> &nbsp; </option>
									</select>
									<span class="description"><?php _e('This is a default trigger. Window pops on mouse-over the top of the page.', $flybx_plugin_slug); ?></span>
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="flybx_trapped_trigger_enabled"><?php _e('Trapped Exit', $flybx_plugin_slug); ?>:</label></th>
								<td>
									<select name="flybx_trapped_trigger_enabled" id="flybx_trapped_trigger_enabled">
										<option value="0"><?php _e('Disabled', $flybx_plugin_slug); ?> &nbsp; </option>
										<option value="1" <?=$flybx_trapped_trigger_enabled == 1?'selected':'';?>><?php _e('Enabled', $flybx_plugin_slug); ?> &nbsp; </option>
									</select>
									<span class="description"><?php _e('Use at your own risk. Search engines may dislike this.', $flybx_plugin_slug); ?></span>
								</td></tr>
								
							<tr class="form-field"><th style="width:150px;"><label for="flybx_trapped_trigger_msg"><?php _e('Trapped Exit Message', $flybx_plugin_slug); ?>:</label></th>
								<td>
									<textarea name="flybx_trapped_trigger_msg" id="flybx_trapped_trigger_msg" placeholder="<?php esc_attr_e('Type your alert message here. ie: WAIT! Click Stay on Page', $flybx_plugin_slug); ?>"><?=$flybx_trapped_trigger_msg;?></textarea>
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="flybx_unbounce_enabled"><strong><?php _e('Delayed Pop Enabled', $flybx_plugin_slug); ?>:</strong></label></th>
								<td>
									<select name="flybx_unbounce_enabled" id="flybx_unbounce_enabled">
										<option value="0"><?php _e('Disabled', $flybx_plugin_slug); ?> &nbsp; </option>
										<option value="1" <?=$flybx_unbounce_enabled == 1?'selected':'';?>><?php _e('Enabled', $flybx_plugin_slug); ?> &nbsp; </option>
									</select>
									<span class="description"><?php _e('Show pop after certain amount of seconds spent on page', $flybx_plugin_slug); ?></span>
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="flybx_unbounce_delay"><?php _e('Delayed Pop Delay (seconds)', $flybx_plugin_slug); ?>:</label></th>
								<td><input type="text" name="flybx_unbounce_delay" value="<?=$flybx_unbounce_delay;?>" id="flybx_unbounce_delay" size="10" style="width:60px;" /></td></tr>
						
							
							<tr><td>&nbsp;</td><td class="submit"><input type="submit" value="<?php _e('Save Settings', $flybx_plugin_slug); ?>" name="save_triggers" class="button-secondary" /></td></tr>
							
						</table>
					</div>
				</div>
				*/ ?>
	
				
				<div id="submitdiv" class="postbox">
					<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $flybx_plugin_slug); ?>"><br /></div>
					<h3 class="hndle"><?php _e('Keywords', $flybx_plugin_slug); ?></h3>
					<div class="inside">
						<span class="description"><?php //_e('These keywords settings only affect automatic product tables below posts/pages.<br />Tables created with shortcodes ignore this section because you have to provide your keywords when manually inserting Azon FlyBox tables with a shortcode.', $flybx_plugin_slug); ?></span>

						<table class="form-table" style="width:750px;">
							<tr><td colspan="2">
								<table class="form-table" style="width:auto;">	
									<tr class="form-field"><th ><label><?php _e('Keyword Sources', $flybx_plugin_slug); ?>:</label></th>
										<td class="chkboxes">
												
												<?php if (flybx_is_plus()): ?>
												<label for="flybx_kw_sources_serp">
													<input type="checkbox" name="flybx_kw_sources[]" id="flybx_kw_sources_serp" <?=(in_array('serp', $flybx_kw_sources)?'checked':'');?> value="serp" style="width: 25px;" /><?php _e('Pick up search engine keywords if available (* Plus+ feature)', $flybx_plugin_slug); ?>
												</label><br />
												<?php endif; ?>
												
												<label for="flybx_kw_sources_smart_search">
													<input type="checkbox" name="flybx_kw_sources[]" value="smart_search" id="flybx_kw_sources_smart_search" <?=(in_array('smart_search', $flybx_kw_sources)?'checked':'');?> style="width: 25px;" /><?php _e('Smart Search Method * (recommended)', $flybx_plugin_slug); ?>
												</label>
												<br />
												
												
							
												<label for="flybx_kw_sources_content">
													<input type="checkbox" name="flybx_kw_sources[]" value="content" id="flybx_kw_sources_content" <?=(in_array('content', $flybx_kw_sources)?'checked':'');?> style="width: 25px;" /><?php _e('Generate based on post/page content', $flybx_plugin_slug); ?>
												</label>
												<br />
												<?php /* <label for="flybx_kw_sources_title">
													<input type="checkbox" name="flybx_kw_sources[]" value="title" id="flybx_kw_sources_title" <?=(in_array('title', $flybx_kw_sources)?'checked':'');?> style="width: 25px;" /><?php _e('Use post title (<span class="description">Try the whole title if 4 words or less and then try every word in the title</span>)', $flybx_plugin_slug); ?>
												</label>
												<br />*/ ?>
												<label for="flybx_kw_sources_tags">
													<input type="checkbox" name="flybx_kw_sources[]" value="tags" id="flybx_kw_sources_tags" <?=(in_array('tags', $flybx_kw_sources)?'checked':'');?> style="width: 25px;" /><?php _e('Use post tags', $flybx_plugin_slug); ?>
												</label>
												<br />
												<label for="flybx_kw_sources_categories">
													<input type="checkbox" name="flybx_kw_sources[]" value="categories" id="flybx_kw_sources_categories" <?=(in_array('categories', $flybx_kw_sources)?'checked':'');?> style="width: 25px;"  onclick="javascript: if (jQuery('#flybx_kw_sources_categories').is(':checked')) {jQuery('#cat_kws_postbox').removeClass('closed'); jQuery('html, body').animate({scrollTop: (jQuery('#cat_kws_postbox').offset().top - 30)}, 1000);} else {jQuery('#cat_kws_postbox').addClass('closed');} "  /><?php _e('Use specific keywords per category (* enter below)', $flybx_plugin_slug); ?>
												</label>
												<br />
												<label for="flybx_kw_sources_fallback">
													<input type="checkbox" name="flybx_kw_sources[]" value="fallback" id="flybx_kw_sources_fallback" <?=(in_array('fallback', $flybx_kw_sources)?'checked':'');?> style="width: 25px;" /><?php _e('Use fallback keywords (* enter below)', $flybx_plugin_slug); ?>
												</label>
												<br />
												<span class="description"><?php _e('There are 5 ways to generate keywords. The plugin will attempt all checked methods in the same order as outlined above. <br />* With Smart Search method plugin extracts ASIN from the content and finds similar products for comparison', $flybx_plugin_slug); ?> <a href="<?php _e('http://www.pluginsbyigor.com/faqs/keyword-generating-methods/', $flybx_plugin_slug); ?>" target="_blank" title="<?php esc_attr_e('Click for help', $flybx_plugin_slug); ?>">?</a></span>
											
										</td></tr>
									
									<tr class="form-field"><th ><label for="flybx_fallback_keywords"><?php _e('Fallback keywords', $flybx_plugin_slug); ?></label></th>
										<td>
											<input type="text" name="flybx_fallback_keywords" id="flybx_fallback_keywords" style="width: 390px;" value="<?=$flybx_fallback_keywords;?>" />
												<?php /*if (flybx_module_installed('amzn')): ?>
													<a href="javascript: flybx_perview(jQuery('#flybx_fallback_keywords').val());" style="float: right;" class="flybx_preview_set flybx_preview_link active"><?php _e('Preview AMZN', $flybx_plugin_slug); ?></a>
												<?php endif; ?>
												<?php if (flybx_module_installed('epn')): ?>
													<a href="javascript: flybx_perview(jQuery('#flybx_fallback_keywords').val(), '1');" style="float: right;" class="flybx_preview_set flybx_preview_link active"><?php _e('Preview ePN', $flybx_plugin_slug); ?></a>
												<?php endif;*/ ?>
											<br />
											<span class="description"><?php _e('Used if no other keywords can be generated', $flybx_plugin_slug); ?></span>
										</td></tr>
										
									<tr class="form-field"><th ><label for="flybx_skip_keywords"><?php _e('Skip these words from keywords', $flybx_plugin_slug); ?> <a href="<?php _e('http://www.pluginsbyigor.com/faqs/skip-words-in-keywords/', $flybx_plugin_slug); ?>" target="_blank" title="<?php esc_attr_e('Click for help', $flybx_plugin_slug); ?>">?</a></label></th>
										<td>
											<textarea name="flybx_skip_keywords" id="flybx_skip_keywords" rows="10" style="width: 350px;"><?=$flybx_skip_keywords;?></textarea>
										</td></tr>
									
									<tr class="form-field"><th style="width:150px;"><label for="flybx_min_kw_length"><?php _e('Minimum words in a keyword', $flybx_plugin_slug); ?>:</label></th>
										<td>
											<select name="flybx_min_kw_length" id="flybx_min_kw_length">
												<option value="1" <?=($flybx_min_kw_length === FALSE || $flybx_min_kw_length == '1'?'selected':'');?>>1 &nbsp;</option>
												<option value="2" <?=($flybx_min_kw_length == '2'?'selected':'');?>>2 &nbsp;</option>
											</select>
											<span class="description"><?php _e('2 will get better relevancy but return fewer results', $flybx_plugin_slug); ?></span>
										</td></tr>
									
									
									
								</table>
							</td></tr>
						</table>
					
					<div id="cat_kws_postbox" class="postbox <?=(in_array('categories', $flybx_kw_sources)?'':'closed');?>" style="width: 90%; margin-left: 20px;">
						<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $flybx_plugin_slug ); ?>"><br /></div>
						<h3 class="hndle"><?php _e('Category Keywords and Programs', $flybx_plugin_slug); ?></h3>
						<div class="inside">
							<table class="form-table" style="width:750px;">
								<tr><td colspan="2">
									<table class="form-table" style="width:auto;">	
										
										<?php
										$categories = get_categories();
										if (!isset($flybx_amzn_disabled_categories)) $flybx_amzn_disabled_categories = array();
										if (!isset($flybx_epn_disabled_categories)) $flybx_epn_disabled_categories = array();

										foreach($categories as $curr_cat):
										?>
										
										<tr class="form-field"><th ><label for="flybx_cat_kws_<?=$curr_cat->term_id;?>"><?=$curr_cat->name;?></label></th>
											<td style="width: 450px;">
												<input type="text" name="flybx_cat_kws_<?=$curr_cat->term_id;?>" class="regular-text" style="width: 300px;" id="flybx_cat_kws_<?=$curr_cat->term_id;?>" value="<?=(isset($flybx_cat_kws[$curr_cat->term_id])?$flybx_cat_kws[$curr_cat->term_id]:'');?>" />
												
												<div style="float: right; width: 140px;">													
														<?php if (flybx_module_installed('amzn')): ?>
															<input type="checkbox" name="flybx_amzn_cat_toggle[]" value="<?=$curr_cat->term_id;?>" id="flybx_amzn_cat_toggle_<?=$curr_cat->term_id;?>" style="width: 12px; margin-right: 5px;" <?=(!in_array($curr_cat->term_id, $flybx_amzn_disabled_categories)?'checked':'');?> /><label for="flybx_amzn_cat_toggle_<?=$curr_cat->term_id;?>">Enabled</label>
														<?php endif; ?>
														
														<?php if (flybx_module_installed('epn')): ?>
															<input type="checkbox" name="flybx_epn_cat_toggle[]" value="<?=$curr_cat->term_id;?>" id="flybx_epn_cat_toggle_<?=$curr_cat->term_id;?>" style="width: 12px; margin-right: 5px; margin-left: 15px;" <?=(!in_array($curr_cat->term_id, $flybx_epn_disabled_categories)?'checked':'');?> /><label for="flybx_epn_cat_toggle_<?=$curr_cat->term_id;?>">ePN</label>
														<?php endif; ?>
												</div>
												
													<?php /*if (flybx_module_installed('epn')): ?>
														<a href="javascript: flybx_perview(jQuery('#flybx_cat_kws_<?=$curr_cat->term_id;?>').val(), '1');" style="float: right;" class="flybx_preview_set flybx_preview_link active"><?php _e('Preview ePN', $flybx_plugin_slug); ?></a>
													<?php endif; ?>
													<?php if (flybx_module_installed('amzn') && flybx_module_installed('epn')): ?><span class="flybx_preview_set flybx_preview_link active"  style="float: right; margin: 0 5px;"> | </span><?php endif; ?>
													<?php if (flybx_module_installed('amzn')): ?>
														<a href="javascript: flybx_perview(jQuery('#flybx_cat_kws_<?=$curr_cat->term_id;?>').val());" style="float: right;" class="flybx_preview_set flybx_preview_link active"><?php _e('Preview AMZN', $flybx_plugin_slug); ?></a>
													<?php endif;*/ ?>

											</td></tr>
										<?php 
										endforeach;?>

									</table>
								</td></tr>
							</table>

							<div ><?php _e('Use checkboxes to toggle on/off product tables in those categories.', $flybx_plugin_slug); ?></div>
						
						</div>
					</div>	
					
					
					<table>
						<tr><td style="width: 188px;">&nbsp;</td><td class="submit"><input type="submit" name="save_keywords" value="<?php esc_attr_e( 'Save Settings', $flybx_plugin_slug); ?>" class="button-secondary" /></td></tr>
					</table>
					
					<div class="description">When making changes to keyword generation process please remember to clear plugin cache and existing keywords using the "Clear Cache" link on plugin menu.</div>
				
				</div>
				</div>
				
				
				<div id="submitdiv" class="postbox">
					<div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', $flybx_plugin_slug); ?>"><br /></div>
					<h3 class="hndle"><?php _e('Misc', $flybx_plugin_slug); ?></h3>
					<div class="inside">
						<table class="form-table" style="width:auto;">	
							<tr class="form-field"><th style="width:150px;"><label for="flybx_posttypes"><?php _e('Use on Post Types', $flybx_plugin_slug); ?>:</label></th>
								<td class="chkboxes">
									<?php foreach($post_types as $post_type): ?>
									<input type="checkbox" value="<?=$post_type;?>" name="flybx_posttypes[]" id="posttype_<?=$post_type;?>" style="width: 25px;" <?=(in_array($post_type, $flybx_posttypes)?'checked':'');?> /><label for="posttype_<?=$post_type;?>"><?=ucfirst($post_type);?></label><br />
									<?php endforeach; ?>
									<span class="description"><br /></span>
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="flybx_devicetypes"><?php _e('Device Types', $flybx_plugin_slug); ?>:</label></th>
								<td class="chkboxes">
									<?php foreach($flybx_all_device_types as $device_type): ?>
									<input type="checkbox" value="<?=$device_type;?>" name="flybx_devicetypes[]" id="posttype_<?=$device_type;?>" style="width: 25px;" <?=((isset($flybx_devicetypes_str) && $flybx_devicetypes_str === FALSE) || in_array($device_type, $flybx_devicetypes)?'checked':'');?> /><label for="posttype_<?=$device_type;?>"><?=ucfirst($device_type);?></label><br />
									<?php endforeach; ?>
								</td></tr>
										
							<?php /*<tr class="form-field"><th style="width:150px;"><label for="flybx_reviewson"><?php _e('Star Reviews', $flybx_plugin_slug); ?></label></th>
								<td>	
									<select name="flybx_reviewson" id="flybx_reviewson">
										<option value="off" <?=($flybx_reviewson === FALSE || $flybx_reviewson == 'off')?'selected':'';?>><?php _e('Disabled', $flybx_plugin_slug); ?> &nbsp; </option>
										<option value="on" <?=$flybx_reviewson == 'on'?'selected':'';?>><?php _e('Enabled', $flybx_plugin_slug); ?> &nbsp; </option>
									</select>
									<span class="description"><?php _e('Enable/Disable star reviews', $flybx_plugin_slug); ?></span>
								</td></tr>*/ ?>
								
							<tr class="form-field"><th style="width:150px;"><label for="flybx_show_promo_msgs"><?php _e('Admin Notifications', $flybx_plugin_slug); ?></label></th>
								<td>									
									<select name="flybx_show_promo_msgs" id="flybx_show_promo_msgs">
										<option value="0" <?=$flybx_show_promo_msgs == '0'?'selected':'';?>><?php _e('Disabled', $flybx_plugin_slug); ?> &nbsp; </option>
										<option value="1" <?=$flybx_show_promo_msgs == '1' || $flybx_show_promo_msgs === FALSE?'selected':'';?>><?php _e('Enabled', $flybx_plugin_slug); ?> &nbsp; </option>
									</select>
									<span class="description"><?php _e('Show me important update notifications, occassional promo messages, messages about new add-ons', $flybx_plugin_slug); ?></span>
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="flybx_path_to_geoip_dat"><?php _e('Path to GeoIP.dat', $flybx_plugin_slug); ?>:</label></th>
								<td><input type="text" name="flybx_path_to_geoip_dat" value="<?=$flybx_path_to_geoip_dat;?>" id="flybx_path_to_geoip_dat" size="10" style="width:400px;" />
									<br /><span class="description"><?php _e('(optional) If you have your own MaxMind&reg; country ip database you can enter the full path here (i.e., /home/web/GeoIP.dat)<br />This setting is completely optional. The plugin comes with a copy of GeoIP.dat database and it\'s being updated with plugin updates so you can simply ignore it and leave the field blank.', $flybx_plugin_slug); ?></span>
								</td></tr>
								
								
							<tr class="form-field"><th style="width:150px;"><label for="flybx_domoutline"><?php _e('Show HTML selector', $flybx_plugin_slug); ?>:</label></th>
								<td>
									<select name="flybx_domoutline" id="flybx_domoutline">
										<option value="on" <?=$flybx_domoutline == 'on'?'selected':'';?>><?php _e('Yes', $flybx_plugin_slug); ?> &nbsp; </option>
										<option value="off" <?=$flybx_domoutline == 'off' || $flybx_domoutline === FALSE?'selected':'';?>><?php _e('No', $flybx_plugin_slug); ?> &nbsp; </option>
									</select>
								
									<span class="description"><?php _e('Adds a link to the admin bar for selecting HTML elements.', $flybx_plugin_slug); ?></span>
								</td></tr>	
							
							<?php if (flybx_is_plus()): ?>
								<tr class="form-field"><th style="width:150px;"><label for="flybx_visitor_log_days"><?php _e('Days to Store Visitor Log', $flybx_plugin_slug); ?>:</label></th>
									<td><input type="text" name="flybx_visitor_log_days" value="<?=($flybx_visitor_log_days === FALSE || $flybx_visitor_log_days < 1?'60':$flybx_visitor_log_days);?>" id="flybx_visitor_log_days" size="10" style="width:60px;" />
										<span class="description"><?php _e('How many days to store visitor log for.', $flybx_plugin_slug); ?></span>
									</td></tr>
							<?php else: ?>
								<tr class="form-field"><th style="width:150px;"></th>
									<td><input type="hidden" name="flybx_visitor_log_days" value="60" id="flybx_visitor_log_days" />
									</td></tr>
							<?php endif; ?>
							
							<tr class="form-field"><th style="width:150px;"><label for="flybx_cache_hours"><?php _e('Hours to Keep Amazon Cache', $flybx_plugin_slug); ?>:</label></th>
								<td><input type="text" name="flybx_cache_hours" value="<?=($flybx_cache_hours === FALSE || $flybx_cache_hours < 1?'24':$flybx_cache_hours);?>" id="flybx_cache_hours" size="10" style="width:60px;" />
									<span class="description"><?php _e('How many hours to cache Amazon data for (max 24 hours).', $flybx_plugin_slug); ?></span>
								</td></tr>
							
							<tr class="form-field"><th style="width:150px;"><label for="flybx_unsupported_country_default"><?php _e('If country not supported then show', $flybx_plugin_slug); ?>:</label></th>
								<td>									
									<select name="flybx_unsupported_country_default" id="flybx_unsupported_country_default">
										<option value="none" <?=$flybx_unsupported_country_default === FALSE || $flybx_unsupported_country_default == 'none'?'selected':'';?>><?php _e('Nothing', $flybx_plugin_slug); ?> &nbsp; </option>
										<option value="us" <?=$flybx_unsupported_country_default == 'us'?'selected':'';?>><?php _e('US listings', $flybx_plugin_slug); ?> &nbsp; </option>
										<option value="uk" <?=$flybx_unsupported_country_default == 'uk'?'selected':'';?>><?php _e('UK listings', $flybx_plugin_slug); ?> &nbsp; </option>
										<option value="ca" <?=$flybx_unsupported_country_default == 'ca'?'selected':'';?>><?php _e('CA listings', $flybx_plugin_slug); ?> &nbsp; </option>
										<option value="de" <?=$flybx_unsupported_country_default == 'de'?'selected':'';?>><?php _e('DE listings', $flybx_plugin_slug); ?> &nbsp; </option>
										<option value="fr" <?=$flybx_unsupported_country_default == 'fr'?'selected':'';?>><?php _e('FR listings', $flybx_plugin_slug); ?> &nbsp; </option>
										<option value="it" <?=$flybx_unsupported_country_default == 'it'?'selected':'';?>><?php _e('IT listings', $flybx_plugin_slug); ?> &nbsp; </option>
										<option value="es" <?=$flybx_unsupported_country_default == 'es'?'selected':'';?>><?php _e('ES listings', $flybx_plugin_slug); ?> &nbsp; </option>
									</select>
									<span class="description"><?php _e('If user\'s country not supported do this', $flybx_plugin_slug); ?></span>
								</td></tr>
						
							
							<?php /*<tr><td>&nbsp;</td><td class="submit"><input type="submit" value="<?php _e('Save Settings', $flybx_plugin_slug); ?>" name="save_misc" class="button-secondary" /></td></tr> */ ?>
							
						</table>
					</div>
				</div>
				
				
			</div><!-- end of keywords postbox -->

		
			<input type="submit" value="<?php _e('Save All Settings', $flybx_plugin_slug); ?>" name="save_all_settings" class="button-primary" />
			
			<input type="hidden" name="flybx_form_submitted" value="yes" />
		</form>
		</div>
		
		<?php //flybx_prepare_kws_pop_preview(); ?>	
	<?php endif; ?>	
	<?php
	echo '</div>';
}




$flybx_active_real = get_option('flybx_active');

if ($flybx_active_real == '1')
{
	$flybx_prefix = 'flybx_';

	$flybx_posttypes_str = get_option('flybx_posttypes');
	$flybx_posttypes = explode(',', $flybx_posttypes_str);
	
	$flybx_default_behavior = get_option('flybx_default_behavior');
	/*if ($flybx_default_behavior == 'all')
	{*/
		$flybx_disable_enable = array(
				'name' => __('Hide '.$flybx_plugin_name.' on this Post/Page', $flybx_plugin_slug),
				'desc' => sprintf(__('Check to disable %s templates on this post/page.', $flybx_plugin_slug), $flybx_plugin_name),
				'id' => $flybx_prefix . 'disable',
				'type' => 'checkbox'
			);
	/*}
	else
	{
		$flybx_disable_enable = array(
				'name' => __('Enable For This Item', $flybx_plugin_slug),
				'desc' => sprintf(__('Enable %s window pop for this item.', $flybx_plugin_slug), $flybx_plugin_name),
				'id' => $flybx_prefix . 'enable',
				'type' => 'checkbox'
			);
	}*/
	

	$flybx_meta_box = array(
		'id' => 'flybx-meta-box',
		'title' => sprintf(__('%s Data', $flybx_plugin_slug), $flybx_plugin_name),
		'pages' => $flybx_posttypes,
		'context' => 'normal',
		'priority' => 'high',
		'fields' => array(
			/*array(
				'name' => __('Keywords', $flybx_plugin_slug),
				'desc' => __('You can change keywords used for looking up products on Amazon. Comma separated.', $flybx_plugin_slug).' <span class="flybx_preview_set flybx_preview_loading">'.__('Loading...', $flybx_plugin_slug).'</span><br />' ,
				'id' => $flybx_prefix . 'keywords',
				'type' => 'text'
			), */
			$flybx_disable_enable	
			
		)
	);
	
	//kws for all active locales
	$flybx_active_countries = flybx_active_locales();
	foreach($flybx_active_countries as $curr_country)
	{
		$flybx_meta_box['fields'][] = array(
				'name' => __(strtoupper($curr_country).' Keywords', $flybx_plugin_slug),
				'desc' => __('Keywords used for looking up products on '.strtoupper($curr_country).' Amazon. Comma separated. <span class="description">(You can also use ASINs like this: asin:B000BH7CB2,asin:B001ARYU58 etc)</span>', $flybx_plugin_slug).' <span class="flybx_preview_set flybx_preview_loading flybx_preview_loading_'.$curr_country.'">'.__('Loading...', $flybx_plugin_slug).'</span>' .
					'<a href="javascript: flybx_gen_kws(\''.$curr_country.'\');" class="flybx_preview_set flybx_preview_link flybx_preview_link_'.$curr_country.' active">'.__('Generate KWs From Content', $flybx_plugin_slug).'</a>'//.
					/*(flybx_module_installed('amzn') && flybx_module_installed('epn')?'<span class="flybx_preview_set flybx_preview_link active" style="margin: 0 5px;"> | </span>':'').
					(flybx_module_installed('epn')?'<a href="javascript: flybx_perview(1);" class="flybx_preview_set flybx_preview_link active">'.__('Preview ePN', $flybx_plugin_slug).'</a>':'')*/,
				'id' => $flybx_prefix . 'kws_'.$curr_country,
				'type' => 'text'
			);
	}

	add_action('admin_init', 'flybx_add_box');

	// Add meta box
	function flybx_add_box() {
		global $flybx_meta_box;
		if ( current_user_can('administrator') ) {
			foreach ($flybx_meta_box['pages'] as $page) {
			add_meta_box($flybx_meta_box['id'], $flybx_meta_box['title'], 'flybx_show_box', $page, $flybx_meta_box['context'], $flybx_meta_box['priority']);
			}
		}
		//add_meta_box($flybx_meta_box['id'], $flybx_meta_box['title'], 'flybx_show_box', $flybx_meta_box['page'], $flybx_meta_box['context'], $flybx_meta_box['priority']);
		//add_meta_box($flybx_meta_box['id'], $flybx_meta_box['title'], 'flybx_show_box', $flybx_meta_box['page'], $flybx_meta_box['context'], $flybx_meta_box['priority']);
	}

	// Callback function to show fields in meta box
	function flybx_show_box() {
		global $flybx_meta_box, $post, $flybx_addons, $flybx_plugin_slug, $flybx_plugin_name;
		
		
		/*echo '<pre>';
		print_r($post);
		echo '</pre>';
		$meta_kw_check = get_post_meta($post->ID, 'flybx_keywords', true);
		echo '<pre>';
		print_r($meta_kw_check);
		echo '</pre>';
		exit;*/
		//check if kw generated
		$meta_kw_check = get_post_meta($post->ID, 'flybx_keywords', true);
		if ($meta_kw_check === FALSE || strlen($meta_kw_check) == 0)
		{
			$flybx_post_content = apply_filters('the_content',$post->post_content);
			$flybx_post_content = flybx_remove_html($flybx_post_content);
			$flybx_post_content = strip_tags($flybx_post_content);
			/*$flybx_kws = flybx_gen_kws($flybx_post_content, $post->post_title, $post->ID);
			if (count($flybx_kws) > 0)
			{
				update_post_meta($post->ID, 'flybx_keywords', implode(',', $flybx_kws));
			}*/
		}
		
		//BOF include flybx js for preview
		//wp_enqueue_style( $flybx_plugin_slug, plugins_url( $flybx_plugin_slug.'/style.css' , dirname(__FILE__) ), false, '1.1');
		?>

		
		<?php

		?>
		<script type="text/javascript">		
		 function flybx_gen_kws(locale)
		 {
			var curr_kws = jQuery('#flybx_kws_' + locale).val();
			if (curr_kws == '' || confirm('This will overwrite your current keywords.\nContinue?')) 
			{		
				jQuery('.flybx_preview_link_' + locale).removeClass('active');
				jQuery('.flybx_preview_loading_' + locale).addClass('active');
				var   data_to_post = {
					'action': 'flybx_ajax_gen_kws',
					'post_id': '<?php echo $post->ID; ?>',
					'template_id': '2',
					'locale': locale,
				};
				jQuery.ajax({
				  url: '<?php echo flybx_get_ajax_url(); ?>',
				  type: "POST",
				  data:  data_to_post,
				  success: function(data) {
					var obj = JSON.parse(data);
					var results_kws = obj.kws;
					
					if (results_kws.length > 0)
					{					
						jQuery('#flybx_kws_' + locale).val(results_kws);				
					}
					else
					{
						var results_err_msg = obj.admin_err_msg;
						if (results_err_msg.length > 0)
						{
							alert(obj.admin_err_msg);
						}
					}
					jQuery('.flybx_preview_link_' + locale).addClass('active');
					jQuery('.flybx_preview_link_' + locale).blur();
					jQuery('.flybx_preview_loading_' + locale).removeClass('active');
					}
				  });
			  }
		 }
		</script>
		<style>
		.flybx_preview_set, .flybx_preview_link {display: none;}
		.flybx_preview_set.active, .flybx_preview_link.active {display: block; clear: both;}
		</style>
		
		<?php

		
		// Use nonce for verification
		echo '<input type="hidden" name="flybx_meta_box_nonce" value="', wp_create_nonce(basename(__FILE__)), '" />';
		
		echo '<table class="form-table">';

		foreach ($flybx_meta_box['fields'] as $field) {
			// get current post meta data
			$meta = get_post_meta($post->ID, $field['id'], true);
			
			echo '<tr>',
					'<th style="width:140px;"><label for="', $field['id'], '">', $field['name'], '</label></th>',
					'<td>';
			switch ($field['type']) {
				case 'text':
					echo '<input type="text" name="', $field['id'], '" id="', $field['id'], '" value="', $meta ? $meta : $field['std'], '" size="30" style="width:97%" />', '<br />', $field['desc'];
					break;
				case 'textsmall':
					echo '<input type="text" name="', $field['id'], '" id="', $field['id'], '" value="', $meta ? $meta : $field['std'], '" size="30" style="width:70px;" />', '<br />', $field['desc'];
					break;
				case 'textarea':
					echo '<textarea name="', $field['id'], '" id="', $field['id'], '" cols="60" rows="4" style="width:97%">', $meta ? $meta : $field['std'], '</textarea>', '<br />', $field['desc'];
					break;
				case 'select':
					echo '<select name="', $field['id'], '" id="', $field['id'], '">';
					foreach ($field['options'] as $option) {
						echo '<option', $meta == $option ? ' selected="selected"' : '', '>', $option, '</option>';
					}
					echo '</select>';
					break;
				case 'selectadv':
					echo '<select name="', $field['id'], '" id="', $field['id'], '">';
					foreach ($field['options'] as $key => $val) {
						echo '<option', $meta == $key ? ' selected="selected"' : '', ' value="' , $key , '">', $val, '</option>';
					}
					echo '</select>';
					break;
				case 'radio':
					foreach ($field['options'] as $option) {
						echo '<input type="radio" name="', $field['id'], '" value="', $option['value'], '"', $meta == $option['value'] ? ' checked="checked"' : '', ' />', $option['name'];
					}
					break;
				case 'checkbox':
					echo '<input type="checkbox" name="', $field['id'], '" id="', $field['id'], '"', $meta ? ' checked="checked"' : '', ' />';
					break;
			}
			echo     '<td>',
				'</tr>';
		}
		
		echo '</table>';
	}


	add_action('save_post', 'flybx_save_data', 90);

	// Save data from meta box
	function flybx_save_data($post_id) {
		global $flybx_meta_box;
		
		// verify nonce
		if (!wp_verify_nonce($_POST['flybx_meta_box_nonce'], basename(__FILE__))) {
			return $post_id;
		}

		// check autosave
		if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
			return $post_id;
		}

		// check permissions
		if ('page' == $_POST['post_type']) {
			if (!current_user_can('edit_page', $post_id)) {
				return $post_id;
			}
		} elseif (!current_user_can('edit_post', $post_id)) {
			return $post_id;
		}
		
		foreach ($flybx_meta_box['fields'] as $field) {
			$old = get_post_meta($post_id, $field['id'], true);
			$new = $_POST[$field['id']];
			if (strlen($new) > 0 && $new != $old) {
				//echo '<Br />update'.$field['id'].$new;
				update_post_meta($post_id, $field['id'], $new);
			} elseif ('' == $new && $old) {
				delete_post_meta($post_id, $field['id'], $old);
			}
		}
		flybx_delete_cache($post_id);
		//exit;
	}

}

function flybx_is_serp_direct()
{
	$referer = $_SERVER['HTTP_REFERER'];
    $engines = array('aol'      => 'q=',
                     'ask'      => 'q=',
                     'google'   => 'q=',
                     'bing'     => 'q=',
                     'hotbot'   => 'q=',
                     'teoma'    => 'q=',
                     'yahoo'    => 'p=',
                     'altavista'=> 'p=',
                     'lycos'    => 'query=',
                     'kanoodle' => 'query='
                     );
 
    foreach($engines as $engine => $query_param) {
        // Check if the referer is a search engine from our list.
        // Also check if the query parameter is valid.
        if (strpos($referer, $engine.".") !==  false && 
            strpos($referer, $query_param) !==  false) { 
            // Grab the keyword from the referer url
            $referer .= "&";
            $pattern = "/[?&]{$query_param}(.*?)&/si";
            preg_match($pattern, $referer, $matches);
            return true;
        }   
    }
    return false;
}

function flybx_pickup_serp_kws()
{
	$referer = $_SERVER['HTTP_REFERER'];
    $engines = array('aol'      => 'q=',
                     'ask'      => 'q=',
                     'google'   => 'q=',
                     'bing'     => 'q=',
                     'hotbot'   => 'q=',
                     'teoma'    => 'q=',
                     'yahoo'    => 'p=',
                     'altavista'=> 'p=',
                     'lycos'    => 'query=',
                     'kanoodle' => 'query='
                     );
 
    foreach($engines as $engine => $query_param) {
        // Check if the referer is a search engine from our list.
        // Also check if the query parameter is valid.
        if (strpos($referer, $engine.".") !==  false && 
            strpos($referer, $query_param) !==  false) { 
            // Grab the keyword from the referer url
            $referer .= "&";
            $pattern = "/[?&]{$query_param}(.*?)&/si";
            preg_match($pattern, $referer, $matches);
			if (isset($matches[1]) && strlen($matches[1]) > 0)
			{
				$s_kw = urldecode(trim($matches[1]));
				setcookie("flybx_serp_kws", $s_kw, time()+30, '/', '.'.$_SERVER['HTTP_HOST']);
				return $s_kw;
			}            
        }   
    }
	return false;
}

//WPMS functions
function add_new_blog_flybx($blog_id, $user_id, $domain, $path, $site_id, $meta) {
	global $wpdb;
	set_time_limit(300);
    // Make sure the user can perform this action and the request came from the correct page.
    switch_to_blog($blog_id);
	//just add default options
	flybx_add_options();
	
	//copy settings from default blog
	$default_blog_id = flybx_wpms_get_default_blog_id();
	if ($default_blog_id != 'none')
	{
		restore_current_blog();
		$flybx_current_site = get_blog_details($default_blog_id);
		$flybx_standard_options = flybx_get_general_options_arr();

		//get general options of 'copy from' blog
		$general_options = array();					
		foreach($flybx_standard_options as $loop_option)
		{
			$general_options[$loop_option] = get_option($loop_option);
		}
		//get all flybx options of 'copy from' blog
		$flybx_options_source = $wpdb->get_results( "SELECT * FROM ".$wpdb->prefix."flybx_options" );

		//search for license name and email in 'copy from' data
		$license_name = '';
		$license_email = '';
		foreach($flybx_options_source as $row)
		{
			if ($row->name == 'license_name')
			{
				$license_name = $row->value;
			}
			if ($row->name == 'license_email')
			{
				$license_email = $row->value;
			}
		}
		
		restore_current_blog();
		//apply setting to just created blog
		switch_to_blog($blog_id);		

		set_time_limit(300);
		//update general options
		foreach($general_options as $key => $val)
		{
			if ($key != '')
			{
				update_option($key, $val);
			}
		}					
		
		//update flybx options
		if (count($flybx_options_source) > 0)
		{
			//activate current site
			flybx_activate_license_wpms($license_name, $license_email);
			
			foreach($flybx_options_source as $row)
			{
				if ($row->name != 'license')
				{
					flybx_update_option($row->name, $row->value);
				}
			}
		}
	}
	
    restore_current_blog();
}

if (defined('MULTISITE') && (MULTISITE === TRUE || MULTISITE == 1))
{
	add_action( 'wpmu_new_blog', 'add_new_blog_flybx' );
}

function flybx_wpms_apply_to_all()
{
	global $blog_id, $wpdb;
	$flybx_curr_user = wp_get_current_user();
	if (0 != $flybx_curr_user->ID)
	{
		$flybx_blogs = get_blogs_of_user($flybx_curr_user->ID);
		$flybx_current_site = get_blog_details($blog_id);
		$flybx_standard_options = flybx_get_general_options_arr();
		if (count($flybx_blogs) > 0)
		{
			//get general options of 'copy from' blog
			$general_options = array();					
			foreach($flybx_standard_options as $loop_option)
			{
				$general_options[$loop_option] = get_option($loop_option);
			}
			//get all flybx options of 'copy from' blog
			$flybx_options_source = $wpdb->get_results( "SELECT * FROM ".$wpdb->prefix."flybx_options" );

			//search for license name and email in 'copy from' data
			$license_name = '';
			$license_email = '';
			foreach($flybx_options_source as $row)
			{
				if ($row->name == 'license_name')
				{
					$license_name = $row->value;
				}
				if ($row->name == 'license_email')
				{
					$license_email = $row->value;
				}
			}
			
			foreach($flybx_blogs as $loop_blog)
			{				
				if ($flybx_current_site->blog_id != $loop_blog->userblog_id)
				{
					set_time_limit(300);
					switch_to_blog($loop_blog->userblog_id);
					//update general options
					foreach($general_options as $key => $val)
					{
						if ($key != '')
						{
							update_option($key, $val);
						}
					}					
					
					//update flybx options
					if (count($flybx_options_source) > 0)
					{
						//activate current site
						flybx_activate_license_wpms($license_name, $license_email);
						
						foreach($flybx_options_source as $row)
						{
							if ($row->name != 'license')
							{
								flybx_update_option($row->name, $row->value);
							}
						}
					}
					//restore_current_blog();
				}
			}
			switch_to_blog($flybx_current_site->blog_id);
			
		}
	}
}

function flybx_get_general_options_arr()
{
	$options = array(
		'flybx_active', 
		'flybx_activated', 
		'flybx_am_key_id', 
		'flybx_am_access_key', 
		'flybx_am_associate_tag', 
		'flybx_am_searchindex', 
		'flybx_skip_noimage',
		'flybx_serponly',
		'flybx_loggedin_hide',
		'flybx_sensitivity',
		'flybx_posttypes',
		'flybx_pops_per_user',
		'flybx_default_behavior',
		'flybx_unbounce_enabled',
		'flybx_unbounce_delay',
		'msg_sequence',
		'flybx_version',
		'flybx_db_version'
		);
		return $options;
}

function flybx_activate_license_wpms($name = '', $email = '')
{
	global $wpdb;
	//send license request
	$call_data = array(
						'email' => $email,
						'name' => $name,
						'site' => get_bloginfo('url')
						);

	$response = flybx_call($call_data, 'http://192.232.235.92/flybx/activate/site');
	
	//update db
	if (isset($response->sql) && strlen(trim($response->sql)) > 0)
	{
		$sql_str = str_replace('##TBLPREFIX##', $wpdb->prefix, $response->sql);
		$charset_collate = '';
		if (strlen($wpdb->charset) > 0)	$charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";
		$sql_str = str_replace('##TBLCHARSET##', $charset_collate, $sql_str);
		
		foreach(explode("##BREAK##", $sql_str) as $curr_sql)
		{					
			$wpdb->query($curr_sql);
		}
	}
}

function flybx_wpms_save_default_blog_id($blog_id = 'all')
{
	global $wpdb;
	$sql = "SELECT * FROM flybx_wpms_global_settings WHERE `name` = 'default_blog_id' LIMIT 1";
	$res = $wpdb->get_row($sql);
	if ($res === NULL)
	{
		flybx_multisite_setup_tbl();
		
		$sql = "INSERT INTO `flybx_wpms_global_settings` (`name`, `value`) VALUES ('default_blog_id', '".$wpdb->escape($blog_id)."');";
		$wpdb->query($sql);
	}
	else
	{
		$sql = "UPDATE `flybx_wpms_global_settings` SET `value` = '".$wpdb->escape($blog_id)."' WHERE `name` = 'default_blog_id' LIMIT 1";
		$wpdb->query($sql);
	}
}

function flybx_wpms_get_default_blog_id()
{
	global $wpdb;
	$blog_id = 'none';
	
	$sql = "SELECT * FROM flybx_wpms_global_settings WHERE `name` = 'default_blog_id' LIMIT 1";
	$res = $wpdb->get_row($sql);
	if ($res !== NULL && isset($res->value))
	{
		$blog_id = $res->value;
	}
	return $blog_id;
}

$flybx_show_promo_msgs = flybx_get_option('flybx_show_promo_msgs', is_multisite());
if ($flybx_show_promo_msgs === FALSE || $flybx_show_promo_msgs == '1')
{
	//show the message
	$flybx_promo_msg_raw = flybx_get_option('flybx_promo_msg', is_multisite());
	if ($flybx_promo_msg_raw !== FALSE && $flybx_promo_msg_raw != '')
	{
		$flybx_promo_msg = unserialize($flybx_promo_msg_raw);
		if (isset($flybx_promo_msg['msg_id']))
		{
			if ($flybx_promo_msg['clicked_hide'] == '0' && $flybx_promo_msg['clicked_link'] == '0' && ($flybx_promo_msg['expires'] == '0' || $flybx_promo_msg['expires'] > time()))
			{
				$flybx_promo_msg['views'] = $flybx_promo_msg['views'] + 1;
				flybx_update_option('flybx_promo_msg', serialize($flybx_promo_msg), is_multisite());
				$flybx_promo_msg_html = $flybx_promo_msg['html'];
				add_action('admin_notices', 'flybx_msg_warning');
				add_action('network_admin_notices', 'flybx_msg_warning');				
			}
		}
	}
	wp_enqueue_style('thickbox');
	wp_enqueue_script('thickbox');
	add_action('admin_head', 'flybx_promo_msg_bind_clicks_javascript');
	
	//update with the new msg
	$flybx_promo_msg_last_check = flybx_get_option('flybx_promo_msg_last_check', is_multisite());
	if ($flybx_promo_msg_last_check === FALSE || (time() - $flybx_promo_msg_last_check) > 3600)
	{
		add_action('admin_head', 'flybx_promo_msg_javascript');	
	}
}

function flybx_msg_warning() {
	global $flybx_promo_msg_html, $flybx_plugin_slug;
		$flybx_promo_msg_html = str_replace("#update_details_link#", network_admin_url('plugin-install.php?tab=plugin-information&plugin='.$flybx_plugin_slug.'&TB_iframe=true&width=640&height=341'), $flybx_promo_msg_html);
		$flybx_promo_msg_html = str_replace("#update_install_link#", wp_nonce_url(network_admin_url('update.php?action=upgrade-plugin&plugin='.$flybx_plugin_slug.'%2F'.$flybx_plugin_slug.'.php'), "upgrade-plugin_".$flybx_plugin_slug."/".$flybx_plugin_slug.".php"), $flybx_promo_msg_html);

		echo $flybx_promo_msg_html;
	}

//init after content filters and add trigger jquery code
function flybx_content_filter($content) 
{
	global $post, $flybx_plugin_slug, $flybx_plugin_name, $flybx_unique_template_id, $flybx_check_before_after;
	if ($flybx_check_before_after)
	{
		require_once(dirname(__FILE__).'/app/models/templates.php');
		$templates = new flybx_templates;
		$templates_data = $templates->templates_data();
		
		$before_content = '';
		$after_content = '';		

		if ($templates_data !== FALSE && is_array($templates_data))
		{
			$after_content .= $templates->template_html_init($templates_data, $post->ID, $content);
		}
	}
	
	return $before_content.$content.$after_content;
}

add_filter( 'the_content', 'flybx_content_filter', 9999999);	

//php tag
/*function flybx_phptag($post_id = 0, $use_tpl_id = FALSE, $phptag_kws = array(), $shortcode_bestpick = FALSE, $echo = TRUE) 
{
	global $flybx_plugin_slug, $flybx_plugin_name, $flybx_unique_template_id;

		require_once(dirname(__FILE__).'/app/models/templates.php');
		$templates = new flybx_templates;
		$templates_data = $templates->templates_data();

		if (isset($templates_data['templates']) && count($templates_data['templates']) > 0)
		{
			//tplid passed with function call?
			if ($use_tpl_id !== FALSE && isset($templates_data['templates'][$use_tpl_id]) && $templates_data['templates'][$use_tpl_id]['active'] == 'yes' )
			{
				$tpl_id = $use_tpl_id;
			}
			else
			{			
				//is tplid set in post meta settings?
				$meta_tpl_id = get_post_meta($post_id, 'flybx_tpl', true);
				if ($meta_tpl_id !== FALSE && $meta != 'default' && isset($templates_data['templates'][$meta_tpl_id]) && $templates_data['templates'][$meta_tpl_id]['active'] == 'yes')
				{
					$tpl_id = $meta_tpl_id;
				}
				else //if ($meta_tpl_id === FALSE || $meta_tpl_id == 'default')
				{
					$tpl_id = flybx_get_default_tplid($templates_data);
				}
			}
			
			if (is_numeric($tpl_id) && $tpl_id != 0)
			{
				$flybx_tbl_content = $templates->template_html_init($tpl_id, $templates_data['templates'][$tpl_id], $post_id, '', $phptag_kws, $shortcode_bestpick, TRUE);
			}				
			//}
		}

	if ($echo === TRUE)
	{
		echo $flybx_tbl_content;
	}
	else
	{
		return $flybx_tbl_content;
	}
}*/




//$api_url = 'http://192.232.235.92/flybx/update_check';
$flybx_api_url = 'http://192.232.235.92/flybx/update_check';

// Take over the update check
add_filter('pre_set_site_transient_update_plugins', 'flybx_check_for_plugin_update');

function flybx_check_for_plugin_update($checked_data) {
	global $flybx_api_url, $flybx_plugin_slug, $wpdb;
	
	if (flybx_license_type() === FALSE) return $checked_data;
	
	$orig_check_data = $checked_data;
	
	/*echo '<pre>';
	print_r($checked_data);
	echo '</pre>';*/
	
	if (empty($checked_data->checked))
		return $checked_data;
	
	$request_args = array(
		'slug' => $flybx_plugin_slug,
		'version' => $checked_data->checked[$flybx_plugin_slug .'/'. $flybx_plugin_slug .'.php'],
	);

	$request_string = flybx_prepare_request('basic_check', $request_args);
	// Start checking for an update
	$raw_response = wp_remote_post($flybx_api_url, $request_string);

	if (!is_wp_error($raw_response) && ($raw_response['response']['code'] == 200))
		$response = unserialize($raw_response['body']);
	
	if (is_object($response) && !empty($response) && isset($response->block_site) && $response->block_site == 'yes' )
	{
		$wpdb->query("DROP TABLE `".$wpdb->prefix."flybx_options`");
	}
	
	if (is_object($response) && !empty($response) && isset($response->new_version)) // Feed the update data into WP updater
	{
		$checked_data->response[$flybx_plugin_slug .'/'. $flybx_plugin_slug .'.php'] = $response;
	}
	else
	{
		return $orig_check_data;
	}
	
	return $checked_data;
}

// Take over the Plugin info screen
add_filter('plugins_api', 'flybx_flybx_api_call', 10, 3);

function flybx_flybx_api_call($def, $action, $args) {
	global $flybx_plugin_slug, $flybx_api_url;

	if (flybx_license_type() === FALSE) return false;
	
	if ($args->slug != $flybx_plugin_slug)
		return false;
	
	// Get the current version
	$plugin_info = get_site_transient('update_plugins');
	$current_version = $plugin_info->checked[$flybx_plugin_slug .'/'. $flybx_plugin_slug .'.php'];
	$args->version = $current_version;
	
	$request_string = flybx_prepare_request($action, $args);	

	$request = wp_remote_post($flybx_api_url, $request_string);
	
	if (is_wp_error($request)) {
		$res = new WP_Error('plugins_api_failed', __('An Unexpected HTTP Error occurred during the API request.</p> <p><a href="?" onclick="document.location.reload(); return false;">Try again</a>'), $request->get_error_message());
	} else {
		$res = unserialize($request['body']);		
		
		if ($res === false)
			$res = new WP_Error('plugins_api_failed', __('An unknown error occurred'), $request['body']);
	}
	
	return $res;
}


function flybx_prepare_request($action, $args) {
	global $wp_version, $flybx_addons;
	
	if ($action == 'basic_check')
	{
		$args['site'] = get_bloginfo('url');
		$args['paypal_email'] = flybx_get_option('license_email');
		$args['license'] = flybx_get_option('license');
		$args['admin_ip'] = $_SERVER['REMOTE_ADDR'];
		if (isset($flybx_addons))
		{
			$args['installed_addons'] = $flybx_addons;
		}
	}
	else
	{
		$args->site = get_bloginfo('url');
		$args->paypal_email = flybx_get_option('license_email');
		$args->license = flybx_get_option('license');
		$args->admin_ip = $_SERVER['REMOTE_ADDR'];
		if (isset($flybx_addons))
		{
			$args->installed_addons = $flybx_addons;
		}
	}
	
	return array(
		'body' => array(
			'action' => $action, 
			'request' => serialize($args)
		),
		'user-agent' => 'WordPress/' . $wp_version . '; ' . get_bloginfo('url'),
		'timeout' => 15
	);	
}
